#include "BoundaryData.h"

// Here is a little class used to hold the boundary data for boundary conditions


BoundaryData::
BoundaryData()
{
  // printf("BoundaryData constructor called\n");
  for( int side=0; side<=1; side++ ) 
    for( int axis=0; axis<3; axis++ )
      boundaryData[side][axis]=NULL;
}

BoundaryData::
BoundaryData(const BoundaryData & x)
{
  // printf("BoundaryData copy constructor called\n");
  for( int side=0; side<=1; side++ ) 
    for( int axis=0; axis<3; axis++ )
      boundaryData[side][axis]=NULL;

  *this=x;
}

BoundaryData & BoundaryData::
operator=(const BoundaryData & x)
{
  // ** this will not work if x.boundaryData[side][axis] is not NULL since we will delete an array twice!
  for( int side=0; side<=1; side++ ) 
    for( int axis=0; axis<3; axis++ )
    {
      if( boundaryData[side][axis]!=NULL )
      {
        boundaryData[side][axis]->decrementReferenceCount();
        if( boundaryData[side][axis]->getReferenceCount()==0 )
	{
          // printf("+++++++++ BoundaryData::= Delete the array for (side,axis)=(%i,%i)\n",side,axis);
          delete boundaryData[side][axis];
	}
      }
      
      boundaryData[side][axis]=x.boundaryData[side][axis];
      if( boundaryData[side][axis]!=NULL )
        boundaryData[side][axis]->incrementReferenceCount();
      
    }
  
  return *this;
}


BoundaryData::
~BoundaryData()
{
   for( int side=0; side<=1; side++ ) 
     for( int axis=0; axis<3; axis++ )
     {
      if( boundaryData[side][axis]!=NULL )
      {
        boundaryData[side][axis]->decrementReferenceCount();
        if( boundaryData[side][axis]->getReferenceCount()==0 )
	{
          // printf("********* ~BoundaryData() Delete the array for (side,axis)=(%i,%i)\n",side,axis);
          delete boundaryData[side][axis];
	}
      }
     }
}

