#ifndef FLOW_SLOUTIONS_H
#define FLOW_SLOUTIONS_H

#include "Overture.h"

// =================================================================
// This class defines some known solutions for various "flows"
// =================================================================

class FlowSolutions
{
public:

 enum KnownSolutionsEnum
 {
   superSonicExpandingFlow,
   specifiedPistonMotion,
   forcedPistonMotion
 };


FlowSolutions();
~FlowSolutions();

int 
getFlowSolution( const KnownSolutionsEnum knownSolution,
             realCompositeGridFunction & ua, int *ipar, real *rpar );

int 
getFlowSolution( const KnownSolutionsEnum knownSolution,
		 MappedGrid & mg, realArray & ua, int *ipar, real *rpar, 
		 const Index & I1, const Index &I2, const Index &I3  );


int 
getSupersonicExpandingFlow( realCompositeGridFunction & ua, int *ipar, real *rpar );

int 
getSupersonicExpandingFlow( MappedGrid & mg, realArray & ua, int *ipar, real *rpar, 
                            const Index & I1, const Index &I2, const Index &I3  );

int 
getPistonFlow( const KnownSolutionsEnum knownSolution,
               MappedGrid & mg, realArray & ua, int *ipar, real *rpar, 
	       const Index & I1, const Index &I2, const Index &I3  );


protected:

// real rho0, p0, u0, v0, a0;

realCompositeGridFunction *v;
RealArray *wallDataPointer;

};

#endif
