eval 'exec perl -S $0 ${1+"$@"}'
if 0;
#
# perl program to run cg convergence tests
# 

require "ctime.pl"; 

$numberOfParameters = @ARGV;
if ($numberOfParameters eq 0)
{
  
  printf("\n");
  printf("================================================================================\n");
  printf("This perl script will run cg regression tests\n");
  printf("  Usage: \n");
  printf("    conv.p file \n");
  printf("  where \n");
  printf("    file = the name of a conv file that contains a list of cases to run \n");
  printf("==============================================================================\n\n");
  exit;
  
}

$convFile="";
foreach $arg ( @ARGV )
{
  if( $arg =~ /check=.*/ )
  {
    $checkFileDirectory = $arg;
    $checkFileDirectory =~ s/check=//;
  }
  else
  {
    $convFile=$arg;
  }
}

$caseName="junk";
$numberOfComponents=-1;
$numberOfDomains=1;      # cgmp can have multiple domains
$title="";
$caption="";
$count=0;  # counts the number of different grids that we check
$check=""; # name of the check file (e.g. "ins.check")
$cmd="";
$outputFile=""; # name of final TeX file with errors and convergence rates
$closeFile="false";
$date=&ctime(time);  chop($date);  # here is the date

printf("Using the conv file [$convFile]\n");

$results="results"; 
open(RESULTS,">$results") || die print "unable to open $results\n";

open(FILE,"$convFile") || die print "unable to open $convFile\n";
while( <FILE> )
{
  if( /^\#/ ){ next; }  # skip comments
  if( /^exit/ ){ last; }  # exit

  $line=$_;
  chop($line);

  $line =~ s/\#.*//;   # remove comments on the end of lines

  # eval the command in the file. 
  if( $line =~ /;/ )
  {  
    printf(" send to the perl parser: line=[$line]\n");
    eval($line);
  }

  # if $cmd has been set then assume it is a command to run a cg solver
  if( $cmd ne "" )
  {
    if( $count == 0 )
    {
      printf(" numberOfComponents=$numberOfComponents\n");
      printf(" title=[$title]\n");
      printf(" caption=[$caption]\n");

      print RESULTS "$title\n";
    }
    printf(" grid=[$grid], res=[$res]\n");

    #$cmd=$1;
    #eval($cmd);
    printf(" cmd=[$cmd]\n");

    $count++;

    printf(">> run [$cmd >! $caseName$count.out]\n");
    $returnValue = system("csh -f -c '$cmd >! $caseName$count.out'");    

    system("cp $check $caseName$count.check");

    open(CHECKFILE,"$check") || die "cannot open file $check!" ;

    # read the last line in the check file: (for multi-domain problems we need the last "numberOfDomains" lines)
    while( <CHECKFILE> )
    {
      for( $j=$numberOfDomains-1; $j>0; $j-- ){ $checkLine[$j]=$checkLine[$j-1]; }
      $checkLine[0]=$_; chop($checkLine[0]);
    }
    close(CHECKFILE);
    
    # concatenate results from the different domains (chop off start of subsequent lines: these start with time ...)
    $line = $checkLine[$numberOfDomains-1]; 
    for( $j=$numberOfDomains-2; $j>=0; $j-- )
    { 
      $extra = substr($checkLine[$j],11);
      printf(" concatenate: add [$extra]\n");
      $line = $line . $extra;
    } 

    print "----------------------------------------------------------------------------------------------- \n";
    print "              t    nc c=0   err     max   c=1    err    max    c=2    err     max    c=3   err    max\n";
    $line1=$line;
    $line1 =~ s/  / /g;
    print " Results: $line1\n";
    print "---------------------------------------------------------------------------------------------- \n";


    @token =  split(' ',$line); 
    foreach $t (@token)
    {
      # print "token=$t\n";
    }
    $time=$token[0];
    

    print RESULTS "$grid \&  $res ";
    for( $j=0; $j<$numberOfComponents; $j++ )
    {
      $error = $token[3+($j)*3];
      print RESULTS "\&  $error";
    }
    print RESULTS "\n";

    $cmd="";
  }

  
  if( $closeFile eq "true" )
  {
     # compute convergence rates and save the TeX file. 

     print RESULTS $caption, "\n";
     close(RESULTS);

     $cr = "../../common/bin/convRate"; 

     print "Now run `$cr $results -output=$outputFile' to compute the convergence rates\n";
     $rt = system("$cr $results -output=$outputFile");
     
     # initialize parameters for the next case
     system("mv results results.$caseName");
     $closeFile="false";
     $count=0;
     open(RESULTS,">$results") || die print "unable to open $results\n";
  }

}


close(FILE);


exit;
# ===============================================================================================================


