*
* cgins command file for flow past a cylinder
*
$tFinal=.1; $tPlot=.1; $debug=3; $show="cic.show"; 
$solver="choose best iterative solver"; $rtolp=1.e-7; $atolp=1.e-8; $pdebug=0; $rtoli=1.e-7; $atoli=1.e-8; $idebug=0; 
$grid="cice2.order2.hdf"; 
* $grid="square5.hdf";
* 
* specify the overlapping grid to use:
$grid
* Specify the equations we solve:
  incompressible Navier Stokes
  exit
*
* Next specify the file to save the results in. 
* This file can be viewed with Overture/bin/plotStuff.
  show file options
     compressed
      open
       $show
    frequency to flush
      3
    exit
*   display parameters
  turn off twilight zone 
*
* choose implicit time stepping:
  implicit
* but integrate the square explicitly:
  choose grids for implicit
    all=implicit
    square=explicit
    done
  final time $tFinal
  times to plot $tPlot
  plot and always wait
**  no plotting
  pde parameters
    nu
      .1 
*      turn off second order artificial diffusion
*      turn off fourth order artificial diffusion
*     turn on second order artificial diffusion
*     OBPDE:second-order artificial diffusion 1
*     OBPDE:ad21,ad22 2,2
*       OBPDE:fourth-order artificial diffusion 1
*       OBPDE:ad41,ad42 1,1
    done
*
*  OBPSF:show variable: vorticity 1
*  OBPSF:show variable: divergence 1
* 
* cfl
*   .25
  boundary conditions
    all=noSlipWall
**   square(0,0)=inflowWithVelocityGiven, uniform(p=1.,u=1.)
    square(0,0)=inflowWithVelocityGiven , parabolic(d=.5,p=1.,v=1.)
**  square(0,0)=inflowWithVelocityGiven , uniform(p=1.,u=1.), oscillate(t0=.0,omega=2.5)
**  square(0,0)=inflowWithVelocityGiven , parabolic(d=.2,p=1.,u=1.), oscillate(a0=1.,t0=.0,omega=.5)
**     square(1,0)=outflow,  pressure(1.*p+1.*p.n=0.)
**    square(1,0)=outflow,  pressure(1.*p+0.*p.n=1.)
**    square(1,0)=outflow 
**    square(0,1)=slipWall
**    square(1,1)=slipWall
    done
  pressure solver options
     $solver
     * yale
     * these tolerances are chosen for PETSc
     relative tolerance
      $rtolp
     absolute tolerance
      $atolp
     debug 
       $pdebug
    exit
* 
  implicit time step solver options
     $solver
     * these tolerances are chosen for PETSc
     relative tolerance
      $rtoli
     absolute tolerance
      $atoli
     debug 
       $idebug
    exit
* 
  initial conditions
*      read from a show file
*      cylinder.show
*       9
  uniform flow
    p=1., u=1.
  exit
  allow user defined output 1
  project initial conditions
  debug $debug 
  continue
*

  movie mode 
  finish


 

















*
* cgins: flow past a cylinder
*
cic.hdf
  incompressible Navier Stokes
  exit
*
   show file options
     * uncompressed
*     open
*       ob.show
     frequency to flush
       2
     exit
*
 turn off twilight zone 
*  implicit
  choose grids for implicit
    all=implicit
    square=explicit
    done
  final time 2.
  times to plot .1
  plot and always wait
  no plotting
  pde parameters
    nu
     .1
*    divergence damping
*      2.
    done
*
*   cfl
*    .5
*
*   slow start time interval
*     .25
*   slow start cfl
*     .25
*  frequency to flush the show file
*    1
   pressure solver options
    * PETSc
    * choose best iterative solver
    yale
     relative tolerance
       1.e-8 1.e-4  1.e-6  1.e-4
     absolute tolerance
       1.e-6
    exit
********
**    OBPDE:include artificial diffusion in pressure equation 1
**    OBPDE:fourth-order artificial diffusion
**    OBPDE:use implicit fourth-order artificial diffusion 1
**    OBPDE:ad41,ad42 1,1
********
  boundary conditions
   all=noSlipWall
   square(0,0)=inflowWithVelocityGiven, uniform(p=1.,u=1.)
*    square(0,0)=inflowWithVelocityGiven, ramp(ta=0.,tb=1.,ua=0.,ub=2.)
*    square(0,0)=inflowWithVelocityGiven, userDefinedBoundaryData
*      variable inflow
*     1. 0. 0. 
*      done
*    square(0,0)=inflowWithVelocityGiven, userDefinedBoundaryData
*      time dependent inflow
*      1. 0. 0. 
*      done
    square(1,0)=outflow
    square(0,1)=slipWall
    square(1,1)=slipWall
    done
  initial conditions
  uniform flow
    p=1., u=1.
    exit
  project initial conditions
*
  continue
*







