* *******************************************************
* cgins command file: 
*
*   Flow past two cylinders in a channel
*   Use multigrid to solve the implicit time stepping equations
*   and the pressure equation
*
* *******************************************************
*
$tFinal=1.; $tPrint=.01; $nu=.1;
*
* two cylinders in a long channel:
* $gridName="tcilc1e.hdf"; $nu=.02;
* $gridName="tcilc2e.hdf"; $nu=.01;
* $gridName="tcilc3.hdf"; $nu=.005;  
*
* $gridName="square20"; 
$gridName="cic2"; 
*
$gridName
*
  incompressible Navier Stokes
  exit
  turn off twilight zone 
*
* ** Warning: with multigrid one must take all grids to be implicit
 implicit
  choose grids for implicit
   all=implicit
  done
*
  final time $tFinal
  times to plot $tPrint 
*
  show file options
    compressed
   * open
   *  tcilc.show
    frequency to flush
      1
    exit
*
  no plotting
  plot and always wait
*
    maximum number of iterations for implicit interpolation
      10
*
  pde parameters
    nu
     $nu 
    done
*************************************
   pressure solver options
    * PETSc
    choose best iterative solver
     * yale
    *  multigrid
     relative tolerance
       1.e-4
     absolute tolerance
       1.e-4
*     define petscOption -info 1
*      define petscOption -ksp_monitor stdout
*       define petscOption -ksp_monitor stdout
*       define petscOption -ksp_view
**       define petscOption -on_error_attach_debugger gdb
*-      multigrid parameters
*-      *  alternating
*-      * cycles: 1=V, 2=W
*-      number of cycles
*-        2
*-      residual tolerance
*-        1.e-8 1.e-10
*-      error tolerance
*-        1.e-2
*-      maximum number of interpolation iterations
*-        4
*-      debug
*-        1 3 7 3 1 0 3
*-      exit
    exit
*
   implicit time step solver options
    * PETSc
    choose best iterative solver
    * yale
*-    multigrid
     relative tolerance
       1.e-4
     absolute tolerance
       1.e-4
*    define petscOption -ksp_monitor stdout
*    block size
*       2
*-      multigrid parameters
*-      *  alternating
*-      * cycles: 1=V, 2=W
*-      number of cycles
*-        2
*-      residual tolerance
*-        1.e-8
*-      error tolerance
*-        1.e-2
*-      debug
*-       3
*-      maximum number of interpolation iterations
*-        4
*-      debug
*-        1
*-      exit
    exit
*
  boundary conditions
*
    all=noSlipWall
    all=slipWall
    square(0,0)=inflowWithVelocityGiven, uniform(p=1.,u=1.)
*    -- can be trouble for 1.*p+0.01*p.n=0.
    square(1,0)=outflow , pressure(1.*p+1.*p.n=0.)
    square(0,1)=slipWall
    square(1,1)=slipWall
*
    done
  initial conditions
  uniform flow
    p=1., u=1.
  done
*** Warning: projecting initial conditions with 4th order doesn't work yet
**  project initial conditions
  debug
   0 17
  continue


  movie mode
  finish
