*
* cgins -- test the twilightzone
*
* Usage:
*   
*  cgins [-noplot] tz -g=<name> -tz=<poly/trig> -degreex=<> -degreet=<> -tf=<tFinal> -tp=<tPlot> ...
*                     -solver=<yale/best> -order=<2/4> -model=<ins/boussinesq/tp/bp> -ts=<implicit|adams PC|forward Euler> -debug=<num> ..,
*                     -bg=<backGround> -fullSystem -imp=<val> -newts[0|1] -go=[run/halt/og]
* 
*  model=bp : Boussinesq + passive scalar
*  -newts : =1 : use the new advanceSteps time stepping routines 
*  -go : run, halt, og=open graphics
* 
* Examples:
* 
*  cgins noplot tz -g=square10 -degreex=2 -degreet=2 -go=g0
*  cgins tz -g=square5 -degreex=2 -degreet=2 -ts=implicit
*  cgins noplot tz -g=nonSquare8 -degreex=2 -degreet=2  -go=g0
*  cgins noplot tz -g=sise -degreex=2 -degreet=2  -go=g0
*  cgins noplot tz -g=sise -degreex=2 -degreet=2 -ts=implicit -go=g0
*  cgins noplot tz -g=cice -degreex=2 -degreet=2  -go=g0
*  cgins tz -g=cic4 -tz=trig  
*  cgins tz -g=square20.order4 -order=4 -degreex=4 -degreet=2 
* 
*  cgins tz -g=square10 -degreex=2 -degreet=1 -ts=fe -newts=1 -go=halt
* 
* -- curved pipe
*  cgins tz -g=curvedPipei1.order2 -tz=trig -solver=best -tf=.1 -tp=.01 -cdv=0. -nu=.05 -tol=1.e-5 -atol=1.e-7 -go=halt
*  cgins tz -g=solidCurvedPipe90e1.order2 -nu=0.025 -tf=0.05 -tz=trig -solver=best -tol=1e-06 -atol=1e-09 -cdv=1 -fx=.5 -fy=.5 -fz=.5 -ft=.5 -tp=.005 -go=halt
* 
*  cgins noplot tz -g=box10 -degreex=2 -degreet=2 -solver=best
*  cgins noplot tz -g=nonBox5 -degreex=2 -degreet=2 -solver=best
*  cgins noplot tz -g=bibe -degreex=2 -degreet=2 -solver=best
*
*  cgins tz -g=sibe2.order2 -tz=trig -nu=.1 -fx=.5 -fy=.5 -fz=.5 -ft=.5 -solver=best -tol=1.e-8 -atol=1.e-9 -go=halt
* 
* -- test new implicit:
*   cgins tz -g=square5 -degreex=2 -degreet=1 -ts=implicit -iv=viscous [exact]
*   cgins tz -g=square5 -degreex=2 -degreet=1 -ts=implicit -iv=viscous -ad2=1  [not exact]
*   cgins tz -g=square5 -degreex=2 -degreet=1 -ts=implicit -iv=viscous -model=boussinesq   [exact]
*   cgins tz -g=square5 -degreex=1 -degreet=1 -ts=implicit -iv=viscous -model=boussinesq -ad2=1 [exact]
*   cgins tz -g=square5 -degreex=1 -degreet=1 -ts=implicit -iv=viscous -model=boussinesq -ad2=1 -bcn="square(0,0)=slipWall\nsquare(0,1)=slipWall" [exact]
* 
* -- Boussinesq:
*  
*  cgins tz -g=square10 -degreex=2 -degreet=2 -model=boussinesq -gravity="-10. 0 0." -tp=.1 -tf=5. [exact]
*  cgins tz -g=square5 -degreex=2 -degreet=1 -ts=implicit -model=boussinesq -gravity="-10. 0 0." -rf=5 -dtMax=.05 -tp=.1 -tf=2. -debug=1 [exact until refactor]
*  cgins tz -g=box5 -degreex=2 -degreet=1 -ts=implicit -model=boussinesq -gravity="-10. 0 0." -rf=5 -dtMax=.05 -tp=.1 -tf=2. -debug=1 [exact until refactor]
* 
* Two-phase flow examples: (see also twoPhase.out)
*   cgins noplot tz -g=square5 -degreex=2 -degreet=1 -model=tp -tp=.005 -tf=.01 -dtMax=.005 -go=go -debug=1 -gravity="0. -10. 0."  [exact]
* -- test with rho varying in time (constant in space)
*   cgins tz -g=square5 -degreex=2 -degreet=1 -model=tp -tp=.005 -tf=.1 -dtMax=.005 -gravity="0. -1. 0." -cfl=.9 -go=halt -rhot=1. [exact]
* 
*   cgins tz -g=square20 -degreex=1 -degreet=0 -model=tp -tp=.005 -tf=.1 -dtMax=.005 -gravity="0. -1. 0." -cfl=.25 -go=halt -mu1=.1 -mu2=.2 [exact]
*
* -- convergence test 
*   cgins noplot tz -g=square10 -degreex=2 -degreet=2 -model=tp -tp=.1 -tf=.1 -dtMax=.05 -gravity="0. -1. 0." -cfl=.9 -go=go -mu1=.1 -mu2=.2 -rho1=2. -rho2=1.
*   cgins tz -g=square40 -degreex=2 -degreet=2 -model=tp -tp=.1 -tf=.1 -dtMax=.05 -gravity="0. -1. 0." -cfl=.9 -go=go -mu1=.1 -mu2=.2 -rho1=2. -rho2=1. -go=halt
* 
*  -- implicit:
* cgins noplot tz -g=square5 -degreex=2 -degreet=0 -model=tp -tp=.1 -tf=.1 -dtMax=.1 -gravity="0. -1. 0." -cfl=.9 -go=go -ts=implicit -imp=1. -fullSystem=1 -av1=1. -av2=1. -kThermal=1. [exact]
* 
* cgins noplot tz -g=square5 -degreex=2 -degreet=1 -model=tp -tp=.1 -tf=.4 -dtMax=.1 -gravity="0. -1. 0." -cfl=.9 -go=go -ts=implicit -imp=.5 -fullSystem=1 -av1=1. -av2=1. -kThermal=1. -debug=1 [exact]
* 
*  cgins noplot tz -g=square5 -degreex=2 -degreet=0 -model=tp -tp=.1 -tf=.1 -dtMax=.1 -gravity="0. 0. 0." -cfl=.9 -go=go -ts=implicit -imp=1. -iv=viscous -fullSystem=1 -av1=1. -av2=1. -kThermal=1. -debug=15 >! junk
* 
*  cgins tz -g=square5 -degreex=2 -degreet=1 -model=tp -tp=.005 -tf=.5 -dtMax=.05 -gravity="0. -1. 0." -cfl=.9 -go=halt -rhot=1. -ts=implicit
* 
* parallel examples:
*
*  srun -N1 -n1 -ppdebug $cginsp tz -g=square5 -degreex=2 -degreet=2 -ts=implicit -model=boussinesq -tp=.01 -tf=.02 -solver=best
* 
* mpirun -np 2 $cginsp tz -g=square10 -degreex=2 -degreet=2 -solver=best -tp=.05 -tf=1. -go=halt
* mpirun -np 2 $cginsp noplot tz -g=square10 -degreex=2 -degreet=2 -ts=implicit -solver=best -tp=.01 -tf=.02 -go=og
* mpirun -np 1 $cginsp noplot tz -g=square5 -degreex=2 -degreet=2 -ts=implicit -model=boussinesq -solver=best -tp=.01 -tf=.02
* 
* === Boussinesq + passive scalar
*  cgins tz -g=square10 -degreex=2 -degreet=2 -model=bp -tp=.1 -tf=5. [exact]
* 
* --- set default values for parameters ---
* 
$model="ins"; $noplot=""; $backGround="square"; $show=" "; $newts=0; 
$ts="adams PC"; $implicitVariation="full"; $implicitFactor=.5; $cdv=1.; $refactorFrequency=100;
$debug = 0;  $tPlot=.1; $maxIterations=100; $tol=1.e-16; $atol=1.e-16; 
$tz = "poly"; $degreex=2; $degreet=2; $fx=1.; $fy=1.; $fz=1.; $ft=1.; $dtMax=.5; $ad2=0; $ad21=1; $ad22=1;
$order = 2; $fullSystem=0; $go="halt"; $bcn="*"; 
$solver="yale"; $ogesDebug=0; $tFinal=1.; $cfl=.9; $nu=.1;  $kThermal=.1; $thermalExpansivity=.1;
$gravity=" 0. -1. 0."; $rho1=1.; $rho2=1.; $mu1=.1; $mu2=.1; $av1=.1; $av2=.1; $rhot=0.
* 
$ksp="bcgs"; $pc="bjacobi"; $subksp="preonly"; $subpc="ilu"; $iluLevels=3;
* $ksp="gmres"; 
*
* ----------------------------- get command line arguments ---------------------------------------
GetOptions( "g=s"=>\$grid,"tf=f"=>\$tFinal,"degreex=i"=>\$degreex, "degreet=i"=>\$degreet, "model=s"=>\$model,\
 "tp=f"=>\$tPlot, "solver=s"=>\$solver, "tz=s"=>\$tz, "show=s"=>\$show,"order=i"=>\$order,"debug=i"=>\$debug, \
 "ts=s"=>\$ts,"nu=f"=>\$nu,"cfl=f"=>\$cfl, "bg=s"=>\$backGround,"fullSystem=i"=>\$fullSystem, "go=s"=>\$go,\
 "noplot=s"=>\$noplot,"dtMax=f"=>\$dtMax,"gravity=s"=>\$gravity,"rho1=f"=>\$rho1,"rho2=f"=>\$rho2,\
 "tol=f"=>\$tol,"atol=f"=>\$atol,"newts=i"=>\$newts,"fx=f"=>\$fx,"fy=f"=>\$fy,"fz=f"=>\$fz,"ft=f"=>\$ft,\
 "mu1=f"=>\$mu1,"mu2=f"=>\$mu2,"av1=f"=>\$av1,"av2=f"=>\$av2,"rhot=f"=>\$rhot,"iv=s"=>\$implicitVariation,\
 "rf=s"=>\$refactorFrequency,"ogesDebug=i"=>\$ogesDebug,"imp=f"=>\$implicitFactor,"kThermal=f"=>\$kThermal,\
  "cdv=f"=>\$cdv,"show=s"=>\$show ,"thermalExpansivity=f"=>\$thermalExpansivity,"ad2=f"=>\$ad2,"bcn=s"=>\$bcn);
* -------------------------------------------------------------------------------------------------
if( $solver eq "best" ){ $solver="choose best iterative solver"; }
if( $tz eq "poly" ){ $tz="turn on polynomial"; }else{ $tz="turn on trigonometric"; }
if( $order eq "2" ){ $order = "second order accurate"; }else{ $order = "fourth order accurate"; }
if( $model eq "ins" ){ $model = "incompressible Navier Stokes"; }\
elsif( $model eq "boussinesq" ){ $model = "incompressible Navier Stokes\n Boussinesq model"; }\
elsif( $model eq "tp" ){ $model = "incompressible Navier Stokes\n two-phase flow model"; }\
elsif( $model eq "bp" ){ $model = "incompressible Navier Stokes\n Boussinesq model\n passive scalar advection"; }
if( $implicitVariation eq "viscous" ){ $implicitVariation = "useNewImplicitMethod\n implicitViscous"; }\
elsif( $implicitVariation eq "adv" ){ $implicitVariation = "useNewImplicitMethod\n implicitAdvectionAndViscous"; }\
elsif( $implicitVariation eq "full" ){ $implicitVariation = "useNewImplicitMethod\n implicitFullLinearized"; }\
else{ $implicitVariation = "implicitFullLinearized"; }
* 
if( $ts eq "fe" ){ $ts="forward Euler";}
if( $ts eq "be" ){ $ts="backward Euler"; }
if( $ts eq "im" ){ $ts="implicit"; }
if( $ts eq "pc" ){ $ts="adams PC"; }
if( $ts eq "mid"){ $ts="midpoint"; }  
* 
if( $newts eq "1" ){ $newts = "use new advanceSteps versions"; }else{ $newts = "*"; }
* 
if( $go eq "halt" ){ $go = "break"; }
if( $go eq "og" ){ $go = "open graphics"; }
if( $go eq "run" || $go eq "go" ){ $go = "movie mode\n finish"; }
*
* test mixed boundaries: 
* $grid="matchingSquares"; $tPlot=.01; $degreex=1; $degreet=0; $debug=1;
* 
$grid
*
  $model
  define real parameter thermalExpansivity $thermalExpansivity
  define real parameter adcBoussinesq 0. 
  * parameters for two-phase flow:
  define real parameter twoPhaseRho1 $rho1
  define real parameter twoPhaseRho2 $rho2
  define real parameter twoPhaseMu1  $mu1
  define real parameter twoPhaseMu2  $mu2
  define real parameter twoPhaseArtDisPsi $av1
  define real parameter twoPhaseArtDisPhi $av2
  * add an explicit time dependence to rho for testing: 
  define real parameter twoPhaseRhot $rhot
  exit
* -- order of accuracy: 
$order 
* 
* 
  show file options
    compressed
     open
      $show
    frequency to flush
      100
    exit
***
* -- twilightzone options:
  $tz
  degree in space $degreex
  degree in time $degreet
  frequencies (x,y,z,t)   $fx $fy $fz $ft
* 
  final time $tFinal
  times to plot $tPlot
  * plot and always wait
  no plotting
  cfl $cfl
  dtMax $dtMax
*
  $newts
*
  pde parameters
    nu $nu
    kThermal $kThermal
    OBPDE:divergence damping  $cdv
    OBPDE:second-order artificial diffusion $ad2
    OBPDE:ad21,ad22  $ad21, $ad22
   gravity
*    0. -1. 0. 
   $gravity
  done
* 
* Choose the time-stepping method:
  $ts
* **************************************
*  first order predictor
*  number of PC corrections 0 
* 
  refactor frequency $refactorFrequency
  $implicitVariation
  implicit factor $implicitFactor 
* for testing, force use of the full implicit system:
  use full implicit system $fullSystem
*
  choose grids for implicit
    all=implicit
  done
*
   pressure solver options
     $solver
     * parallel bi-conjugate gradient stabilized
**     lu preconditioner
*     parallel gmres
*     gmres
     define petscOption -ksp_type $ksp
     define petscOption -pc_type $pc
     define petscOption -sub_ksp_type $subksp
     define petscOption -sub_pc_type $subpc
     define petscOption -pc_factor_levels $iluLevels
     define petscOption -sub_pc_factor_levels $iluLevels
     * define petscOption -pc_factor_nonzeros_along_diagonal 1
*
     maximum number of iterations
      $maxIterations
     relative tolerance
       $tol 
     absolute tolerance
       $atol
     maximum number of iterations
       $maxIterations
     debug 
      $ogesDebug
    exit
*
   implicit time step solver options
    $solver
     * parallel bi-conjugate gradient stabilized
**     lu preconditioner
*
     maximum number of iterations
      $maxIterations
     relative tolerance
       $tol
     absolute tolerance
       $atol
     maximum number of iterations
       $maxIterations
     debug 
       $ogesDebug
    exit
* 
  boundary conditions
    all=dirichletBoundaryCondition
    $bcn
** all=noSlipWall
**    all=noSlipWall, mixedDerivative(1.*t+0.*t.n=0.)
*    $backGround(0,0)=noSlipWall, mixedDerivative(0.*t+1.*t.n=0.)
*    $backGround(1,0)=outflow
*     all=noSlipWall, mixedDerivative(1.*t+0.*t.n=0.)
*     square(0,1)=dirichletBoundaryCondition
*
*     square(0,1)=slipWall
*   square(0,0)=inflowWithVelocityGiven , uniform(p=1.,u=1.)
*    square(1,0)=outflow 
*    square(1,0)=outflow , pressure(.1*p+1.*p.n=0.)
*     square(0,0)=inflowWithVelocityGiven , parabolic(d=.2,p=1.,u=1.), oscillate(t0=.3,omega=2.5)
* 
   done
  debug $debug
*   check error on ghost
*     1
 continue
* 
 $go

 movie mode
 finish

