c
c Compute du/dt for the incompressible NS on rectangular AND curvilinear grids
c


c These next include files will define the macros that will define the difference approximations
c The actual macro is called below
#Include "defineDiffOrder2f.h"
#Include "defineDiffOrder4f.h"

#Include "commonMacros.h"

#beginMacro loopse1(e1)
if( useWhereMask.ne.0 )then
 do i3=n3a,n3b
 do i2=n2a,n2b
 do i1=n1a,n1b
  if( mask(i1,i2,i3).gt.0 )then
   e1
  end if
 end do
 end do
 end do
else
 do i3=n3a,n3b
 do i2=n2a,n2b
 do i1=n1a,n1b
  e1
 end do
 end do
 end do
end if
#endMacro
#beginMacro loopse2(e1,e2)
if( useWhereMask.ne.0 )then
 do i3=n3a,n3b
 do i2=n2a,n2b
 do i1=n1a,n1b
  if( mask(i1,i2,i3).gt.0 )then
   e1
   e2
  end if
 end do
 end do
 end do
else
 do i3=n3a,n3b
 do i2=n2a,n2b
 do i1=n1a,n1b
  e1
  e2
 end do
 end do
 end do
end if
#endMacro

#beginMacro loopse3(e1,e2,e3)
if( useWhereMask.ne.0 )then
  do i3=n3a,n3b
  do i2=n2a,n2b
  do i1=n1a,n1b
    if( mask(i1,i2,i3).gt.0 )then
      e1
      e2
      e3
    end if
  end do
  end do
  end do
else
  do i3=n3a,n3b
  do i2=n2a,n2b
  do i1=n1a,n1b
      e1
      e2
      e3
  end do
  end do
  end do
end if
#endMacro

#beginMacro loopse4(e1,e2,e3,e4)
if( useWhereMask.ne.0 )then
  do i3=n3a,n3b
  do i2=n2a,n2b
  do i1=n1a,n1b
    if( mask(i1,i2,i3).gt.0 )then
      e1
      e2
      e3
      e4
    end if
  end do
  end do
  end do
else
  do i3=n3a,n3b
  do i2=n2a,n2b
  do i1=n1a,n1b
      e1
      e2
      e3
      e4
  end do
  end do
  end do
end if
#endMacro

#beginMacro loopse6(e1,e2,e3,e4,e5,e6)
if( useWhereMask.ne.0 )then
  do i3=n3a,n3b
  do i2=n2a,n2b
  do i1=n1a,n1b
    if( mask(i1,i2,i3).gt.0 )then
      e1
      e2
      e3
      e4
      e5
      e6
    end if
  end do
  end do
  end do
else
  do i3=n3a,n3b
  do i2=n2a,n2b
  do i1=n1a,n1b
      e1
      e2
      e3
      e4
      e5
      e6
  end do
  end do
  end do
end if
#endMacro


c* 
c* 
c* c Define the artificial diffusion coefficients
c* c gt should be R or C (gridType is Rectangular or Curvilinear)
c* c tb should be blank or SA  (SA=Spalart-Allamras turbulence model)
c* #beginMacro defineArtificialDiffusionCoefficients(dim,gt,tb)
c*   #If #dim == "2" 
c*     cdmz=admz ## gt ## tb(i1  ,i2  ,i3)
c*     cdpz=admz ## gt ## tb(i1+1,i2  ,i3)
c*     cdzm=adzm ## gt ## tb(i1  ,i2  ,i3)
c*     cdzp=adzm ## gt ## tb(i1  ,i2+1,i3)
c*     cdDiag=cdmz+cdpz+cdzm+cdzp
c*     ! write(*,'(1x,''insdt:i1,i2,cdmz,cdzm='',2i3,2f9.3)') i1,i2,cdmz,cdzm
c*   #Else
c*     cdmzz=admzz ## gt ## tb(i1  ,i2  ,i3  )
c*     cdpzz=admzz ## gt ## tb(i1+1,i2  ,i3  )
c*     cdzmz=adzmz ## gt ## tb(i1  ,i2  ,i3  )
c*     cdzpz=adzmz ## gt ## tb(i1  ,i2+1,i3  )
c*     cdzzm=adzzm ## gt ## tb(i1  ,i2  ,i3  )
c*     cdzzp=adzzm ## gt ## tb(i1  ,i2  ,i3+1)
c*     cdDiag=cdmzz+cdpzz+cdzmz+cdzpz+cdzzm+cdzzp
c*   #End
c* #endMacro
c* 
c* c Define macros for the derivatives based on the dimension, order of accuracy and grid-type
c* #beginMacro defineDerivativeMacros(DIM,ORDER,GRIDTYPE)
c* 
c* #defineMacro U(cc) u(i1,i2,i3,cc)
c* #defineMacro UU(cc) uu(i1,i2,i3,cc)
c* 
c* #If #DIM == "2"
c*  #If #ORDER == "2" 
c*    #If #GRIDTYPE == "rectangular" 
c*      #defineMacro UX(cc) ux22r(i1,i2,i3,cc)
c*      #defineMacro UY(cc) uy22r(i1,i2,i3,cc)
c*      #defineMacro UXX(cc) uxx22r(i1,i2,i3,cc)
c*      #defineMacro UXY(cc) uxy22r(i1,i2,i3,cc)
c*      #defineMacro UYY(cc) uyy22r(i1,i2,i3,cc)
c*      #defineMacro ULAP(cc) ulaplacian22r(i1,i2,i3,cc)
c*    #Else
c*      #defineMacro UX(cc) ux22(i1,i2,i3,cc)
c*      #defineMacro UY(cc) uy22(i1,i2,i3,cc)
c*      #defineMacro UXX(cc) uxx22(i1,i2,i3,cc)
c*      #defineMacro UXY(cc) uxy22(i1,i2,i3,cc)
c*      #defineMacro UYY(cc) uyy22(i1,i2,i3,cc)
c*      #defineMacro ULAP(cc) ulaplacian22(i1,i2,i3,cc)
c*    #End
c*  #Else
c*    #If #GRIDTYPE == "rectangular" 
c*      #defineMacro UX(cc) ux42r(i1,i2,i3,cc)
c*      #defineMacro UY(cc) uy42r(i1,i2,i3,cc)
c*      #defineMacro UXX(cc) uxx42r(i1,i2,i3,cc)
c*      #defineMacro UXY(cc) uxy42r(i1,i2,i3,cc)
c*      #defineMacro UYY(cc) uyy42r(i1,i2,i3,cc)
c*      #defineMacro ULAP(cc) ulaplacian42r(i1,i2,i3,cc)
c*    #Else
c*      #defineMacro UX(cc) ux42(i1,i2,i3,cc)
c*      #defineMacro UY(cc) uy42(i1,i2,i3,cc)
c*      #defineMacro UXX(cc) uxx42(i1,i2,i3,cc)
c*      #defineMacro UXY(cc) uxy42(i1,i2,i3,cc)
c*      #defineMacro UYY(cc) uyy42(i1,i2,i3,cc)
c*      #defineMacro ULAP(cc) ulaplacian42(i1,i2,i3,cc)
c*    #End
c*  #End
c* #Else
c*  #If #ORDER == "2" 
c*    #If #GRIDTYPE == "rectangular" 
c*      #defineMacro UX(cc) ux23r(i1,i2,i3,cc)
c*      #defineMacro UY(cc) uy23r(i1,i2,i3,cc)
c*      #defineMacro UZ(cc) uz23r(i1,i2,i3,cc)
c*      #defineMacro UXX(cc) uxx23r(i1,i2,i3,cc)
c*      #defineMacro UXY(cc) uxy23r(i1,i2,i3,cc)
c*      #defineMacro UXZ(cc) uxz23r(i1,i2,i3,cc)
c*      #defineMacro UYY(cc) uyy23r(i1,i2,i3,cc)
c*      #defineMacro UYZ(cc) uyz23r(i1,i2,i3,cc)
c*      #defineMacro UZZ(cc) uzz23r(i1,i2,i3,cc)
c*      #defineMacro ULAP(cc) ulaplacian23r(i1,i2,i3,cc)
c*    #Else
c*      #defineMacro UX(cc) ux23(i1,i2,i3,cc)
c*      #defineMacro UY(cc) uy23(i1,i2,i3,cc)
c*      #defineMacro UZ(cc) uz23(i1,i2,i3,cc)
c*      #defineMacro UXX(cc) uxx23(i1,i2,i3,cc)
c*      #defineMacro UXY(cc) uxy23(i1,i2,i3,cc)
c*      #defineMacro UXZ(cc) uxz23(i1,i2,i3,cc)
c*      #defineMacro UYY(cc) uyy23(i1,i2,i3,cc)
c*      #defineMacro UYZ(cc) uyz23(i1,i2,i3,cc)
c*      #defineMacro UZZ(cc) uzz23(i1,i2,i3,cc)
c*      #defineMacro ULAP(cc) ulaplacian23(i1,i2,i3,cc)
c*    #End
c* 
c*  #Else
c* 
c*    #If #GRIDTYPE == "rectangular" 
c*      #defineMacro UX(cc) ux43r(i1,i2,i3,cc)
c*      #defineMacro UY(cc) uy43r(i1,i2,i3,cc)
c*      #defineMacro UZ(cc) uz43r(i1,i2,i3,cc)
c*      #defineMacro UXX(cc) uxx43r(i1,i2,i3,cc)
c*      #defineMacro UXY(cc) uxy43r(i1,i2,i3,cc)
c*      #defineMacro UXZ(cc) uxz43r(i1,i2,i3,cc)
c*      #defineMacro UYY(cc) uyy43r(i1,i2,i3,cc)
c*      #defineMacro UYZ(cc) uyz43r(i1,i2,i3,cc)
c*      #defineMacro UZZ(cc) uzz43r(i1,i2,i3,cc)
c*      #defineMacro ULAP(cc) ulaplacian43r(i1,i2,i3,cc)
c*    #Else
c*      #defineMacro UX(cc) ux43(i1,i2,i3,cc)
c*      #defineMacro UY(cc) uy43(i1,i2,i3,cc)
c*      #defineMacro UZ(cc) uz43(i1,i2,i3,cc)
c*      #defineMacro UXX(cc) uxx43(i1,i2,i3,cc)
c*      #defineMacro UXY(cc) uxy43(i1,i2,i3,cc)
c*      #defineMacro UXZ(cc) uxz43(i1,i2,i3,cc)
c*      #defineMacro UYY(cc) uyy43(i1,i2,i3,cc)
c*      #defineMacro UYZ(cc) uyz43(i1,i2,i3,cc)
c*      #defineMacro UZZ(cc) uzz43(i1,i2,i3,cc)
c*      #defineMacro ULAP(cc) ulaplacian43(i1,i2,i3,cc)
c*    #End
c*  #End
c* #End
c* #endMacro 
c* 
c* 
c* c =============================================================
c* c Compute derivatives of u,v,w 
c* c =============================================================
c* #beginMacro setupDerivatives(DIM)
c*  u0x=UX(uc)
c*  u0y=UY(uc)
c*  v0x=UX(vc)
c*  v0y=UY(vc)
c* #If #DIM == "3"
c*  u0z=UZ(uc)
c*  v0z=UZ(vc)
c*  w0x=UX(wc)
c*  w0y=UY(wc)
c*  w0z=UZ(wc)
c* #End
c* #endMacro
c* 
c* c =============================================================
c* c Compute Spalart-Allmaras quantities
c* c   This macro assumes u0x,u0y, ... are defined
c* c =============================================================
c* #beginMacro setupSpalartAllmaras(DIM)
c*  n0=u(i1,i2,i3,nc)
c*  chi=n0/nu
c*  chi3=chi**3
c*  fnu1=chi3/( chi3+cv1e3)
c*  fnu2=1.-chi/(1.+chi*fnu1)
c*  dd = dw(i1,i2,i3)+cd0
c*  dKappaSq=(dd*kappa)**2
c* #If #DIM == "2"
c*   s=abs(u0y-v0x)+ n0*fnu2/dKappaSq ! turbulence source term 
c* #Else
c*   s=n0*fnu2/dKappaSq \
c*     +sqrt( (u0y-v0x)**2 + (v0z-w0y)**2 + (w0x-u0z)**2 )
c* #End
c*  r= min( n0/( s*dKappaSq ), cr0 )
c*  g=r+cw2*(r**6-r)
c*  fw=g*( (1.+cw3e6)/(g**6+cw3e6) )**(1./6.)
c*  nSqBydSq=cw1*fw*(n0/dd)**2
c*  nuT = nu+n0*chi3/(chi3+cv1e3)
c*  nuTd= chi3*(chi3+4.*cv1e3)/(chi3+cv1e3)**2
c*  n0x=UX(nc)
c*  n0y=UY(nc)
c*  nuTx=n0x*nuTd
c*  nuTy=n0y*nuTd
c*  #If #DIM == "3" 
c*    n0z=UZ(nc)
c*    nuTz=n0z*nuTd
c*  #End
c* #endMacro
c* 
c* c =============================================================
c* c Compute k-epsilon quantities
c* c   This macro assumes u0x,u0y, ... are defined
c* c =============================================================
c* #beginMacro setupKEpsilon(DIM)
c*  k0=u(i1,i2,i3,kc)
c*  e0=u(i1,i2,i3,ec)
c*  nuT = cMu*k0**2/e0
c*  nuP=nu+nuT
c*  k0x=UX(kc)
c*  e0x=UX(ec)
c*  nuTx=cMu*k0*( 2.*k0x*e0 - k0*e0x )/e0**2
c*  k0y=UY(kc)
c*  e0y=UY(ec)
c*  nuTy=cMu*k0*( 2.*k0y*e0 - k0*e0y )/e0**2
c* #If #DIM == "2"
c*  prod = nuT*( 2.*(u0x**2+v0y**2) + (v0x+u0y)**2 )
c* #Else
c*  prod = nuT*( 2.*(u0x**2+v0y**2+w0z**2) +(v0x+u0y)**2 +(w0y+v0z)**2 +(u0z+w0x)**2  )  
c*  k0z=UZ(kc)
c*   e0z=UZ(ec)
c*   nuTz=cMu*k0*( 2.*k0z*e0 - k0*e0z )/e0**2
c* #End
c* #endMacro
c* 
c* c =============================================================================
c* c Evaluate the coefficients of the visco-plastic model
c* c ============================================================================
c* #beginMacro getViscoPlasticCoefficients(DIM)
c*  nuT = u(i1,i2,i3,vsc)
c*  nuTx=UX(vsc)
c*  nuTy=UY(vsc)
c*  #If #DIM == "3" 
c*   nuTz=UZ(vsc)
c*  #End
c* #endMacro
c* 
c* c====================================================================
c* c This macro will build the statements that form the body of the loop
c* c
c* c IMPEXP: EXPLICIT, EXPLICIT_ONLY, BOTH
c* c OPTION: INS : INS equations
c* c         INSSPAL - INS + Spalart-Allmaras turbulence model
c* c         INS-BL - INS + Baldwin Lomax turbulence model
c* c SCALAR: NONE
c* c         PASSIVE - include equations for a passive scalar
c* c AXISYMMETRIC : YES or NO
c* c====================================================================
c* #beginMacro buildEquations(IMPEXP,OPTION,SCALAR,DIM,ORDER,GRIDTYPE,AXISYMMETRIC)
c* #If #IMPEXP == "EXPLICIT"
c* 
c* 
c*  #If #OPTION == "INS" 
c*   ! INS, no AD
c*   #If #DIM == "2"
c*    ut(i1,i2,i3,uc)= -UU(uc)*UX(uc)-UU(vc)*UY(uc)-UX(pc)+nu*ULAP(uc)
c*    ut(i1,i2,i3,vc)= -UU(uc)*UX(vc)-UU(vc)*UY(vc)-UY(pc)+nu*ULAP(vc)
c*   #Else
c*    ut(i1,i2,i3,uc)= -UU(uc)*UX(uc)-UU(vc)*UY(uc)-UU(wc)*UZ(uc)-UX(pc)+nu*ULAP(uc)
c*    ut(i1,i2,i3,vc)= -UU(uc)*UX(vc)-UU(vc)*UY(vc)-UU(wc)*UZ(vc)-UY(pc)+nu*ULAP(vc)
c*    ut(i1,i2,i3,wc)= -UU(uc)*UX(wc)-UU(vc)*UY(wc)-UU(wc)*UZ(wc)-UZ(pc)+nu*ULAP(wc)
c*   #End
c* 
c*   #If #AXISYMMETRIC == "YES"
c*    ! -- add on axisymmetric corrections ---
c*    ri=radiusInverse(i1,i2,i3)
c*    if( ri.ne.0. )then
c*      ut(i1,i2,i3,uc)=ut(i1,i2,i3,uc)+nu*( UY(uc)*ri )
c*      ut(i1,i2,i3,vc)=ut(i1,i2,i3,vc)+nu*( (UY(vc)-UU(vc)*ri)*ri )
c*    else
c*      ut(i1,i2,i3,uc)=ut(i1,i2,i3,uc)+nu*( UYY(uc) )
c*      ut(i1,i2,i3,vc)=ut(i1,i2,i3,vc)+nu*( .5*UYY(vc) )
c*    end if
c*   #End
c* 
c*  #Elif #OPTION == "INSVD" 
c*   ! variable density INS 
c*   #If #DIM == "2"
c*    ut(i1,i2,i3,rc)= -UU(uc)*UX(rc)-UU(vc)*UY(rc)                        
c*    ut(i1,i2,i3,uc)= -UU(uc)*UX(uc)-UU(vc)*UY(uc) + (-UX(pc)+nu*ULAP(uc))/UU(rc)
c*    ut(i1,i2,i3,vc)= -UU(uc)*UX(vc)-UU(vc)*UY(vc) + (-UY(pc)+nu*ULAP(vc))/UU(rc)
c*   #Else
c*    ut(i1,i2,i3,rc)= -UU(uc)*UX(rc)-UU(vc)*UY(rc)-UU(wc)*UZ(rc)
c*    ut(i1,i2,i3,uc)= -UU(uc)*UX(uc)-UU(vc)*UY(uc)-UU(wc)*UZ(uc)+ (-UX(pc)+nu*ULAP(uc))/UU(rc)
c*    ut(i1,i2,i3,vc)= -UU(uc)*UX(vc)-UU(vc)*UY(vc)-UU(wc)*UZ(vc)+ (-UY(pc)+nu*ULAP(vc))/UU(rc)
c*    ut(i1,i2,i3,wc)= -UU(uc)*UX(wc)-UU(vc)*UY(wc)-UU(wc)*UZ(wc)+ (-UZ(pc)+nu*ULAP(wc))/UU(rc)
c*   #End
c* 
c*   #If #AXISYMMETRIC == "YES"
c*    ! -- add on axisymmetric corrections ---
c*    ri=radiusInverse(i1,i2,i3)
c*    if( ri.ne.0. )then
c*      ut(i1,i2,i3,uc)=ut(i1,i2,i3,uc)+nu*( UY(uc)*ri )/UU(rc)
c*      ut(i1,i2,i3,vc)=ut(i1,i2,i3,vc)+nu*( (UY(vc)-UU(vc)*ri)*ri )/UU(rc)
c*    else
c*      ut(i1,i2,i3,uc)=ut(i1,i2,i3,uc)+nu*( UYY(uc) )/UU(rc)
c*      ut(i1,i2,i3,vc)=ut(i1,i2,i3,vc)+nu*( .5*UYY(vc) )/UU(rc)
c*    end if
c*   #End
c* 
c*  #Elif #OPTION == "INSSPAL" 
c*   ! INS with Spalart-Allmaras turbulence model
c*   setupDerivatives(DIM)
c*   setupSpalartAllmaras(DIM)
c*   #If #DIM == "2"
c*    ut(i1,i2,i3,uc)= -UU(uc)*u0x-UU(vc)*u0y-UX(pc)+nuT*ULAP(uc)+nuTx*(2.*u0x    ) +nuTy*(u0y+v0x)
c*    ut(i1,i2,i3,vc)= -UU(uc)*v0x-UU(vc)*v0y-UY(pc)+nuT*ULAP(vc)+nuTx*(u0y+v0x) +nuTy*(2.*v0y)
c*    ut(i1,i2,i3,nc)= -UU(uc)*n0x-UU(vc)*n0y + cb1*s*U(nc) + sigmai*(nu+U(nc))*(ULAP(nc))\
c*                     + ((1.+cb2)*sigmai)*(n0x**2+n0y**2)- nSqBydSq
c*   #Else
c*    ut(i1,i2,i3,uc)= -UU(uc)*u0x-UU(vc)*u0y-UU(wc)*u0z-UX(pc)+nuT*ULAP(uc)\
c*                     +nuTx*(2.*u0x    ) +nuTy*(u0y+v0x) +nuTz*(u0z+w0x)
c*    ut(i1,i2,i3,vc)= -UU(uc)*v0x-UU(vc)*v0y-UU(wc)*v0z-UY(pc)+nuT*ULAP(vc)\
c*                     +nuTx*(u0y+v0x) +nuTy*(2.*v0y) +nuTz*(v0z+w0y)
c*    ut(i1,i2,i3,wc)= -UU(uc)*w0x-UU(vc)*w0y-UU(wc)*w0z-UZ(pc)+nuT*ULAP(wc)\
c*                     +nuTx*(u0z+w0x) +nuTy*(v0z+w0y) +nuTz*(2.*w0z)
c*    ut(i1,i2,i3,nc)= -UU(uc)*n0x-UU(vc)*n0y-UU(wc)*n0z \
c*         + cb1*s*U(nc) + sigmai*(nu+U(nc))*(ULAP(nc))\
c* 	+ ((1.+cb2)*sigmai)*(n0x**2+n0y**2+n0z**2) - nSqBydSq
c*   #End
c*  #Elif #OPTION == "INSKE" 
c*   ! INS with k-epsilon turbulence model
c*   setupDerivatives(DIM)
c*   setupKEpsilon(DIM)
c*   #If #DIM == "2"
c*    ut(i1,i2,i3,uc)= -UU(uc)*u0x-UU(vc)*u0y-UX(pc)+nuP*ULAP(uc)+nuTx*(2.*u0x    ) +nuTy*(u0y+v0x)
c*    ut(i1,i2,i3,vc)= -UU(uc)*v0x-UU(vc)*v0y-UY(pc)+nuP*ULAP(vc)+nuTx*(u0y+v0x) +nuTy*(2.*v0y)
c*    ut(i1,i2,i3,kc)= -UU(uc)*k0x-UU(vc)*k0y +prod -U(ec)\
c*              +(nu+sigmaKI*nuT)*ULAP(kc)+sigmaKI*(nuTx*k0x+nuTy*k0y)
c*    ut(i1,i2,i3,ec)= -UU(uc)*e0x-UU(vc)*e0y\
c*      +cEps1*(U(ec)/U(kc))*prod-cEps2*(U(ec)**2/U(kc))+(nu+sigmaEpsI*nuT)*ULAP(ec)+sigmaEpsI*(nuTx*e0x+nuTy*e0y)
c*   #Else
c*    ut(i1,i2,i3,uc)= -UU(uc)*u0x-UU(vc)*u0y-UU(wc)*u0z-UX(pc)+nuP*ULAP(uc)\
c*                     +nuTx*(2.*u0x    ) +nuTy*(u0y+v0x) +nuTz*(u0z+w0x)
c*    ut(i1,i2,i3,vc)= -UU(uc)*v0x-UU(vc)*v0y-UU(wc)*v0z-UY(pc)+nuP*ULAP(vc)\
c*                     +nuTx*(u0y+v0x) +nuTy*(2.*v0y) +nuTz*(v0z+w0y)
c*    ut(i1,i2,i3,wc)= -UU(uc)*w0x-UU(vc)*w0y-UU(wc)*w0z-UZ(pc)+nuP*ULAP(wc)\
c*                     +nuTx*(u0z+w0x) +nuTy*(v0z+w0y) +nuTz*(2.*w0z)
c*    ut(i1,i2,i3,kc)= -UU(uc)*k0x-UU(vc)*k0y-UU(wc)*k0z+prod -U(ec)\
c*                          +(nu+sigmaKI*nuT)*ULAP(kc)+sigmaKI*(nuTx*k0x+nuTy*k0y+nuTz*k0z)
c*    ut(i1,i2,i3,ec)= -UU(uc)*e0x-UU(vc)*e0y-UU(wc)*e0z+cEps1*(U(ec)/U(kc))*prod-cEps2*(U(ec)**2/U(kc))\
c*             +(nu+sigmaEpsI*nuT)*ULAP(ec)+sigmaEpsI*(nuTx*e0x+nuTy*e0y+nuTz*e0z)
c*   #End
c* 
c*  #Elif #OPTION == "INSVP" 
c* 
c*   ! INS Visco-plastic  *** finish this ****
c*   setupDerivatives(DIM)
c*   getViscoPlasticCoefficients(DIM)
c*   #If #DIM == "2"
c*    ut(i1,i2,i3,uc)= -UU(uc)*u0x-UU(vc)*u0y-UX(pc)+nuT*ULAP(uc)+nuTx*(2.*u0x    ) +nuTy*(u0y+v0x)
c*    ut(i1,i2,i3,vc)= -UU(uc)*v0x-UU(vc)*v0y-UY(pc)+nuT*ULAP(vc)+nuTx*(u0y+v0x) +nuTy*(2.*v0y)
c*   #Else
c*    ut(i1,i2,i3,uc)= -UU(uc)*u0x-UU(vc)*u0y-UU(wc)*u0z-UX(pc)+nuT*ULAP(uc)\
c*                     +nuTx*(2.*u0x    ) +nuTy*(u0y+v0x) +nuTz*(u0z+w0x)
c*    ut(i1,i2,i3,vc)= -UU(uc)*v0x-UU(vc)*v0y-UU(wc)*v0z-UY(pc)+nuT*ULAP(vc)\
c*                     +nuTx*(u0y+v0x) +nuTy*(2.*v0y) +nuTz*(v0z+w0y)
c*    ut(i1,i2,i3,wc)= -UU(uc)*w0x-UU(vc)*w0y-UU(wc)*w0z-UZ(pc)+nuT*ULAP(wc)\
c*                     +nuTx*(u0z+w0x) +nuTy*(v0z+w0y) +nuTz*(2.*w0z)
c*   #End
c* 
c*  #End
c* 
c* #Elif #IMPEXP == "EXPLICIT_ONLY" || #IMPEXP == "BOTH"
c*  ! explicit terms only, no diffusion
c*  #If #DIM == "2"
c*   ut(i1,i2,i3,uc)= -UU(uc)*UX(uc)-UU(vc)*UY(uc)-UX(pc)
c*   ut(i1,i2,i3,vc)= -UU(uc)*UX(vc)-UU(vc)*UY(vc)-UY(pc)
c*  #Else
c*   ut(i1,i2,i3,uc)= -UU(uc)*UX(uc)-UU(vc)*UY(uc)-UU(wc)*UZ(uc)-UX(pc)
c*   ut(i1,i2,i3,vc)= -UU(uc)*UX(vc)-UU(vc)*UY(vc)-UU(wc)*UZ(vc)-UY(pc)
c*   ut(i1,i2,i3,wc)= -UU(uc)*UX(wc)-UU(vc)*UY(wc)-UU(wc)*UZ(wc)-UZ(pc)
c*  #End
c* #Else
c*   stop 88
c* 
c* #End
c* 
c* #If #IMPEXP == "BOTH"
c*  ! include implicit terms - diffusion
c*  #If #DIM == "2"
c*   uti(i1,i2,i3,uc)= nu*ULAP(uc)
c*   uti(i1,i2,i3,vc)= nu*ULAP(vc)
c*  #Elif #DIM == "3"
c*   uti(i1,i2,i3,uc)= nu*ULAP(uc)
c*   uti(i1,i2,i3,vc)= nu*ULAP(vc)
c*   uti(i1,i2,i3,wc)= nu*ULAP(wc)
c*  #Else
c*    stop 11
c*  #End
c* 
c*  #If #AXISYMMETRIC == "YES"
c*   ri=radiusInverse(i1,i2,i3)
c*   if( ri.ne.0. )then
c*     uti(i1,i2,i3,uc)=uti(i1,i2,i3,uc)+nu*( UY(uc)*ri )
c*     uti(i1,i2,i3,vc)=uti(i1,i2,i3,vc)+nu*( (UY(vc)-UU(vc)*ri)*ri )
c*   else
c*     uti(i1,i2,i3,uc)=uti(i1,i2,i3,uc)+nu*( UYY(uc) )
c*     uti(i1,i2,i3,vc)=uti(i1,i2,i3,vc)+nu*( .5*UYY(vc) )
c*   end if
c*  #End
c* 
c* #End
c* 
c* 
c* #endMacro 
c* 
c* c***************************************************************
c* c  Define the equations for EXPLICIT time stepping
c* c
c* c SOLVER: INS, INSSPAL, INSBL, INSKE
c* c ORDER: 2,4
c* c DIM: 2,3
c* c GRIDTYPE: rectangular, curvilinear
c* c
c* c***************************************************************
c* #beginMacro fillEquations(SOLVER,DIM,ORDER,GRIDTYPE)
c* 
c* defineDerivativeMacros(DIM,ORDER,GRIDTYPE)
c* 
c* if( isAxisymmetric.eq.0 )then
c* 
c*  if( gridIsImplicit.eq.0 )then
c*   ! explicit
c* 
c*   loopse1($buildEquations(EXPLICIT,SOLVER,NONE,DIM,ORDER,GRIDTYPE,NO))
c* 
c*  else ! gridIsImplicit
c*   ! ***** implicit *******
c* 
c*   if( implicitOption .eq.computeImplicitTermsSeparately )then
c*     loopse1($buildEquations(BOTH,SOLVER,NONE,DIM,ORDER,GRIDTYPE,NO))
c*   else if( implicitOption.eq.doNotComputeImplicitTerms )then
c*     loopse1($buildEquations(EXPLICIT_ONLY,SOLVER,NONE,DIM,ORDER,GRIDTYPE,NO))
c*   else
c*    write(*,*)'insdt: Unknown implicitOption=',implicitOption
c*    stop 5
c*   end if  ! end implicitOption
c* 
c*  end if
c* 
c* else if( isAxisymmetric.eq.1 )then
c* 
c*  #If (#DIM == "2") && (#SOLVER == "INS" || #SOLVER == "INSVD" )
c*  ! **** axisymmetric case ****
c*  if( gridIsImplicit.eq.0 )then
c*   ! explicit
c* 
c*   loopse1($buildEquations(EXPLICIT,SOLVER,NONE,DIM,ORDER,GRIDTYPE,YES))
c* 
c*  else ! gridIsImplicit
c*   ! ***** implicit *******
c* 
c*   if( implicitOption .eq.computeImplicitTermsSeparately )then
c*     loopse1($buildEquations(BOTH,SOLVER,NONE,DIM,ORDER,GRIDTYPE,YES))
c*   else if( implicitOption.eq.doNotComputeImplicitTerms )then
c*     loopse1($buildEquations(EXPLICIT_ONLY,SOLVER,NONE,DIM,ORDER,GRIDTYPE,YES))
c*   else
c*    write(*,*)'insdt: Unknown implicitOption=',implicitOption
c*    stop 5
c*   end if  ! end implicitOption
c* 
c*  end if
c*  #End
c* 
c* else
c*   stop 88733
c* end if 
c* 
c* #endMacro
c* 
c* 
c* c$$$#beginMacro fillByOrder(SOLVER,DIM,GRIDTYPE)
c* c$$$if( orderOfAccuracy.eq.2 )then
c* c$$$ fillEquations(SOLVER,DIM,2,GRIDTYPE)
c* c$$$else if( orderOfAccuracy.eq.4 )then
c* c$$$ fillEquations(SOLVER,DIM,4,GRIDTYPE)
c* c$$$else
c* c$$$ stop 88
c* c$$$end if
c* c$$$#endMacro
c* c$$$
c* c$$$#beginMacro fillByDimension(SOLVER,GRIDTYPE)
c* c$$$if( nd.eq.2 )then
c* c$$$ fillByOrder(SOLVER,2,GRIDTYPE)
c* c$$$else if( nd.eq.3 )then
c* c$$$ fillByOrder(SOLVER,3,GRIDTYPE)
c* c$$$else
c* c$$$ stop 99
c* c$$$end if
c* c$$$#endMacro
c* 
c* c====================================================================================
c* c
c* c SOLVER: INS, INSSPAL, INSBL, INSKE
c* c
c* c====================================================================================
c* #beginMacro assignEquations(SOLVER,DIM,ORDER)
c* if( gridType.eq.rectangular )then
c*  fillEquations(SOLVER,DIM,ORDER,rectangular)
c* else if( gridType.eq.curvilinear )then
c*  fillEquations(SOLVER,DIM,ORDER,curvilinear)
c* else
c*   stop 77
c* end if
c* #endMacro
c* 
c* 
c* 
c================================================================
c  Add on the artificial dissipation
c================================================================
#beginMacro addArtficialDissipation(ADTYPE,DIM,ORDER,GRIDTYPE)

#If #ADTYPE == "AD2" || #ADTYPE == "AD24" || #ADTYPE == "AD4"
#Else
  stop 99
#End

#If #DIM == "2"
 if( turbulenceModel.eq.noTurbulenceModel )then
  defineArtificialDissipationMacro(ADTYPE,DIM,INS)
  loopse4($getArtificialDissipationCoeff(ADTYPE,DIM,INS),\
          ut(i1,i2,i3,uc)=ut(i1,i2,i3,uc) artificialDissipation(uc),\
          ut(i1,i2,i3,vc)=ut(i1,i2,i3,vc) artificialDissipation(vc),)
 else if( turbulenceModel.eq.spalartAllmaras )then
  defineArtificialDissipationMacro(ADTYPE,DIM,SPAL)
  loopse4($getArtificialDissipationCoeff(ADTYPE,DIM,SPAL),\
          ut(i1,i2,i3,uc)=ut(i1,i2,i3,uc) artificialDissipation(uc),\
          ut(i1,i2,i3,vc)=ut(i1,i2,i3,vc) artificialDissipation(vc),\
          ut(i1,i2,i3,nc)=ut(i1,i2,i3,nc) artificialDissipationTM(nc))
 else if( turbulenceModel.eq.kEpsilon )then
  defineArtificialDissipationMacro(ADTYPE,DIM,SPAL)
  loopse6($getArtificialDissipationCoeff(ADTYPE,DIM,SPAL),\
          ut(i1,i2,i3,uc)=ut(i1,i2,i3,uc) artificialDissipation(uc),\
          ut(i1,i2,i3,vc)=ut(i1,i2,i3,vc) artificialDissipation(vc),\
          ut(i1,i2,i3,kc)=ut(i1,i2,i3,kc) artificialDissipationTM(kc),\
          ut(i1,i2,i3,ec)=ut(i1,i2,i3,ec) artificialDissipationTM(ec),)
 else
   stop 44
 end if

#Elif #DIM == "3"

 if( turbulenceModel.eq.noTurbulenceModel )then
  defineArtificialDissipationMacro(ADTYPE,DIM,INS)
  loopse4($getArtificialDissipationCoeff(ADTYPE,DIM,INS),\
          ut(i1,i2,i3,uc)=ut(i1,i2,i3,uc) artificialDissipation(uc),\
          ut(i1,i2,i3,vc)=ut(i1,i2,i3,vc) artificialDissipation(vc),\
          ut(i1,i2,i3,wc)=ut(i1,i2,i3,wc) artificialDissipation(wc))
 else if( turbulenceModel.eq.spalartAllmaras )then
  defineArtificialDissipationMacro(ADTYPE,DIM,SPAL)
  loopse6($getArtificialDissipationCoeff(ADTYPE,DIM,SPAL),\
          ut(i1,i2,i3,uc)=ut(i1,i2,i3,uc) artificialDissipation(uc),\
          ut(i1,i2,i3,vc)=ut(i1,i2,i3,vc) artificialDissipation(vc),\
          ut(i1,i2,i3,wc)=ut(i1,i2,i3,wc) artificialDissipation(wc),\
          ut(i1,i2,i3,nc)=ut(i1,i2,i3,nc) artificialDissipationTM(nc),)
 else if( turbulenceModel.eq.kEpsilon )then
  defineArtificialDissipationMacro(ADTYPE,DIM,SPAL)
  loopse6($getArtificialDissipationCoeff(ADTYPE,DIM,SPAL),\
          ut(i1,i2,i3,uc)=ut(i1,i2,i3,uc) artificialDissipation(uc),\
          ut(i1,i2,i3,vc)=ut(i1,i2,i3,vc) artificialDissipation(vc),\
          ut(i1,i2,i3,wc)=ut(i1,i2,i3,wc) artificialDissipation(wc),\
          ut(i1,i2,i3,kc)=ut(i1,i2,i3,kc) artificialDissipationTM(kc),\
          ut(i1,i2,i3,ec)=ut(i1,i2,i3,ec) artificialDissipationTM(ec))
 else
   stop 44
 end if


#Else
  stop 1234

#End

#endMacro

#beginMacro addDissipationByADType( DIM,ORDER,GRIDTYPE )

 ! NOTE: we always use second derivatives for the coefficient:
 defineDerivativeMacros(DIM,2,GRIDTYPE)

  if( use2ndOrderAD.eq.1 .and. use4thOrderAD.eq.0 )then
    addArtficialDissipation(AD2,DIM,ORDER,GRIDTYPE)
  else if( use2ndOrderAD.eq.0 .and. use4thOrderAD.eq.1 )then
    addArtficialDissipation(AD4,DIM,ORDER,GRIDTYPE)
  else if( use2ndOrderAD.eq.1 .and. use4thOrderAD.eq.1 )then
    addArtficialDissipation(AD24,DIM,ORDER,GRIDTYPE)
  else
    stop 7
  end if

#endMacro

#beginMacro addDissipationByOrder( DIM,GRIDTYPE )
  if( orderOfAccuracy.eq.2 )then
    addDissipationByADType( DIM,2,GRIDTYPE )
  else if( orderOfAccuracy.eq.4 )then
    addDissipationByADType( DIM,4,GRIDTYPE )
  else
    stop 66
  end if
#endMacro

#beginMacro addDissipationByDimension( GRIDTYPE )
  if( nd.eq.2 )then
    addDissipationByOrder( 2,GRIDTYPE )
  else if( nd.eq.3 )then
    addDissipationByOrder( 3,GRIDTYPE )
  else
    stop 66
  end if
#endMacro
c* 
c* c======================================================================================
c* c Define the subroutine to compute du/dt
c* c
c* c SOLVER: INS, INSSPAL, INSBL, INSKE
c* c
c* c======================================================================================
c* #beginMacro INSDT(SOLVER,NAME,DIM,ORDER)
c*  subroutine NAME(nd,n1a,n1b,n2a,n2b,n3a,n3b,nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,nd4a,nd4b,\
c*          mask,xy,rsxy,radiusInverse,  u,uu, ut,uti,gv,dw,  bc, ipar, rpar, ierr )
c* c======================================================================
c* c   Compute du/dt for the incompressible NS on rectangular grids
c* c     OPTIMIZED version for rectangular grids.
c* c nd : number of space dimensions
c* c
c* c gv : gridVelocity for moving grids
c* c uu : for moving grids uu is a workspace to hold u-gv, otherwise uu==u
c* c dw : distance to the wall for some turbulence models
c* c======================================================================
c*  implicit none
c*  integer nd, n1a,n1b,n2a,n2b,n3a,n3b,nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,nd4a,nd4b
c* 
c*  real u(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
c*  real uu(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
c*  real ut(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
c*  real uti(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
c*  real gv(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,0:nd-1)
c*  real dw(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
c*  real xy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,0:nd-1)
c*  real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,0:nd-1,0:nd-1)
c*  real radiusInverse(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
c* 
c*  integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
c*  integer bc(0:1,0:2),ierr
c* 
c*  integer ipar(0:*)
c*  real rpar(0:*)
c*  
c*  !     ---- local variables -----
c*  integer c,i1,i2,i3,kd,kd3,orderOfAccuracy,gridIsMoving,useWhereMask
c*  integer gridIsImplicit,implicitOption,implicitMethod,isAxisymmetric,use2ndOrderAD,use4thOrderAD
c*  integer rc,pc,uc,vc,wc,sc,nc,kc,ec,tc,grid,m,advectPassiveScalar,vsc
c*  real nu,dt,nuPassiveScalar,adcPassiveScalar
c*  real dxi,dyi,dzi,dri,dsi,dti,dr2i,ds2i,dt2i
c*  real ad21,ad22,ad41,ad42,cd22,cd42,adc
c*  real ad21n,ad22n,ad41n,ad42n,cd22n,cd42n
c*  real yy,ri
c* 
c*  integer gridType
c*  integer rectangular,curvilinear
c*  parameter( rectangular=0, curvilinear=1 )
c* 
c*  integer turbulenceModel,noTurbulenceModel
c*  integer baldwinLomax,spalartAllmaras,kEpsilon,kOmega
c*  parameter (noTurbulenceModel=0,baldwinLomax=1,kEpsilon=2,kOmega=3,spalartAllmaras=4 )
c* 
c*  integer pdeModel,standardModel,BoussinesqModel,viscoPlasticModel,variableDensityModel
c*  parameter( standardModel=0,BoussinesqModel=1,viscoPlasticModel=2,variableDensityModel=3 )
c* 
c*  integer computeAllTerms,\
c*      doNotComputeImplicitTerms,\
c*      computeImplicitTermsSeparately,\
c*      computeAllWithWeightedImplicit
c* 
c*  parameter( computeAllTerms=0,\
c*            doNotComputeImplicitTerms=1,\
c*            computeImplicitTermsSeparately=2,\
c*            computeAllWithWeightedImplicit=3 )
c* 
c*  real rx,ry,rz,sx,sy,sz,tx,ty,tz
c*  real dr(0:2), dx(0:2)
c* 
c*  ! for SPAL TM
c*  real n0,n0x,n0y,n0z
c*  real cb1, cb2, cv1, sigma, sigmai, kappa, cw1, cw2, cw3, cw3e6, cv1e3, cd0, cr0
c*  real chi,chi3,fnu1,fnu2,s,r,g,fw,dKappaSq,nSqBydSq,dd
c*  real nuT,nuTx,nuTy,nuTz,nuTd
c* 
c*  real u0,u0x,u0y,u0z
c*  real v0,v0x,v0y,v0z
c*  real w0,w0x,w0y,w0z
c*  ! for k-epsilon
c*  real k0,k0x,k0y,k0z, e0,e0x,e0y,e0z
c*  real nuP,prod
c*  real cMu,cEps1,cEps2,sigmaEpsI,sigmaKI
c* 
c*  ! for visco-plastic
c*  ! real nuVP,etaVP,yieldStressVP,exponentVP,epsVP
c*  ! real eDotNorm,exp0
c*  ! real u0xx,u0xy,u0xz,u0yy,u0yz,u0zz
c*  ! real v0xx,v0xy,v0xz,v0yy,v0yz,v0zz
c*  ! real w0xx,w0xy,w0xz,w0yy,w0yz,w0zz
c* 
c*  real delta22,delta23,delta42,delta43
c* 
c* #If #ORDER == "2"
c*  declareDifferenceOrder2(u,RX)
c* #End
c* #If #ORDER == "4"
c*  declareDifferenceOrder4(u,RX)
c* #End
c*  !  --- begin statement functions
c*  rx(i1,i2,i3)=rsxy(i1,i2,i3,0,0)
c*  ry(i1,i2,i3)=rsxy(i1,i2,i3,0,1)
c*  rz(i1,i2,i3)=rsxy(i1,i2,i3,0,2)
c*  sx(i1,i2,i3)=rsxy(i1,i2,i3,1,0)
c*  sy(i1,i2,i3)=rsxy(i1,i2,i3,1,1)
c*  sz(i1,i2,i3)=rsxy(i1,i2,i3,1,2)
c*  tx(i1,i2,i3)=rsxy(i1,i2,i3,2,0)
c*  ty(i1,i2,i3)=rsxy(i1,i2,i3,2,1)
c*  tz(i1,i2,i3)=rsxy(i1,i2,i3,2,2)
c* 
c* c     The next macro call will define the difference approximation statement functions
c* #If #ORDER == "2"
c*  defineDifferenceOrder2Components1(u,RX)
c* #End
c* #If #ORDER == "4"
c*  defineDifferenceOrder4Components1(u,RX)
c* #End
c* 
c* c    --- For 2nd order 2D artificial diffusion ---
c*  delta22(c)=    (u(i1+1,i2,i3,c)-4.*u(i1,i2,i3,c)+u(i1-1,i2,i3,c)  \
c*                 +u(i1,i2+1,i3,c)                 +u(i1,i2-1,i3,c))
c* c    --- For 2nd order 3D artificial diffusion ---
c*  delta23(c)= \
c*    (u(i1+1,i2,i3,c)-6.*u(i1,i2,i3,c)+u(i1-1,i2,i3,c)   \
c*    +u(i1,i2+1,i3,c)                   +u(i1,i2-1,i3,c)  \
c*    +u(i1,i2,i3+1,c)                   +u(i1,i2,i3-1,c)) 
c* c     ---For fourth-order artificial diffusion in 2D
c*  delta42(c)= \
c*    (   -u(i1+2,i2,i3,c)-u(i1-2,i2,i3,c)   \
c*        -u(i1,i2+2,i3,c)-u(i1,i2-2,i3,c)   \
c*    +4.*(u(i1+1,i2,i3,c)+u(i1-1,i2,i3,c)   \
c*        +u(i1,i2+1,i3,c)+u(i1,i2-1,i3,c))  \
c*     -12.*u(i1,i2,i3,c) ) 
c* c     ---For fourth-order artificial diffusion in 3D
c*  delta43(c)= \
c*    (   -u(i1+2,i2,i3,c)-u(i1-2,i2,i3,c)  \
c*        -u(i1,i2+2,i3,c)-u(i1,i2-2,i3,c)  \
c*        -u(i1,i2,i3+2,c)-u(i1,i2,i3-2,c)  \
c*    +4.*(u(i1+1,i2,i3,c)+u(i1-1,i2,i3,c)  \
c*        +u(i1,i2+1,i3,c)+u(i1,i2-1,i3,c)  \
c*        +u(i1,i2,i3+1,c)+u(i1,i2,i3-1,c)) \
c*     -18.*u(i1,i2,i3,c) )
c* 
c* c     --- end statement functions
c* 
c*  ierr=0
c*  ! write(*,'("Inside insdt: gridType=",i2)') gridType
c* 
c*  pc                 =ipar(0)
c*  uc                 =ipar(1)
c*  vc                 =ipar(2)
c*  wc                 =ipar(3)
c*  nc                 =ipar(4)
c*  sc                 =ipar(5)
c*  tc                 =ipar(6)  ! **new**
c*  grid               =ipar(7)
c*  orderOfAccuracy    =ipar(8)
c*  gridIsMoving       =ipar(9)
c*  useWhereMask       =ipar(10)
c*  gridIsImplicit     =ipar(11)
c*  implicitMethod     =ipar(12)
c*  implicitOption     =ipar(13)
c*  isAxisymmetric     =ipar(14)
c*  use2ndOrderAD      =ipar(15)
c*  use4thOrderAD      =ipar(16)
c*  advectPassiveScalar=ipar(17)
c*  gridType           =ipar(18)
c*  turbulenceModel    =ipar(19)
c*  pdeModel           =ipar(20)
c*  vsc                =ipar(21)
c*  rc                 =ipar(22)
c* 
c*  dr(0)             =rpar(0)
c*  dr(1)             =rpar(1)
c*  dr(2)             =rpar(2)
c*  dx(0)             =rpar(3)
c*  dx(1)             =rpar(4)
c*  dx(2)             =rpar(5)
c*  nu                =rpar(6)
c*  ad21              =rpar(7)
c*  ad22              =rpar(8)
c*  ad41              =rpar(9)
c*  ad42              =rpar(10)
c*  nuPassiveScalar   =rpar(11)
c*  adcPassiveScalar  =rpar(12)
c*  ad21n             =rpar(13)
c*  ad22n             =rpar(14)
c*  ad41n             =rpar(15)
c*  ad42n             =rpar(16)
c* 
c*  ! nuVP              =rpar(24)  ! for visco-plastic
c*  ! etaVP             =rpar(25)
c*  ! yieldStressVP     =rpar(26)
c*  ! exponentVP        =rpar(27)
c*  ! epsVP             =rpar(28)
c* 
c* ! write(*,'(" insdt: eta,yield,exp,eps=",4e10.2)') etaVP,yieldStressVP,exponentVP,epsVP
c* 
c*  kc=nc
c*  ec=kc+1
c* 
c*  if( orderOfAccuracy.ne.2 .and. orderOfAccuracy.ne.4 )then
c*    write(*,'("insdt:ERROR orderOfAccuracy=",i6)') orderOfAccuracy
c*    stop 1
c*  end if
c*  if( gridType.ne.rectangular .and. gridType.ne.curvilinear )then
c*    write(*,'("insdt:ERROR gridType=",i6)') gridType
c*    stop 2
c*  end if
c*  if( uc.lt.0 .or. vc.lt.0 .or. (nd.eq.3 .and. wc.lt.0) )then
c*    write(*,'("insdt:ERROR uc,vc,ws=",3i6)') uc,vc,wc
c*    stop 4
c*  end if
c* 
c* c      write(*,'("insdt: turbulenceModel=",2i6)') turbulenceModel
c* c      write(*,'("insdt: nd,uc,vc,wc,kc=",2i6)') nd,uc,vc,wc,kc
c* 
c*  if( turbulenceModel.eq.kEpsilon .and. (kc.lt.uc+nd .or. kc.gt.1000) )then
c*    write(*,'("insdt:ERROR in kc: nd,uc,vc,wc,kc=",2i6)') nd,uc,vc,wc,kc
c*    stop 5
c*  end if
c* 
c* 
c* c ** these are needed by self-adjoint terms **fix**
c*  dxi=1./dx(0)
c*  dyi=1./dx(1)
c*  dzi=1./dx(2)
c*  dri=1./dr(0)
c*  dsi=1./dr(1)
c*  dti=1./dr(2)
c*  dr2i=1./(2.*dr(0))
c*  ds2i=1./(2.*dr(1))
c*  dt2i=1./(2.*dr(2))
c* 
c*  if( turbulenceModel.eq.spalartAllmaras )then
c*    call getSpalartAllmarasParameters(cb1, cb2, cv1, sigma, sigmai, kappa, cw1, cw2, cw3, cw3e6, \
c*       cv1e3, cd0, cr0)
c*  else if( turbulenceModel.eq.kEpsilon )then
c* 
c*   ! write(*,'(" insdt: k-epsilon: nc,kc,ec=",3i3)') nc,kc,ec
c* 
c*    call getKEpsilonParameters( cMu,cEps1,cEps2,sigmaEpsI,sigmaKI )
c*    !  write(*,'(" insdt: cMu,cEps1,cEps2,sigmaEpsI,sigmaKI=",5f8.3)') cMu,cEps1,cEps2,sigmaEpsI,sigmaKI
c* 
c*  else if( turbulenceModel.ne.noTurbulenceModel )then
c*    stop 88
c*  end if
c* 
c*  adc=adcPassiveScalar ! coefficient of linear artificial diffusion
c*  cd22=ad22/(nd**2)
c*  cd42=ad42/(nd**2)
c* 
c* c     *********************************      
c* c     ********MAIN LOOPS***************      
c* c     *********************************      
c*  assignEquations(SOLVER,DIM,ORDER)
c* 
c*  return
c*  end
c* #endMacro
c* 
c* c 
c* c : empty version for linking when we don't want an option
c* c
c* #beginMacro INSDT_NULL(SOLVER,NAME,DIM,ORDER)
c*  subroutine NAME(nd,n1a,n1b,n2a,n2b,n3a,n3b,nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,nd4a,nd4b,\
c*          mask,xy,rsxy,radiusInverse,  u,uu, ut,uti,gv,dw,  bc, ipar, rpar, ierr )
c* c======================================================================
c* c       EMPTY VERSION for Linking without this Capability
c* c
c* c   Compute du/dt for the incompressible NS on rectangular grids
c* c     OPTIMIZED version for rectangular grids.
c* c nd : number of space dimensions
c* c
c* c gv : gridVelocity for moving grids
c* c uu : for moving grids uu is a workspace to hold u-gv, otherwise uu==u
c* c dw : distance to the wall for some turbulence models
c* c======================================================================
c*  implicit none
c*  integer nd, n1a,n1b,n2a,n2b,n3a,n3b,nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,nd4a,nd4b
c* 
c*  real u(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
c*  real uu(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
c*  real ut(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
c*  real uti(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
c*  real gv(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,0:nd-1)
c*  real dw(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
c*  real xy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,0:nd-1)
c*  real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,0:nd-1,0:nd-1)
c*  real radiusInverse(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
c* 
c*  integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
c*  integer bc(0:1,0:2),ierr
c* 
c*  integer ipar(0:*)
c*  real rpar(0:*)
c* 
c*  write(*,'("ERROR: NULL version of subroutine NAME called")')
c*  write(*,'(" You may have to turn on an option in the Makefile.")')
c*  ! ' 
c*  stop 1080
c* 
c*  return
c*  end
c* #endMacro
c* 
c* 
c* #beginMacro buildFile(SOLVER,NAME,DIM,ORDER)
c* #beginFile src/NAME.f
c*  INSDT(SOLVER,NAME,DIM,ORDER)
c* #endFile
c* #beginFile src/NAME ## Null.f
c*  INSDT_NULL(SOLVER,NAME,DIM,ORDER)
c* #endFile
c* #endMacro
c* 
c* ct:  temporarily turn off the building of these files 
c* ct:      buildFile(INS,insdtINS2dOrder2,2,2)
c* ct:      buildFile(INS,insdtINS2dOrder4,2,4)
c* ct:      buildFile(INS,insdtINS3dOrder2,3,2)
c* ct:      buildFile(INS,insdtINS3dOrder4,3,4)
c* ct:
c* ct:      buildFile(INSSPAL,insdtSPAL2dOrder2,2,2)
c* ct:      buildFile(INSSPAL,insdtSPAL2dOrder4,2,4)
c* ct:      buildFile(INSSPAL,insdtSPAL3dOrder2,3,2)
c* ct:      buildFile(INSSPAL,insdtSPAL3dOrder4,3,4)
c* ct:
c* ct:      buildFile(INSKE,insdtKE2dOrder2,2,2)
c* ct:      buildFile(INSKE,insdtKE2dOrder4,2,4)
c* ct:      buildFile(INSKE,insdtKE3dOrder2,3,2)
c* ct:      buildFile(INSKE,insdtKE3dOrder4,3,4)
c* ct:
c* ct:      ! Visco-plastic case
c* ct:      buildFile(INSVP,insdtVP2dOrder2,2,2)
c* ct:      buildFile(INSVP,insdtVP3dOrder2,3,2)
c* ct:
c* ct:      ! Variable density
c* ct:      buildFile(INSVD,insdtVD2dOrder2,2,2)
c* ct:      buildFile(INSVD,insdtVD3dOrder2,3,2)
c* 

c ====================================================
c SOLVER: INS, SPAL, KE
c ====================================================
#beginMacro insdtFunctions(SOLVER)
 if( orderOfAccuracy.eq.2 )then
  if( nd.eq.2 )then
    call insdt ## SOLVER ## 2dOrder2(nd,n1a,n1b,n2a,n2b,n3a,n3b,nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,nd4a,nd4b,\
           mask,xy,rsxy,radiusInverse,  u,uu, ut,uti,gv,dw,  bc, ipar, rpar, ierr )
  else 
    call insdt ## SOLVER ## 3dOrder2(nd,n1a,n1b,n2a,n2b,n3a,n3b,nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,nd4a,nd4b,\
           mask,xy,rsxy,radiusInverse,  u,uu, ut,uti,gv,dw,  bc, ipar, rpar, ierr )
  end if
#If #SOLVER ne "VP" && #SOLVER ne "VD"
 else if( orderOfAccuracy.eq.4 )then
  if( nd.eq.2 )then
    call insdt ## SOLVER ## 2dOrder4(nd,n1a,n1b,n2a,n2b,n3a,n3b,nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,nd4a,nd4b,\
           mask,xy,rsxy,radiusInverse,  u,uu, ut,uti,gv,dw,  bc, ipar, rpar, ierr )
  else 
    call insdt ## SOLVER ## 3dOrder4(nd,n1a,n1b,n2a,n2b,n3a,n3b,nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,nd4a,nd4b,\
           mask,xy,rsxy,radiusInverse,  u,uu, ut,uti,gv,dw,  bc, ipar, rpar, ierr )
  end if
#End
 else
   stop 1111
 end if
#endMacro


c ==========================================================
c  Advect a passive scalar -- kernel
c ==========================================================
#beginMacro passiveScalarKernel(DIM,ORDER,GRIDTYPE)

 defineDerivativeMacros(DIM,ORDER,GRIDTYPE)

 do i3=n3a,n3b
 do i2=n2a,n2b
 do i1=n1a,n1b
  if( mask(i1,i2,i3).gt.0 )then

  #If #DIM == "2"
   #If #ORDER == "2"
    ut(i1,i2,i3,sc)= -UU(uc)*UX(sc)-UU(vc)*UY(sc)+nuPassiveScalar*ULAP(sc)+adcPassiveScalar*delta2 ## DIM(sc)
   #Else
    ut(i1,i2,i3,sc)= -UU(uc)*UX(sc)-UU(vc)*UY(sc)+nuPassiveScalar*ULAP(sc)+adcPassiveScalar*delta4 ## DIM(sc)
   #End
  #Else
   #If #ORDER == "2"
    ut(i1,i2,i3,sc)= -UU(uc)*UX(sc)-UU(vc)*UY(sc)-UU(wc)*UZ(sc)+nuPassiveScalar*ULAP(sc)\
                      +adcPassiveScalar*delta2 ## DIM(sc)
   #Else
    ut(i1,i2,i3,sc)= -UU(uc)*UX(sc)-UU(vc)*UY(sc)-UU(wc)*UZ(sc)+nuPassiveScalar*ULAP(sc)\
                      +adcPassiveScalar*delta4 ## DIM(sc)
   #End
  #End

  end if
 end do
 end do
 end do

#endMacro

c ==============================================================
c  Advect a passive scalar -- build loops for different cases:
c     DIM,ORDER,GRIDTYPE
c ==============================================================
#beginMacro passiveScalarMacro()

 if( gridType.eq.rectangular )then
  if( orderOfAccuracy.eq.2 )then
    if( nd.eq.2 )then
      passiveScalarKernel(2,2,rectangular)
    else 
      passiveScalarKernel(3,2,rectangular)
    end if
  else if( orderOfAccuracy.eq.4 )then
    if( nd.eq.2 )then
      passiveScalarKernel(2,4,rectangular)
    else 
      passiveScalarKernel(3,4,rectangular)
    end if
  else
   stop 1281
  end if

 else if( gridType.eq.curvilinear )then

  if( orderOfAccuracy.eq.2 )then
    if( nd.eq.2 )then
      passiveScalarKernel(2,2,curvilinear)
    else 
      passiveScalarKernel(3,2,curvilinear)
    end if
  else if( orderOfAccuracy.eq.4 )then
    if( nd.eq.2 )then
      passiveScalarKernel(2,4,curvilinear)
    else 
      passiveScalarKernel(3,4,curvilinear)
    end if
  else
   stop 1282
  end if

 else
   stop 1717
 end if

#endMacro


c ==========================================================
c  Boussinseq approximation -- kernel
c
c IMPEXP: EXPLICIT, EXPLICIT_ONLY, BOTH
c ==========================================================
#beginMacro boussinesqKernel(DIM,ORDER,GRIDTYPE,IMPEXP)

 defineDerivativeMacros(DIM,ORDER,GRIDTYPE)

 do i3=n3a,n3b
 do i2=n2a,n2b
 do i1=n1a,n1b
  if( mask(i1,i2,i3).gt.0 )then
    ! add on gravity terms to the momentum equations:
    ut(i1,i2,i3,uc)=ut(i1,i2,i3,uc)-gravity(0)*thermalExpansivity*u(i1,i2,i3,tc)
    ut(i1,i2,i3,vc)=ut(i1,i2,i3,vc)-gravity(1)*thermalExpansivity*u(i1,i2,i3,tc)
    #If #DIM == "3" 
      ut(i1,i2,i3,wc)=ut(i1,i2,i3,wc)-gravity(2)*thermalExpansivity*u(i1,i2,i3,tc)
    #End

#If #IMPEXP == "EXPLICIT"

  #If #DIM == "2"
    ut(i1,i2,i3,tc)= -UU(uc)*UX(tc)-UU(vc)*UY(tc)+kThermal*ULAP(tc)+adcBoussinesq*delta ## ORDER DIM(tc)
  #Else
    ut(i1,i2,i3,tc)= -UU(uc)*UX(tc)-UU(vc)*UY(tc)-UU(wc)*UZ(tc)+kThermal*ULAP(tc)+adcBoussinesq*delta ## ORDER DIM(tc)
  #End

  if( isAxisymmetric.eq.1 )then
    ! -- add on axisymmetric corrections ---
    ri=radiusInverse(i1,i2,i3)
    if( ri.ne.0. )then
      ut(i1,i2,i3,tc)=ut(i1,i2,i3,tc)+kThermal*( UY(tc)*ri )
    else
      ut(i1,i2,i3,tc)=ut(i1,i2,i3,tc)+kThermal*( UYY(tc) )
    end if  
  end if

#Elif #IMPEXP == "EXPLICIT_ONLY" || #IMPEXP == "BOTH"

  #If #DIM == "2"
    ut(i1,i2,i3,tc)= -UU(uc)*UX(tc)-UU(vc)*UY(tc)+adcBoussinesq*delta ## ORDER DIM(tc)
  #Else
    ut(i1,i2,i3,tc)= -UU(uc)*UX(tc)-UU(vc)*UY(tc)-UU(wc)*UZ(tc)+adcBoussinesq*delta ## ORDER DIM(tc)
  #End

#End
#If #IMPEXP == "BOTH"
 ! include implicit terms - diffusion
 uti(i1,i2,i3,tc)= kThermal*ULAP(tc)
 if( isAxisymmetric.eq.1 )then
   ri=radiusInverse(i1,i2,i3)
   if( ri.ne.0. )then
     uti(i1,i2,i3,tc)=uti(i1,i2,i3,tc)+kThermal*( UY(tc)*ri )
   else
     uti(i1,i2,i3,tc)=uti(i1,i2,i3,tc)+kThermal*( UYY(tc) )
   end if
 end if
#End

  end if
 end do
 end do
 end do

#endMacro

c ==============================================================
c  Boussinesq Model -- build loops for different cases
c
c IMPEXP: EXPLICIT, EXPLICIT_ONLY, BOTH
c
c ==============================================================
#beginMacro boussinesqLoopsMacro(IMPEXP)

 if( gridType.eq.rectangular )then
  if( orderOfAccuracy.eq.2 )then
    if( nd.eq.2 )then
      boussinesqKernel(2,2,rectangular,IMPEXP)
    else 
      boussinesqKernel(3,2,rectangular,IMPEXP)
    end if
  else if( orderOfAccuracy.eq.4 )then
    if( nd.eq.2 )then
      boussinesqKernel(2,4,rectangular,IMPEXP)
    else 
      boussinesqKernel(3,4,rectangular,IMPEXP)
    end if
  else
   stop 2281
  end if

 else if( gridType.eq.curvilinear )then

  if( orderOfAccuracy.eq.2 )then
    if( nd.eq.2 )then
      boussinesqKernel(2,2,curvilinear,IMPEXP)
    else 
      boussinesqKernel(3,2,curvilinear,IMPEXP)
    end if
  else if( orderOfAccuracy.eq.4 )then
    if( nd.eq.2 )then
      boussinesqKernel(2,4,curvilinear,IMPEXP)
    else 
      boussinesqKernel(3,4,curvilinear,IMPEXP)
    end if
  else
   stop 2282
  end if

 else
   stop 2717
 end if

#endMacro


c ==============================================================
c  Boussinesq Model -- add on gravity terms, eval T equation
c
c ==============================================================
#beginMacro boussinesqMacro()
 if( gridIsImplicit.eq.0 )then ! explicit
  boussinesqLoopsMacro(EXPLICIT)
 else ! ***** implicit *******
  if( implicitOption .eq.computeImplicitTermsSeparately )then
    boussinesqLoopsMacro(BOTH)
  else if( implicitOption.eq.doNotComputeImplicitTerms )then
    boussinesqLoopsMacro(EXPLICIT_ONLY)
  else
   write(*,*)'insdt:boussinesq Unknown implicitOption=',implicitOption
   stop 4135
  end if  ! end implicitOption

 end if
#endMacro



      subroutine insdt(nd,n1a,n1b,n2a,n2b,n3a,n3b,nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,nd4a,nd4b,\
                       mask,xy,rsxy,radiusInverse,  u,uu, ut,uti,gv,dw,  bc, ipar, rpar, ierr )
c======================================================================
c   Compute du/dt for the incompressible NS on rectangular grids
c     OPTIMIZED version for rectangular grids.
c nd : number of space dimensions
c
c gv : gridVelocity for moving grids
c uu : for moving grids uu is a workspace to hold u-gv, otherwise uu==u
c dw : distance to the wall for some turbulence models
c======================================================================
      implicit none
      integer nd, n1a,n1b,n2a,n2b,n3a,n3b,
     & nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,nd4a,nd4b

      real u(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
      real uu(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
      real ut(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
      real uti(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
      real gv(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,0:nd-1)
      real dw(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real xy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,0:nd-1)
      real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,0:nd-1,0:nd-1)
      real radiusInverse(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)

      integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      integer bc(0:1,0:2),ierr

      integer ipar(0:*)
      real rpar(0:*)
      
c     ---- local variables -----
      integer c,i1,i2,i3,kd,kd3,orderOfAccuracy,gridIsMoving,useWhereMask
      integer gridIsImplicit,implicitOption,implicitMethod,
     & isAxisymmetric,use2ndOrderAD,use4thOrderAD
      integer pc,uc,vc,wc,sc,nc,kc,ec,tc,grid,m,advectPassiveScalar
      real nu,dt,nuPassiveScalar,adcPassiveScalar
      real gravity(0:2), thermalExpansivity, adcBoussinesq,kThermal
      real dxi,dyi,dzi,dri,dsi,dti,dr2i,ds2i,dt2i
      real ad21,ad22,ad41,ad42,cd22,cd42,adc
      real ad21n,ad22n,ad41n,ad42n,cd22n,cd42n
      real yy,ri

      integer gridType
      integer rectangular,curvilinear
      parameter( rectangular=0, curvilinear=1 )

      integer turbulenceModel,noTurbulenceModel
      integer baldwinLomax,spalartAllmaras,kEpsilon,kOmega
      parameter (noTurbulenceModel=0,baldwinLomax=1,kEpsilon=2,kOmega=3,spalartAllmaras=4 )

      integer computeAllTerms,
     &     doNotComputeImplicitTerms,
     &     computeImplicitTermsSeparately,
     &     computeAllWithWeightedImplicit

      parameter( computeAllTerms=0,
     &           doNotComputeImplicitTerms=1,
     &           computeImplicitTermsSeparately=2,
     &           computeAllWithWeightedImplicit=3 )

      integer pdeModel,standardModel,BoussinesqModel,viscoPlasticModel,twoPhaseFlowModel
      parameter( standardModel=0,BoussinesqModel=1,viscoPlasticModel=2,twoPhaseFlowModel=3 )

      real cdmz,cdpz,cdzm,cdzp,cdmzz,cdpzz,cdzmz,cdzpz,cdzzm,cdzzp,cdDiag,cdm,cdp
      real uxmzzR,uymzzR,uzmzzR,uxzmzR,uyzmzR,uzzmzR,uxzzmR,uyzzmR,uzzzmR
      real udmzC,udzmC,udmzzC,udzmzC,udzzmC
      real admzR,adzmR,admzzR,adzmzR,adzzmR
      real admzC,adzmC,admzzC,adzmzC,adzzmC
      real admzRSA,adzmRSA,admzzRSA,adzmzRSA,adzzmRSA
      real admzCSA,adzmCSA,admzzCSA,adzmzCSA,adzzmCSA
      real adE0,adE1,ade2,adE3d0,adE3d1,adE3d2,ad2f,ad3f

      real delta22,delta23,delta42,delta43

      real adCoeff2,adCoeff4

      real ad2,ad23,ad4,ad43
      real adSelfAdjoint2dR,adSelfAdjoint3dR,adSelfAdjoint2dC,adSelfAdjoint3dC
      real adSelfAdjoint2dRSA,adSelfAdjoint3dRSA,adSelfAdjoint2dCSA,adSelfAdjoint3dCSA

      real rx,ry,rz,sx,sy,sz,tx,ty,tz
      real dr(0:2), dx(0:2)

      ! for SPAL TM
      real n0,n0x,n0y,n0z
      real cb1, cb2, cv1, sigma, sigmai, kappa, cw1, cw2, cw3, cw3e6, cv1e3, cd0, cr0
      real chi,chi3,fnu1,fnu2,s,r,g,fw,dKappaSq,nSqBydSq,dd
      real nuT,nuTx,nuTy,nuTz,nuTd

      real u0,u0x,u0y,u0z
      real v0,v0x,v0y,v0z
      real w0,w0x,w0y,w0z
      ! for k-epsilon
      real k0,k0x,k0y,k0z, e0,e0x,e0y,e0z
      real nuP,prod
      real cMu,cEps1,cEps2,sigmaEpsI,sigmaKI


      ! include 'declareDiffOrder2f.h'
      ! include 'declareDiffOrder4f.h'

      declareDifferenceOrder2(u,RX)
      declareDifferenceOrder4(u,RX)

c     --- begin statement functions
      rx(i1,i2,i3)=rsxy(i1,i2,i3,0,0)
      ry(i1,i2,i3)=rsxy(i1,i2,i3,0,1)
      rz(i1,i2,i3)=rsxy(i1,i2,i3,0,2)
      sx(i1,i2,i3)=rsxy(i1,i2,i3,1,0)
      sy(i1,i2,i3)=rsxy(i1,i2,i3,1,1)
      sz(i1,i2,i3)=rsxy(i1,i2,i3,1,2)
      tx(i1,i2,i3)=rsxy(i1,i2,i3,2,0)
      ty(i1,i2,i3)=rsxy(i1,i2,i3,2,1)
      tz(i1,i2,i3)=rsxy(i1,i2,i3,2,2)

c     The next macro call will define the difference approximation statement functions
      defineDifferenceOrder2Components1(u,RX)
      defineDifferenceOrder4Components1(u,RX)


c    --- 2nd order 2D artificial diffusion ---
      ad2(c)=adc*(u(i1+1,i2,i3,c)-4.*u(i1,i2,i3,c)+u(i1-1,i2,i3,c)  
     &           +u(i1,i2+1,i3,c)                 +u(i1,i2-1,i3,c))

c    --- 2nd order 3D artificial diffusion ---
      ad23(c)=adc
     &    *(u(i1+1,i2,i3,c)-6.*u(i1,i2,i3,c)+u(i1-1,i2,i3,c)  
     &     +u(i1,i2+1,i3,c)                   +u(i1,i2-1,i3,c) 
     &     +u(i1,i2,i3+1,c)                   +u(i1,i2,i3-1,c))
                       
c     ---fourth-order artificial diffusion in 2D
      ad4(c)=adc
     &    *(   -u(i1+2,i2,i3,c)-u(i1-2,i2,i3,c)    
     &         -u(i1,i2+2,i3,c)-u(i1,i2-2,i3,c)    
     &     +4.*(u(i1+1,i2,i3,c)+u(i1-1,i2,i3,c)    
     &         +u(i1,i2+1,i3,c)+u(i1,i2-1,i3,c))   
     &      -12.*u(i1,i2,i3,c) ) 
c     ---fourth-order artificial diffusion in 3D
      ad43(c)=adc
     &    *(   -u(i1+2,i2,i3,c)-u(i1-2,i2,i3,c)   
     &         -u(i1,i2+2,i3,c)-u(i1,i2-2,i3,c)   
     &         -u(i1,i2,i3+2,c)-u(i1,i2,i3-2,c)   
     &     +4.*(u(i1+1,i2,i3,c)+u(i1-1,i2,i3,c)   
     &         +u(i1,i2+1,i3,c)+u(i1,i2-1,i3,c)   
     &         +u(i1,i2,i3+1,c)+u(i1,i2,i3-1,c))  
     &      -18.*u(i1,i2,i3,c) )

c    --- For 2nd order 2D artificial diffusion ---
      delta22(c)=    (u(i1+1,i2,i3,c)-4.*u(i1,i2,i3,c)+u(i1-1,i2,i3,c)  \
                   +u(i1,i2+1,i3,c)                 +u(i1,i2-1,i3,c))
c    --- For 2nd order 3D artificial diffusion ---
      delta23(c)= \
        (u(i1+1,i2,i3,c)-6.*u(i1,i2,i3,c)+u(i1-1,i2,i3,c)   \
        +u(i1,i2+1,i3,c)                   +u(i1,i2-1,i3,c)  \
        +u(i1,i2,i3+1,c)                   +u(i1,i2,i3-1,c)) 
c     ---For fourth-order artificial diffusion in 2D
      delta42(c)= \
        (   -u(i1+2,i2,i3,c)-u(i1-2,i2,i3,c)   \
            -u(i1,i2+2,i3,c)-u(i1,i2-2,i3,c)   \
        +4.*(u(i1+1,i2,i3,c)+u(i1-1,i2,i3,c)   \
            +u(i1,i2+1,i3,c)+u(i1,i2-1,i3,c))  \
         -12.*u(i1,i2,i3,c) ) 
c     ---For fourth-order artificial diffusion in 3D
      delta43(c)= \
        (   -u(i1+2,i2,i3,c)-u(i1-2,i2,i3,c)  \
            -u(i1,i2+2,i3,c)-u(i1,i2-2,i3,c)  \
            -u(i1,i2,i3+2,c)-u(i1,i2,i3-2,c)  \
        +4.*(u(i1+1,i2,i3,c)+u(i1-1,i2,i3,c)  \
            +u(i1,i2+1,i3,c)+u(i1,i2-1,i3,c)  \
            +u(i1,i2,i3+1,c)+u(i1,i2,i3-1,c)) \
         -18.*u(i1,i2,i3,c) )


#Include "selfAdjointArtificialDiffusion.h"

c     --- end statement functions

      ierr=0
      ! write(*,'("Inside insdt: gridType=",i2)') gridType

      pc                 =ipar(0)
      uc                 =ipar(1)
      vc                 =ipar(2)
      wc                 =ipar(3)
      nc                 =ipar(4)
      sc                 =ipar(5)
      tc                 =ipar(6)  ! **new**
      grid               =ipar(7)
      orderOfAccuracy    =ipar(8)
      gridIsMoving       =ipar(9)
      useWhereMask       =ipar(10)
      gridIsImplicit     =ipar(11)
      implicitMethod     =ipar(12)
      implicitOption     =ipar(13)
      isAxisymmetric     =ipar(14)
      use2ndOrderAD      =ipar(15)
      use4thOrderAD      =ipar(16)
      advectPassiveScalar=ipar(17)
      gridType           =ipar(18)
      turbulenceModel    =ipar(19)
      pdeModel           =ipar(20)  ! **new**

      dr(0)             =rpar(0)
      dr(1)             =rpar(1)
      dr(2)             =rpar(2)
      dx(0)             =rpar(3)
      dx(1)             =rpar(4)
      dx(2)             =rpar(5)
      nu                =rpar(6)
      ad21              =rpar(7)
      ad22              =rpar(8)
      ad41              =rpar(9)
      ad42              =rpar(10)
      nuPassiveScalar   =rpar(11)
      adcPassiveScalar  =rpar(12)
      ad21n             =rpar(13)
      ad22n             =rpar(14)
      ad41n             =rpar(15)
      ad42n             =rpar(16)

      gravity(0)        =rpar(18)
      gravity(1)        =rpar(19)
      gravity(2)        =rpar(20)
      thermalExpansivity=rpar(21)
      adcBoussinesq     =rpar(22) ! coefficient of artificial diffusion for Boussinesq T equation 
      kThermal          =rpar(23)
      ! nuVP              =rpar(24)

      kc=nc
      ec=kc+1

      if( orderOfAccuracy.ne.2 .and. orderOfAccuracy.ne.4 )then
        write(*,'("insdt:ERROR orderOfAccuracy=",i6)') orderOfAccuracy
        stop 1
      end if
      if( gridType.ne.rectangular .and. gridType.ne.curvilinear )then
        write(*,'("insdt:ERROR gridType=",i6)') gridType
        stop 2
      end if
      if( uc.lt.0 .or. vc.lt.0 .or. (nd.eq.3 .and. wc.lt.0) )then
        write(*,'("insdt:ERROR uc,vc,ws=",3i6)') uc,vc,wc
        stop 4
      end if

c      write(*,'("insdt: turbulenceModel=",2i6)') turbulenceModel
c      write(*,'("insdt: nd,uc,vc,wc,kc=",2i6)') nd,uc,vc,wc,kc

      if( turbulenceModel.eq.kEpsilon .and. (kc.lt.uc+nd .or. kc.gt.1000) )then
        write(*,'("insdt:ERROR in kc: nd,uc,vc,wc,kc=",2i6)') nd,uc,vc,wc,kc
        stop 5
      end if

c ** these are needed by self-adjoint terms **fix**
      dxi=1./dx(0)
      dyi=1./dx(1)
      dzi=1./dx(2)
c     dx2i=1./(2.*dx(0))
c     dy2i=1./(2.*dx(1))
c     dz2i=1./(2.*dx(2))

      dri=1./dr(0)
      dsi=1./dr(1)
      dti=1./dr(2)
      dr2i=1./(2.*dr(0))
      ds2i=1./(2.*dr(1))
      dt2i=1./(2.*dr(2))

      if( turbulenceModel.eq.spalartAllmaras )then
        call getSpalartAllmarasParameters(cb1, cb2, cv1, sigma, sigmai, kappa, cw1, cw2, cw3, cw3e6, \
           cv1e3, cd0, cr0)
      else if( turbulenceModel.eq.kEpsilon )then

       ! write(*,'(" insdt: k-epsilon: nc,kc,ec=",3i3)') nc,kc,ec

        call getKEpsilonParameters( cMu,cEps1,cEps2,sigmaEpsI,sigmaKI )
        !  write(*,'(" insdt: cMu,cEps1,cEps2,sigmaEpsI,sigmaKI=",5f8.3)') cMu,cEps1,cEps2,sigmaEpsI,sigmaKI

      else if( turbulenceModel.ne.noTurbulenceModel )then
        stop 88
      end if

      adc=adcPassiveScalar ! coefficient of linear artificial diffusion
      cd22=ad22/(nd**2)
      cd42=ad42/(nd**2)

      if( gridIsMoving.ne.0 )then
        ! compute uu = u -gv
        if( nd.eq.2 )then
          loopse2(uu(i1,i2,i3,uc)=u(i1,i2,i3,uc)-gv(i1,i2,i3,0),\
                  uu(i1,i2,i3,vc)=u(i1,i2,i3,vc)-gv(i1,i2,i3,1))
        else if( nd.eq.3 )then
          loopse3(uu(i1,i2,i3,uc)=u(i1,i2,i3,uc)-gv(i1,i2,i3,0),\
                  uu(i1,i2,i3,vc)=u(i1,i2,i3,vc)-gv(i1,i2,i3,1),\
                  uu(i1,i2,i3,wc)=u(i1,i2,i3,wc)-gv(i1,i2,i3,2))
        else
          stop 11
        end if
      end if

c     *********************************      
c     ********MAIN LOOPS***************      
c     *********************************      

      if( turbulenceModel.eq.noTurbulenceModel .and. pdeModel.eq.viscoPlasticModel )then
        ! ins + visco-plastic model
        insdtFunctions(VP)

      else if( turbulenceModel.eq.noTurbulenceModel )then

        insdtFunctions(INS)

      else if( turbulenceModel.eq.spalartAllmaras )then

        insdtFunctions(SPAL)

      else if( turbulenceModel.eq.kEpsilon )then

        insdtFunctions(KE)

      else
        write(*,'("Unknown turbulence model")') 
        stop 68
      end if


c     *********************************
c     ******** passive scalar *********
c     *********************************

      if( advectPassiveScalar.eq.1 )then
        passiveScalarMacro()
      end if


c     *********************************
c     ******** Boussinesq Model *******
c     *********************************

      ! write(*,'("insdt: pdeModel=",i2," kThermal=",e10.2)') pdeModel,kThermal
      ! ' 
      if( pdeModel.eq.BoussinesqModel .or. pdeModel.eq.viscoPlasticModel )then
        if( tc.lt.0 )then
          write(*,'("insdt:Boussinesq:ERROR: tc<0 !")')
          stop 8868
        end if
        boussinesqMacro()
      end if

c     **********************************
c     ****** artificial diffusion ******  
c     **********************************

      if( use2ndOrderAD.eq.1 .or. use4thOrderAD.eq.1 )then
        if( gridType.eq.rectangular )then
          addDissipationByDimension( rectangular )
        else if( gridType.eq.curvilinear )then
          addDissipationByDimension( curvilinear )
        else
          stop 77
        end if
      end if


      return
      end




c ..................................................................................


c Include "/home/henshaw/Overture.g/include/defineDiffOrder2f.h"

      subroutine insArtificialDiffusion(nd,
     & n1a,n1b,n2a,n2b,n3a,n3b,
     & nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,nd4a,nd4b,
     & mask,rsxy,  u,v,  ipar, rpar, ierr )
c======================================================================
c   Add on the artificial diffusion in a semi-implicit way
c
c  Approximately add on: 
c       v = u + dt*AD( v )
c by iterating
c       v(0) = u
c       for k=0,1,..
c         v(k+1) = u + dt*AD( v(k) )   --- but do this implicitly
c
c======================================================================
      implicit none
      integer nd, n1a,n1b,n2a,n2b,n3a,n3b,
     & nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,nd4a,nd4b

      real u(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
      real v(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
      real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,0:nd-1,0:nd-1)

      integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      integer ierr

      integer ipar(0:*)
      real rpar(0:*)
      
c     ---- local variables -----
      integer c,i1,i2,i3,orderOfAccuracy,gridType,useWhereMask,numberOfIterations
      integer gridIsImplicit,use2ndOrderAD,use4thOrderAD,use6thOrderAD
      integer pc,uc,vc,wc,sc,grid,m,nc,advectPassiveScalar
      real dt,dr(0:2),dx(0:2),adcPassiveScalar
      real ad21,ad22,ad41,ad42,ad61,ad62,cd22,cd42,cd62,adc
      real ad21n,ad22n,ad41n,ad42n,cd22n,cd42n

      integer rectangular,curvilinear
      parameter( rectangular=0, curvilinear=1 )

      integer computeAllTerms,
     &     doNotComputeImplicitTerms,
     &     computeImplicitTermsSeparately,
     &     computeAllWithWeightedImplicit

      parameter( computeAllTerms=0,
     &           doNotComputeImplicitTerms=1,
     &           computeImplicitTermsSeparately=2,
     &           computeAllWithWeightedImplicit=3 )

      ! declare variables for difference approximations
      ! include 'declareDiffOrder2f.h'

      declareDifferenceOrder2(u,RX)


c      real cdmz,cdpz,cdzm,cdzp,cdmzz,cdpzz,cdzmz,cdzpz,cdzzm,cdzzp,cdDiag,cdm,cdp
c      real uxmzzR,uymzzR,uzmzzR,uxzmzR,uyzmzR,uzzmzR,uxzzmR,uyzzmR,uzzzmR
c      real udmzC,udzmC,udmzzC,udzmzC,udzzmC
c      real admzR,adzmR,admzzR,adzmzR,adzzmR
c      real admzC,adzmC,admzzC,adzmzC,adzzmC
c     real admzRSA,adzmRSA,admzzRSA,adzmzRSA,adzzmRSA
c     real admzCSA,adzmCSA,admzzCSA,adzmzCSA,adzzmCSA
c     real adE0,adE1,ade2,adE3d0,adE3d1,adE3d2,ad2f,ad3f
c     real dr2i,ds2i,dt2i,dri,dsi,dti

c     --- begin statement functions
      real ad2Coeff,ad2,ad23Coeff,ad23,ad4Coeff,ad4,ad43Coeff,ad43
      real ad2rCoeff,ad23rCoeff,ad4rCoeff,ad43rCoeff
      real ad2nd,ad23nd,ad4nd,ad43nd

c      real adSelfAdjoint2dR,adSelfAdjoint3dR,adSelfAdjoint2dC,adSelfAdjoint3dC
c      real adSelfAdjoint2dRSA,adSelfAdjoint3dRSA,adSelfAdjoint2dCSA,adSelfAdjoint3dCSA
c***  include 'insDeriv.h'

c .............. begin statement functions
      integer kd
      real rx,ry,rz,sx,sy,sz,tx,ty,tz

c.......statement functions for jacobian
      rx(i1,i2,i3)=rsxy(i1,i2,i3,0,0)
      ry(i1,i2,i3)=rsxy(i1,i2,i3,0,1)
      rz(i1,i2,i3)=rsxy(i1,i2,i3,0,2)
      sx(i1,i2,i3)=rsxy(i1,i2,i3,1,0)
      sy(i1,i2,i3)=rsxy(i1,i2,i3,1,1)
      sz(i1,i2,i3)=rsxy(i1,i2,i3,1,2)
      tx(i1,i2,i3)=rsxy(i1,i2,i3,2,0)
      ty(i1,i2,i3)=rsxy(i1,i2,i3,2,1)
      tz(i1,i2,i3)=rsxy(i1,i2,i3,2,2)

c     The next macro call will define the difference approximation statement functions
      defineDifferenceOrder2Components1(u,RX)

c    --- 2nd order 2D artificial diffusion ---
      ad2Coeff()=(ad21 + cd22* 
     &    ( abs(ux22(i1,i2,i3,uc))+abs(uy22(i1,i2,i3,uc))  
     &     +abs(ux22(i1,i2,i3,vc))+abs(uy22(i1,i2,i3,vc)) ) )
      ad2rCoeff()=(ad21 + cd22* 
     &    ( abs(ux22r(i1,i2,i3,uc))+abs(uy22r(i1,i2,i3,uc))  
     &     +abs(ux22r(i1,i2,i3,vc))+abs(uy22r(i1,i2,i3,vc)) ) )
      ad2(c)=adc*(u(i1+1,i2,i3,c)-4.*u(i1,i2,i3,c)+u(i1-1,i2,i3,c)  
     &           +u(i1,i2+1,i3,c)                 +u(i1,i2-1,i3,c))
      ad2nd(c)=adc*(u(i1+1,i2,i3,c)                 +u(i1-1,i2,i3,c)  ! no diagonal term
     &             +u(i1,i2+1,i3,c)                 +u(i1,i2-1,i3,c))

c    --- 2nd order 3D artificial diffusion ---
      ad23Coeff()=(ad21 + cd22*   
     &    ( abs(ux23(i1,i2,i3,uc))+abs(uy23(i1,i2,i3,uc))+abs(uz23(i1,i2,i3,uc)) 
     &     +abs(ux23(i1,i2,i3,vc))+abs(uy23(i1,i2,i3,vc))+abs(uz23(i1,i2,i3,vc))  
     &     +abs(ux23(i1,i2,i3,wc))+abs(uy23(i1,i2,i3,wc))+abs(uz23(i1,i2,i3,wc)) ) )
      ad23rCoeff()=(ad21 + cd22*   
     &    ( abs(ux23r(i1,i2,i3,uc))+abs(uy23r(i1,i2,i3,uc))+abs(uz23r(i1,i2,i3,uc)) 
     &     +abs(ux23r(i1,i2,i3,vc))+abs(uy23r(i1,i2,i3,vc))+abs(uz23r(i1,i2,i3,vc))  
     &     +abs(ux23r(i1,i2,i3,wc))+abs(uy23r(i1,i2,i3,wc))+abs(uz23r(i1,i2,i3,wc)) ) )
      ad23(c)=adc
     &    *(u(i1+1,i2,i3,c)-6.*u(i1,i2,i3,c)+u(i1-1,i2,i3,c)  
     &     +u(i1,i2+1,i3,c)                   +u(i1,i2-1,i3,c) 
     &     +u(i1,i2,i3+1,c)                   +u(i1,i2,i3-1,c))
      ad23nd(c)=adc
     &    *(u(i1+1,i2,i3,c)                   +u(i1-1,i2,i3,c)  
     &     +u(i1,i2+1,i3,c)                   +u(i1,i2-1,i3,c) 
     &     +u(i1,i2,i3+1,c)                   +u(i1,i2,i3-1,c))
                       
c     ---fourth-order artificial diffusion in 2D
      ad4Coeff()=(ad41 + cd42*    
     &    ( abs(ux22(i1,i2,i3,uc))+abs(uy22(i1,i2,i3,uc))    
     &     +abs(ux22(i1,i2,i3,vc))+abs(uy22(i1,i2,i3,vc)) ) )
      ad4rCoeff()=(ad41 + cd42*    
     &    ( abs(ux22r(i1,i2,i3,uc))+abs(uy22r(i1,i2,i3,uc))    
     &     +abs(ux22r(i1,i2,i3,vc))+abs(uy22r(i1,i2,i3,vc)) ) )
      ad4(c)=adc
     &    *(   -u(i1+2,i2,i3,c)-u(i1-2,i2,i3,c)    
     &         -u(i1,i2+2,i3,c)-u(i1,i2-2,i3,c)    
     &     +4.*(u(i1+1,i2,i3,c)+u(i1-1,i2,i3,c)    
     &         +u(i1,i2+1,i3,c)+u(i1,i2-1,i3,c))   
     &      -12.*u(i1,i2,i3,c) ) 
      ad4nd(c)=adc
     &    *(   -u(i1+2,i2,i3,c)-u(i1-2,i2,i3,c)    
     &         -u(i1,i2+2,i3,c)-u(i1,i2-2,i3,c)    
     &     +4.*(u(i1+1,i2,i3,c)+u(i1-1,i2,i3,c)    
     &         +u(i1,i2+1,i3,c)+u(i1,i2-1,i3,c))   
     &                         ) 
c     ---fourth-order artificial diffusion in 3D
      ad43Coeff()=
     &   (ad41 + cd42*    
     &    ( abs(ux23(i1,i2,i3,uc))+abs(uy23(i1,i2,i3,uc))+abs(uz23(i1,i2,i3,uc))    
     &     +abs(ux23(i1,i2,i3,vc))+abs(uy23(i1,i2,i3,vc))+abs(uz23(i1,i2,i3,vc))    
     &     +abs(ux23(i1,i2,i3,wc))+abs(uy23(i1,i2,i3,wc))+abs(uz23(i1,i2,i3,wc)) ) )
      ad43rCoeff()=
     &   (ad41 + cd42*    
     &    ( abs(ux23r(i1,i2,i3,uc))+abs(uy23r(i1,i2,i3,uc))+abs(uz23r(i1,i2,i3,uc))    
     &     +abs(ux23r(i1,i2,i3,vc))+abs(uy23r(i1,i2,i3,vc))+abs(uz23r(i1,i2,i3,vc))    
     &     +abs(ux23r(i1,i2,i3,wc))+abs(uy23r(i1,i2,i3,wc))+abs(uz23r(i1,i2,i3,wc)) ) )
      ad43(c)=adc
     &    *(   -u(i1+2,i2,i3,c)-u(i1-2,i2,i3,c)   
     &         -u(i1,i2+2,i3,c)-u(i1,i2-2,i3,c)   
     &         -u(i1,i2,i3+2,c)-u(i1,i2,i3-2,c)   
     &     +4.*(u(i1+1,i2,i3,c)+u(i1-1,i2,i3,c)   
     &         +u(i1,i2+1,i3,c)+u(i1,i2-1,i3,c)   
     &         +u(i1,i2,i3+1,c)+u(i1,i2,i3-1,c))  
     &      -18.*u(i1,i2,i3,c) )
      ad43nd(c)=adc
     &    *(   -u(i1+2,i2,i3,c)-u(i1-2,i2,i3,c)   
     &         -u(i1,i2+2,i3,c)-u(i1,i2-2,i3,c)   
     &         -u(i1,i2,i3+2,c)-u(i1,i2,i3-2,c)   
     &     +4.*(u(i1+1,i2,i3,c)+u(i1-1,i2,i3,c)   
     &         +u(i1,i2+1,i3,c)+u(i1,i2-1,i3,c)   
     &         +u(i1,i2,i3+1,c)+u(i1,i2,i3-1,c))  
     &                         )


c**** Include "selfAdjointArtificialDiffusion.h"

c     --- end statement functions

      ierr=0
      ! write(*,*) 'Inside insdt'

      pc                 =ipar(0)
      uc                 =ipar(1)
      vc                 =ipar(2)
      wc                 =ipar(3)
      sc                 =ipar(4)
      grid               =ipar(5)
      orderOfAccuracy    =ipar(6)
      gridType           =ipar(7)
      useWhereMask       =ipar(8)
      gridIsImplicit     =ipar(9)
      use2ndOrderAD      =ipar(10)
      use4thOrderAD      =ipar(11)
      use6thOrderAD      =ipar(12)
      advectPassiveScalar=ipar(13)
      numberOfIterations =ipar(14)

      dx(0)             =rpar(0)
      dx(1)             =rpar(1)
      dx(2)             =rpar(2)
      dr(0)             =rpar(3)
      dr(1)             =rpar(4)
      dr(2)             =rpar(5)
      ad21              =rpar(6)
      ad22              =rpar(7)
      ad41              =rpar(8)
      ad42              =rpar(9)
      ad61              =rpar(10)
      ad62              =rpar(11)
      adcPassiveScalar  =rpar(12) 

      dt                = rpar(11) ! ************* add this **************

c$$$      dxi=1./dx
c$$$      dyi=1./dy
c$$$      dzi=1./dz
c$$$      dx2i=1./(2.*dx)
c$$$      dy2i=1./(2.*dy)
c$$$      dz2i=1./(2.*dz)
c$$$      dxsqi=1./(dx*dx)
c$$$      dysqi=1./(dy*dy)
c$$$      dzsqi=1./(dz*dz)
c$$$
c$$$      if( orderOfAccuracy.eq.4 )then
c$$$        dx12i=1./(12.*dx)
c$$$        dy12i=1./(12.*dy)
c$$$        dz12i=1./(12.*dz)
c$$$        dxsq12i=1./(12.*dx**2)
c$$$        dysq12i=1./(12.*dy**2)
c$$$        dzsq12i=1./(12.*dz**2)
c$$$      end if


c     **********************************
c     ****** artificial diffusion ******  
c     **********************************


      cd22n=ad22n/nd
      cd42n=ad42n/nd

      if( use2ndOrderAD.eq.1 .and. 
     &     (ad21.gt.0. .or. ad22.gt.0.) ) then

c      *******************************************
c      ****** 2nd-order artificial diffusion *****
c      *******************************************

       cd22=ad22/(nd**2)
       if( nd.eq.1 )then
         stop 1
       else if( nd.eq.2 )then

c       non-self-adjoint form:
c       loopse4(adc=ad2Coeff(), \
c               ut(i1,i2,i3,uc)=ut(i1,i2,i3,uc)+ad2(uc),\
c               ut(i1,i2,i3,vc)=ut(i1,i2,i3,vc)+ad2(vc),)

c        self-adjoint form:
c        loopse4($defineArtificialDiffusionCoefficients(2,R,), \
c                ut(i1,i2,i3,uc)=ut(i1,i2,i3,uc)+ad2f(i1,i2,i3,uc),\
c                ut(i1,i2,i3,vc)=ut(i1,i2,i3,vc)+ad2f(i1,i2,i3,vc),)

         ! -- Here is a aprtially implicit version ---
         if( gridType.eq.rectangular )then     
          loopse4(adc=dt*ad2rCoeff(), \
            v(i1,i2,i3,uc)=(u(i1,i2,i3,uc)+ad2nd(uc))/(1.+4.*adc),\
            v(i1,i2,i3,vc)=(u(i1,i2,i3,vc)+ad2nd(vc))/(1.+4.*adc),)
         else
          loopse4(adc=dt*ad2Coeff(), \
            v(i1,i2,i3,uc)=(u(i1,i2,i3,uc)+ad2nd(uc))/(1.+4.*adc),\
            v(i1,i2,i3,vc)=(u(i1,i2,i3,vc)+ad2nd(vc))/(1.+4.*adc),)
         end if
         
       else ! 3D
c        loopse4(adc=ad23Coeff(), \
c                ut(i1,i2,i3,uc)=ut(i1,i2,i3,uc)+ad23(uc),\
c                ut(i1,i2,i3,vc)=ut(i1,i2,i3,vc)+ad23(vc),\
c                ut(i1,i2,i3,wc)=ut(i1,i2,i3,wc)+ad23(wc) )

c        loopse4($defineArtificialDiffusionCoefficients(3,R,), \
c                ut(i1,i2,i3,uc)=ut(i1,i2,i3,uc)+ad3f(i1,i2,i3,uc),\
c                ut(i1,i2,i3,vc)=ut(i1,i2,i3,vc)+ad3f(i1,i2,i3,vc),\
c                ut(i1,i2,i3,wc)=ut(i1,i2,i3,wc)+ad3f(i1,i2,i3,wc) )

         stop 2
       end if

      end if

      if( use4thOrderAD.eq.1 .and. 
     &     (ad41.gt.0. .or. ad42.gt.0.) ) then

       cd42=ad42/(nd**2)
       if( nd.eq.1 )then
         stop 1
       else if( nd.eq.2 )then

         if( gridType.eq.rectangular )then     
          loopse4(adc=dt*ad4rCoeff(), \
            v(i1,i2,i3,uc)=(u(i1,i2,i3,uc)+ad4nd(uc))/(1.+12.*adc),\
            v(i1,i2,i3,vc)=(u(i1,i2,i3,vc)+ad4nd(vc))/(1.+12.*adc),)
         else
          loopse4(adc=dt*ad4Coeff(), \
            v(i1,i2,i3,uc)=(u(i1,i2,i3,uc)+ad4nd(uc))/(1.+12.*adc),\
            v(i1,i2,i3,vc)=(u(i1,i2,i3,vc)+ad4nd(vc))/(1.+12.*adc),)
         end if

       else ! 3D
         stop 2
c        loopse4(adc=ad43Coeff(), \
c                ut(i1,i2,i3,uc)=ut(i1,i2,i3,uc)+ad43(uc),\
c                ut(i1,i2,i3,vc)=ut(i1,i2,i3,vc)+ad43(vc),\
c                ut(i1,i2,i3,wc)=ut(i1,i2,i3,wc)+ad43(wc) )

       end if

      end if

c     *************************************************
c     *********Advect a passive scalar ****************
c     *************************************************
      if( advectPassiveScalar.eq.1 )then
       adc=adcPassiveScalar ! coefficient of linear artificial diffusion
c       if( nd.eq.1 )then
c         if( orderOfAccuracy.eq.2 )then
c           loopse4(ut(i1,i2,i3,sc)= -uu(uc)*ux2(sc)+nuPassiveScalar*uxx2(sc),,,)
c         else
c           loopse4(ut(i1,i2,i3,sc)= -uu(uc)*ux4(sc)+nuPassiveScalar*uxx4(sc),,,)
c         end if
c
c       else if( nd.eq.2 )then
c         if( orderOfAccuracy.eq.2 )then
c          loopse4(ut(i1,i2,i3,sc)= -uu(uc)*ux2(sc)-uu(vc)*uy2(sc)+nuPassiveScalar*lap2d2(sc)+ad2(sc),,,)
c         else ! order==4
c          loopse4(ut(i1,i2,i3,sc)= -uu(uc)*ux4(sc)-uu(vc)*uy4(sc)+nuPassiveScalar*lap2d4(sc)+ad4(sc),,,)
c         end if
c       else ! nd==3
c        if( orderOfAccuracy.eq.2 )then
c           loopse4(ut(i1,i2,i3,sc)= -uu(uc)*ux2(sc)-uu(vc)*uy2(sc)-uu(wc)*uz2(sc)\
c                                    +nuPassiveScalar*lap3d2(sc)+ad23(sc),,,)
c        else
c           loopse4(ut(i1,i2,i3,sc)= -uu(uc)*ux4(sc)-uu(vc)*uy4(sc)-uu(wc)*uz4(sc)\
c                                    +nuPassiveScalar*lap3d4(sc)+ad43(sc),,,)
c        end if
c       end if ! end nd

      end if ! advectPassiveScalar


      return
      end
