! This file automatically generated from insdts.bf with bpp.
c
c Compute the time step dt for the incompressible NS on rectangular AND curvilinear grids
c

c These next include files will define the macros that will define the difference approximations
c The actual macro is called below
c Use this next macro to declare the statement functions that are defined below
c To include derivatives of rx use OPTION=RX


c Define statement functions for difference approximations of order 2 
c To include derivatives of rx use OPTION=RX
c To include derivatives of rx use OPTION=RX



c Use this next macro to declare the statement functions that are defined below
c To include derivatives of rx use OPTION=RX


c Define statement functions for difference approximations of order 4 
c To include derivatives of rx use OPTION=RX
c To include derivatives of rx use OPTION=RX





c Define macros for the derivatives based on the dimension, order of accuracy and grid-type


c =============================================================
c Compute derivatives of u,v,w 
c =============================================================

c =============================================================
c Compute Spalart-Allmaras quantities
c   This macro assumes u0x,u0y, ... are defined
c =============================================================



c ============== from inspf.bf ***
c Return nuT and it's first derivatives for SPAL

c ============== from inspf.bf ***
c Return nuT and it's first derivatives for BL

c ============== from inspf.bf ***
c Return nuT and it's first derivatives for KE

c ============== from inspf.bf ***
c Return the visco-plastic viscosity and it's first derivatives for BL


c====================================================================================
c
c SOLVER: INS, INSSPAL, INSBL, INSKE
c METHOD: GLOBAL, LOCAL  (GLOBAL=fixed time step, LOCAL=local-time stepping -> compute dtVar)
c OPTION: EXPLICIT, IMPLICIT
c ADTYPE: AD2, AD4, AD24 --- NOT USED NOW
c ORDER: 2,4
c DIM: 2,3
c GRIDTYPE: rectangular, curvilinear
c AXISYMMETRIC: notAxisymmetric, or axisymmetric
c====================================================================================

c ====================================================================================
c ====================================================================================







! This is not finished yet..


c ============================================================================================================
c  Define the subroutine that compute the eigenvalues for a given solver
c ============================================================================================================


      subroutine insdts(nd,n1a,n1b,n2a,n2b,n3a,n3b,nd1a,nd1b,nd2a,nd2b,
     & nd3a,nd3b,nd4a,nd4b,mask,xy,rsxy,  u,uu, gv,dw, divDamping, 
     & dtVar, bc, ipar, rpar, pdb, ierr )
c======================================================================
c
c    Determine the time step for the INS equations.
c    ---------------------------------------------
c
c nd : number of space dimensions
c
c gv : gridVelocity for moving grids
c uu : for moving grids uu is a workspace to hold u-gv, otherwise uu==u
c dw : distance to the wall for some turbulence models
c======================================================================
      implicit none
      integer nd, n1a,n1b,n2a,n2b,n3a,n3b,
     & nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,nd4a,nd4b

      real u(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
      real uu(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
      real gv(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
      real dw(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real divDamping(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real dtVar(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real xy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,0:nd-1)
      real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,0:nd-1,0:nd-1)

      integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      integer bc(0:1,0:2),ierr

      integer ipar(0:*)
      real rpar(0:*)

      double precision pdb  ! pointer to data base

c     ---- local variables -----
c$$$      integer c,i1,i2,i3,kd,kd3,orderOfAccuracy,gridIsMoving,useWhereMask
c$$$      integer gridIsImplicit,implicitOption,implicitMethod,
c$$$     & isAxisymmetric,use2ndOrderAD,use4thOrderAD,useLocalTimeStepping
c$$$      integer pc,uc,vc,wc,sc,nc,kc,ec,grid,m,advectPassiveScalar
c$$$      real nu,dt,nuPassiveScalar,adcPassiveScalar
c$$$      real dtVarMin,dtVarMax,dtMax,dtMaxInverse
c$$$      real dxi,dyi,dzi,dri,dsi,dti,dr2i,ds2i,dt2i
c$$$      real ad21,ad22,ad41,ad42,cd22,cd42,adc,cd22n
c$$$      real scaleFactor,factor,cDt,cdv,cr,crr
c$$$
c$$$      integer gridType
c$$$      integer rectangular,curvilinear
c$$$      parameter( rectangular=0, curvilinear=1 )

      integer turbulenceModel,noTurbulenceModel
      integer baldwinLomax,spalartAllmaras,kEpsilon,kOmega
      parameter (noTurbulenceModel=0,baldwinLomax=1,kEpsilon=2,
     & kOmega=3,spalartAllmaras=4 )

      integer pdeModel,standardModel,BoussinesqModel,viscoPlasticModel,
     & twoPhaseFlowModel
      parameter( standardModel=0,BoussinesqModel=1,viscoPlasticModel=2,
     & twoPhaseFlowModel=3 )

c$$$      integer computeAllTerms,
c$$$     &     doNotComputeImplicitTerms,
c$$$     &     computeImplicitTermsSeparately,
c$$$     &     computeAllWithWeightedImplicit
c$$$
c$$$      parameter( computeAllTerms=0,
c$$$     &           doNotComputeImplicitTerms=1,
c$$$     &           computeImplicitTermsSeparately=2,
c$$$     &           computeAllWithWeightedImplicit=3 )
c$$$
c$$$      ! These should match those in OB_Parameters.h
c$$$      integer notImplicit,backwardEuler,secondOrderBDF,crankNicolson,lineImplicit
c$$$      parameter( notImplicit=0,backwardEuler=1,secondOrderBDF=2,crankNicolson=3,lineImplicit=4 )
c$$$
c$$$
c$$$      real dr(0:2), dx(0:2)
c$$$
c$$$      real rePart,imPart,imLambda,reLambda,a1,a2,a3,nuMax

c     --- end statement functions

      ierr=0
      ! write(*,'("Inside insdts: gridType=",i2)') gridType

c$$$      pc                 =ipar(0)
c$$$      uc                 =ipar(1)
c$$$      vc                 =ipar(2)
c$$$      wc                 =ipar(3)
c$$$      nc                 =ipar(4)
c$$$      sc                 =ipar(5)
c$$$      grid               =ipar(6)
c$$$      orderOfAccuracy    =ipar(7)
c$$$      gridIsMoving       =ipar(8)
c$$$      useWhereMask       =ipar(9)
c$$$      gridIsImplicit     =ipar(10)
c$$$      implicitMethod     =ipar(11)
c$$$      implicitOption     =ipar(12)
c$$$      isAxisymmetric     =ipar(13)
c$$$      use2ndOrderAD      =ipar(14)
c$$$      use4thOrderAD      =ipar(15)
c$$$      advectPassiveScalar=ipar(16)
c$$$      gridType           =ipar(17)
      turbulenceModel    =ipar(18)
c$$$      useLocalTimeStepping=ipar(19)

      pdeModel           =ipar(23)

c$$$      kc=nc
c$$$      ec=kc+1
c$$$
c$$$      if( orderOfAccuracy.ne.2 .and. orderOfAccuracy.ne.4 )then
c$$$        write(*,'("insdts:ERROR orderOfAccuracy=",i6)') orderOfAccuracy
c$$$        stop 1
c$$$      end if
c$$$      if( gridType.ne.rectangular .and. gridType.ne.curvilinear )then
c$$$        write(*,'("insdts:ERROR gridType=",i6)') gridType
c$$$        stop 2
c$$$      end if
c$$$      if( uc.lt.0 .or. vc.lt.0 .or. (nd.eq.3 .and. wc.lt.0) )then
c$$$        write(*,'("insdts:ERROR uc,vc,ws=",3i6)') uc,vc,wc
c$$$        stop 4
c$$$      end if
c$$$      if( turbulenceModel.eq.kEpsilon .and. (kc.lt.uc+nd .or. kc.gt.1000) )then
c$$$        write(*,'("insdts:ERROR in kc: nd,uc,vc,wc,kc=",2i6)') nd,uc,vc,wc,kc
c$$$        stop 5
c$$$      end if
c$$$      if( nd.ne.2 .and. nd.ne.3 )then
c$$$        write(*,'("insdts:ERROR nd=",i6)') nd
c$$$        stop 1
c$$$      end if

c     *****************************************************
c     ********DETERMINE THE TIME STEPPING EIGENVALUES *****
c     *****************************************************      

      if( turbulenceModel.eq.noTurbulenceModel )then

        if( pdeModel.eq.standardModel .or. pdeModel.eq.BoussinesqModel 
     & )then
          call insdtsINS(nd,n1a,n1b,n2a,n2b,n3a,n3b,nd1a,nd1b,nd2a,
     & nd2b,nd3a,nd3b,nd4a,nd4b,mask,xy,rsxy,  u,uu, gv,dw, 
     & divDamping, dtVar, bc, ipar, rpar, pdb, ierr )
        else if( pdeModel.eq.viscoPlasticModel )then
          call insdtsVP(nd,n1a,n1b,n2a,n2b,n3a,n3b,nd1a,nd1b,nd2a,nd2b,
     & nd3a,nd3b,nd4a,nd4b,mask,xy,rsxy,  u,uu, gv,dw, divDamping, 
     & dtVar, bc, ipar, rpar, pdb, ierr )
        else if( pdeModel.eq.twoPhaseFlowModel )then
          call insdtsTP(nd,n1a,n1b,n2a,n2b,n3a,n3b,nd1a,nd1b,nd2a,nd2b,
     & nd3a,nd3b,nd4a,nd4b,mask,xy,rsxy,  u,uu, gv,dw, divDamping, 
     & dtVar, bc, ipar, rpar, pdb, ierr )
        else
          write(*,'("insdts:ERROR::pdeModel=",i2)') pdeModel
          stop 45
        end if

      else if( turbulenceModel.eq.spalartAllmaras )then

        call insdtsSPAL(nd,n1a,n1b,n2a,n2b,n3a,n3b,nd1a,nd1b,nd2a,nd2b,
     & nd3a,nd3b,nd4a,nd4b,mask,xy,rsxy,  u,uu, gv,dw, divDamping, 
     & dtVar, bc, ipar, rpar, pdb, ierr )

      else if( turbulenceModel.eq.baldwinLomax )then

        call insdtsBL(nd,n1a,n1b,n2a,n2b,n3a,n3b,nd1a,nd1b,nd2a,nd2b,
     & nd3a,nd3b,nd4a,nd4b,mask,xy,rsxy,  u,uu, gv,dw, divDamping, 
     & dtVar, bc, ipar, rpar, pdb, ierr )

      else if( turbulenceModel.eq.kEpsilon )then

        call insdtsKE(nd,n1a,n1b,n2a,n2b,n3a,n3b,nd1a,nd1b,nd2a,nd2b,
     & nd3a,nd3b,nd4a,nd4b,mask,xy,rsxy,  u,uu, gv,dw, divDamping, 
     & dtVar, bc, ipar, rpar, pdb, ierr )

      else
        stop 33
      end if


      return
      end

c 
c : empty version for linking when we don't want an option
c





