*================================================================================================
*  cgmx example:  Compute the eigenfunctions of a box.
*
* Usage:
*   
*  cgmx [-noplot] boxeigen -g=<name> -tf=<tFinal> -tp=<tPlot> -mx=<num> -my=<num> -mz=<num> ...
*                          -diss=<> -debug=<num> -cons=[0/1] -go=[run/halt/og]
* Arguments:
*  -mx= -my= -mz= : integer mode numbers defining the eigenfunction 
*
* Examples:
*   cgmx noplot boxeigen -g=box32.order4.hdf -go=go
*   cgmx boxeigen -g=box32.order4.hdf -mx=3 -my=3 -mz=3 
*   cgmx noplot boxeigen -g=box64.order4.hdf -go=go
* parallel: 
*   mpirun -np 2 $cgmxp boxeigen -g=box64.order4.hdf -mx=3 -my=3 -mz=3 
*
*================================================================================================
* 
$tFinal=1.; $tPlot=.2; $diss=.0; $cfl=.95; 
$grid="box32.order4.hdf";
$cons=0; $go="halt"; 
$mx=1; $my=1; $mz=1;   # defines the eigenfunction 
* ----------------------------- get command line arguments ---------------------------------------
GetOptions( "g=s"=>\$grid,"tf=f"=>\$tFinal,"diss=f"=>\$diss,"tp=f"=>\$tPlot,"show=s"=>\$show,"debug=i"=>\$debug, \
 "cfl=f"=>\$cfl, "bg=s"=>\$backGround,"bcn=s"=>\$bcn,"go=s"=>\$go,"noplot=s"=>\$noplot,\
  "dtMax=f"=>\$dtMax,"mx=i"=>\$mx,"my=i"=>\$my,"mz=i"=>\$mz, "cons=i"=>\$cons );
* -------------------------------------------------------------------------------------------------
if( $go eq "halt" ){ $go = "break"; }
if( $go eq "og" ){ $go = "open graphics"; }
if( $go eq "run" || $go eq "go" ){ $go = "movie mode\n finish"; }
*
*
* $grid="nonBox64.order4.hdf"; $tPlot=1.; 
*
$grid
*
modifiedEquationTimeStepping
*
NFDTD
***
solve for magnetic field 0
***
*
****
bc: all=perfectElectricalConductor
***
*****
squareEigenfunctionInitialCondition
 $mx $my $mz
squareEigenfunctionKnownSolution
***
*specify probes
*  .2 .3 0.
*  done
*****
*
tFinal $tFinal
tPlot  $tPlot
dissipation $diss
cfl  $cfl
use conservative divergence $cons 
continue
$go
