*================================================================================================
*  cgmx example:  scattering from an array of dielectric disks (e.g. a photonic band gap simulation)
*
*   cgmx lattice
* 
* Usage:
*   
*  cgmx [-noplot] lattice  -g=<name> -tf=<tFinal> -tp=<tPlot> -kx=<num> -ky=<num> -kz=<num> ...
*                          -diss=<> -debug=<num> -cons=[0/1] -go=[run/halt/og]
* Arguments:
*  -kx= -ky= -kz= : integer wave number of the incident wave
*
* Examples:
*   cgmx lattice -g=lattice2.order4.hdf -eps1=.25 -eps2=1.  -go=halt
* parallel: 
*
*================================================================================================
* 
$tFinal=2.; $tPlot=.2; $diss=.5; $cfl=.8; 
$kx=1; $ky=0; $kz=0;
$eps1=1.; # inner
$eps2=1.; # outer 
$show=" "; $backGround="backGround";
$interfaceIterations=3;
$grid="lattice2.order4.hdf";
$cons=0; $go="halt"; 
* ----------------------------- get command line arguments ---------------------------------------
GetOptions( "g=s"=>\$grid,"tf=f"=>\$tFinal,"diss=f"=>\$diss,"tp=f"=>\$tPlot,"show=s"=>\$show,"debug=i"=>\$debug, \
 "cfl=f"=>\$cfl, "bg=s"=>\$backGround,"bcn=s"=>\$bcn,"go=s"=>\$go,"noplot=s"=>\$noplot,\
  "dtMax=f"=>\$dtMax,"kx=i"=>\$kx,"ky=i"=>\$ky,"kz=i"=>\$kz,"eps1=f"=>\$eps1,"eps2=f"=>\$eps2, "cons=i"=>\$cons );
* -------------------------------------------------------------------------------------------------
if( $go eq "halt" ){ $go = "break"; }
if( $go eq "og" ){ $go = "open graphics"; }
if( $go eq "run" || $go eq "go" ){ $go = "movie mode\n finish"; }
*
* 
* $gridName = "lattice.hdf"; $eps1=.5; $interfaceIterations=1; $tPlot=.01;
* $gridName = "lattice2.hdf"; $eps1=1.;
* $gridName = "lattice2.hdf"; $eps1=.5; $interfaceIterations=1; $tPlot=.01;
* $gridName = "lattice2.hdf"; $eps1=.5; $interfaceIterations=1;
*
* $gridName = "lattice2.order4.hdf"; $eps1=1.; $interfaceIterations=1;
* $gridName = "lattice2.order4.hdf"; $eps1=.25; $interfaceIterations=1;
* $gridName = "lattice4.order4.hdf"; $eps1=.25; $interfaceIterations=1;
* $gridName = "innerOuter2.order4.hdf"; $eps1=.25; $cfl=.8; $diss=.5; $tFinal=1.; $interfaceIterations=1; $backGround="outerSquare";
* $gridName = "innerOuter8.order4.hdf"; $eps1=.25; $cfl=.8; $diss=.5; $tFinal=1.; $interfaceIterations=1;
*
$grid
*
NFDTD
planeWaveInitialCondition
* ++ zeroInitialCondition
* ====
* planeWaveScatteredFieldInitialCondition
* ====
* twilightZone
*  degreeSpace, degreeTime  1 1
*
kx,ky,kz $kx $ky $kz
*
* bc: all=dirichlet
* bc: all=perfectElectricalConductor
bc: $backGround(0,0)=planeWaveBoundaryCondition
bc: $backGround(1,0)=abcEM2
bc: $backGround(0,1)=abcEM2
bc: $backGround(1,1)=abcEM2
* 
*      innerAnnulus
*      innerSquare
*      outerAnnulus
*      outerSquare
* NOTE: material interfaces have share>=100
** coefficients $eps1 1. all (eps,mu,grid-name)
coefficients $eps1 1. innerAnnulus* (eps,mu,grid-name)
coefficients $eps1 1. innerSquare* (eps,mu,grid-name)
coefficients $eps2 1. outerAnnulus* (eps,mu,grid-name)
coefficients $eps2 1. outerSquare* (eps,mu,grid-name)
*
interface BC iterations $interfaceIterations
*
* bc: Annulus=perfectElectricalConductor
tFinal $tFinal
tPlot  $tPlot
*
dissipation $diss
**********************************
show file options...
  MXSF:compressed
  MXSF:open
    $show
  * MXSF:frequency to save 
  MXSF:frequency to flush 100
exit
***********************************
*
* use conservative difference 0
debug 0
*
cfl $cfl 
plot errors 0
check errors 0
continue
*
plot:Ey
$go
