*================================================================================================
*  cgmx example: Test the radiation boundary conditions
*
* Usage:
*   
*  cgmx [-noplot] rbc -g=<name> -tf=<tFinal> -tp=<tPlot> -diss=<> -debug=<num> -cons=[0/1] ...
*                     -rbc=[abcEM2|rbcNonLocal|abcPML] -go=[run/halt/og]
*
*  Examples:
*     cgmx rbc -g=square128npx2y4.order4.hdf -rbc=abcEM2
*     cgmx rbc -g=square128npx2y4.order4.hdf -rbc=rbcNonLocal
*     cgmx rbc -g=square128npx2y4.order4.hdf -rbc=abcPML
*
* $show=" "; $tFinal=2.; $tPlot=.2; $cfl=.9; $diss=.1; 
* square32np.order4.hdf
* square64np.order4.hdf
* square128np.order4.hdf
* $grid="square128npx2y4.order4.hdf"; $show="gaussianInARectangle.show"; 
*
$tFinal=10.; $tPlot=.2; $diss=.1; $cfl=.9; $x0=0.5; $y0=0.5; $z0=0.; $kx=1; $ky=0; $kz=0.; 
$grid="sib1.order4.hdf"; $ic="gs"; $ks="none";
$cons=0; $go="halt"; $rbc="abcEM2"; $bcn="debug $debug"; 
* ----------------------------- get command line arguments ---------------------------------------
GetOptions( "g=s"=>\$grid,"tf=f"=>\$tFinal,"diss=f"=>\$diss,"tp=f"=>\$tPlot,"show=s"=>\$show,"debug=i"=>\$debug, \
 "cfl=f"=>\$cfl, "bg=s"=>\$backGround,"bcn=s"=>\$bcn,"go=s"=>\$go,"noplot=s"=>\$noplot,"ic=s"=>\$ic,"bc=s"=>\$bc,\
  "dtMax=f"=>\$dtMax, "cons=i"=>\$cons,"x0=f"=>\$x0,"y0=f"=>\$y0,"z0=f"=>\$z0,"kx=i"=>\$kx,"ky=i"=>\$ky,"kz=i"=>\$kz,\
   "ks=s"=>\$ks,"rbc=s"=>\$rbc );
* -------------------------------------------------------------------------------------------------
if( $go eq "halt" ){ $go = "break"; }
if( $go eq "og" ){ $go = "open graphics"; }
if( $go eq "run" || $go eq "go" ){ $go = "movie mode\n finish"; }
*
$grid
*
gaussianSource
NFDTD
* twilightZone
* planeWaveInitialCondition
* gaussianPlaneWave
* nx,ny 41 41
*
bc: square(0,0)=rbcNonLocal
bc: square(1,0)=rbcNonLocal
*
* bc: square=abcPML
* pml width,strength,power 41 30. 4
pml width,strength,power 41 50. 6
* 
* bc: square(0,0)=abcEM2
* bc: square(1,0)=abcEM2
*
$freq=10.; 
Gaussian source: 100. 5. .0 .0 0. 
tFinal $tFinal
tPlot  $tPlot
dissipation $diss
* accuracy in space 4
* accuracy in time 4
* order of dissipation 4
* trouble at corners for larger cfl:
cfl $cfl
**********************************
show file options...
  MXSF:compressed
  MXSF:open
    $show
  * MXSF:frequency to save 
  MXSF:frequency to flush 10
exit
***********************************
continue
plot:Hz


moviemode
finish
