// This file automatically generated from getInitialConditions.bC with bpp.
#include "Maxwell.h"
#include "CompositeGridOperators.h"
#include "display.h"
#include "UnstructuredMapping.h"
#include "OGPolyFunction.h"
#include "OGTrigFunction.h"
#include "OGPulseFunction.h"
#include "interpPoints.h"
#include "ShowFileReader.h"
#include "ParallelUtility.h"

#define scatCyl EXTERN_C_NAME(scatcyl)
#define scatSphere EXTERN_C_NAME(scatsphere)
#define exmax EXTERN_C_NAME(exmax)

extern "C"
{
void scatCyl(const int&nd ,
           	     const int&n1a,const int&n1b,const int&n2a,const int&n2b,const int&n3a,const int&n3b,const int&nd1a,
           	     const int&nd1b,const int&nd2a,const int&nd2b,const int&nd3a,const int&nd3b,const int&nd4a,const int&nd4b,
           	     const real& xy, real&u, const int&ipar, const real&rpar );

void scatSphere(const int&nd ,
           	     const int&n1a,const int&n1b,const int&n2a,const int&n2b,const int&n3a,const int&n3b,const int&nd1a,
           	     const int&nd1b,const int&nd2a,const int&nd2b,const int&nd3a,const int&nd3b,const int&nd4a,const int&nd4b,
           	     const real& xy, real&u, const int&ipar, const real&rpar );

void exmax(double&Ez,double&Bx,double&By,const int &nsources,const double&xs,const double&ys,
                      const double&tau,const double&var,const double&amp, const double&a,
                      const double&x,const double&y,const double&time);

}


#define FOR_3D(i1,i2,i3,I1,I2,I3) int I1Base =I1.getBase(),   I2Base =I2.getBase(),  I3Base =I3.getBase();  int I1Bound=I1.getBound(),  I2Bound=I2.getBound(), I3Bound=I3.getBound(); for(i3=I3Base; i3<=I3Bound; i3++) for(i2=I2Base; i2<=I2Bound; i2++) for(i1=I1Base; i1<=I1Bound; i1++)

#define FOR_3(i1,i2,i3,I1,I2,I3) I1Base =I1.getBase(),   I2Base =I2.getBase(),  I3Base =I3.getBase();  I1Bound=I1.getBound(),  I2Bound=I2.getBound(), I3Bound=I3.getBound(); for(i3=I3Base; i3<=I3Bound; i3++) for(i2=I2Base; i2<=I2Bound; i2++) for(i1=I1Base; i1<=I1Bound; i1++)

// Define macros for forcing functions:
//   (Ex).t = (1/eps)*[  (Hz).y ]
//   (Ey).t = (1/eps)*[ -(Hz).x ]
//   (Hz).t = (1/mu) *[ (Ex).y - (Ey).x ]

#define exTrue(x,y,t) sin(twoPi*(kx*(x)+ky*(y)-cc*(t)))*(-ky/(eps*cc))
#define eyTrue(x,y,t) sin(twoPi*(kx*(x)+ky*(y)-cc*(t)))*( kx/(eps*cc))
#define hzTrue(x,y,t) sin(twoPi*(kx*(x)+ky*(y)-cc*(t)))

#define exLaplacianTrue(x,y,t) sin(twoPi*(kx*(x)+ky*(y)-cc*(t)))*(+ky*(twoPi*twoPi*(kx*kx+ky*ky))/(eps*cc))
#define eyLaplacianTrue(x,y,t) sin(twoPi*(kx*(x)+ky*(y)-cc*(t)))*(-kx*(twoPi*twoPi*(kx*kx+ky*ky))/(eps*cc))
#define hzLaplacianTrue(x,y,t) sin(twoPi*(kx*(x)+ky*(y)-cc*(t)))*( -(twoPi*twoPi*(kx*kx+ky*ky) ) )

// define eyTrue(x,y,t) exp( -beta*SQR((x-x0)-c*(t)) )

// Here is a plane wave with the shape of a Gaussian
// xi = kx*(x)+ky*(y)-cc*(t)
// cc=  c*sqrt( kx*kx+ky*ky );
#define hzGaussianPulse(xi)  exp(-betaGaussianPlaneWave*((xi)*(xi)))
#define exGaussianPulse(xi)  hzGaussianPulse(xi)*(-ky/(eps*cc))
#define eyGaussianPulse(xi)  hzGaussianPulse(xi)*( kx/(eps*cc))

#define hzLaplacianGaussianPulse(xi)  ((4.*betaGaussianPlaneWave*betaGaussianPlaneWave*(kx*kx+ky*ky))*xi*xi-(2.*betaGaussianPlaneWave*(kx*kx+ky*ky)))*exp(-betaGaussianPlaneWave*((xi)*(xi)))
#define exLaplacianGaussianPulse(xi)  hzLaplacianGaussianPulse(xi,t)*(-ky/(eps*cc))
#define eyLaplacianGaussianPulse(xi)  hzLaplacianGaussianPulse(xi,t)*( kx/(eps*cc))

// 3D
// E:
//   u.tt = (1/eps)*[ ((1/mu)*u.x).x + ((1/mu)*u.y).y + ((1/mu)*u.z).z ]
//   div(u)=0
// H
//   v.tt = (1/mu)*[ ((1/eps)*v.x).x + ((1/eps)*v.y).y + ((1/eps)*v.z).z ]
// Define macros for forcing functions


//
//   (Ex).t = (1/eps)*[ (Hz).y - (Hy).z ]
//   (Ey).t = (1/eps)*[ (Hx).z - (Hz).x ]
//   (Ez).t = (1/eps)*[ (Hy).x - (Hx).y ]
//   (Hx).t = (1/mu) *[ (Ey).z - (Ez).y ]
//   (Hy).t = (1/mu) *[ (Ez).x - (Ex).z ]
//   (Hz).t = (1/mu) *[ (Ex).y - (Ey).x ]

// ****************** finish this -> should `rotate' the 2d solution ****************

#define exTrue3d(x,y,z,t) sin(twoPi*(kx*(x)+ky*(y)+kz*(z)-cc*(t)))*(-ky/(eps*cc))
#define eyTrue3d(x,y,z,t) sin(twoPi*(kx*(x)+ky*(y)+kz*(z)-cc*(t)))*( kx/(eps*cc))
#define ezTrue3d(x,y,z,t) 0

#define hxTrue3d(x,y,z,t) 0
#define hyTrue3d(x,y,z,t) 0
#define hzTrue3d(x,y,z,t) sin(twoPi*(kx*(x)+ky*(y)+kz*(z)-cc*(t)))

#define exLaplacianTrue3d(x,y,z,t) sin(twoPi*(kx*(x)+ky*(y)-cc*(t)))*(+ky*(twoPi*twoPi*(kx*kx+ky*ky))/(eps*cc))
#define eyLaplacianTrue3d(x,y,z,t) sin(twoPi*(kx*(x)+ky*(y)-cc*(t)))*(-kx*(twoPi*twoPi*(kx*kx+ky*ky))/(eps*cc))
#define ezLaplacianTrue3d(x,y,z,t) 0

#define hxLaplacianTrue3d(x,y,z,t) 0
#define hyLaplacianTrue3d(x,y,z,t) 0
#define hzLaplacianTrue3d(x,y,z,t) sin(twoPi*(kx*(x)+ky*(y)-cc*(t)))*( -(twoPi*twoPi*(kx*kx+ky*ky) ) )


// ------------ macros for the plane material interface -------------------------


// OPTION: initialCondition, error, boundaryCondition

//==================================================================================================
// Evaluate Tom Hagstom's exact solution defined as an integral of Guassian sources
// 
// OPTION: OPTION=solution or OPTION=error OPTION=bounary to compute the solution or the error or
//     the boundary condition
//
//==================================================================================================


//==================================================================================================
// The DEFINE_GF_MACRO is a helper for EXTRACT_GFP and sets up the cpp macros for a given field
//
//==================================================================================================
//==================================================================================================

//==================================================================================================
// The EXTRACT_GFP macro extracts gridfunction pointers and array bounds.
//                 We use these to write code that works in 2/3D for both the nfdtd and
//                 dsi schemes.
//
// The macro expects the user to have the following variables defined in the enclosing scope:
//    Index I1,I2,I3 - used to get the index ranges for each grid
//    CompositeGrid &cg - the composite grid used by the fields
//    int grid      - the current grid to setup the pointers for
//    int i1,i2,i3  - grid indices into the arrays at the appropriate centering
//    MappedGrid *Maxwell:mgp - or -
//          CompositeGrid *Maxwell cgfields -or- CompositeGrid *Maxwell dsi_cgfields
//
// The macro defines:
//    cpp macros:
//               UH{XYZ}(i0,i1,i2) - access the current h field at i1,i2,i3 with the appropriate centering
//               UE{XYZ}(i0,i1,i2) - access the current e field at i1,i2,i3 with the appropriate centering        
//               UMH{XYZ}(i0,i1,i2) - the h field at the previous timestep
//               UME{XYZ}(i0,i1,i2) - the e field at the previous timestep
//               UNH{XYZ}(i0,i1,i2) - the h field at the next timestep
//               UNE{XYZ}(i0,i1,i2) - the h field at the next timestep
//
//               ERRH{XYZ}(i0,i1,i2) - acces the h field error gridfunction
//               ERRE{XYZ}(i0,i1,i2) - acces the e field error gridfunction
//
//               XEP(i0,i1,i2,i3) - coordinates of e centering
//               XHP(i0,i1,i2,i3) - coordinates of h centering
// 
//    variables:
//               MappedGrid &mg - the current mapped grid (cg[grid])
//
//               const bool isStructured - true for structured grids
//               const bool isRectangular - true for rectangular grids
//
//               realMappedGridFunction uh - view of the current h or h.n field
//               realMappedGridFunction ue - view of the current e or e.n field
//               realMappedGridFunction umh - view of the previous h or h.n field
//               realMappedGridFunction ume - view of the previous e or e.n field
//               realMappedGridFunction unh - view of the next h or h.n field
//               realMappedGridFunction une - view of the next e or e.n field
//               realMappedGridFunction errh - view of the h field error
//               realMappedGridFunction erre - view of the e field error
//               realArray xe - view of the x coordinates at the e centering
//               realArray xh - view of the x coordinates at the h centering
//               realArray ye - view of the y coordinates at the e centering
//               realArray yh - view of the y coordinates at the h centering
//               realArray ze - view of the z coordinates at the e centering
//               realArray zh - view of the z coordinates at the h centering
//               realArray xce - coordinates of the e centering
//               realArray xch - coordinates of the h centering
//               realArray emptyArray - used for setting references to things we don't need
//               real *uhp - data pointer for the current h or h.n field
//               real *uep - data pointer for the current h or e.n field
//               real *umhp - data pointer for the previous h or h.n field
//               real *umep - data pointer for the previous h or e.n field
//               real *unhp - data pointer for the next h or h.n field
//               real *unep - data pointer for the next h or e.n field
//               real *xep - data pointer for the coordinates at the e centering
//               real *xhp - data pointer for the coordinates at the h centering
//
//               real dx[3] - dx in each direction for rectangular grids  (={0,0,0} if !isRectangular)
//               real xab[2][3] - coordinate bounds for rectangular grids (={ {0,0},.. } if !isRectangular)
//
//               int uhDim0,uhDim1,uhDim2 - array dimensions for the e gridfunctions
//               int ueDim0,ueDim1,ueDim2 - array dimensions for the h gridfunctions
//               int xeDim0,xeDim1,xeDim2 - array dimensions for the e centering coordinates
//               int xhDim0,xhDim1,xhDim2 - array dimensions for the h centering coordinates
//
// KNOWN ASSUMPTIONS:  * gridFunctions for the same variable at different time levels have the same
//                                   raw data sizes
//                     * there are unrecognized and perhaps subtle assumptions being made
//         
// OPTION: 
//==================================================================================================
//==================================================================================================
//==================================================================================================



//==================================================================================================
// This bpp macro undefs the cpp macros defined by EXTRACT_GFP
//               UH(i0,i1,i2) - access the current h field at i1,i2,i3 with the appropriate centering
//               UE(i0,i1,i2) - access the current e field at i1,i2,i3 with the appropriate centering        
//               UMH(i0,i1,i2) - the h field at the previous timestep
//               UME(i0,i1,i2) - the e field at the previous timestep
//               UNH(i0,i1,i2) - the h field at the next timestep
//               UNE(i0,i1,i2) - the h field at the next timestep
//               XEP(i0,i1,i2,i3) - coordinates of e centering
//               XHP(i0,i1,i2,i3) - coordinates of h centering
// OPTION: 
//==================================================================================================
//==================================================================================================
// Evaluate the annulus eigenfunction or it's error
// 
// OPTION: solution, error
//==================================================================================================

// Gaussian pulse initial conditions:

// =============================================================
//  Assign initial conditions for the Gaussian pulse
//
// GRIDTYPE: curvilinear or rectangular
// ==============================================================

// Polynomial TZ functions

 // ********** initialize3DPolyTW is a bpp macro that sets up the E and H polynomial tw function
    
    

// ********************************************************
// *** This macro defines the polynomial TZ functions *****
// ********************************************************


// Trigonometric TZ functions
// ***********************************************************
// *** This macro defines the trigonometric TZ functions *****
// ***********************************************************


//==================================================================================================
//==================================================================================================
int 
Maxwell::
getCenters( MappedGrid &mg, UnstructuredMapping::EntityTypeEnum cent, realArray &xe )
{
    if ( cent==UnstructuredMapping::Vertex ) 
        {
            xe.redim(0);
            xe = mg.vertex();
            return 0;
        }

    Mapping & map = mg.mapping().getMapping();
    assert( map.getClassName()=="UnstructuredMapping" );
    
    UnstructuredMapping & uns= (UnstructuredMapping &)map;
    
    UnstructuredMappingIterator citer, citer_end;
    UnstructuredMappingAdjacencyIterator viter, viter_end;
    UnstructuredMappingAdjacencyIterator fiter, fiter_end;
    int nNodes;

    xe.redim(uns.size(cent),mg.numberOfDimensions());
    xe = 0.;
    
    const realArray & verts = mg.vertex();

    citer_end = uns.end(cent);
    for ( citer=uns.begin(cent); citer!=citer_end; citer++ )
    {
        int e=*citer;
        if ( cent==UnstructuredMapping::Face || mg.numberOfDimensions()==2 || false)
        {
            nNodes = 0;
            viter_end = uns.adjacency_end(citer, UnstructuredMapping::Vertex);
            for ( viter=uns.adjacency_begin(citer, UnstructuredMapping::Vertex);
          	    viter!=viter_end;
          	    viter++ )
            {
      	int v=*viter;
      	for ( int a=0; a<mg.numberOfDimensions(); a++ )
        	  xe(e,a) += verts(v,0,0,a);
      	nNodes++;
            }
        	  
            for ( int a=0; a<mg.numberOfDimensions(); a++ )
      	xe(e,a)/=real(nNodes);
        }
        else
        {
            ArraySimpleFixed<real,3,1,1,1> xfc;
            int nFaces=0;
            fiter_end = uns.adjacency_end(citer, UnstructuredMapping::Face);
            for ( fiter=uns.adjacency_begin(citer, UnstructuredMapping::Face);
          	    fiter!=fiter_end;
          	    fiter++ )
            {
      	nNodes = 0;
      	viter_end = uns.adjacency_end(citer, UnstructuredMapping::Vertex);
      	xfc=0;
      	for ( viter=uns.adjacency_begin(citer, UnstructuredMapping::Vertex);
            	      viter!=viter_end;
            	      viter++ )
      	{
        	  int v=*viter;
        	  for ( int a=0; a<mg.numberOfDimensions(); a++ )
          	    xfc[a] += verts(v,0,0,a);
        	  nNodes++;
      	}
      	for ( int a=0; a<mg.numberOfDimensions(); a++ )
        	  xe(e,a) += xfc[a]/real(nNodes);
      	nFaces++;
            }

            for ( int a=0; a<mg.numberOfDimensions(); a++ )
      	xe(e,a) /= real(nFaces);

        }
    }
    
    return 0;
}

static int
getFaceCenters( MappedGrid & mg, realArray & xe )
{
    Mapping & map = mg.mapping().getMapping();
    assert( map.getClassName()=="UnstructuredMapping" );
    
    UnstructuredMapping & uns= (UnstructuredMapping &)map;
    
    int numberOfFaces=uns.size(UnstructuredMapping::Edge);//getNumberOfFaces();
    xe.redim(numberOfFaces,mg.numberOfDimensions());
    const realArray & x= uns.getNodes();
    const intArray & faces = uns.getFaces();
    
    for( int f=0; f<numberOfFaces; f++ )
    {
        int n0=faces(f,0), n1=faces(f,1);
        xe(f,0)=.5*( x(n0,0)+x(n1,0));
        xe(f,1)=.5*( x(n0,1)+x(n1,1));
    }
    return 0;
}





//! Return the true solution for the electric field
void Maxwell::
getField( real x, real y, real t, real *eField )
{
    const real cc= c*sqrt( kx*kx+ky*ky +kz*kz );
    eField[0]=exTrue(x,y,t);
    eField[1]=eyTrue(x,y,t);
    
}




//! Assign initial conditions
//   (Ex).t = (1/eps)*[  (Hz).y ]
//   (Ey).t = (1/eps)*[ -(Hz).x ]
//   (Hz).t = (1/mu) *[ (Ex).y - (Ey).x ]
void Maxwell::
assignInitialConditions(int current, real t, real dt )
// ===========================================================================================
// ===========================================================================================
{
    real time0=getCPU();
    
    assert( cgp!=NULL );
    CompositeGrid & cg = *cgp;
    const int numberOfDimensions=cg.numberOfDimensions();

    if( forcingOption==twilightZoneForcing )
    {
        int numberOfComponents;
        if( numberOfDimensions==2 )
            numberOfComponents=3; 
        else
            numberOfComponents=(int(solveForElectricField)+int(solveForMagneticField))*3;

        delete tz;
        if( twilightZoneOption==polynomialTwilightZone )
        {
            
            tz = new OGPolyFunction(degreeSpace,numberOfDimensions,numberOfComponents,degreeTime);
            const int ndp=max(max(5,degreeSpace+1),degreeTime+1);
            printF("\n $$$$$$$ assignInitialConditions: build OGPolyFunction: degreeSpace=%i, degreeTime=%i ndp=%i $$$$\n",
                          degreeSpace,degreeTime,ndp);
            RealArray spatialCoefficientsForTZ(ndp,ndp,ndp,numberOfComponents);  
            spatialCoefficientsForTZ=0.;
            RealArray timeCoefficientsForTZ(ndp,numberOfComponents);      
            timeCoefficientsForTZ=0.;
            if( numberOfDimensions==2 )
            {
                if( degreeSpace==0 )
                {
                    spatialCoefficientsForTZ(0,0,0,ex)=1.;      // u=1
                    spatialCoefficientsForTZ(0,0,0,ey)= 2.;      // v=2
                    spatialCoefficientsForTZ(0,0,0,hz)=-1.;      // w=-1
                }
                else if( degreeSpace==1 )
                {
                    spatialCoefficientsForTZ(0,0,0,ex)=1.;      // u=1+x+y
                    spatialCoefficientsForTZ(1,0,0,ex)=1.;
                    spatialCoefficientsForTZ(0,1,0,ex)=1.;
                    spatialCoefficientsForTZ(0,0,0,ey)= 2.;      // v=2+x-y
                    spatialCoefficientsForTZ(1,0,0,ey)= 1.;
                    spatialCoefficientsForTZ(0,1,0,ey)=-1.;
                    spatialCoefficientsForTZ(0,0,0,hz)=-1.;      // w=-1+x + y
                    spatialCoefficientsForTZ(1,0,0,hz)= 1.;
                    spatialCoefficientsForTZ(0,1,0,hz)= 1.;
                }
                else if( degreeSpace==2 )
                {
                    spatialCoefficientsForTZ(2,0,0,ex)=1.;      // u=x^2 + 2xy + y^2 
                    spatialCoefficientsForTZ(1,1,0,ex)=2.;
                    spatialCoefficientsForTZ(0,2,0,ex)=1.;
                    spatialCoefficientsForTZ(2,0,0,ey)= 1.;      // v=x^2 -2xy - y^2 
                    spatialCoefficientsForTZ(1,1,0,ey)=-2.;
                    spatialCoefficientsForTZ(0,2,0,ey)=-1.;
                    spatialCoefficientsForTZ(2,0,0,hz)= 1.;      // w=x^2 + y^2 -1 +.5 xy
                    spatialCoefficientsForTZ(0,2,0,hz)= 1.;
                    spatialCoefficientsForTZ(0,0,0,hz)=-1.; 
                    spatialCoefficientsForTZ(1,1,0,hz)= .5;
                }
                else if( degreeSpace==3 )
                {
                    spatialCoefficientsForTZ(2,0,0,ex)=1.;      // u=x^2 + 2xy + y^2 + .5*y^3 + .25*x^2*y + .2*x^3  - .3*x*y^2
                    spatialCoefficientsForTZ(1,1,0,ex)=2.;
                    spatialCoefficientsForTZ(0,2,0,ex)=1.;
                    spatialCoefficientsForTZ(0,3,0,ex)=.5;
                    spatialCoefficientsForTZ(2,1,0,ex)=.25;
                    spatialCoefficientsForTZ(3,0,0,0,ex)=.2;
                    spatialCoefficientsForTZ(1,2,0,0,ex)=-.3;
                    spatialCoefficientsForTZ(2,0,0,ey)= 1.;      // v=x^2 -2xy - y^2 -.5*x^3 -.25*x*y^2  -.6*x^2*y + .1*y^3
                    spatialCoefficientsForTZ(1,1,0,ey)=-2.;
                    spatialCoefficientsForTZ(0,2,0,ey)=-1.;
                    spatialCoefficientsForTZ(3,0,0,ey)=-.5;
                    spatialCoefficientsForTZ(1,2,0,ey)=-.25;
                    spatialCoefficientsForTZ(2,1,0,ey)=-.6;
                    spatialCoefficientsForTZ(0,3,0,ey)= .1;
                    spatialCoefficientsForTZ(2,0,0,hz)= 1.;      // w=x^2 + y^2 -1 +.5 xy + .25*x^3 - .25*y^3
                    spatialCoefficientsForTZ(0,2,0,hz)= 1.;
                    spatialCoefficientsForTZ(0,0,0,hz)=-1.; 
                    spatialCoefficientsForTZ(1,1,0,hz)= .5;
                    spatialCoefficientsForTZ(3,0,0,hz)= .25;
                    spatialCoefficientsForTZ(0,3,0,hz)=-.25;
                }
                else if( degreeSpace==4 || degreeSpace==5 )
                {
                    if( degreeSpace!=4 ) printF(" ****WARNING***** using a TZ function with degree=4 in space *****\n");
                    spatialCoefficientsForTZ(2,0,0,hz)= 1.;      // p=x^2 + y^2 -1 +.5 xy + x^4 + y^4 
                    spatialCoefficientsForTZ(0,2,0,hz)= 1.;
                    spatialCoefficientsForTZ(0,0,0,hz)=-1.; 
                    spatialCoefficientsForTZ(1,1,0,hz)= .5;
                    spatialCoefficientsForTZ(4,0,0,hz)= 1.;     
                    spatialCoefficientsForTZ(0,4,0,hz)= 1.;     
                    spatialCoefficientsForTZ(2,2,0,hz)= -.3;
                    spatialCoefficientsForTZ(2,0,0,ex)=1.;      // u=x^2 + 2xy + y^2 + .2*x^4 + .5*y^4 + xy^3
                    spatialCoefficientsForTZ(1,1,0,ex)=2.;
                    spatialCoefficientsForTZ(0,2,0,ex)=1.;
                    spatialCoefficientsForTZ(4,0,0,ex)=.2;   
                    spatialCoefficientsForTZ(0,4,0,ex)=.5;   
                    spatialCoefficientsForTZ(1,3,0,ex)=1.;   
                    spatialCoefficientsForTZ(2,0,0,ey)= 1.;      // v=x^2 -2xy - y^2 +.125*x^4 -.25*y^4 -.8*x^3 y
                    spatialCoefficientsForTZ(1,1,0,ey)=-2.;
                    spatialCoefficientsForTZ(0,2,0,ey)=-1.;
                    spatialCoefficientsForTZ(4,0,0,ey)=.125;
                    spatialCoefficientsForTZ(0,4,0,ey)=-.25;
                    spatialCoefficientsForTZ(3,1,0,ey)=-.8;
                }
                else if( degreeSpace>=6 )
                {
                    if( degreeSpace!=6 ) printF(" ****WARNING***** using a TZ function with degree=4 in space *****\n");
                    spatialCoefficientsForTZ(1,0,0,hz)= 1.;
                    spatialCoefficientsForTZ(0,0,0,hz)= 1.;
                    spatialCoefficientsForTZ(2,0,0,hz)= 1.;      // p=x^2 + y^2 -1 +.5 xy + x^4 + y^4 
                    spatialCoefficientsForTZ(0,2,0,hz)= 1.;
                    spatialCoefficientsForTZ(0,0,0,hz)=-1.; 
                    spatialCoefficientsForTZ(1,1,0,hz)= .5;
                    spatialCoefficientsForTZ(4,0,0,hz)= .2;     
                    spatialCoefficientsForTZ(0,4,0,hz)= .4;     
                    spatialCoefficientsForTZ(2,2,0,hz)= -.3;
                    spatialCoefficientsForTZ(3,2,0,hz)= .4;  
                    spatialCoefficientsForTZ(2,3,0,hz)= .8;  
                    spatialCoefficientsForTZ(3,3,0,hz)= .7;  
                    spatialCoefficientsForTZ(5,1,0,hz)= .25;  
                    spatialCoefficientsForTZ(1,5,0,hz)=-.25;  
                    spatialCoefficientsForTZ(6,0,0,hz)= .2;     
                    spatialCoefficientsForTZ(0,6,0,hz)=-.2;     
          //    spatialCoefficientsForTZ=0.; // ************************************************
          //spatialCoefficientsForTZ(2,4,0,hz)= 1.;
          //spatialCoefficientsForTZ(4,2,0,hz)= 1.;
                    spatialCoefficientsForTZ(2,0,0,ex)=1.;      // u=x^2 + 2xy + y^2 + .2*x^4 + .5*y^4 + xy^3
                    spatialCoefficientsForTZ(1,1,0,ex)=2.;
                    spatialCoefficientsForTZ(0,2,0,ex)=1.;
                    spatialCoefficientsForTZ(4,0,0,ex)=.2;   
                    spatialCoefficientsForTZ(0,4,0,ex)=.5;   
                    spatialCoefficientsForTZ(1,3,0,ex)=1.;   
                    spatialCoefficientsForTZ(3,2,0,ex)=.1;      // .1*x^3*y^2
                    spatialCoefficientsForTZ(4,2,0,ex)=.3;      // .3 x^4 y^2 ** III
                    spatialCoefficientsForTZ(3,3,0,ex)=.4;      // .4 x^3 y^3 ** IV 
                    spatialCoefficientsForTZ(6,0,0,ex)=.1;      //  + .1*x^6 +.25*y^6 -.6*x*y^5
                    spatialCoefficientsForTZ(0,6,0,ex)=.25;
                    spatialCoefficientsForTZ(1,5,0,ex)=-.6;
                    spatialCoefficientsForTZ(2,0,0,ey)= 1.;      // v=x^2 -2xy - y^2 +.125*x^4 -.25*y^4 -.8*x^3 y
                    spatialCoefficientsForTZ(1,1,0,ey)=-2.;
                    spatialCoefficientsForTZ(0,2,0,ey)=-1.;
                    spatialCoefficientsForTZ(2,3,0,ey)=-.1;      // -.1*x^2*y^3
                    spatialCoefficientsForTZ(3,3,0,ey)=-.4;     //-.4 x^3 y^3 ** III 
                    spatialCoefficientsForTZ(2,4,0,ey)=-.3;      //-.3 x^2 y^4 ** IV
                    spatialCoefficientsForTZ(4,0,0,ey)=.125;
                    spatialCoefficientsForTZ(0,4,0,ey)=-.25;
                    spatialCoefficientsForTZ(3,1,0,ey)=-.8;
                    spatialCoefficientsForTZ(6,0,0,ey)=.3;    //   .3*x^6 +.1*y^6  + .6*x^5*y 
                    spatialCoefficientsForTZ(0,6,0,ey)=.1;
                    spatialCoefficientsForTZ(5,1,0,ey)=-.6;
                }
                else
                {
                    printF("Maxwell:: not implemented for degree in space =%i \n",degreeSpace);
                    Overture::abort("error");
                }
            }
      // *****************************************************************
      // ******************* Three Dimensions ****************************
      // *****************************************************************
            else if( numberOfDimensions==3 )
            {
                if( solveForMagneticField )
                {
                    Overture::abort("forcing not finished for H in 3d");
                }
                if ( solveForElectricField )
                {
                        if( (degreeSpaceX==0 || degreeSpaceY==0 || degreeSpaceZ==0) 
                                && (degreeSpaceX!=0 || degreeSpaceY!=0 || degreeSpaceZ!=0)  )
                            {
                // For testing we can set the TZ function in 3D to equal that of the 2D function
                            int e1,e2;
                            if( degreeSpaceX==0 )
                            { // here we rotate about the y-axis so (x->z, y->y)
                                e1=ez; e2=ey;
                            }
                            else if( degreeSpaceY==0 )
                            { // here we rotate about the x-axis  (y->z x->x
                                e1=ex; e2=ez;
                            }
                            else
                            {
                                e1=ex; e2=ey;
                            }
                            int degreeSpace2=max(degreeSpaceX,degreeSpaceY,degreeSpaceZ);
                            if( degreeSpace2==1 )
                            {
                                spatialCoefficientsForTZ(0,0,0,e1)=1.;      // u=1+x+y
                                spatialCoefficientsForTZ(1,0,0,e1)=1.;
                                spatialCoefficientsForTZ(0,1,0,e1)=1.;
                                spatialCoefficientsForTZ(0,0,0,e2)= 2.;      // v=2+x-y
                                spatialCoefficientsForTZ(1,0,0,e2)= 1.;
                                spatialCoefficientsForTZ(0,1,0,e2)=-1.;
                            }
                            else if( degreeSpace2==2 )
                            {
                                spatialCoefficientsForTZ(2,0,0,e1)=1.;      // u=x^2 + 2xy + y^2 
                                spatialCoefficientsForTZ(1,1,0,e1)=2.;
                                spatialCoefficientsForTZ(0,2,0,e1)=1.;
                                spatialCoefficientsForTZ(2,0,0,e2)= 1.;      // v=x^2 -2xy - y^2 
                                spatialCoefficientsForTZ(1,1,0,e2)=-2.;
                                spatialCoefficientsForTZ(0,2,0,e2)=-1.;
                            }
                            else if( degreeSpace2==3 )
                            {
                                spatialCoefficientsForTZ(2,0,0,e1)=1.;      // u=x^2 + 2xy + y^2 + .5*y^3 + .25*x^2*y + .2*x^3  - .3*x*y^2
                                spatialCoefficientsForTZ(1,1,0,e1)=2.;
                                spatialCoefficientsForTZ(0,2,0,e1)=1.;
                                spatialCoefficientsForTZ(0,3,0,e1)=.5;
                                spatialCoefficientsForTZ(2,1,0,e1)=.25;
                                spatialCoefficientsForTZ(3,0,0,0,e1)=.2;
                                spatialCoefficientsForTZ(1,2,0,0,e1)=-.3;
                                spatialCoefficientsForTZ(2,0,0,e2)= 1.;      // v=x^2 -2xy - y^2 -.5*x^3 -.25*x*y^2  -.6*x^2*y + .1*y^3
                                spatialCoefficientsForTZ(1,1,0,e2)=-2.;
                                spatialCoefficientsForTZ(0,2,0,e2)=-1.;
                                spatialCoefficientsForTZ(3,0,0,e2)=-.5;
                                spatialCoefficientsForTZ(1,2,0,e2)=-.25;
                                spatialCoefficientsForTZ(2,1,0,e2)=-.6;
                                spatialCoefficientsForTZ(0,3,0,e2)= .1;
                            }
                            else if( degreeSpace2==4 ) 
                            {
                                if( degreeSpaceZ==0 )
                                {
                          	spatialCoefficientsForTZ(2,0,0,e1)=1.;      // u=x^2 + 2xy + y^2 + .2*x^4 + .5*y^4 + xy^3
                          	spatialCoefficientsForTZ(1,1,0,e1)=2.;
                          	spatialCoefficientsForTZ(0,2,0,e1)=1.;
                          	spatialCoefficientsForTZ(4,0,0,e1)=.2;   
                          	spatialCoefficientsForTZ(0,4,0,e1)=.5;   
                          	spatialCoefficientsForTZ(1,3,0,e1)=1.;   
                          	spatialCoefficientsForTZ(2,0,0,e2)= 1.;      // v=x^2 -2xy - y^2 +.125*x^4 -.25*y^4 -.8*x^3 y
                          	spatialCoefficientsForTZ(1,1,0,e2)=-2.;
                          	spatialCoefficientsForTZ(0,2,0,e2)=-1.;
                          	spatialCoefficientsForTZ(4,0,0,e2)=.125;
                          	spatialCoefficientsForTZ(0,4,0,e2)=-.25;
                          	spatialCoefficientsForTZ(3,1,0,e2)=-.8;
                                }
                                else if( degreeSpaceX==0 )// degreeSpaceX==0
                                {
          	// switch x->z
                          	spatialCoefficientsForTZ(0,0,2,e1)=1.;      // u=x^2 + 2xy + y^2 + .2*x^4 + .5*y^4 + xy^3
                          	spatialCoefficientsForTZ(0,1,1,e1)=2.;
                          	spatialCoefficientsForTZ(0,2,0,e1)=1.;
                          	spatialCoefficientsForTZ(0,0,4,e1)=.2;   
                          	spatialCoefficientsForTZ(0,4,0,e1)=.5;   
                          	spatialCoefficientsForTZ(0,3,1,e1)=1.;   
                          	spatialCoefficientsForTZ(0,0,2,e2)= 1.;      // v=x^2 -2xy - y^2 +.125*x^4 -.25*y^4 -.8*x^3 y
                          	spatialCoefficientsForTZ(0,1,1,e2)=-2.;
                          	spatialCoefficientsForTZ(0,2,0,e2)=-1.;
                          	spatialCoefficientsForTZ(0,0,4,e2)=.125;
                          	spatialCoefficientsForTZ(0,4,0,e2)=-.25;
                          	spatialCoefficientsForTZ(0,1,3,e2)=-.8;
                                }
                                else  // degreeY==0   
                                {
                          	spatialCoefficientsForTZ(2,0,0,e1)=1.;      // u=x^2 + 2xy + y^2 + .2*x^4 + .5*y^4 + xy^3
                          	spatialCoefficientsForTZ(1,0,1,e1)=2.;
                          	spatialCoefficientsForTZ(0,0,2,e1)=1.;
                          	spatialCoefficientsForTZ(4,0,0,e1)=.2;   
                          	spatialCoefficientsForTZ(0,0,4,e1)=.5;   
                          	spatialCoefficientsForTZ(1,0,3,e1)=1.;   
                          	spatialCoefficientsForTZ(2,0,0,e2)= 1.;      // v=x^2 -2xy - y^2 +.125*x^4 -.25*y^4 -.8*x^3 y
                          	spatialCoefficientsForTZ(1,0,1,e2)=-2.;
                          	spatialCoefficientsForTZ(0,0,2,e2)=-1.;
                          	spatialCoefficientsForTZ(4,0,0,e2)=.125;
                          	spatialCoefficientsForTZ(0,0,4,e2)=-.25;
                          	spatialCoefficientsForTZ(3,0,1,e2)=-.8;
                                }
                            }
                            else
                                {
                          	Overture::abort("unimplemented values of degreeSpace");
                                }
                            }
                        else if( degreeSpace==1 )
                        {
                            spatialCoefficientsForTZ(0,0,0,ex)=1.;      // u=1 + x + y + z
                            spatialCoefficientsForTZ(1,0,0,ex)=1.;
                            spatialCoefficientsForTZ(0,1,0,ex)=1.;
                            spatialCoefficientsForTZ(0,0,1,ex)=1.;
                            spatialCoefficientsForTZ(0,0,0,ey)= 2.;      // v=2+x-2y+z
                            spatialCoefficientsForTZ(1,0,0,ey)= 1.;
                            spatialCoefficientsForTZ(0,1,0,ey)=-2.;
                            spatialCoefficientsForTZ(0,0,1,ey)= 1.;
                            spatialCoefficientsForTZ(1,0,0,ez)=-1.;      // w=-x+y+z
                            spatialCoefficientsForTZ(0,1,0,ez)= 1.;
                            spatialCoefficientsForTZ(0,0,1,ez)= 1.;
                        }
                        else if( degreeSpace==2 )
                            {
                                spatialCoefficientsForTZ(2,0,0,ex)=1.;      // u=x^2 + 2xy + y^2 + xz  - .25*yz -.5*z^2
                                spatialCoefficientsForTZ(1,1,0,ex)=2.;
                                spatialCoefficientsForTZ(0,2,0,ex)=1.;
                                spatialCoefficientsForTZ(1,0,1,ex)=1.;
                                spatialCoefficientsForTZ(0,1,1,ex)=-.25;
                                spatialCoefficientsForTZ(0,0,2,ex)=-.5;
                                spatialCoefficientsForTZ(2,0,0,ey)= 1.;      // v=x^2 -2xy - y^2 + 3yz + .25*xz +.5*z^2
                                spatialCoefficientsForTZ(1,1,0,ey)=-2.;
                                spatialCoefficientsForTZ(0,2,0,ey)=-1.;
                                spatialCoefficientsForTZ(0,1,1,ey)=+3.;
                                spatialCoefficientsForTZ(1,0,1,ey)=.25;
                                spatialCoefficientsForTZ(0,0,2,ey)=.5;
                                spatialCoefficientsForTZ(2,0,0,ez)= 1.;      // w=x^2 + y^2 - 2 z^2 + .25*xy 
                                spatialCoefficientsForTZ(0,2,0,ez)= 1.;
                                spatialCoefficientsForTZ(0,0,2,ez)=-2.;
                                spatialCoefficientsForTZ(1,1,0,ez)=.25;
                            }
                        else if( degreeSpace==0 )
                            {
                                spatialCoefficientsForTZ(0,0,0,ex)=1.; // -1.; 
                                spatialCoefficientsForTZ(0,0,0,ey)=1.; //-.5;
                                spatialCoefficientsForTZ(0,0,0,ez)=1.; //.75; 
                            }
                        else if( degreeSpace==3 )
                            {
                                spatialCoefficientsForTZ(2,0,0,ex)=1.;      // u=x^2 + 2xy + y^2 + xz 
                                spatialCoefficientsForTZ(1,1,0,ex)=2.;    //        + .125( x^3 + y^3 + z^3 ) -.75*x*y^2 + x^2*z +.4yz
                                spatialCoefficientsForTZ(0,2,0,ex)=1.;
                                spatialCoefficientsForTZ(1,0,1,ex)=1.;
                                spatialCoefficientsForTZ(3,0,0,ex)=.125; 
                                spatialCoefficientsForTZ(0,3,0,ex)=.125; 
                                spatialCoefficientsForTZ(0,0,3,ex)=.125; 
                                spatialCoefficientsForTZ(1,2,0,ex)=-.75;
                                spatialCoefficientsForTZ(2,0,1,ex)=+1.; 
                                spatialCoefficientsForTZ(0,1,1,ex)=.4; 
                                spatialCoefficientsForTZ(2,0,0,ey)= 1.;      // v=x^2 -2xy - y^2 + 3yz 
                                spatialCoefficientsForTZ(1,1,0,ey)=-2.;      //    + .25( x^3 + y^3 + z^3 ) -.375*x^2 y  -.375*y*z^2  
                                spatialCoefficientsForTZ(0,2,0,ey)=-1.;
                                spatialCoefficientsForTZ(0,1,1,ey)=+3.;
                                spatialCoefficientsForTZ(3,0,0,ey)=.25; 
                                spatialCoefficientsForTZ(0,3,0,ey)=.25; 
                                spatialCoefficientsForTZ(0,0,3,ey)=.25; 
                                spatialCoefficientsForTZ(2,1,0,ey)=-3.*.125; 
                                spatialCoefficientsForTZ(0,1,2,ey)=-3.*.125; 
                                spatialCoefficientsForTZ(2,0,0,ez)= 1.;      // w=x^2 + y^2 - 2 z^2 
                                spatialCoefficientsForTZ(0,2,0,ez)= 1.;      //      + .25x^3 -.2y^3 +.125 z^3 - x z^2 -.6*xy^2
                                spatialCoefficientsForTZ(0,0,2,ez)=-2.;
                                spatialCoefficientsForTZ(3,0,0,ez)=.25; 
                                spatialCoefficientsForTZ(0,3,0,ez)=-.2; 
                                spatialCoefficientsForTZ(0,0,3,ez)=.125; 
                                spatialCoefficientsForTZ(1,0,2,ez)=-1.;
                                spatialCoefficientsForTZ(1,2,0,ez)=-.6;
                            }
                        else if( degreeSpace==4 )
                            {
                                spatialCoefficientsForTZ(2,0,0,ex)=1.;      // u=x^2 + 2xy + y^2 + xz
                                spatialCoefficientsForTZ(1,1,0,ex)=2.;
                                spatialCoefficientsForTZ(0,2,0,ex)=1.;
                                spatialCoefficientsForTZ(1,0,1,ex)=1.;
                                spatialCoefficientsForTZ(3,0,0,ex)=.5;      // + .5*x^3
                                spatialCoefficientsForTZ(4,0,0,ex)=.125;    // + .125*x^4 + .125*y^4 + .125*z^4  -.5*xz^3
                                spatialCoefficientsForTZ(0,4,0,ex)=.125;    
                                spatialCoefficientsForTZ(0,0,4,ex)=.125; 
                                spatialCoefficientsForTZ(1,0,3,ex)=-.5; 
                                spatialCoefficientsForTZ(0,1,3,ex)=.25;    // + .25*y*z^3 -.25*y^2*z^2 +.25*y^3z
                                spatialCoefficientsForTZ(0,2,2,ex)=-.25; 
                                spatialCoefficientsForTZ(0,3,1,ex)=.25; 
                                spatialCoefficientsForTZ(2,0,0,ey)= 1.;      // v=x^2 -2xy - y^2 + 3yz
                                spatialCoefficientsForTZ(1,1,0,ey)=-2.;
                                spatialCoefficientsForTZ(0,2,0,ey)=-1.;
                                spatialCoefficientsForTZ(0,1,1,ey)=+3.;
                                spatialCoefficientsForTZ(2,1,0,ey)=-1.5;     // -1.5x^2*y
                                spatialCoefficientsForTZ(4,0,0,ey)=.25; 
                                spatialCoefficientsForTZ(0,4,0,ey)=.25; 
                                spatialCoefficientsForTZ(0,0,4,ey)=.25; 
                                spatialCoefficientsForTZ(3,1,0,ey)=-.5; 
                                spatialCoefficientsForTZ(1,0,3,ey)=.25;    // + .25*x*z^3 -.25*x^2*z^2 +.25*x^3z
                                spatialCoefficientsForTZ(2,0,2,ey)=-.25; 
                                spatialCoefficientsForTZ(3,0,1,ey)=.25; 
                                spatialCoefficientsForTZ(2,0,0,ez)= 1.;      // w=x^2 + y^2 - 2 z^2
                                spatialCoefficientsForTZ(0,2,0,ez)= 1.;
                                spatialCoefficientsForTZ(0,0,2,ez)=-2.;
                                spatialCoefficientsForTZ(4,0,0,ez)=.25; 
                                spatialCoefficientsForTZ(0,4,0,ez)=-.2; 
                                spatialCoefficientsForTZ(0,0,4,ez)=.125; 
                                spatialCoefficientsForTZ(0,3,1,ez)=-1.;
                                spatialCoefficientsForTZ(1,3,0,ez)=.25;    // + .25*x*y^3 -.25*x^2*y^2 +.25*x^3y
                                spatialCoefficientsForTZ(2,2,0,ez)=-.25; 
                                spatialCoefficientsForTZ(3,1,0,ez)=.25; 
                        }
                        else if( degreeSpace>=5 )
                        {
                            if( true || degreeSpace!=5 ) printF(" ****WARNING***** using a TZ function with degree=5 in space *****\n");
                            spatialCoefficientsForTZ(2,0,0,ex)=1.;      // u=x^2 + 2xy + y^2 + xz
                            spatialCoefficientsForTZ(1,1,0,ex)=2.;
                            spatialCoefficientsForTZ(0,2,0,ex)=1.;
                            spatialCoefficientsForTZ(1,0,1,ex)=1.;
                            spatialCoefficientsForTZ(4,0,0,ex)=.125;    // + .125*x^4 + .125*y^4 + .125*z^4  -.5*xz^3
                            spatialCoefficientsForTZ(0,4,0,ex)=.125;    
                            spatialCoefficientsForTZ(0,0,4,ex)=.125; 
                            spatialCoefficientsForTZ(1,0,3,ex)=-.5; 
                            spatialCoefficientsForTZ(0,1,3,ex)=.25;    // + .25*y*z^3 -.25*y^2*z^2 +.25*y^3z
                            spatialCoefficientsForTZ(0,2,2,ex)=-.25; 
                            spatialCoefficientsForTZ(0,3,1,ex)=.25; 
                            spatialCoefficientsForTZ(0,5,0,ex)=.125;   // y^5
                            spatialCoefficientsForTZ(2,0,0,ey)= 1.;      // v=x^2 -2xy - y^2 + 3yz
                            spatialCoefficientsForTZ(1,1,0,ey)=-2.;
                            spatialCoefficientsForTZ(0,2,0,ey)=-1.;
                            spatialCoefficientsForTZ(0,1,1,ey)=+3.;
                            spatialCoefficientsForTZ(4,0,0,ey)=.25; 
                            spatialCoefficientsForTZ(0,4,0,ey)=.25; 
                            spatialCoefficientsForTZ(0,0,4,ey)=.25; 
                            spatialCoefficientsForTZ(3,1,0,ey)=-.5; 
                            spatialCoefficientsForTZ(1,0,3,ey)=.25;    // + .25*x*z^3 -.25*x^2*z^2 +.25*x^3z
                            spatialCoefficientsForTZ(2,0,2,ey)=-.25; 
                            spatialCoefficientsForTZ(3,0,1,ey)=.25; 
              // spatialCoefficientsForTZ(5,0,0,ey)=.125;  // x^5
                            spatialCoefficientsForTZ(2,0,0,ez)= 1.;      // w=x^2 + y^2 - 2 z^2
                            spatialCoefficientsForTZ(0,2,0,ez)= 1.;
                            spatialCoefficientsForTZ(0,0,2,ez)=-2.;
                            spatialCoefficientsForTZ(4,0,0,ez)=.25; 
                            spatialCoefficientsForTZ(0,4,0,ez)=-.2; 
                            spatialCoefficientsForTZ(0,0,4,ez)=.125; 
                            spatialCoefficientsForTZ(0,3,1,ez)=-1.;
                            spatialCoefficientsForTZ(1,3,0,ez)=.25;    // + .25*x*y^3 -.25*x^2*y^2 +.25*x^3y
                            spatialCoefficientsForTZ(2,2,0,ez)=-.25; 
                            spatialCoefficientsForTZ(3,1,0,ez)=.25; 
              // spatialCoefficientsForTZ(5,0,0,ez)=.125;
                        }
                        else
                        {
                            printF("Maxwell:: not implemented for degree in space =%i \n",degreeSpace);
                            Overture::abort("error");
                        }
          	// *** end the initialize3DPolyTW bpp macro 
                }
                if ( solveForMagneticField )
                {
                        if( (degreeSpaceX==0 || degreeSpaceY==0 || degreeSpaceZ==0) 
                                && (degreeSpaceX!=0 || degreeSpaceY!=0 || degreeSpaceZ!=0)  )
                            {
                // For testing we can set the TZ function in 3D to equal that of the 2D function
                            int e1,e2;
                            if( degreeSpaceX==0 )
                            { // here we rotate about the y-axis so (x->z, y->y)
                                e1=hz; e2=hy;
                            }
                            else if( degreeSpaceY==0 )
                            { // here we rotate about the x-axis  (y->z x->x
                                e1=hx; e2=hz;
                            }
                            else
                            {
                                e1=hx; e2=hy;
                            }
                            int degreeSpace2=max(degreeSpaceX,degreeSpaceY,degreeSpaceZ);
                            if( degreeSpace2==1 )
                            {
                                spatialCoefficientsForTZ(0,0,0,e1)=1.;      // u=1+x+y
                                spatialCoefficientsForTZ(1,0,0,e1)=1.;
                                spatialCoefficientsForTZ(0,1,0,e1)=1.;
                                spatialCoefficientsForTZ(0,0,0,e2)= 2.;      // v=2+x-y
                                spatialCoefficientsForTZ(1,0,0,e2)= 1.;
                                spatialCoefficientsForTZ(0,1,0,e2)=-1.;
                            }
                            else if( degreeSpace2==2 )
                            {
                                spatialCoefficientsForTZ(2,0,0,e1)=1.;      // u=x^2 + 2xy + y^2 
                                spatialCoefficientsForTZ(1,1,0,e1)=2.;
                                spatialCoefficientsForTZ(0,2,0,e1)=1.;
                                spatialCoefficientsForTZ(2,0,0,e2)= 1.;      // v=x^2 -2xy - y^2 
                                spatialCoefficientsForTZ(1,1,0,e2)=-2.;
                                spatialCoefficientsForTZ(0,2,0,e2)=-1.;
                            }
                            else if( degreeSpace2==3 )
                            {
                                spatialCoefficientsForTZ(2,0,0,e1)=1.;      // u=x^2 + 2xy + y^2 + .5*y^3 + .25*x^2*y + .2*x^3  - .3*x*y^2
                                spatialCoefficientsForTZ(1,1,0,e1)=2.;
                                spatialCoefficientsForTZ(0,2,0,e1)=1.;
                                spatialCoefficientsForTZ(0,3,0,e1)=.5;
                                spatialCoefficientsForTZ(2,1,0,e1)=.25;
                                spatialCoefficientsForTZ(3,0,0,0,e1)=.2;
                                spatialCoefficientsForTZ(1,2,0,0,e1)=-.3;
                                spatialCoefficientsForTZ(2,0,0,e2)= 1.;      // v=x^2 -2xy - y^2 -.5*x^3 -.25*x*y^2  -.6*x^2*y + .1*y^3
                                spatialCoefficientsForTZ(1,1,0,e2)=-2.;
                                spatialCoefficientsForTZ(0,2,0,e2)=-1.;
                                spatialCoefficientsForTZ(3,0,0,e2)=-.5;
                                spatialCoefficientsForTZ(1,2,0,e2)=-.25;
                                spatialCoefficientsForTZ(2,1,0,e2)=-.6;
                                spatialCoefficientsForTZ(0,3,0,e2)= .1;
                            }
                            else if( degreeSpace2==4 ) 
                            {
                                if( degreeSpaceZ==0 )
                                {
                          	spatialCoefficientsForTZ(2,0,0,e1)=1.;      // u=x^2 + 2xy + y^2 + .2*x^4 + .5*y^4 + xy^3
                          	spatialCoefficientsForTZ(1,1,0,e1)=2.;
                          	spatialCoefficientsForTZ(0,2,0,e1)=1.;
                          	spatialCoefficientsForTZ(4,0,0,e1)=.2;   
                          	spatialCoefficientsForTZ(0,4,0,e1)=.5;   
                          	spatialCoefficientsForTZ(1,3,0,e1)=1.;   
                          	spatialCoefficientsForTZ(2,0,0,e2)= 1.;      // v=x^2 -2xy - y^2 +.125*x^4 -.25*y^4 -.8*x^3 y
                          	spatialCoefficientsForTZ(1,1,0,e2)=-2.;
                          	spatialCoefficientsForTZ(0,2,0,e2)=-1.;
                          	spatialCoefficientsForTZ(4,0,0,e2)=.125;
                          	spatialCoefficientsForTZ(0,4,0,e2)=-.25;
                          	spatialCoefficientsForTZ(3,1,0,e2)=-.8;
                                }
                                else if( degreeSpaceX==0 )// degreeSpaceX==0
                                {
          	// switch x->z
                          	spatialCoefficientsForTZ(0,0,2,e1)=1.;      // u=x^2 + 2xy + y^2 + .2*x^4 + .5*y^4 + xy^3
                          	spatialCoefficientsForTZ(0,1,1,e1)=2.;
                          	spatialCoefficientsForTZ(0,2,0,e1)=1.;
                          	spatialCoefficientsForTZ(0,0,4,e1)=.2;   
                          	spatialCoefficientsForTZ(0,4,0,e1)=.5;   
                          	spatialCoefficientsForTZ(0,3,1,e1)=1.;   
                          	spatialCoefficientsForTZ(0,0,2,e2)= 1.;      // v=x^2 -2xy - y^2 +.125*x^4 -.25*y^4 -.8*x^3 y
                          	spatialCoefficientsForTZ(0,1,1,e2)=-2.;
                          	spatialCoefficientsForTZ(0,2,0,e2)=-1.;
                          	spatialCoefficientsForTZ(0,0,4,e2)=.125;
                          	spatialCoefficientsForTZ(0,4,0,e2)=-.25;
                          	spatialCoefficientsForTZ(0,1,3,e2)=-.8;
                                }
                                else  // degreeY==0   
                                {
                          	spatialCoefficientsForTZ(2,0,0,e1)=1.;      // u=x^2 + 2xy + y^2 + .2*x^4 + .5*y^4 + xy^3
                          	spatialCoefficientsForTZ(1,0,1,e1)=2.;
                          	spatialCoefficientsForTZ(0,0,2,e1)=1.;
                          	spatialCoefficientsForTZ(4,0,0,e1)=.2;   
                          	spatialCoefficientsForTZ(0,0,4,e1)=.5;   
                          	spatialCoefficientsForTZ(1,0,3,e1)=1.;   
                          	spatialCoefficientsForTZ(2,0,0,e2)= 1.;      // v=x^2 -2xy - y^2 +.125*x^4 -.25*y^4 -.8*x^3 y
                          	spatialCoefficientsForTZ(1,0,1,e2)=-2.;
                          	spatialCoefficientsForTZ(0,0,2,e2)=-1.;
                          	spatialCoefficientsForTZ(4,0,0,e2)=.125;
                          	spatialCoefficientsForTZ(0,0,4,e2)=-.25;
                          	spatialCoefficientsForTZ(3,0,1,e2)=-.8;
                                }
                            }
                            else
                                {
                          	Overture::abort("unimplemented values of degreeSpace");
                                }
                            }
                        else if( degreeSpace==1 )
                        {
                            spatialCoefficientsForTZ(0,0,0,hx)=1.;      // u=1 + x + y + z
                            spatialCoefficientsForTZ(1,0,0,hx)=1.;
                            spatialCoefficientsForTZ(0,1,0,hx)=1.;
                            spatialCoefficientsForTZ(0,0,1,hx)=1.;
                            spatialCoefficientsForTZ(0,0,0,hy)= 2.;      // v=2+x-2y+z
                            spatialCoefficientsForTZ(1,0,0,hy)= 1.;
                            spatialCoefficientsForTZ(0,1,0,hy)=-2.;
                            spatialCoefficientsForTZ(0,0,1,hy)= 1.;
                            spatialCoefficientsForTZ(1,0,0,hz)=-1.;      // w=-x+y+z
                            spatialCoefficientsForTZ(0,1,0,hz)= 1.;
                            spatialCoefficientsForTZ(0,0,1,hz)= 1.;
                        }
                        else if( degreeSpace==2 )
                            {
                                spatialCoefficientsForTZ(2,0,0,hx)=1.;      // u=x^2 + 2xy + y^2 + xz  - .25*yz -.5*z^2
                                spatialCoefficientsForTZ(1,1,0,hx)=2.;
                                spatialCoefficientsForTZ(0,2,0,hx)=1.;
                                spatialCoefficientsForTZ(1,0,1,hx)=1.;
                                spatialCoefficientsForTZ(0,1,1,hx)=-.25;
                                spatialCoefficientsForTZ(0,0,2,hx)=-.5;
                                spatialCoefficientsForTZ(2,0,0,hy)= 1.;      // v=x^2 -2xy - y^2 + 3yz + .25*xz +.5*z^2
                                spatialCoefficientsForTZ(1,1,0,hy)=-2.;
                                spatialCoefficientsForTZ(0,2,0,hy)=-1.;
                                spatialCoefficientsForTZ(0,1,1,hy)=+3.;
                                spatialCoefficientsForTZ(1,0,1,hy)=.25;
                                spatialCoefficientsForTZ(0,0,2,hy)=.5;
                                spatialCoefficientsForTZ(2,0,0,hz)= 1.;      // w=x^2 + y^2 - 2 z^2 + .25*xy 
                                spatialCoefficientsForTZ(0,2,0,hz)= 1.;
                                spatialCoefficientsForTZ(0,0,2,hz)=-2.;
                                spatialCoefficientsForTZ(1,1,0,hz)=.25;
                            }
                        else if( degreeSpace==0 )
                            {
                                spatialCoefficientsForTZ(0,0,0,hx)=1.; // -1.; 
                                spatialCoefficientsForTZ(0,0,0,hy)=1.; //-.5;
                                spatialCoefficientsForTZ(0,0,0,hz)=1.; //.75; 
                            }
                        else if( degreeSpace==3 )
                            {
                                spatialCoefficientsForTZ(2,0,0,hx)=1.;      // u=x^2 + 2xy + y^2 + xz 
                                spatialCoefficientsForTZ(1,1,0,hx)=2.;    //        + .125( x^3 + y^3 + z^3 ) -.75*x*y^2 + x^2*z +.4yz
                                spatialCoefficientsForTZ(0,2,0,hx)=1.;
                                spatialCoefficientsForTZ(1,0,1,hx)=1.;
                                spatialCoefficientsForTZ(3,0,0,hx)=.125; 
                                spatialCoefficientsForTZ(0,3,0,hx)=.125; 
                                spatialCoefficientsForTZ(0,0,3,hx)=.125; 
                                spatialCoefficientsForTZ(1,2,0,hx)=-.75;
                                spatialCoefficientsForTZ(2,0,1,hx)=+1.; 
                                spatialCoefficientsForTZ(0,1,1,hx)=.4; 
                                spatialCoefficientsForTZ(2,0,0,hy)= 1.;      // v=x^2 -2xy - y^2 + 3yz 
                                spatialCoefficientsForTZ(1,1,0,hy)=-2.;      //    + .25( x^3 + y^3 + z^3 ) -.375*x^2 y  -.375*y*z^2  
                                spatialCoefficientsForTZ(0,2,0,hy)=-1.;
                                spatialCoefficientsForTZ(0,1,1,hy)=+3.;
                                spatialCoefficientsForTZ(3,0,0,hy)=.25; 
                                spatialCoefficientsForTZ(0,3,0,hy)=.25; 
                                spatialCoefficientsForTZ(0,0,3,hy)=.25; 
                                spatialCoefficientsForTZ(2,1,0,hy)=-3.*.125; 
                                spatialCoefficientsForTZ(0,1,2,hy)=-3.*.125; 
                                spatialCoefficientsForTZ(2,0,0,hz)= 1.;      // w=x^2 + y^2 - 2 z^2 
                                spatialCoefficientsForTZ(0,2,0,hz)= 1.;      //      + .25x^3 -.2y^3 +.125 z^3 - x z^2 -.6*xy^2
                                spatialCoefficientsForTZ(0,0,2,hz)=-2.;
                                spatialCoefficientsForTZ(3,0,0,hz)=.25; 
                                spatialCoefficientsForTZ(0,3,0,hz)=-.2; 
                                spatialCoefficientsForTZ(0,0,3,hz)=.125; 
                                spatialCoefficientsForTZ(1,0,2,hz)=-1.;
                                spatialCoefficientsForTZ(1,2,0,hz)=-.6;
                            }
                        else if( degreeSpace==4 )
                            {
                                spatialCoefficientsForTZ(2,0,0,hx)=1.;      // u=x^2 + 2xy + y^2 + xz
                                spatialCoefficientsForTZ(1,1,0,hx)=2.;
                                spatialCoefficientsForTZ(0,2,0,hx)=1.;
                                spatialCoefficientsForTZ(1,0,1,hx)=1.;
                                spatialCoefficientsForTZ(3,0,0,hx)=.5;      // + .5*x^3
                                spatialCoefficientsForTZ(4,0,0,hx)=.125;    // + .125*x^4 + .125*y^4 + .125*z^4  -.5*xz^3
                                spatialCoefficientsForTZ(0,4,0,hx)=.125;    
                                spatialCoefficientsForTZ(0,0,4,hx)=.125; 
                                spatialCoefficientsForTZ(1,0,3,hx)=-.5; 
                                spatialCoefficientsForTZ(0,1,3,hx)=.25;    // + .25*y*z^3 -.25*y^2*z^2 +.25*y^3z
                                spatialCoefficientsForTZ(0,2,2,hx)=-.25; 
                                spatialCoefficientsForTZ(0,3,1,hx)=.25; 
                                spatialCoefficientsForTZ(2,0,0,hy)= 1.;      // v=x^2 -2xy - y^2 + 3yz
                                spatialCoefficientsForTZ(1,1,0,hy)=-2.;
                                spatialCoefficientsForTZ(0,2,0,hy)=-1.;
                                spatialCoefficientsForTZ(0,1,1,hy)=+3.;
                                spatialCoefficientsForTZ(2,1,0,hy)=-1.5;     // -1.5x^2*y
                                spatialCoefficientsForTZ(4,0,0,hy)=.25; 
                                spatialCoefficientsForTZ(0,4,0,hy)=.25; 
                                spatialCoefficientsForTZ(0,0,4,hy)=.25; 
                                spatialCoefficientsForTZ(3,1,0,hy)=-.5; 
                                spatialCoefficientsForTZ(1,0,3,hy)=.25;    // + .25*x*z^3 -.25*x^2*z^2 +.25*x^3z
                                spatialCoefficientsForTZ(2,0,2,hy)=-.25; 
                                spatialCoefficientsForTZ(3,0,1,hy)=.25; 
                                spatialCoefficientsForTZ(2,0,0,hz)= 1.;      // w=x^2 + y^2 - 2 z^2
                                spatialCoefficientsForTZ(0,2,0,hz)= 1.;
                                spatialCoefficientsForTZ(0,0,2,hz)=-2.;
                                spatialCoefficientsForTZ(4,0,0,hz)=.25; 
                                spatialCoefficientsForTZ(0,4,0,hz)=-.2; 
                                spatialCoefficientsForTZ(0,0,4,hz)=.125; 
                                spatialCoefficientsForTZ(0,3,1,hz)=-1.;
                                spatialCoefficientsForTZ(1,3,0,hz)=.25;    // + .25*x*y^3 -.25*x^2*y^2 +.25*x^3y
                                spatialCoefficientsForTZ(2,2,0,hz)=-.25; 
                                spatialCoefficientsForTZ(3,1,0,hz)=.25; 
                        }
                        else if( degreeSpace>=5 )
                        {
                            if( true || degreeSpace!=5 ) printF(" ****WARNING***** using a TZ function with degree=5 in space *****\n");
                            spatialCoefficientsForTZ(2,0,0,hx)=1.;      // u=x^2 + 2xy + y^2 + xz
                            spatialCoefficientsForTZ(1,1,0,hx)=2.;
                            spatialCoefficientsForTZ(0,2,0,hx)=1.;
                            spatialCoefficientsForTZ(1,0,1,hx)=1.;
                            spatialCoefficientsForTZ(4,0,0,hx)=.125;    // + .125*x^4 + .125*y^4 + .125*z^4  -.5*xz^3
                            spatialCoefficientsForTZ(0,4,0,hx)=.125;    
                            spatialCoefficientsForTZ(0,0,4,hx)=.125; 
                            spatialCoefficientsForTZ(1,0,3,hx)=-.5; 
                            spatialCoefficientsForTZ(0,1,3,hx)=.25;    // + .25*y*z^3 -.25*y^2*z^2 +.25*y^3z
                            spatialCoefficientsForTZ(0,2,2,hx)=-.25; 
                            spatialCoefficientsForTZ(0,3,1,hx)=.25; 
                            spatialCoefficientsForTZ(0,5,0,hx)=.125;   // y^5
                            spatialCoefficientsForTZ(2,0,0,hy)= 1.;      // v=x^2 -2xy - y^2 + 3yz
                            spatialCoefficientsForTZ(1,1,0,hy)=-2.;
                            spatialCoefficientsForTZ(0,2,0,hy)=-1.;
                            spatialCoefficientsForTZ(0,1,1,hy)=+3.;
                            spatialCoefficientsForTZ(4,0,0,hy)=.25; 
                            spatialCoefficientsForTZ(0,4,0,hy)=.25; 
                            spatialCoefficientsForTZ(0,0,4,hy)=.25; 
                            spatialCoefficientsForTZ(3,1,0,hy)=-.5; 
                            spatialCoefficientsForTZ(1,0,3,hy)=.25;    // + .25*x*z^3 -.25*x^2*z^2 +.25*x^3z
                            spatialCoefficientsForTZ(2,0,2,hy)=-.25; 
                            spatialCoefficientsForTZ(3,0,1,hy)=.25; 
              // spatialCoefficientsForTZ(5,0,0,hy)=.125;  // x^5
                            spatialCoefficientsForTZ(2,0,0,hz)= 1.;      // w=x^2 + y^2 - 2 z^2
                            spatialCoefficientsForTZ(0,2,0,hz)= 1.;
                            spatialCoefficientsForTZ(0,0,2,hz)=-2.;
                            spatialCoefficientsForTZ(4,0,0,hz)=.25; 
                            spatialCoefficientsForTZ(0,4,0,hz)=-.2; 
                            spatialCoefficientsForTZ(0,0,4,hz)=.125; 
                            spatialCoefficientsForTZ(0,3,1,hz)=-1.;
                            spatialCoefficientsForTZ(1,3,0,hz)=.25;    // + .25*x*y^3 -.25*x^2*y^2 +.25*x^3y
                            spatialCoefficientsForTZ(2,2,0,hz)=-.25; 
                            spatialCoefficientsForTZ(3,1,0,hz)=.25; 
              // spatialCoefficientsForTZ(5,0,0,hz)=.125;
                        }
                        else
                        {
                            printF("Maxwell:: not implemented for degree in space =%i \n",degreeSpace);
                            Overture::abort("error");
                        }
          	// *** end the initialize3DPolyTW bpp macro 
                }
            }
            else
            {
                Overture::abort("ERROR:unimplemented number of dimensions");
            }
            for( int n=0; n<numberOfComponents; n++ )
            {
                for( int i=0; i<ndp; i++ )
                    timeCoefficientsForTZ(i,n)= i<=degreeTime ? 1./(i+1) : 0. ;
            }
      // ::display(spatialCoefficientsForTZ,"spatialCoefficientsForTZ","%6.2f ");
            ((OGPolyFunction*)tz)->setCoefficients( spatialCoefficientsForTZ,timeCoefficientsForTZ ); 

        }
        else if( twilightZoneOption==trigonometricTwilightZone )
        {

            const int nc = numberOfComponents + int(useChargeDensity);  // include charge density in TZ
            RealArray fx(nc),fy(nc),fz(nc),ft(nc);
            RealArray gx(nc),gy(nc),gz(nc),gt(nc);
            gx=0.;
            gy=0.;
            gz=0.;
            gt=0.;
            RealArray amplitude(nc), cc(nc);
            amplitude=1.;
            cc=0.;
            fx=omega[0];
            fy = numberOfDimensions>1 ? omega[1] : 0.;
            fz = numberOfDimensions>2 ? omega[2] : 0.;
            ft = omega[3];
            if( numberOfDimensions==2  )
            {   
                const int uc=ex, vc=ey, wc=hz;
                if( !useChargeDensity )
                {
          // rho=0 : create div(E)=0 TZ function
          // u=cos(pi x) cos( pi y )* .5
          // v=sin(pi x) sin( pi y )* .5 
          // w=cos(    ) sin(      )* .5
                    assert( omega[0]==omega[1] );
                    gx(vc)=.5/omega[0];   // shift by pi/2 to turn cos() into sin()
                    gy(vc)=.5/omega[1];
                    amplitude(uc)=.5;  cc(uc)=.0;
                    amplitude(vc)=.5;  cc(vc)=.0;
                    gy(wc)=.5/omega[1]; // turn off for testing symmetry
                    cc(wc)=.0;
                }
                else
                {
          // rho= cos(pi x) cos( pi y )* omega[0]*pi 
          // 
          // u=sin(pi x) cos( pi y )* .5
          // v=cos(pi x) sin( pi y )* .5 
          // w=cos(    ) sin(      )* .5
                    assert( omega[0]==omega[1] );
                    assert( rc==numberOfComponents );
                    gx(uc)=.5/omega[0];   // shift by pi/2 to turn cos() into sin()
                    gy(vc)=.5/omega[1];
                    amplitude(rc)=omega[0]*Pi;  cc(rc)=.0;
                    amplitude(uc)=.5;           cc(uc)=.0;
                    amplitude(vc)=.5;           cc(vc)=.0;
                    gy(wc)=.5/omega[1]; // turn off for testing symmetry
                    cc(wc)=.0;
                }
            }
            else if( numberOfDimensions==3 )
            {
                if( solveForElectricField )
                {
                    const int uc=ex, vc=ey, wc=ez;
          // u=   cos(pi x) cos( pi y ) cos( pi z)  // **** fix ***
          // v=.5 sin(pi x) sin( pi y ) cos( pi z)
          // w=.5 sin(pi x) cos( pi y ) sin( pi z)
                    if( omega[0]==omega[1] && omega[0]==omega[2] )
                    {
                        gx(vc)=.5/omega[0];
                        gy(vc)=.5/omega[1];
                        amplitude(vc)=.5;
                        gx(wc)=.5/omega[0];
                        gz(wc)=.5/omega[2];
                        amplitude(wc)=.5;
                    }
                    else if( omega[0]==omega[2] && omega[1]==0 )
                    {
            // pseudo 2D case
                        gx(wc)=.5/omega[0];   // shift by pi/2 to turn cos() into sin()
                        gz(wc)=.5/omega[2];
                        amplitude(uc)=.5;  cc(uc)=.0;
                        amplitude(wc)=.5;  cc(wc)=.0;
                    }
                    else
                        {
                  	Overture::abort("Invalid values for omega[0..2]");
                        }
                }
                if( solveForMagneticField )
                    {
                        const int uc=hx, vc=hy, wc=hz;
          // u=   cos(pi x) cos( pi y ) cos( pi z)  // **** fix ***
          // v=.5 sin(pi x) sin( pi y ) cos( pi z)
          // w=.5 sin(pi x) cos( pi y ) sin( pi z)
                    if( omega[0]==omega[1] && omega[0]==omega[2] )
                    {
                        gx(vc)=.5/omega[0];
                        gy(vc)=.5/omega[1];
                        amplitude(vc)=.5;
                        gx(wc)=.5/omega[0];
                        gz(wc)=.5/omega[2];
                        amplitude(wc)=.5;
                    }
                    else if( omega[0]==omega[2] && omega[1]==0 )
                    {
            // pseudo 2D case
                        gx(wc)=.5/omega[0];   // shift by pi/2 to turn cos() into sin()
                        gz(wc)=.5/omega[2];
                        amplitude(uc)=.5;  cc(uc)=.0;
                        amplitude(wc)=.5;  cc(wc)=.0;
                    }
                    else
                    {
                        Overture::abort("Invalid values for omega[0..2]");
                    }
                }
            }
            tz = new OGTrigFunction(fx,fy,fz,ft);
            ((OGTrigFunction*)tz)->setShifts(gx,gy,gz,gt);
            ((OGTrigFunction*)tz)->setAmplitudes(amplitude);
            ((OGTrigFunction*)tz)->setConstants(cc);

        }
        else if( twilightZoneOption==pulseTwilightZone )
        {
            tz= new OGPulseFunction;
        }
        else
        {
            printF("assignInitialConditions:ERROR:unknown value for twilightZoneOption=%i\n",(int)twilightZoneOption);
            Overture::abort("assignInitialConditions:ERROR");
        }

    };


    
    const int prev = (current-1+numberOfTimeLevels) % numberOfTimeLevels;
    const int next = (current+1) % numberOfTimeLevels;

    const int numberOfComponentGrids = cg.numberOfComponentGrids();

    if( method==nfdtd && orderOfAccuracyInTime>=4 )
    {
    // ** functions only needed for curvilinear grids **** fix ****
        numberOfFunctions=1; //  orderOfAccuracyInTime-1;

        if( true || cg.numberOfDimensions()==3 ) numberOfFunctions=3;  // *********************** fix *************** how many are needed?

        delete [] fn;
        fn = new realArray [numberOfFunctions*numberOfComponentGrids];
    }


    for( int grid=0; grid<numberOfComponentGrids; grid++ )
    {

        const real c = cGrid(grid);
        const real eps = epsGrid(grid);
        const real mu = muGrid(grid);

        const real cc= c*sqrt( kx*kx+ky*ky +kz*kz);
        const real csq=c*c;

    // call the bpp macro to define the E and H field gridfunctions and cpp macros
        #ifdef EXTGFP_SENTINEL
        ERROR : XXX : you have not closed the current EXTRACT_GFP macro before starting a new one!
        #endif
        #define EXTGFP_SENTINEL
        #ifdef EXTGFP_SENTINEL
        realArray emptyArray;
        realSerialArray emptySerialArray;
        Range all;
        Index I1,I2,I3;
        Index Iev[3], &Ie1=Iev[0], &Ie2=Iev[1], &Ie3=Iev[2];
        Index Ihv[3], &Ih1=Ihv[0], &Ih2=Ihv[1], &Ih3=Ihv[2];
        MappedGrid & mg = cg[grid];
        const bool isStructured = mg.getGridType()==MappedGrid::structuredGrid;
        const bool isRectangular = mg.isRectangular();
        assert( !(isRectangular && !isStructured) ); // just a little check on the MappedGrid's data
        real dx[3]={1.,1.,1.}, xab[2][3]={{0.,0.,0.},{0.,0.,0.}};
        if( isRectangular )
            mg.getRectangularGridParameters( dx, xab );
    //realMappedGridFunction uh,ue,umh,ume,unh,une;
        realSerialArray uh,ue,umh,ume,unh,une,errh,erre;
        realSerialArray xe,xh,ye,yh,ze,zh,xce,xch;
        realSerialArray uepp, uhpp; // dsi projection arrays
        intArray & mask = mg.mask();
        #ifdef USE_PPP
            intSerialArray maskLocal;  getLocalArrayWithGhostBoundaries(mask,maskLocal);
        #else
            intSerialArray & maskLocal = mask;
        #endif
        const bool buildCenter = !( isRectangular &&
                              			    ( initialConditionOption==squareEigenfunctionInitialCondition ||
                                			      initialConditionOption==gaussianPulseInitialCondition ||
                                                                    (forcingOption==gaussianChargeSource && initialConditionOption==defaultInitialCondition)
                                   // || initialConditionOption==planeMaterialInterfaceInitialCondition
    			       // ||  initialConditionOption==annulusEigenfunctionInitialCondition
                                 			       ) 
                              			    ); // fix this 
        if( buildCenter )
        {
      // printF("assignInitialConditions:INFO:build the grid vertices, grid=%i\n",grid);
            mg.update(MappedGrid::THEcenter | MappedGrid::THEvertex);
        }
        const realArray & center = buildCenter ? mg.center() : emptyArray;
        realSerialArray uLocal;
        real dtb2=dt*.5;
        real tE = t, tH = t;
        getIndex(mg.dimension(),I1,I2,I3);
        int includeGhost=1;
        bool ok = ParallelUtility::getLocalArrayBounds(mask,maskLocal,I1,I2,I3,includeGhost);
        if( !ok ) continue;  // no communication allowed after this point : check this ******************************************************
        if (method==nfdtd ) 
        {
            Ie1 = Ih1 = I1;
            Ie2 = Ih2 = I2;
            Ie3 = Ih3 = I3;
      // nfdtd uses one gridFunction per time level
            realMappedGridFunction & uall = mgp==NULL ? getCGField(HField,current)[grid] : fields[current];
            realMappedGridFunction & umall = mgp==NULL ? getCGField(HField,prev)[grid] : fields[prev];
            realMappedGridFunction & unall = mgp==NULL ? getCGField(HField,next)[grid] : fields[next];
            #ifdef USE_PPP
                getLocalArrayWithGhostBoundaries(uall,uLocal);
                realSerialArray umLocal; getLocalArrayWithGhostBoundaries(umall,umLocal);
                realSerialArray unLocal; getLocalArrayWithGhostBoundaries(unall,unLocal);
            #else
                uLocal.reference(uall);
                realSerialArray & umLocal = umall;
                realSerialArray & unLocal = unall;
            #endif
            if ( cg.numberOfDimensions()==2 ) 
            {
                ue.reference( uLocal(I1,I2,I3,Range(ex,ey)) );
                uh.reference( uLocal(I1,I2,I3,hz) );
                ume.reference( umLocal(I1,I2,I3,Range(ex,ey)) );
                umh.reference( umLocal(I1,I2,I3,hz) );
                une.reference( unLocal(I1,I2,I3,Range(ex,ey)) );
                unh.reference( unLocal(I1,I2,I3,hz) );
                if( errp )
                {
                    #ifdef USE_PPP
                        realSerialArray errLocal; getLocalArrayWithGhostBoundaries(*errp,errLocal);
                        errh.reference(errLocal(I1,I2,I3,hz));
                        erre.reference(errLocal(I1,I2,I3,Range(ex,ey)));
                    #else
                        errh.reference((*errp)(I1,I2,I3,hz));
                        erre.reference((*errp)(I1,I2,I3,Range(ex,ey)));
                    #endif
                }
                else if ( cgerrp )
                {
                    #ifdef USE_PPP
                        realSerialArray errLocal; getLocalArrayWithGhostBoundaries((*cgerrp)[grid],errLocal);
                        errh.reference(errLocal(I1,I2,I3,hz));
                        erre.reference(errLocal(I1,I2,I3,Range(ex,ey)));
                    #else
                        errh.reference((*cgerrp)[grid](I1,I2,I3,hz));
                        erre.reference((*cgerrp)[grid](I1,I2,I3,Range(ex,ey)));
                    #endif
                }
            }
            else
            {
                if ( solveForElectricField )
                {
                    ue.reference( uLocal(I1,I2,I3,Range(ex,ez)) );
                    ume.reference( umLocal(I1,I2,I3,Range(ex,ez)) );
                    une.reference( unLocal(I1,I2,I3,Range(ex,ez)) );
                    if ( errp )
                    {
                        #ifdef USE_PPP
                            realSerialArray errLocal; getLocalArrayWithGhostBoundaries(*errp,errLocal);
                            erre.reference(errLocal(I1,I2,I3,Range(ex,ez)));
                        #else
                            erre.reference((*errp)(I1,I2,I3,Range(ex,ez)));
                        #endif
                    }
                    else if ( cgerrp )
                    {
                        #ifdef USE_PPP
                            realSerialArray errLocal; getLocalArrayWithGhostBoundaries((*cgerrp)[grid],errLocal);
                            erre.reference(errLocal(I1,I2,I3,Range(ex,ez)));
                        #else
                            erre.reference((*cgerrp)[grid](I1,I2,I3,Range(ex,ez)));
                        #endif
                    }
                }
                if ( solveForMagneticField )
                {
                    uh.reference( uLocal(I1,I2,I3,Range(hx,hz)) );
                    umh.reference( umLocal(I1,I2,I3,Range(hx,hz)) );
                    unh.reference( unLocal(I1,I2,I3,Range(hx,hz)) );
                    if ( errp )
                    {
                        #ifdef USE_PPP
                            realSerialArray errLocal; getLocalArrayWithGhostBoundaries(*errp,errLocal);
                            errh.reference(errLocal(I1,I2,I3,Range(hx,hz)));
                        #else
                            errh.reference((*errp)(I1,I2,I3,Range(hx,hz)));
                        #endif
                    }
                    else if ( cgerrp )
                    {
                        #ifdef USE_PPP
                            realSerialArray errLocal; getLocalArrayWithGhostBoundaries((*cgerrp)[grid],errLocal);
                            errh.reference(errLocal(I1,I2,I3,Range(hx,hz)));
                        #else
                            errh.reference((*cgerrp)[grid](I1,I2,I3,Range(hx,hz)));
                        #endif
                    }
                }
            }
            #ifdef USE_PPP
                realSerialArray xLocal; if( buildCenter ) getLocalArrayWithGhostBoundaries(center,xLocal);
            #else
                const realSerialArray & xLocal = center;
            #endif
            if( buildCenter )
            {
        // *wdh* 041015 these next assignments fail in P++ if buildCenter==false -- but why make the reference?
                xe.reference( (buildCenter ? xLocal(I1,I2,I3,0) : emptySerialArray) );
                ye.reference( (buildCenter ? xLocal(I1,I2,I3,1) : emptySerialArray) );
                if ( numberOfDimensions==3 )
                    ze.reference( (buildCenter ? xLocal(I1,I2,I3,2) : emptySerialArray) );
        // nfdtd uses the same centering for e and h
                xh.reference(xe);
                yh.reference(ye);
                zh.reference(yh);
            }
            if ( buildCenter )
            {
                xce.reference(xLocal);
                xch.reference(xce);
            }
        }
        else // dsi or yee scheme
        {
            tE -= dtb2;
            if ( method==dsiMatVec /*&& numberOfDimensions==3*/ )
            {
                realMappedGridFunction &uep = (mgp==NULL ? getCGField(EField,current)[grid] : fields[current+numberOfTimeLevels]);
                realMappedGridFunction &uhp = (mgp==NULL ? getCGField(HField,current)[grid] : fields[current]);
                realMappedGridFunction &uepm = (mgp==NULL ? getCGField(EField,next)[grid] : fields[next+numberOfTimeLevels]);
                realMappedGridFunction &uhpm = (mgp==NULL ? getCGField(HField,next)[grid] : fields[next]);
                #ifdef USE_PPP
                    realSerialArray uepLocal; getLocalArrayWithGhostBoundaries(uep,uepLocal);
                    realSerialArray uhpLocal; getLocalArrayWithGhostBoundaries(uhp,uhpLocal);
                    realSerialArray uepmLocal; getLocalArrayWithGhostBoundaries(uepm,uepmLocal);
                    realSerialArray uhpmLocal; getLocalArrayWithGhostBoundaries(uhpm,uhpmLocal);
                #else
                    realSerialArray & uepLocal=uep;
                    realSerialArray & uhpLocal=uhp;
                    realSerialArray & uepmLocal=uepm;
                    realSerialArray & uhpmLocal=uhpm;
                #endif
                realMappedGridFunction uer, uhr, uerm, uhrm;
                uepp.reference(uepLocal);
                uhpp.reference(uhpLocal);
                uer.updateToMatchGrid(mg,GridFunctionParameters::edgeCentered,numberOfDimensions);
                uerm.updateToMatchGrid(mg,GridFunctionParameters::edgeCentered,numberOfDimensions);
                if ( numberOfDimensions==2 )
                {
                    uhr.updateToMatchGrid(mg,GridFunctionParameters::cellCentered);
                    uhrm.updateToMatchGrid(mg,GridFunctionParameters::cellCentered);
                }
                else
                {
                    uhr.updateToMatchGrid(mg,GridFunctionParameters::faceCenteredAll,numberOfDimensions);
                    uhrm.updateToMatchGrid(mg,GridFunctionParameters::faceCenteredAll,numberOfDimensions);
                }      
                uer = uerm = -100;
                uhr = uhrm = -100;
                #ifdef USE_PPP
                    realSerialArray uerLocal; getLocalArrayWithGhostBoundaries(uer,uerLocal);
                    realSerialArray uhrLocal; getLocalArrayWithGhostBoundaries(uhr,uhrLocal);
                    realSerialArray uermLocal; getLocalArrayWithGhostBoundaries(uerm,uermLocal);
                    realSerialArray uhrmLocal; getLocalArrayWithGhostBoundaries(uhrm,uhrmLocal);
                #else
                    realSerialArray & uerLocal=uer;
                    realSerialArray & uhrLocal=uhr;
                    realSerialArray & uermLocal=uerm;
                    realSerialArray & uhrmLocal=uhrm;
                #endif
                ue.reference ( uerLocal );
                uh.reference ( uhrLocal );
                ume.reference ( uermLocal );
                umh.reference ( uhrmLocal );
        //      cout<<"UMH SIZE "<<umh.getLength(0)<<"  "<<umh.getLength(3)<<endl;
            }
            else
            {
                #ifdef USE_PPP
                    Overture::abort("finish me for parallel");
                #else
                    ue.reference ( (mgp==NULL ? getCGField(EField,current)[grid] : fields[current+numberOfTimeLevels]) );
                    uh.reference ( (mgp==NULL ? getCGField(HField,current)[grid] : fields[current]) );
                    ume.reference ( (mgp==NULL ? getCGField(EField,next)[grid] : fields[next+numberOfTimeLevels]) );
                    umh.reference ( (mgp==NULL ? getCGField(HField,next)[grid] : fields[next]) );
                #endif
            }
    // #Else
    //       ue.reference ( (mgp==NULL ? getCGField(EField,current)[grid] : fields[current+numberOfTimeLevels]) );
    //       uh.reference ( (mgp==NULL ? getCGField(HField,current)[grid] : fields[current]) );
    //       ume.reference ( (mgp==NULL ? getCGField(EField,next)[grid] : fields[next+numberOfTimeLevels]) );
    //       umh.reference ( (mgp==NULL ? getCGField(HField,next)[grid] : fields[next]) );
    // #End
            if ( errp )
            {
                #ifdef USE_PPP
                    Overture::abort("finish me for parallel");
                #else
                    erre.reference(errp[0]);
                    errh.reference(errp[1]);
                #endif
            }
            else if ( cgerrp )
            {
                #ifdef USE_PPP
                    Overture::abort("finish me for parallel");
                #else
                    erre.reference(cgerrp[0][grid]);
                    errh.reference(cgerrp[1][grid]);
                #endif
            }
            Ih1 = Range(uh.getBase(0),uh.getBound(0));
            Ih2 = Range(uh.getBase(1),uh.getBound(1));
            Ih3 = Range(uh.getBase(2),uh.getBound(2));
            Ie1 = Range(ue.getBase(0),ue.getBound(0));
            Ie2 = Range(ue.getBase(1),ue.getBound(1));
            Ie3 = Range(ue.getBase(2),ue.getBound(2));
            I1 = Ih1;
            I2 = Ih2;
            I3 = Ih3;
            if ( buildCenter )
            {
                const realArray & center = mg.isAllVertexCentered() ? mg.corner() : mg.center();
        //      cout<<"CENTER SIZE "<<center.getLength(0)<<endl;
        //      cout<<"MG VERTEX/CELL CENT "<<mg.isAllVertexCentered()<<"  "<<mg.isAllCellCentered()<<endl;
        //      getFaceCenters(mg, xce);
              #ifdef USE_PPP
                  Overture::abort("finish me for parallel");
              #else    
                if ( mg.numberOfDimensions()==2 )
                {
                    getCenters(mg, UnstructuredMapping::Edge, xce);
                    xch.reference(center);
                    xce.reshape(Range(xce.getLength(0)),1,1,Range(xce.getLength(1)));
                }
                else
                {
                    getCenters(mg, UnstructuredMapping::Face, xch);
                    getCenters(mg, UnstructuredMapping::Edge, xce);
                    xce.reshape(Range(xce.getLength(0)),1,1,Range(xce.getLength(1)));
                    xch.reshape(Range(xch.getLength(0)),1,1,Range(xch.getLength(1)));
                }
        //xh.reference(xch(all,all,all,0));
        //yh.reference(xch(all,all,all,1));
                xh.reference(xch(Ih1,Ih2,Ih3,0,all));
                yh.reference(xch(Ih1,Ih2,Ih3,1,all));
                if ( numberOfDimensions==3 )
                    zh.reference(xch(Ih1,Ih2,Ih3,2,all));
                xe.reference(xce(Ie1,Ie2,Ie3,0,all));
                ye.reference(xce(Ie1,Ie2,Ie3,1,all));
                if ( numberOfDimensions==3 )
                    ze.reference(xce(Ie1,Ie2,Ie3,2,all));
            #endif
            }
        }
        real *uhp=0,*uep=0,*umhp=0,*umep=0,*unhp=0,*unep=0,*xep=0,*xhp=0,*errhp=0,*errep=0;
        int uhDim0,uhDim1,uhDim2,uhDimFA;
        int ueDim0,ueDim1,ueDim2,ueDimFA;
        int xeDim0,xeDim1,xeDim2;
        int xhDim0,xhDim1,xhDim2;
        uhDim0=uhDim1=uhDim2=ueDim0=ueDim1=ueDim2=xeDim0=xeDim1=xeDim2=xhDim0=xhDim1=xhDim2=-1;
    // #ifdef USE_PPP
    // realSerialArray uel; getLocalArrayWithGhostBoundaries(ue,uel);
    // realSerialArray uhl; getLocalArrayWithGhostBoundaries(uh,uhl);
    // realSerialArray umel; if( ume.getLength(0)>0 ) ume.getLocalArrayWithGhostBoundaries(ume,umel);
    // realSerialArray umhl; if( umh.getLength(0)>0 ) umh.getLocalArrayWithGhostBoundaries(umh,umhl);
    // realSerialArray unel; getLocalArrayWithGhostBoundaries(une,unel);
    // realSerialArray unhl; getLocalArrayWithGhostBoundaries(unh,unhl);
    // realSerialArray xcel; getLocalArrayWithGhostBoundaries(xce,xcel);
    // realSerialArray xchl; getLocalArrayWithGhostBoundaries(xch,xchl);
    // realSerialArray errel; getLocalArrayWithGhostBoundaries(erre,errel);
    // realSerialArray errhl; getLocalArrayWithGhostBoundaries(errh,errhl);
    // // intSerialArray maskLocal; getLocalArrayWithGhostBoundaries(mask,maskl);
    // #else
        const realSerialArray &uel = ue;
        const realSerialArray &uhl = uh;
        const realSerialArray &umel = ume;
        const realSerialArray &umhl = umh;
        const realSerialArray &unel = une;
        const realSerialArray &unhl = unh;
        const realSerialArray &xcel = xce;
        const realSerialArray &xchl = xch;
        const realSerialArray &errel = erre;
        const realSerialArray &errhl = errh;
    // const intSerialArray & maskLocal = mask;
    // #endif
    // H field pointer and array definitions
        uhp = uhl.Array_Descriptor.Array_View_Pointer3;
        if ( umhl.getLength(0) )
        {
            umhp = umhl.Array_Descriptor.Array_View_Pointer3;
        }
        unhp = unhl.Array_Descriptor.Array_View_Pointer3;
        uhDim0 = uhl.getRawDataSize(0);
        uhDim1 = uhl.getRawDataSize(1);
        uhDim2 = uhl.getRawDataSize(2);
        uhDimFA = uhl.getRawDataSize(4);
    //DEFINE_GF_MACRO is a bpp macro
        #ifdef UHX
        ERROR : UHXalready defined!
        #else
        #define UHX(i0,i1,i2) uhp[i0+uhDim0*(i1+uhDim1*(i2+uhDim2*( hx )))]
        #endif
        #ifdef UHY
        ERROR : UHYalready defined!
        #else
        #define UHY(i0,i1,i2) uhp[i0+uhDim0*(i1+uhDim1*(i2+uhDim2*( hy )))]
        #endif
        #ifdef UHZ
        ERROR : UHZalready defined!
        #else
        #define UHZ(i0,i1,i2) uhp[i0+uhDim0*(i1+uhDim1*(i2+uhDim2*( hz )))]
        #endif
        #ifdef UMHX
        ERROR : UMHXalready defined!
        #else
        #define UMHX(i0,i1,i2) umhp[i0+uhDim0*(i1+uhDim1*(i2+uhDim2*( hx )))]
        #endif
        #ifdef UMHY
        ERROR : UMHYalready defined!
        #else
        #define UMHY(i0,i1,i2) umhp[i0+uhDim0*(i1+uhDim1*(i2+uhDim2*( hy )))]
        #endif
        #ifdef UMHZ
        ERROR : UMHZalready defined!
        #else
        #define UMHZ(i0,i1,i2) umhp[i0+uhDim0*(i1+uhDim1*(i2+uhDim2*( hz )))]
        #endif
        #ifdef UNHX
        ERROR : UNHXalready defined!
        #else
        #define UNHX(i0,i1,i2) unhp[i0+uhDim0*(i1+uhDim1*(i2+uhDim2*( hx )))]
        #endif
        #ifdef UNHY
        ERROR : UNHYalready defined!
        #else
        #define UNHY(i0,i1,i2) unhp[i0+uhDim0*(i1+uhDim1*(i2+uhDim2*( hy )))]
        #endif
        #ifdef UNHZ
        ERROR : UNHZalready defined!
        #else
        #define UNHZ(i0,i1,i2) unhp[i0+uhDim0*(i1+uhDim1*(i2+uhDim2*( hz )))]
        #endif
        errhp = errhl.Array_Descriptor.Array_View_Pointer3;
        #ifdef ERRHX
        ERROR : ERRHXalready defined!
        #else
        #define ERRHX(i0,i1,i2) errhp[i0+uhDim0*(i1+uhDim1*(i2+uhDim2*( hx )))]
        #endif
        #ifdef ERRHY
        ERROR : ERRHYalready defined!
        #else
        #define ERRHY(i0,i1,i2) errhp[i0+uhDim0*(i1+uhDim1*(i2+uhDim2*( hy )))]
        #endif
        #ifdef ERRHZ
        ERROR : ERRHZalready defined!
        #else
        #define ERRHZ(i0,i1,i2) errhp[i0+uhDim0*(i1+uhDim1*(i2+uhDim2*( hz )))]
        #endif
    // #ifdef UNH
    // ERROR : UNH already defined!
    // #else
    // #define UNH(i0,i1,i2,i3) unhp[i0+uhDim0*(i1+uhDim1*(i2+uhDim2*(i3)))]
    // #endif
        xhp = xchl.Array_Descriptor.Array_View_Pointer3;
        xhDim0 = xchl.getRawDataSize(0);
        xhDim1 = xchl.getRawDataSize(1);
        xhDim2 = xchl.getRawDataSize(2);
        #ifdef XHP
        ERROR : XHP already defined!
        #else
        #define XHP(i0,i1,i2,i3) xhp[i0+xhDim0*(i1+xhDim1*(i2+xhDim2*(i3)))]
        #endif
        #ifdef X
        ERROR : X already defined!
        #else
        #define X(i0,i1,i2,i3) xhp[i0+xhDim0*(i1+xhDim1*(i2+xhDim2*(i3)))]
        #endif
    // E Field pointer and array definitions
        uep = uel.Array_Descriptor.Array_View_Pointer3;
        if ( umel.getLength(0) )
        {
            umep = umel.Array_Descriptor.Array_View_Pointer3;
        }
        unep = unel.Array_Descriptor.Array_View_Pointer3;
        ueDim0 = uel.getRawDataSize(0);
        ueDim1 = uel.getRawDataSize(1);
        ueDim2 = uel.getRawDataSize(2);
        ueDimFA = uel.getRawDataSize(4);
    //DEFINE_GF_MACRO is a bpp macro
        #ifdef UEX
        ERROR : UEXalready defined!
        #else
        #define UEX(i0,i1,i2) uep[i0+ueDim0*(i1+ueDim1*(i2+ueDim2*( ex )))]
        #endif
        #ifdef UEY
        ERROR : UEYalready defined!
        #else
        #define UEY(i0,i1,i2) uep[i0+ueDim0*(i1+ueDim1*(i2+ueDim2*( ey )))]
        #endif
        #ifdef UEZ
        ERROR : UEZalready defined!
        #else
        #define UEZ(i0,i1,i2) uep[i0+ueDim0*(i1+ueDim1*(i2+ueDim2*( ez )))]
        #endif
        #ifdef UMEX
        ERROR : UMEXalready defined!
        #else
        #define UMEX(i0,i1,i2) umep[i0+ueDim0*(i1+ueDim1*(i2+ueDim2*( ex )))]
        #endif
        #ifdef UMEY
        ERROR : UMEYalready defined!
        #else
        #define UMEY(i0,i1,i2) umep[i0+ueDim0*(i1+ueDim1*(i2+ueDim2*( ey )))]
        #endif
        #ifdef UMEZ
        ERROR : UMEZalready defined!
        #else
        #define UMEZ(i0,i1,i2) umep[i0+ueDim0*(i1+ueDim1*(i2+ueDim2*( ez )))]
        #endif
        #ifdef UNEX
        ERROR : UNEXalready defined!
        #else
        #define UNEX(i0,i1,i2) unep[i0+ueDim0*(i1+ueDim1*(i2+ueDim2*( ex )))]
        #endif
        #ifdef UNEY
        ERROR : UNEYalready defined!
        #else
        #define UNEY(i0,i1,i2) unep[i0+ueDim0*(i1+ueDim1*(i2+ueDim2*( ey )))]
        #endif
        #ifdef UNEZ
        ERROR : UNEZalready defined!
        #else
        #define UNEZ(i0,i1,i2) unep[i0+ueDim0*(i1+ueDim1*(i2+ueDim2*( ez )))]
        #endif
        errep = errel.Array_Descriptor.Array_View_Pointer3;
        #ifdef ERREX
        ERROR : ERREXalready defined!
        #else
        #define ERREX(i0,i1,i2) errep[i0+ueDim0*(i1+ueDim1*(i2+ueDim2*( ex )))]
        #endif
        #ifdef ERREY
        ERROR : ERREYalready defined!
        #else
        #define ERREY(i0,i1,i2) errep[i0+ueDim0*(i1+ueDim1*(i2+ueDim2*( ey )))]
        #endif
        #ifdef ERREZ
        ERROR : ERREZalready defined!
        #else
        #define ERREZ(i0,i1,i2) errep[i0+ueDim0*(i1+ueDim1*(i2+ueDim2*( ez )))]
        #endif
        const int *maskp = maskLocal.Array_Descriptor.Array_View_Pointer2;
        const int maskDim0=maskLocal.getRawDataSize(0);
        const int maskDim1=maskLocal.getRawDataSize(1);
        const int md1=maskDim0, md2=md1*maskDim1; 
        #define MASK(i0,i1,i2) maskp[(i0)+(i1)*md1+(i2)*md2]
    // #ifdef UE
    // ERROR : UE already defined!
    // #else
    // #define UE(i0,i1,i2,i3) uep[i0+ueDim0*(i1+ueDim1*(i2+ueDim2*(i3)))]
    // #endif
        xep = xcel.Array_Descriptor.Array_View_Pointer3;
        xeDim0 = xcel.getRawDataSize(0);
        xeDim1 = xcel.getRawDataSize(1);
        xeDim2 = xcel.getRawDataSize(2);
        #ifdef XEP
        ERROR : XEP already defined!
        #else
        #define XEP(i0,i1,i2,i3) xep[i0+xeDim0*(i1+xeDim1*(i2+xeDim2*(i3)))]
        #endif

        const int i0a=mg.gridIndexRange(0,0);
        const int i1a=mg.gridIndexRange(0,1);
        const int i2a=mg.gridIndexRange(0,2);

        const real xa=xab[0][0], dx0=dx[0];
        const real ya=xab[0][1], dy0=dx[1];
        const real za=xab[0][2], dz0=dx[2];

        #define X0(i0,i1,i2) (xa+dx0*(i0-i0a))
        #define X1(i0,i1,i2) (ya+dy0*(i1-i1a))
        #define X2(i0,i1,i2) (za+dz0*(i2-i2a))


        const bool saveExtraForcingLevels = orderOfAccuracyInTime>=4 && timeSteppingMethod!=modifiedEquationTimeStepping;

        uh = umh = 0;
        ue = ume = 0;

        if( true /*numberOfComponents==3 || method==nfdtd*/ )
        {
            if( saveExtraForcingLevels || 
	  !isRectangular )  // ********************** fix this -- FN used in advanceStructured *****************
            {
	// we need to save the "RHS" at some previous times.
      	Index D1,D2,D3;
      	getIndex(mg.dimension(),D1,D2,D3);
      	Range C(ex,hz);
      	for( int m=0; m<numberOfFunctions; m++ )
      	{
#define FN(m) fn[m+numberOfFunctions*(grid)]
        	  FN(m).partition(mg.getPartition());
        	  FN(m).redim(D1,D2,D3,C);
      	}
      	currentFn=0; 
            }

            Range C(ex,hz);

            getIndex(mg.dimension(),I1,I2,I3);  // ***************** fix this -- needed for bug in OGP

            if( forcingOption==twilightZoneForcing )
            {
      	assert( tz!=NULL );
      	OGFunction & e = *tz;
          	    
      	Index J1,J2,J3;
      	int i1,i2,i3;
      	if( mg.numberOfDimensions()==2 )
      	{

	  // these ranges should work since we get the u*Dim* from the local raw data sizes (??!!)
        	  J1 = Range(max(Ie1.getBase(),uel.getBase(0)),min(Ie1.getBound(),uel.getBound(0)));
        	  J2 = Range(max(Ie2.getBase(),uel.getBase(1)),min(Ie2.getBound(),uel.getBound(1)));
        	  J3 = Range(max(Ie3.getBase(),uel.getBase(2)),min(Ie3.getBound(),uel.getBound(2)));

        	  FOR_3D(i1,i2,i3,J1,J2,J3)
        	  {

          	    real xe0 = XEP(i1,i2,i3,0);
          	    real ye0 = XEP(i1,i2,i3,1);

          	    UEX(i1,i2,i3) =e(xe0,ye0,0.,ex,tE);
          	    UEY(i1,i2,i3) =e(xe0,ye0,0.,ey,tE);
        	  }
            		
	  //	  if ( method==nfdtd )
        	  {
          	    FOR_3D(i1,i2,i3,J1,J2,J3)
          	    {
            	      real xe0 = XEP(i1,i2,i3,0);
            	      real ye0 = XEP(i1,i2,i3,1);
            	      UMEX(i1,i2,i3)=e(xe0,ye0,0.,ex,tE-dt);
            	      UMEY(i1,i2,i3)=e(xe0,ye0,0.,ey,tE-dt);
          	    }
        	  }

        	  J1 = Range(max(Ih1.getBase(),uhl.getBase(0)),min(Ih1.getBound(),uhl.getBound(0)));
        	  J2 = Range(max(Ih2.getBase(),uhl.getBase(1)),min(Ih2.getBound(),uhl.getBound(1)));
        	  J3 = Range(max(Ih3.getBase(),uhl.getBase(2)),min(Ih3.getBound(),uhl.getBound(2)));

        	  FOR_3(i1,i2,i3,J1,J2,J3)
        	  {
          	    real xh0 = XHP(i1,i2,i3,0);
          	    real yh0 = XHP(i1,i2,i3,1);
            		
          	    UHZ(i1,i2,i3) =e(xh0,yh0,0.,hz,tH);
        	  }

	  //	  if ( method==nfdtd )
        	  {
          	    FOR_3(i1,i2,i3,J1,J2,J3)
          	    {
            	      real xh0 = XHP(i1,i2,i3,0);
            	      real yh0 = XHP(i1,i2,i3,1);
            	      UMHZ(i1,i2,i3)=e(xh0,yh0,0.,hz,t-dt);
          	    }
        	  }


      	}
      	else
      	{ // ***** 3D TZ IC's ****

        	  if( solveForElectricField )
        	  {
	    // these ranges should work since we get the u*Dim* from the local raw data sizes (??!!)
          	    J1 = Range(max(Ie1.getBase(),uel.getBase(0)),min(Ie1.getBound(),uel.getBound(0)));
          	    J2 = Range(max(Ie2.getBase(),uel.getBase(1)),min(Ie2.getBound(),uel.getBound(1)));
          	    J3 = Range(max(Ie3.getBase(),uel.getBase(2)),min(Ie3.getBound(),uel.getBound(2)));

          	    FOR_3D(i1,i2,i3,J1,J2,J3)
          	    {
            	      real x0 = XEP(i1,i2,i3,0);
            	      real y0 = XEP(i1,i2,i3,1);
            	      real z0 = XEP(i1,i2,i3,2);
            	      UEX(i1,i2,i3) =e(x0,y0,z0,ex,tE);
            	      UMEX(i1,i2,i3)=e(x0,y0,z0,ex,tE-dt);

            	      UEY(i1,i2,i3) =e(x0,y0,z0,ey,tE);
            	      UMEY(i1,i2,i3)=e(x0,y0,z0,ey,tE-dt);
                  			
            	      UEZ(i1,i2,i3) =e(x0,y0,z0,ez,tE);
            	      UMEZ(i1,i2,i3)=e(x0,y0,z0,ez,tE-dt);
          	    }
        	  }
            		
        	  if ( solveForMagneticField )
        	  {
          	    J1 = Range(max(Ih1.getBase(),uhl.getBase(0)),min(Ih1.getBound(),uhl.getBound(0)));
          	    J2 = Range(max(Ih2.getBase(),uhl.getBase(1)),min(Ih2.getBound(),uhl.getBound(1)));
          	    J3 = Range(max(Ih3.getBase(),uhl.getBase(2)),min(Ih3.getBound(),uhl.getBound(2)));
          	    FOR_3D(i1,i2,i3,J1,J2,J3)
          	    {
            	      real x0 = XHP(i1,i2,i3,0);
            	      real y0 = XHP(i1,i2,i3,1);
            	      real z0 = XHP(i1,i2,i3,2);
            	      UHX(i1,i2,i3) =e(x0,y0,z0,hx,tH);
            	      UMHX(i1,i2,i3)=e(x0,y0,z0,hx,tH-dt);
            	      UHY(i1,i2,i3) =e(x0,y0,z0,hy,tH);
            	      UMHY(i1,i2,i3)=e(x0,y0,z0,hy,tH-dt);
            	      UHZ(i1,i2,i3) =e(x0,y0,z0,hz,tH);
            	      UMHZ(i1,i2,i3)=e(x0,y0,z0,hz,tH-dt);
          	    }
        	  }
        	  
      	}
            	      
            
      	
      	if( saveExtraForcingLevels )
      	{
	  // we need to save the "RHS" at some previous times.
        	  for( int m=0; m<numberOfFunctions; m++ )
        	  {
#ifdef USE_PPP
          	    realSerialArray fnLocal; getLocalArrayWithGhostBoundaries(FN(m),fnLocal);
          	    Overture::abort("finish me for parallel");
#else
          	    realSerialArray & fnLocal = FN(m);
#endif

          	    FN(m)(I1,I2,I3,C)=csq*e.laplacian(mg,I1,I2,I3,C,t-dt*(m+1));
          	    getForcing( current, grid,FN(m),t-dt*(m+1),dt );
        	  }
      	}
            } // end if forcing option == twilightzone
            else if( initialConditionOption==planeWaveInitialCondition )
            {
	// ::display(initialConditionBoundingBox,"initialConditionBoundingBox");
                printF(" *** planeWaveInitialCondition: t=%9.3e dt=%9.3e eps=%9.3e mu=%9.3e c=%9.3e ***\n",t,dt,eps,mu,c);
      	
      	if( numberOfDimensions==2 )
      	{
        	  if( initialConditionBoundingBox(1,0) < initialConditionBoundingBox(0,0) )
        	  {
          	    if( method==nfdtd ) // should be (numberOfTimeLevels>2) ??!!
          	    {
            	      ume(Ie1,Ie2,Ie3,ex)=exTrue(xe,ye,t-dt);
            	      ume(Ie1,Ie2,Ie3,ey)=eyTrue(xe,ye,t-dt);
            	      umh(Ih1,Ih2,Ih3,hz)=hzTrue(xh,yh,t-dt);
          	    }

          	    ue(Ie1,Ie2,Ie3,ex)=exTrue(xe,ye,tE);
          	    ue(Ie1,Ie2,Ie3,ey)=eyTrue(xe,ye,tE);
          	    uh(Ih1,Ih2,Ih3,hz)=hzTrue(xh,yh,tH);
        	  }
        	  else
        	  { // limit the plane wave initial condition to lie inside a bounding box: 
          	    assert( method==nfdtd );
          	    int i1,i2,i3;
          	    FOR_3D(i1,i2,i3,Ie1,Ie2,Ie3)
          	    {
            	      real x=xe(i1,i2,i3), y=ye(i1,i2,i3);
            	      if( x>=initialConditionBoundingBox(0,0) && x<=initialConditionBoundingBox(1,0) &&
                                    y>=initialConditionBoundingBox(0,1) && y<=initialConditionBoundingBox(1,1) )
            	      {

            		ume(i1,i2,i3,ex)=exTrue(x,y,t-dt);
            		ume(i1,i2,i3,ey)=eyTrue(x,y,t-dt);
            		umh(i1,i2,i3,hz)=hzTrue(x,y,t-dt);

            		ue(i1,i2,i3,ex)=exTrue(x,y,tE);
            		ue(i1,i2,i3,ey)=eyTrue(x,y,tE);
            		uh(i1,i2,i3,hz)=hzTrue(x,y,tH);

            	      }
          	    }
          	    
        	  }
        	  
      	}
      	else
      	{  // ***** 3D ********
        	  if( solveForElectricField )
        	  {
          	    if( initialConditionBoundingBox(1,0) < initialConditionBoundingBox(0,0) )
          	    {
            	      if ( method==nfdtd )
            	      {
            		ume(I1,I2,I3,ex)=exTrue3d(xe,ye,ze,tE-dt);
            		ume(I1,I2,I3,ey)=eyTrue3d(xe,ye,ze,tE-dt);
            		ume(I1,I2,I3,ez)=ezTrue3d(xe,ye,ze,tE-dt);
            	      }

            	      ue(Ie1,Ie2,Ie3,ex)=exTrue3d(xe,ye,ze,tE);
            	      ue(Ie1,Ie2,Ie3,ey)=eyTrue3d(xe,ye,ze,tE);
            	      ue(Ie1,Ie2,Ie3,ez)=ezTrue3d(xe,ye,ze,tE);
          	    }
          	    else
          	    { // limit the plane wave initial condition to lie inside a bounding box: 
            	      assert( method==nfdtd );
                            assert( !solveForMagneticField );  // fix me for this case
            	      int i1,i2,i3;
            	      FOR_3D(i1,i2,i3,Ie1,Ie2,Ie3)
            	      {
            		real x=xe(i1,i2,i3), y=ye(i1,i2,i3), z=ze(i1,i2,i3);
            		if( x>=initialConditionBoundingBox(0,0) && x<=initialConditionBoundingBox(1,0) &&
                		    y>=initialConditionBoundingBox(0,1) && y<=initialConditionBoundingBox(1,1) &&
                		    z>=initialConditionBoundingBox(0,2) && z<=initialConditionBoundingBox(1,2) )
            		{

              		  ume(i1,i2,i3,ex)=exTrue3d(x,y,z,tE-dt);
              		  ume(i1,i2,i3,ey)=eyTrue3d(x,y,z,tE-dt);
              		  ume(i1,i2,i3,ez)=ezTrue3d(x,y,z,tE-dt);

              		  ue(i1,i2,i3,ex)=exTrue3d(x,y,z,tE);
              		  ue(i1,i2,i3,ey)=eyTrue3d(x,y,z,tE);
              		  ue(i1,i2,i3,ez)=ezTrue3d(x,y,z,tE);

            		}
            	      }

          	    }
        	  }
        	  if( solveForMagneticField )
        	  {
          	    if ( method==nfdtd )
          	    {
            	      umh(I1,I2,I3,hx)=hxTrue3d(xh,yh,zh,tH-dt);
            	      umh(I1,I2,I3,hy)=hyTrue3d(xh,yh,zh,tH-dt);
            	      umh(I1,I2,I3,hz)=hzTrue3d(xh,yh,zh,tH-dt);
          	    }

          	    uh(Ih1,Ih2,Ih3,hx)=hxTrue3d(xh,yh,zh,tH);
          	    uh(Ih1,Ih2,Ih3,hy)=hyTrue3d(xh,yh,zh,tH);
          	    uh(Ih1,Ih2,Ih3,hz)=hzTrue3d(xh,yh,zh,tH);
        	  }
            	      
      	}
          	    

      	if( saveExtraForcingLevels && timeSteppingMethod!=modifiedEquationTimeStepping )
      	{
	  // we need to save the "RHS" at some previous times.
        	  for( int m=0; m<numberOfFunctions; m++ )
        	  {
#ifdef USE_PPP
          	    realSerialArray fnLocal; getLocalArrayWithGhostBoundaries(FN(m),fnLocal);
#else
          	    realSerialArray & fnLocal = FN(m);
#endif
          	    if( numberOfDimensions==2 )
          	    {
            	      fnLocal(I1,I2,I3,ex)=csq*exLaplacianTrue(xe,ye,t-dt*(m+1));
            	      fnLocal(I1,I2,I3,ey)=csq*eyLaplacianTrue(xe,ye,t-dt*(m+1));
            	      fnLocal(I1,I2,I3,hz)=csq*hzLaplacianTrue(xh,yh,t-dt*(m+1));

          	    }
          	    else
          	    {
            	      if( solveForElectricField )
            	      {
            		fnLocal(I1,I2,I3,ex)=csq*exLaplacianTrue3d(xe,ye,ze,t-dt*(m+1));
            		fnLocal(I1,I2,I3,ey)=csq*eyLaplacianTrue3d(xe,ye,ze,t-dt*(m+1));
            		fnLocal(I1,I2,I3,ez)=csq*ezLaplacianTrue3d(xe,ye,ze,t-dt*(m+1));
            	      }
            	      if( solveForMagneticField )
            	      {
            		fnLocal(I1,I2,I3,hx)=csq*hxLaplacianTrue3d(xh,yh,zh,t-dt*(m+1));
            		fnLocal(I1,I2,I3,hy)=csq*hyLaplacianTrue3d(xh,yh,zh,t-dt*(m+1));
            		fnLocal(I1,I2,I3,hz)=csq*hzLaplacianTrue3d(xh,yh,zh,t-dt*(m+1));
            	      }
              		  
          	    }
          	    getForcing( current, grid,FN(m),t-dt*(m+1),dt );
            		
        	  }
      	}
      	else if( timeSteppingMethod!=modifiedEquationTimeStepping && orderOfAccuracyInTime!=2 )
      	{
        	  Overture::abort();
      	}
        	  
            }
            else if( forcingOption==magneticSinusoidalPointSource )
            {
      	uh=0.;
      	ue=0.;
      	const IntegerArray & gid = mg.gridIndexRange();
      	int i1=gid(0,0)+(gid(1,0)-gid(0,0))/2;
      	int i2=gid(0,1)+(gid(1,1)-gid(0,1))/2;
      	int i3=gid(0,2)+(gid(1,2)-gid(0,2))/2;
          	    
	//kkc 0 for the last index takes care of faceCenteredAll H gridFunctions in 3D
      	uh(i1,i2,i3,hz,0)=sin(twoPi*frequency*t);
            }
            else if( initialConditionOption==zeroInitialCondition )
            {
      	printF("Setting ZERO initial conditions\n");

      	uh(Ih1,Ih2,Ih3,all,all)=0.;
      	ue(Ie1,Ie2,Ie3,all,all)=0.;
	//            u(I1,I2,I3,ey)=0.;

      	if ( method==nfdtd )
      	{
        	  umh(I1,I2,I3,all,all)=0.;
        	  ume(I1,I2,I3,all,all)=0.;
      	}
	//            um(I1,I2,I3,ey)=0.;

      	if( forcingOption==planeWaveBoundaryForcing )
      	{//kkc XXX probably not working for DSI schemes yet
        	  printF("*** Set BC's for planeWaveBoundaryForcing on initial conditions...\n");
        	  realMappedGridFunction & fieldPrev    =mgp!=NULL ? fields[prev]    : cgfields[prev][grid];
        	  realMappedGridFunction & fieldCurrent =mgp!=NULL ? fields[current] : cgfields[current][grid];

        	  int option=0; // not used.
        	  assignBoundaryConditions( option, grid, t-dt, dt, fieldPrev, fieldPrev, prev );
        	  assignBoundaryConditions( option, grid, t   , dt, fieldCurrent, fieldCurrent, current );

      	}
            }
            else if( initialConditionOption==gaussianPlaneWave )
            {
	// (Hz).t = (1/mu) *[ (Ex).y - (Ey).x ]
      	printF("Setting initial condition to be a Gaussian plane wave, kx,ky,kz=%i %i %i\n",kx,ky,kz);
          	    
      	realSerialArray xei,xhi;

      	xei=kx*(xe-x0GaussianPlaneWave)+ky*(ye-y0GaussianPlaneWave) -cc*tE;
      	xhi=kx*(xh-x0GaussianPlaneWave)+ky*(yh-y0GaussianPlaneWave) -cc*tH;

      	uh(Ih1,Ih2,Ih3,hz)=hzGaussianPulse(xhi);
      	ue(Ie1,Ie2,Ie3,ex)=exGaussianPulse(xei);//u(I1,I2,I3,hz)*(-ky/(eps*cc));
      	ue(Ie1,Ie2,Ie3,ey)=eyGaussianPulse(xei);//u(I1,I2,I3,hz)*( kx/(eps*cc));

      	xhi+=cc*dt;
      	xei+=cc*dt;
      	umh(Ih1,Ih2,Ih3,hz)=hzGaussianPulse(xhi);
      	ume(Ie1,Ie2,Ie3,ex)=exGaussianPulse(xei);//u(I1,I2,I3,hz)*(-ky/(eps*cc));
      	ume(Ie1,Ie2,Ie3,ey)=eyGaussianPulse(xei);//u(I1,I2,I3,hz)*( kx/(eps*cc));

      	if( saveExtraForcingLevels )
      	{
	  // we need to save the "RHS" at some previous times.
        	  for( int m=0; m<numberOfFunctions; m++ )
        	  {
#ifdef USE_PPP
          	    realSerialArray fnLocal; getLocalArrayWithGhostBoundaries(FN(m),fnLocal);
          	    Overture::abort("finish me for parallel");
#else
          	    realSerialArray & fnLocal = FN(m);
#endif
          	    xhi=kx*(xe-x0GaussianPlaneWave)+ky*(ye-y0GaussianPlaneWave) -cc*(t-dt*(m+1));
          	    fnLocal(I1,I2,I3,hz)=hzLaplacianGaussianPulse(xhi);
          	    fnLocal(I1,I2,I3,ex)=fnLocal(I1,I2,I3,hz)*(-ky/(eps*cc));
          	    fnLocal(I1,I2,I3,ey)=fnLocal(I1,I2,I3,hz)*( kx/(eps*cc));
        	  }
      	}
            }
            else if( initialConditionOption==gaussianPulseInitialCondition )
            {
      	ue=0.;
      	uh=0.;
//             // (Hz).t = (1/mu) *[ (Ex).y - (Ey).x ]
      	Index J1 = Range(max(Ie1.getBase(),uel.getBase(0)),min(Ie1.getBound(),uel.getBound(0)));
      	Index J2 = Range(max(Ie2.getBase(),uel.getBase(1)),min(Ie2.getBound(),uel.getBound(1)));
      	Index J3 = Range(max(Ie3.getBase(),uel.getBase(2)),min(Ie3.getBound(),uel.getBound(2)));
      	for( int pulse=0; pulse<numberOfGaussianPulses; pulse++ )
      	{
            	      
        	  const real *gpp = gaussianPulseParameters[pulse];

        	  const real beta    = gpp[0];
        	  const real scale   = gpp[1];
        	  const real exponent= gpp[2];
        	  const real x0      = gpp[3];
        	  const real y0      = gpp[4];
        	  const real z0      = gpp[5];
          	    

        	  printF("Gaussian pulse IC's: beta=%8.2e, scale=%8.2e, exponent=%8.2e, (x0,y0,z0)=(%8.2e,%8.2e,%8.2e) \n",
             		 beta,scale,exponent,x0,y0,z0);

        	  const real c0= pulse==0 ? 0. : 1.;
        	  if( true )
        	  {
          	    int i1,i2,i3;
          	    if( isRectangular )
          	    {
                        if( mg.numberOfDimensions()==2 )
                        {
                            J1 = Range(max(Ie1.getBase(),uel.getBase(0)),min(Ie1.getBound(),uel.getBound(0)));
                            J2 = Range(max(Ie2.getBase(),uel.getBase(1)),min(Ie2.getBound(),uel.getBound(1)));
                            J3 = Range(max(Ie3.getBase(),uel.getBase(2)),min(Ie3.getBound(),uel.getBound(2)));
                            FOR_3D(i1,i2,i3,J1,J2,J3)
                            {
                                    real xe = X0(i1,i2,i3)-x0;
                                    real ye = X1(i1,i2,i3)-y0;
                                real temp=exp( -pow(beta*(xe*xe+ye*ye),exponent) );
                                UEX(i1,i2,i3) =c0*UEX(i1,i2,i3)-ye*scale*temp;   // Ex = -C (Hz).y
                                UEY(i1,i2,i3) =c0*UEY(i1,i2,i3)+xe*scale*temp;   // Ey =  C (Hz).x
                                UMEX(i1,i2,i3)=UEX(i1,i2,i3);
                                UMEY(i1,i2,i3)=UEY(i1,i2,i3);
                            }
                            J1 = Range(max(Ih1.getBase(),uhl.getBase(0)),min(Ih1.getBound(),uhl.getBound(0)));
                            J2 = Range(max(Ih2.getBase(),uhl.getBase(1)),min(Ih2.getBound(),uhl.getBound(1)));
                            J3 = Range(max(Ih3.getBase(),uhl.getBase(2)),min(Ih3.getBound(),uhl.getBound(2)));
                            FOR_3(i1,i2,i3,J1,J2,J3)
                            {
                                    real xh = X0(i1,i2,i3)-x0;
                                    real yh = X1(i1,i2,i3)-y0;
                                real temp=exp( -pow(beta*(xh*xh+yh*yh),exponent) );
                                UHZ(i1,i2,i3) =c0*UHZ(i1,i2,i3) + exp( -pow(beta*(xh*xh+yh*yh),exponent) ); 
                                UMHZ(i1,i2,i3)=UHZ(i1,i2,i3);   // This is wrong : should use u_t = w_y ...
                            }
                        }
                        else
                        {
                            J1 = Range(max(Ie1.getBase(),uel.getBase(0)),min(Ie1.getBound(),uel.getBound(0)));
                            J2 = Range(max(Ie2.getBase(),uel.getBase(1)),min(Ie2.getBound(),uel.getBound(1)));
                            J3 = Range(max(Ie3.getBase(),uel.getBase(2)),min(Ie3.getBound(),uel.getBound(2)));
                            FOR_3D(i1,i2,i3,J1,J2,J3)
                            {
                                    real xe = X0(i1,i2,i3)-x0;
                                    real ye = X1(i1,i2,i3)-y0;
                                    real ze = X2(i1,i2,i3)-z0;
                  // XXX NONE of the 3D part of this macro has really been implemented for staggered grids
                                real rsq = xe*xe+ye*ye+ze*ze;
                // E = curl( phi ), phi = (phix,phiy,phiz)
                // real phix = constant*exp( -pow(beta*rsq,exponent) );
                                real dphix = scale*exp( -pow(beta*rsq,exponent) ); // exponent*pow(beta*rsq,exponent-1.);
                                real dphiy = dphix;
                                real dphiz = dphix; 
                                UEX(i1,i2,i3)=c0*UEX(i1,i2,i3)+  ye*dphiz -ze*dphiy;        //  (phiz).y - (phiy).z
                                UEY(i1,i2,i3)=c0*UEX(i1,i2,i3)+  ze*dphix -xe*dphiz ;        // 
                                UEZ(i1,i2,i3)=c0*UEX(i1,i2,i3)+  xe*dphiy -ye*dphix ;
                                UMEX(i1,i2,i3)=UEX(i1,i2,i3);
                                UMEY(i1,i2,i3)=UEY(i1,i2,i3);
                                UMEZ(i1,i2,i3)=UEZ(i1,i2,i3);   // This is wrong : should use u_t = w_y ...
                            }
                            J1 = Range(max(Ih1.getBase(),uhl.getBase(0)),min(Ih1.getBound(),uhl.getBound(0)));
                            J2 = Range(max(Ih2.getBase(),uhl.getBase(1)),min(Ih2.getBound(),uhl.getBound(1)));
                            J3 = Range(max(Ih3.getBase(),uhl.getBase(2)),min(Ih3.getBound(),uhl.getBound(2)));
                            FOR_3(i1,i2,i3,J1,J2,J3)
                            {
                                    real xe = X0(i1,i2,i3)-x0;
                                    real ye = X1(i1,i2,i3)-y0;
                                    real ze = X2(i1,i2,i3)-z0;
                                    real xh = xe;// Cartesian grid stuff not implemented for staggered grids yet (Yee, DSI)
                                    real yh = ye;
                                    real zh = ze;
                  // XXX NONE of the 3D part of this macro has really been properly implemented for staggered grids
                                real rsq = xh*xh+yh*yh+zh*zh;
                // E = curl( phi ), phi = (phix,phiy,phiz)
                // real phix = constant*exp( -pow(beta*rsq,exponent) );
                                real dphix = scale*exp( -pow(beta*rsq,exponent) ); // exponent*pow(beta*rsq,exponent-1.);
                                real dphiy = dphix;
                                real dphiz = dphix; 
                                UHX(i1,i2,i3)=c0*UHX(i1,i2,i3) +  dphix;
                                UHY(i1,i2,i3)=c0*UHY(i1,i2,i3) +  dphiy;
                                UHZ(i1,i2,i3)=c0*UHZ(i1,i2,i3) +  dphiz;
                                UMHX(i1,i2,i3)=UHX(i1,i2,i3);
                                UMHY(i1,i2,i3)=UHY(i1,i2,i3);
                                UMHZ(i1,i2,i3)=UHZ(i1,i2,i3);   // This is wrong : should use u_t = w_y ...
                            }
                        }
          	    }
          	    else
          	    {
                        if( mg.numberOfDimensions()==2 )
                        {
                            J1 = Range(max(Ie1.getBase(),uel.getBase(0)),min(Ie1.getBound(),uel.getBound(0)));
                            J2 = Range(max(Ie2.getBase(),uel.getBase(1)),min(Ie2.getBound(),uel.getBound(1)));
                            J3 = Range(max(Ie3.getBase(),uel.getBase(2)),min(Ie3.getBound(),uel.getBound(2)));
                            FOR_3D(i1,i2,i3,J1,J2,J3)
                            {
                                    real xe = XEP(i1,i2,i3,0)-x0;
                                    real ye = XEP(i1,i2,i3,1)-y0;
                                real temp=exp( -pow(beta*(xe*xe+ye*ye),exponent) );
                                UEX(i1,i2,i3) =c0*UEX(i1,i2,i3)-ye*scale*temp;   // Ex = -C (Hz).y
                                UEY(i1,i2,i3) =c0*UEY(i1,i2,i3)+xe*scale*temp;   // Ey =  C (Hz).x
                                UMEX(i1,i2,i3)=UEX(i1,i2,i3);
                                UMEY(i1,i2,i3)=UEY(i1,i2,i3);
                            }
                            J1 = Range(max(Ih1.getBase(),uhl.getBase(0)),min(Ih1.getBound(),uhl.getBound(0)));
                            J2 = Range(max(Ih2.getBase(),uhl.getBase(1)),min(Ih2.getBound(),uhl.getBound(1)));
                            J3 = Range(max(Ih3.getBase(),uhl.getBase(2)),min(Ih3.getBound(),uhl.getBound(2)));
                            FOR_3(i1,i2,i3,J1,J2,J3)
                            {
                                    real xh = XHP(i1,i2,i3,0)-x0;
                                    real yh = XHP(i1,i2,i3,1)-y0;
                                real temp=exp( -pow(beta*(xh*xh+yh*yh),exponent) );
                                UHZ(i1,i2,i3) =c0*UHZ(i1,i2,i3) + exp( -pow(beta*(xh*xh+yh*yh),exponent) ); 
                                UMHZ(i1,i2,i3)=UHZ(i1,i2,i3);   // This is wrong : should use u_t = w_y ...
                            }
                        }
                        else
                        {
                            J1 = Range(max(Ie1.getBase(),uel.getBase(0)),min(Ie1.getBound(),uel.getBound(0)));
                            J2 = Range(max(Ie2.getBase(),uel.getBase(1)),min(Ie2.getBound(),uel.getBound(1)));
                            J3 = Range(max(Ie3.getBase(),uel.getBase(2)),min(Ie3.getBound(),uel.getBound(2)));
                            FOR_3D(i1,i2,i3,J1,J2,J3)
                            {
                                    real xe = XEP(i1,i2,i3,0)-x0;
                                    real ye = XEP(i1,i2,i3,1)-y0;
                                    real ze = XEP(i1,i2,i3,2)-z0;
                  // XXX NONE of the 3D part of this macro has really been implemented for staggered grids
                                real rsq = xe*xe+ye*ye+ze*ze;
                // E = curl( phi ), phi = (phix,phiy,phiz)
                // real phix = constant*exp( -pow(beta*rsq,exponent) );
                                real dphix = scale*exp( -pow(beta*rsq,exponent) ); // exponent*pow(beta*rsq,exponent-1.);
                                real dphiy = dphix;
                                real dphiz = dphix; 
                                UEX(i1,i2,i3)=c0*UEX(i1,i2,i3)+  ye*dphiz -ze*dphiy;        //  (phiz).y - (phiy).z
                                UEY(i1,i2,i3)=c0*UEX(i1,i2,i3)+  ze*dphix -xe*dphiz ;        // 
                                UEZ(i1,i2,i3)=c0*UEX(i1,i2,i3)+  xe*dphiy -ye*dphix ;
                                UMEX(i1,i2,i3)=UEX(i1,i2,i3);
                                UMEY(i1,i2,i3)=UEY(i1,i2,i3);
                                UMEZ(i1,i2,i3)=UEZ(i1,i2,i3);   // This is wrong : should use u_t = w_y ...
                            }
                            J1 = Range(max(Ih1.getBase(),uhl.getBase(0)),min(Ih1.getBound(),uhl.getBound(0)));
                            J2 = Range(max(Ih2.getBase(),uhl.getBase(1)),min(Ih2.getBound(),uhl.getBound(1)));
                            J3 = Range(max(Ih3.getBase(),uhl.getBase(2)),min(Ih3.getBound(),uhl.getBound(2)));
                            FOR_3(i1,i2,i3,J1,J2,J3)
                            {
                                    real xh = XHP(i1,i2,i3,0)-x0;
                                    real yh = XHP(i1,i2,i3,1)-y0;
                                    real zh = XHP(i1,i2,i3,2)-z0;
                  // XXX NONE of the 3D part of this macro has really been properly implemented for staggered grids
                                real rsq = xh*xh+yh*yh+zh*zh;
                // E = curl( phi ), phi = (phix,phiy,phiz)
                // real phix = constant*exp( -pow(beta*rsq,exponent) );
                                real dphix = scale*exp( -pow(beta*rsq,exponent) ); // exponent*pow(beta*rsq,exponent-1.);
                                real dphiy = dphix;
                                real dphiz = dphix; 
                                UHX(i1,i2,i3)=c0*UHX(i1,i2,i3) +  dphix;
                                UHY(i1,i2,i3)=c0*UHY(i1,i2,i3) +  dphiy;
                                UHZ(i1,i2,i3)=c0*UHZ(i1,i2,i3) +  dphiz;
                                UMHX(i1,i2,i3)=UHX(i1,i2,i3);
                                UMHY(i1,i2,i3)=UHY(i1,i2,i3);
                                UMHZ(i1,i2,i3)=UHZ(i1,i2,i3);   // This is wrong : should use u_t = w_y ...
                            }
                        }
          	    }
        	  }
      	}
          	    
      	if( saveExtraForcingLevels )
      	{
	  // we need to save the "RHS" at some previous times.
        	  for( int m=0; m<numberOfFunctions; m++ )
        	  {
#ifdef USE_PPP
          	    realSerialArray fnLocal; getLocalArrayWithGhostBoundaries(FN(m),fnLocal);
          	    Overture::abort("finish me for parallel");
#else
          	    realSerialArray & fnLocal = FN(m);
#endif
          	    fnLocal(I1,I2,I3,hz)=0.;
          	    fnLocal(I1,I2,I3,ex)=0.;
          	    fnLocal(I1,I2,I3,ey)=0.;
        	  }
      	}
            }
            else if( initialConditionOption==squareEigenfunctionInitialCondition )
            {
      	real fx=Pi*initialConditionParameters[0];
      	real fy=Pi*initialConditionParameters[1];
      	real fz=Pi*initialConditionParameters[2];
      	real omega,x0, y0, z0;
      	real a1=1., a2=-2., a3=1.;  // For 3d, divergence free if a1+a2+a3=0
      	if( numberOfDimensions==2 )
      	{
        	  omega=c*sqrt(fx*fx+fy*fy);
        	  x0=-.5, y0=-.5;   // for the square [-.5,.5]x[-.5,.5] 
      	}
      	else
      	{
        	  omega=c*sqrt(fx*fx+fy*fy+fz*fz);
        	  x0=0., y0=0., z0=0.;   // for the box [0,1]^3
      	}
          	    
      	Index J1 = Range(max(Ie1.getBase(),uel.getBase(0)),min(Ie1.getBound(),uel.getBound(0)));
      	Index J2 = Range(max(Ie2.getBase(),uel.getBase(1)),min(Ie2.getBound(),uel.getBound(1)));
      	Index J3 = Range(max(Ie3.getBase(),uel.getBase(2)),min(Ie3.getBound(),uel.getBound(2)));
      	int i1,i2,i3;
      	real xd,yd,zd;

      	if( isRectangular )
      	{

        	  if( numberOfDimensions==2 )
        	  {
          	    Index J1 = Range(max(Ih1.getBase(),uhl.getBase(0)),min(Ih1.getBound(),uhl.getBound(0)));
          	    Index J2 = Range(max(Ih2.getBase(),uhl.getBase(1)),min(Ih2.getBound(),uhl.getBound(1)));
          	    Index J3 = Range(max(Ih3.getBase(),uhl.getBase(2)),min(Ih3.getBound(),uhl.getBound(2)));
          	    FOR_3D(i1,i2,i3,J1,J2,J3)
          	    {
            	      real xdh=X0(i1,i2,i3)-x0;
            	      real ydh=X1(i1,i2,i3)-y0;
            	      UHZ(i1,i2,i3) =cos(fx*xdh)*cos(fy*ydh)*cos(omega*tH);
          	    }

          	    J1 = Range(max(Ie1.getBase(),uel.getBase(0)),min(Ie1.getBound(),uel.getBound(0)));
          	    J2 = Range(max(Ie2.getBase(),uel.getBase(1)),min(Ie2.getBound(),uel.getBound(1)));
          	    J3 = Range(max(Ie3.getBase(),uel.getBase(2)),min(Ie3.getBound(),uel.getBound(2)));

          	    FOR_3(i1,i2,i3,J1,J2,J3)
          	    {
            	      real xde=X0(i1,i2,i3)-x0;
            	      real yde=X1(i1,i2,i3)-y0;
            	      UEX(i1,i2,i3) =  (-fy/omega)*cos(fx*xde)*sin(fy*yde)*sin(omega*tE);  // Ex.t = Hz.y
            	      UEY(i1,i2,i3) =  ( fx/omega)*sin(fx*xde)*cos(fy*yde)*sin(omega*tE);  // Ey.t = - Hz.x
          	    }

          	    if ( method==nfdtd )
          	    {
            	      FOR_3D(i1,i2,i3,J1,J2,J3)
            	      {
            		real xdh=X0(i1,i2,i3)-x0;
            		real ydh=X1(i1,i2,i3)-y0;
            		UMHZ(i1,i2,i3)=cos(fx*xdh)*cos(fy*ydh)*cos(omega*(t-dt));
            	      }
            	      FOR_3(i1,i2,i3,J1,J2,J3)
            	      {
            		real xde=X0(i1,i2,i3)-x0;
            		real yde=X1(i1,i2,i3)-y0;
            		UMEX(i1,i2,i3) =  (-fy/omega)*cos(fx*xde)*sin(fy*yde)*sin(omega*(t-dt));  // Ex.t = Hz.y
            		UMEY(i1,i2,i3) =  ( fx/omega)*sin(fx*xde)*cos(fy*yde)*sin(omega*(t-dt));  // Ey.t = - Hz.x
            	      }
          	    }
        	  } 
        	  else // 3D
        	  {

          	    FOR_3D(i1,i2,i3,J1,J2,J3)
          	    {
            	      real xde=X0(i1,i2,i3)-x0;
            	      real yde=X1(i1,i2,i3)-y0;
            	      real zde=X2(i1,i2,i3)-z0;

            	      UEX(i1,i2,i3) =  (a1/fx)*cos(fx*xde)*sin(fy*yde)*sin(fz*zde)*cos(omega*t);  // 
            	      UEY(i1,i2,i3) =  (a2/fy)*sin(fx*xde)*cos(fy*yde)*sin(fz*zde)*cos(omega*t);  // 
            	      UEZ(i1,i2,i3) =  (a3/fz)*sin(fx*xde)*sin(fy*yde)*cos(fz*zde)*cos(omega*t);  // 

            	      UMEX(i1,i2,i3) =  (a1/fx)*cos(fx*xde)*sin(fy*yde)*sin(fz*zde)*cos(omega*(t-dt));  // 
            	      UMEY(i1,i2,i3) =  (a2/fy)*sin(fx*xde)*cos(fy*yde)*sin(fz*zde)*cos(omega*(t-dt));  // 
            	      UMEZ(i1,i2,i3) =  (a3/fz)*sin(fx*xde)*sin(fy*yde)*cos(fz*zde)*cos(omega*(t-dt));  // 
          	    }
        	  }
      	}
      	else 
      	{
	  // curvilinear
        	  if( numberOfDimensions==2 )
        	  {
          	    Index J1 = Range(max(Ih1.getBase(),uhl.getBase(0)),min(Ih1.getBound(),uhl.getBound(0)));
          	    Index J2 = Range(max(Ih2.getBase(),uhl.getBase(1)),min(Ih2.getBound(),uhl.getBound(1)));
          	    Index J3 = Range(max(Ih3.getBase(),uhl.getBase(2)),min(Ih3.getBound(),uhl.getBound(2)));

          	    FOR_3D(i1,i2,i3,J1,J2,J3)
          	    {
            	      xd=XHP(i1,i2,i3,0)-x0;
            	      yd=XHP(i1,i2,i3,1)-y0;
            	      UHZ(i1,i2,i3) =cos(fx*xd)*cos(fy*yd)*cos(omega*tH);
          	    }

          	    J1 = Range(max(Ie1.getBase(),uel.getBase(0)),min(Ie1.getBound(),uel.getBound(0)));
          	    J2 = Range(max(Ie2.getBase(),uel.getBase(1)),min(Ie2.getBound(),uel.getBound(1)));
          	    J3 = Range(max(Ie3.getBase(),uel.getBase(2)),min(Ie3.getBound(),uel.getBound(2)));
          	    FOR_3(i1,i2,i3,J1,J2,J3)
          	    {
            	      xd=XEP(i1,i2,i3,0)-x0;
            	      yd=XEP(i1,i2,i3,1)-y0;
            		
            	      UEX(i1,i2,i3) =  (-fy/omega)*cos(fx*xd)*sin(fy*yd)*sin(omega*tE);  // Ex.t = Hz.y
            	      UEY(i1,i2,i3) =  ( fx/omega)*sin(fx*xd)*cos(fy*yd)*sin(omega*tE);  // Ey.t = - Hz.x
          	    }            

          	    if ( method==nfdtd )
          	    {
            	      FOR_3D(i1,i2,i3,J1,J2,J3)
            	      {
            		xd=XHP(i1,i2,i3,0)-x0;
            		yd=XHP(i1,i2,i3,1)-y0;
            		UMHZ(i1,i2,i3)=cos(fx*xd)*cos(fy*yd)*cos(omega*(t-dt));
            	      }
            	      FOR_3(i1,i2,i3,J1,J2,J3)
            	      {
            		xd=XEP(i1,i2,i3,0)-x0;
            		yd=XEP(i1,i2,i3,1)-y0;
                  			
            		UMEX(i1,i2,i3) =  (-fy/omega)*cos(fx*xd)*sin(fy*yd)*sin(omega*(t-dt));  // Ex.t = Hz.y
            		UMEY(i1,i2,i3) =  ( fx/omega)*sin(fx*xd)*cos(fy*yd)*sin(omega*(t-dt));  // Ey.t = - Hz.x
            	      }
          	    }
        	  } 
        	  else // 3D
        	  {

          	    FOR_3D(i1,i2,i3,J1,J2,J3)
          	    {
            	      xd=XEP(i1,i2,i3,0)-x0;
            	      yd=XEP(i1,i2,i3,1)-y0;
            	      zd=XEP(i1,i2,i3,2)-z0;

            	      UEX(i1,i2,i3) =  (a1/fx)*cos(fx*xd)*sin(fy*yd)*sin(fz*zd)*cos(omega*t);  // 
            	      UEY(i1,i2,i3) =  (a2/fy)*sin(fx*xd)*cos(fy*yd)*sin(fz*zd)*cos(omega*t);  // 
            	      UEZ(i1,i2,i3) =  (a3/fz)*sin(fx*xd)*sin(fy*yd)*cos(fz*zd)*cos(omega*t);  // 

            	      if ( method==nfdtd )
            	      {
            		UMEX(i1,i2,i3) =  (a1/fx)*cos(fx*xd)*sin(fy*yd)*sin(fz*zd)*cos(omega*(t-dt));  // 
            		UMEY(i1,i2,i3) =  (a2/fy)*sin(fx*xd)*cos(fy*yd)*sin(fz*zd)*cos(omega*(t-dt));  // 
            		UMEZ(i1,i2,i3) =  (a3/fz)*sin(fx*xd)*sin(fy*yd)*cos(fz*zd)*cos(omega*(t-dt));  // 
            	      }
            	      else
            		Overture::abort("not implemented for staggered grids");
          	    }
        	  }
            	      
      	}
      	if( saveExtraForcingLevels )
      	{ // not implemented
        	  Overture::abort("error: not implemented");
      	}

            }
            else if( initialConditionOption==annulusEigenfunctionInitialCondition )
            {
              
	// This is a macro:
      //   printF(" I1.getBase(),uLocal.getBase(0),I1.getBound(),uLocal.getBound(0)=%i %i %i %i \n",
      // 	 I1.getBase(),uLocal.getBase(0),I1.getBound(),uLocal.getBound(0));
              Index J1 = Range(max(I1.getBase(),uLocal.getBase(0)),min(I1.getBound(),uLocal.getBound(0)));
              Index J2 = Range(max(I2.getBase(),uLocal.getBase(1)),min(I2.getBound(),uLocal.getBound(1)));
              Index J3 = Range(max(I3.getBase(),uLocal.getBase(2)),min(I3.getBound(),uLocal.getBound(2)));
              if( numberOfDimensions==2 )
              {
            #include "besselPrimeZeros.h"
                  const int n = int(initialConditionParameters[0]+.5);  // angular number, n=0,1,... --> Jn(omega*r)
                  const int m = int(initialConditionParameters[1]+.5);  // radial number m=0,... 
                  assert( m<mdbpz && n<ndbpz );
                  real omega = besselPrimeZeros[n][m];  // m'th zero of Jn' (excluding r=0 for J0)
      // printF("Annulus: Bessel function solution: n=%i, m=%i, omega=%e (c=%8.2e)\n",n,m,omega,c);
                  const real eps=sqrt(REAL_EPSILON);
                  real np1Factorial=1.;
                  for( int k=2; k<=n+1; k++ )
                      np1Factorial*=k;              //  (n+1)!
                  int i1,i2,i3;
                  real r,gr,xd,yd,zd,bj,bjp,rx,ry,theta,thetax,thetay;
                  real cosTheta,sinTheta,bjThetax,bjThetay,uex,uey,cosn,sinn;
                  FOR_3D(i1,i2,i3,J1,J2,J3)
                  {
                      xd=X(i1,i2,i3,0);
                      yd=X(i1,i2,i3,1);
                      r = sqrt(xd*xd+yd*yd);
                      theta=atan2(yd,xd);
           // if( theta<0. ) theta+=2.*Pi;
                      cosTheta=cos(theta);
                      sinTheta=sin(theta);
                      cosn=cos(n*theta);
                      sinn=sin(n*theta);
                      gr=omega*r;
                      rx = cosTheta;  // x/r
                      ry = sinTheta;  // y/r
                      bj=jn(n,gr);  // Bessel function J of order n
                      if( gr>eps )  // need asymptotic expansion for small gr ??
                      {
                          bjp = -jn(n+1,gr) + n*bj/gr;  // from the recursion relation for Jn'
                          thetay= cosTheta/r;
                          thetax=-sinTheta/r;
                          uex =  (1./omega)*(omega*ry*bjp*cosn -n*bj*thetay*sinn);
                          uey = -(1./omega)*(omega*rx*bjp*cosn -n*bj*thetax*sinn);
                      }
                      else
                      {
             // Jn(z) = (.5*z)^n *( 1 - (z*z/4)/(n+1)! + .. 
             // At r=0 all the Jn'(0) are zero except for n=1
             // bjp = n==1 ? 1./2. : 0.;
                          bjp = n==0 ? 0. : pow(.5,double(n))*pow(gr,n-1.)*( 1. - (gr*gr)/(4.*np1Factorial) );
             // bj/r = omega*bjp at r=0
                          bjThetay= omega*bjp*cosTheta;
                          bjThetax=-omega*bjp*sinTheta;
                          uex =  (1./omega)*(omega*ry*bjp*cosn -n*bjThetay*sinn);  // Ex.t = Hz.y
                          uey = -(1./omega)*(omega*rx*bjp*cosn -n*bjThetax*sinn);  // Ey.t = - Hz.x
                      }
                          UHZ(i1,i2,i3)  = bj*cosn*cos(omega*t);
                          UEX(i1,i2,i3) = uex*sin(omega*t);  // Ex.t = Hz.y
                          UEY(i1,i2,i3) = uey*sin(omega*t);  // Ey.t = - Hz.x
                          UMHZ(i1,i2,i3) = bj*cosn*cos(omega*(t-dt));
                          UMEX(i1,i2,i3) = uex*sin(omega*(t-dt)); 
                          UMEY(i1,i2,i3) = uey*sin(omega*(t-dt)); 
                }
              }
              else /* 3D */
              {
            #include "besselZeros.h"
                  const real cylinderLength=cylinderAxisEnd-cylinderAxisStart;
                  const int n = int(initialConditionParameters[0]+.5);  // angular number, n=0,1,... --> Jn(omega*r)
                  const int m = int(initialConditionParameters[1]+.5);  // radial number m=0,... 
                  const int k = int(initialConditionParameters[2]+.5);  // axial number k=1,2,3,...
                  assert( m<mdbz && n<ndbz );
                  real lambda = besselZeros[n][m];  // m'th zero of Jn (excluding r=0 for J0)
                  real omega = sqrt( SQR(k*Pi/cylinderLength) + lambda*lambda );
                  printF("***Cylinder: Bessel function soln: n=%i, m=%i, k=%i, lambda=%e, omega=%e (c=%8.2e) [za,zb]=[%4.2f,%4.2f]\n",
                                n,m,k,lambda,omega,c,cylinderAxisStart,cylinderAxisEnd);
                  const real eps=sqrt(REAL_EPSILON);
                  real np1Factorial=1.;
                  for( int k=2; k<=n+1; k++ )
                      np1Factorial*=k;              //  (n+1)!
                  int i1,i2,i3;
                  real r,gr,xd,yd,zd,bj,bjp,rx,ry,theta,thetax,thetay;
                  real cosTheta,sinTheta,bjThetax,bjThetay,uex,uey,cosn,sinn,sinkz,coskz,cost,sint;
                  FOR_3D(i1,i2,i3,J1,J2,J3)
                  {
                      xd=X(i1,i2,i3,0);
                      yd=X(i1,i2,i3,1);
                      zd=(X(i1,i2,i3,2)-cylinderAxisStart)/cylinderLength; // *wdh* 040626 -- allow for any length
                      sinkz=sin(Pi*k*zd);   
                      coskz=cos(Pi*k*zd); 
                      r = sqrt(xd*xd+yd*yd);
                      theta=atan2(yd,xd);
                      cosTheta=cos(theta);
                      sinTheta=sin(theta);
                      cosn=cos(n*theta);
                      sinn=sin(n*theta);
                      cost=cos(omega*t);
                      gr=lambda*r;
                      rx = cosTheta;  // x/r
                      ry = sinTheta;  // y/r
                      bj=jn(n,gr);  // Bessel function J of order n
                      if( gr>eps )  // need asymptotic expansion for small gr ??
                      {
                          bjp = -jn(n+1,gr) + n*bj/gr;  // from the recursion relation for Jn'
                          thetay= cosTheta/r;
                          thetax=-sinTheta/r;
                          uex = -(k*Pi/(cylinderLength*lambda*lambda))*( lambda*rx*bjp*cosn - n*bj*thetax*sinn );
                          uey = -(k*Pi/(cylinderLength*lambda*lambda))*( lambda*ry*bjp*cosn - n*bj*thetay*sinn );
                      }
                      else
                      {
             // Jn(z) = (.5*z)^n *( 1 - (z*z/4)/(n+1)! + .. 
             // At r=0 all the Jn'(0) are zero except for n=1
             // bjp = n==1 ? 1./2. : 0.;
                          bjp = n==0 ? 0. : pow(.5,double(n))*pow(gr,n-1.)*( 1. - (gr*gr)/(4.*np1Factorial) );
             // bj/r = lambda*bjp at r=0
                          bjThetay= lambda*bjp*cosTheta;
                          bjThetax=-lambda*bjp*sinTheta;
                          uex = -(k*Pi/(cylinderLength*lambda*lambda))*( lambda*rx*bjp*cosn -n*bjThetax*sinn);  // Ex.t = Hz.y
                          uey = -(k*Pi/(cylinderLength*lambda*lambda))*( lambda*ry*bjp*cosn -n*bjThetay*sinn);  // Ey.t = - Hz.x
                      }
                          UEX(i1,i2,i3) = uex*sinkz*cost;
                          UEY(i1,i2,i3) = uey*sinkz*cost;
                          UEZ(i1,i2,i3) = bj*cosn*coskz*cost;
                          cost=cos(omega*(t-dt)); 
                          UMEX(i1,i2,i3) = uex*sinkz*cost;
                          UMEY(i1,i2,i3) = uey*sinkz*cost;
                          UMEZ(i1,i2,i3) = bj*cosn*coskz*cost;
                }
              }
          	    
        	  if( saveExtraForcingLevels )
        	  { // not implemented
          	    Overture::abort("error: not implemented");
        	  }
          	    

            }
            else if( initialConditionOption==planeWaveScatteredFieldInitialCondition )
            {
      	printF("Setting initial conditions to be planeWaveScatterFieldInitialCondition. dt=%14.6e\n",dt);
      	if( debug & 2 ) fPrintF(debugFile,
                        				"Setting initial conditions to be planeWaveScatterFieldInitialCondition. dt=%14.6e\n",dt);

      	if ( method!=nfdtd )
        	  Overture::abort("not implemented for staggered grids");

      	if( knownSolution==NULL )
      	{
        	  initializeKnownSolution();
      	}
      	const realArray & ug = (*knownSolution)[grid];

      	const real cc0= cGrid(0)*sqrt( kx*kx+ky*ky ); // NOTE: use grid 0 values for multi-materials

	// The analytic solution assumed incident field was Ei = exp(i*k*x-i*w*t) 
	//     This gives solution
	//           Re(E)*cos(w*t) - Im(E)*sin(w*t) for Ei=cos(w*t)
	//      or   Re(E)*cos(w*t-pi/2) - Im(E)*sin(w*t-pi/2) for Ei=cos(w*t-pi/2)               
	//      i.e. Re(E)*sin(w*t) + Im(E)*cos(w*t) for Ei=sin(w*t)
	// Ex:
      	const real cost = cos(-twoPi*cc0*t); // *wdh* 040626 add "-"
      	const real sint = sin(-twoPi*cc0*t); // *wdh* 040626 add "-"
      	const real costm= cos(-twoPi*cc0*(t-dt)); // *wdh* 040626 add "-"
      	const real sintm= sin(-twoPi*cc0*(t-dt)); // *wdh* 040626 add "-"

	//kkc XXX this only works for nfdtd right now (knownSolution will need to change a bit
	//                                             to handle staggered grids)
          	    
      	Range CE = numberOfDimensions==2 ? Range(ex,ey) : Range(ex,ez);
      	Range CH = numberOfDimensions==2 ? Range(hz,hz) : Range(hx,hz);


#ifdef USE_PPP
      	realSerialArray ugLocal; getLocalArrayWithGhostBoundaries(ug,ugLocal);
#else
      	const realSerialArray & ugLocal = ug; 
#endif
      	if( method==nfdtd )
      	{ // do this with scalar indexing to avoid a possible bug in P++
        	  real *ugp = ugLocal.Array_Descriptor.Array_View_Pointer3;
        	  const int ugDim0=ugLocal.getRawDataSize(0);
        	  const int ugDim1=ugLocal.getRawDataSize(1);
        	  const int ugDim2=ugLocal.getRawDataSize(2);
#undef UG
#define UG(i0,i1,i2,i3) ugp[i0+ugDim0*(i1+ugDim1*(i2+ugDim2*(i3)))]

	  // adjust array dimensions for local arrays
        	  Index J1 = Range(max(I1.getBase(),uel.getBase(0)),min(I1.getBound(),uel.getBound(0)));
        	  Index J2 = Range(max(I2.getBase(),uel.getBase(1)),min(I2.getBound(),uel.getBound(1)));
        	  Index J3 = Range(max(I3.getBase(),uel.getBase(2)),min(I3.getBound(),uel.getBound(2)));
        	  int i1,i2,i3;
        	  if( numberOfDimensions==2 )
        	  {
          	    FOR_3D(i1,i2,i3,J1,J2,J3)
          	    {
            	      UEX(i1,i2,i3)= UG(i1,i2,i3,ex)*sint+UG(i1,i2,i3,ex+3)*cost;
            	      UEY(i1,i2,i3)= UG(i1,i2,i3,ey)*sint+UG(i1,i2,i3,ey+3)*cost;
            	      UHZ(i1,i2,i3)= UG(i1,i2,i3,hz)*sint+UG(i1,i2,i3,hz+3)*cost;

            	      UMEX(i1,i2,i3)= UG(i1,i2,i3,ex)*sintm+UG(i1,i2,i3,ex+3)*costm;
            	      UMEY(i1,i2,i3)= UG(i1,i2,i3,ey)*sintm+UG(i1,i2,i3,ey+3)*costm;
            	      UMHZ(i1,i2,i3)= UG(i1,i2,i3,hz)*sintm+UG(i1,i2,i3,hz+3)*costm;
          	    }
        	  }
        	  else 
        	  {
          	    if( solveForElectricField )
          	    {
            	      FOR_3D(i1,i2,i3,J1,J2,J3)
            	      {
            		UEX(i1,i2,i3)= UG(i1,i2,i3,ex)*sint+UG(i1,i2,i3,ex+3)*cost;
            		UEY(i1,i2,i3)= UG(i1,i2,i3,ey)*sint+UG(i1,i2,i3,ey+3)*cost;
            		UEZ(i1,i2,i3)= UG(i1,i2,i3,ez)*sint+UG(i1,i2,i3,ez+3)*cost;

            		UMEX(i1,i2,i3)= UG(i1,i2,i3,ex)*sintm+UG(i1,i2,i3,ex+3)*costm;
            		UMEY(i1,i2,i3)= UG(i1,i2,i3,ey)*sintm+UG(i1,i2,i3,ey+3)*costm;
            		UMEZ(i1,i2,i3)= UG(i1,i2,i3,ez)*sintm+UG(i1,i2,i3,ez+3)*costm;
            	      }
          	    }
          	    if( solveForMagneticField )
          	    {
            	      FOR_3D(i1,i2,i3,J1,J2,J3)
            	      {
            		UHX(i1,i2,i3)= UG(i1,i2,i3,hx)*sint+UG(i1,i2,i3,hx+3)*cost;
            		UHY(i1,i2,i3)= UG(i1,i2,i3,hy)*sint+UG(i1,i2,i3,hy+3)*cost;
            		UHZ(i1,i2,i3)= UG(i1,i2,i3,hz)*sint+UG(i1,i2,i3,hz+3)*cost;

            		UMHX(i1,i2,i3)= UG(i1,i2,i3,hx)*sintm+UG(i1,i2,i3,hx+3)*costm;
            		UMHY(i1,i2,i3)= UG(i1,i2,i3,hy)*sintm+UG(i1,i2,i3,hy+3)*costm;
            		UMHZ(i1,i2,i3)= UG(i1,i2,i3,hz)*sintm+UG(i1,i2,i3,hz+3)*costm;
            	      }
          	    }
        	  }
#undef UG

      	}
      	else
      	{
        	  ue(Ie1,Ie2,Ie3,CE)= ugLocal(Ie1,Ie2,Ie3,CE)*sint+ugLocal(Ie1,Ie2,Ie3,CE+3)*cost;
        	  uh(Ih1,Ih2,Ih3,CH)= ugLocal(Ih1,Ih2,Ih3,CH)*sint+ugLocal(Ih1,Ih2,Ih3,CH+3)*cost;

	  //            ume(I1,I2,I3,C)= ug(I1,I2,I3,C)*sint+ug(I1,I2,I3,C+3)*cost;
        	  ume(I1,I2,I3,CE)= ugLocal(I1,I2,I3,CE)*sintm+ugLocal(I1,I2,I3,CE+3)*costm;
        	  umh(I1,I2,I3,CH)= ugLocal(I1,I2,I3,CH)*sintm+ugLocal(I1,I2,I3,CH+3)*costm;
      	}
          	    
            }
            else if( initialConditionOption==planeMaterialInterfaceInitialCondition )
            {
      	if( method==nfdtd )
      	{ 
	  // adjust array dimensions for local arrays
        	  Index J1 = Range(max(I1.getBase(),uel.getBase(0)),min(I1.getBound(),uel.getBound(0)));
        	  Index J2 = Range(max(I2.getBase(),uel.getBase(1)),min(I2.getBound(),uel.getBound(1)));
        	  Index J3 = Range(max(I3.getBase(),uel.getBase(2)),min(I3.getBound(),uel.getBound(2)));

                    int i1,i2,i3;
          // we assume there are just two grids with an interface in-between
                    const real c1=cGrid(0);
                    const real c2=cGrid(1);
                    const real kNorm = sqrt(kx*kx+ky*ky);
                    const real a1=-ky/kNorm, a2= kx/kNorm;
                    const real b1=-ky/kNorm, b2=-kx/kNorm;
                    const real w = c1*kNorm;
                    if( kz!=0 )
                    {
                        printF("ERROR: plane material interface: kz!=0 \n");
                        Overture::abort("error");
                    }
                    real kappax,kappay,kappaNorm;
                    const real cr=c2/c1;
                    kappay=ky;
          // discriminant is assumed positive (otherwise internal reflection)
                    kappax=sqrt( (kx*kx+ky*ky)/(cr*cr) - kappay*kappay );
                    kappaNorm=sqrt(kappax*kappax+kappay*kappay);
                    const real d1=-kappay/kappaNorm;
                    const real d2= kappax/kappaNorm;
                    const real cosTheta1=kx/kNorm;
                    const real cosTheta2=kappax/kappaNorm;
           // reflection and transmission coefficients
                    const real r = (c1*cosTheta1-c2*cosTheta2)/(c1*cosTheta1+c2*cosTheta2);
                    const real tau = (2.*c2*cosTheta1)/(c1*cosTheta1+c2*cosTheta2);
                    real tm=t-dt,x,y;
                    const real x0=x0PlaneMaterialInterface[0], y0=x0PlaneMaterialInterface[1];
          // The solution is rotated according to the normal of the plane of the material interface
                    real an0=normalPlaneMaterialInterface[0], an1=normalPlaneMaterialInterface[1];
                    real aNorm = sqrt(an0*an0+an1*an1);
                    an0/= aNorm; an1/=aNorm;
                    real aa1=an0*a1-an1*a2, aa2= an1*a1+an0*a2;
                    real bb1=an0*b1-an1*b2, bb2= an1*b1+an0*b2;
                    real dd1=an0*d1-an1*d2, dd2= an1*d1+an0*d2;
                    if( numberOfDimensions==2 )
                    {
                      if( grid==0 )
                      { // incident plus reflected wave.
                        FOR_3D(i1,i2,i3,J1,J2,J3)
                        {
                            real xx1 = XEP(i1,i2,i3,0) -x0;
                            real yy1 = XEP(i1,i2,i3,1) -y0;
              // rotate the coordinate system
                            x = an0*xx1+an1*yy1;
                            y =-an1*xx1+an0*yy1;
                            real u1 = (aa1*cos(twoPi*(kx*(x)+ky*(y)-w*(t)))+r*bb1*cos(twoPi*(-kx*(x)+ky*(y)-w*(t))));
                            real u2 = (aa2*cos(twoPi*(kx*(x)+ky*(y)-w*(t)))+r*bb2*cos(twoPi*(-kx*(x)+ky*(y)-w*(t))));
                            real u3 = ((-twoPi/w)*((a1*ky-a2*kx)*sin(twoPi*(kx*(x)+ky*(y)-w*(t)))+(b1*ky+b2*kx)*r*sin(twoPi*(-kx*(x)+ky*(y)-w*(t)))));
                              UEX(i1,i2,i3)= u1;
                              UEY(i1,i2,i3)= u2;
                              UHZ(i1,i2,i3)= u3;
                              UMEX(i1,i2,i3)= (aa1*cos(twoPi*(kx*(x)+ky*(y)-w*(tm)))+r*bb1*cos(twoPi*(-kx*(x)+ky*(y)-w*(tm))));
                              UMEY(i1,i2,i3)= (aa2*cos(twoPi*(kx*(x)+ky*(y)-w*(tm)))+r*bb2*cos(twoPi*(-kx*(x)+ky*(y)-w*(tm))));
                              UMHZ(i1,i2,i3)= ((-twoPi/w)*((a1*ky-a2*kx)*sin(twoPi*(kx*(x)+ky*(y)-w*(tm)))+(b1*ky+b2*kx)*r*sin(twoPi*(-kx*(x)+ky*(y)-w*(tm)))));
                        }
                      }
                      else
                      {
            // transmitted wave
                        FOR_3D(i1,i2,i3,J1,J2,J3)
                        {
                            real xx1 = XEP(i1,i2,i3,0) -x0;
                            real yy1 = XEP(i1,i2,i3,1) -y0;
              // rotate the coordinate system
                            x = an0*xx1+an1*yy1;
                            y =-an1*xx1+an0*yy1;
                            real u1 = (tau*dd1*cos(twoPi*(kappax*(x)+kappay*(y)-w*(t))));
                            real u2 = (tau*dd2*cos(twoPi*(kappax*(x)+kappay*(y)-w*(t))));
                            real u3 = ((-twoPi*tau/w)*(d1*kappay-d2*kappax)*sin(twoPi*(kappax*(x)+kappay*(y)-w*(t))));
                              UEX(i1,i2,i3)= u1;
                              UEY(i1,i2,i3)= u2;
                              UHZ(i1,i2,i3)= u3;
                              UMEX(i1,i2,i3)= (tau*dd1*cos(twoPi*(kappax*(x)+kappay*(y)-w*(tm))));
                              UMEY(i1,i2,i3)= (tau*dd2*cos(twoPi*(kappax*(x)+kappay*(y)-w*(tm))));
                              UMHZ(i1,i2,i3)= ((-twoPi*tau/w)*(d1*kappay-d2*kappax)*sin(twoPi*(kappax*(x)+kappay*(y)-w*(tm))));
                        }
                      }
                    }
                    else // 3D -- just assume the interface is 2D -- no Ez component
                    {
                      if( grid==0 )
                      { // incident plus reflected wave.
                        FOR_3D(i1,i2,i3,J1,J2,J3)
                        {
                            real xx1 = XEP(i1,i2,i3,0) -x0;
                            real yy1 = XEP(i1,i2,i3,1) -y0;
              // rotate the coordinate system
                            x = an0*xx1+an1*yy1;
                            y =-an1*xx1+an0*yy1;
                            real u1 = (aa1*cos(twoPi*(kx*(x)+ky*(y)-w*(t)))+r*bb1*cos(twoPi*(-kx*(x)+ky*(y)-w*(t))));
                            real u2 = (aa2*cos(twoPi*(kx*(x)+ky*(y)-w*(t)))+r*bb2*cos(twoPi*(-kx*(x)+ky*(y)-w*(t))));
                            real u3 = (0.);
                              UEX(i1,i2,i3)= u1;
                              UEY(i1,i2,i3)= u2;
                              UEZ(i1,i2,i3)= u3;
                              UMEX(i1,i2,i3)= (aa1*cos(twoPi*(kx*(x)+ky*(y)-w*(tm)))+r*bb1*cos(twoPi*(-kx*(x)+ky*(y)-w*(tm))));
                              UMEY(i1,i2,i3)= (aa2*cos(twoPi*(kx*(x)+ky*(y)-w*(tm)))+r*bb2*cos(twoPi*(-kx*(x)+ky*(y)-w*(tm))));
                              UMEZ(i1,i2,i3)= (0.);
                        }
                      }
                      else
                      {
            // transmitted wave
                        FOR_3D(i1,i2,i3,J1,J2,J3)
                        {
                            real xx1 = XEP(i1,i2,i3,0) -x0;
                            real yy1 = XEP(i1,i2,i3,1) -y0;
              // rotate the coordinate system
                            x = an0*xx1+an1*yy1;
                            y =-an1*xx1+an0*yy1;
                            real u1 = (tau*dd1*cos(twoPi*(kappax*(x)+kappay*(y)-w*(t))));
                            real u2 = (tau*dd2*cos(twoPi*(kappax*(x)+kappay*(y)-w*(t))));
                            real u3 = (0.);
                              UEX(i1,i2,i3)= u1;
                              UEY(i1,i2,i3)= u2;
                              UEZ(i1,i2,i3)= u3;
                              UMEX(i1,i2,i3)= (tau*dd1*cos(twoPi*(kappax*(x)+kappay*(y)-w*(tm))));
                              UMEY(i1,i2,i3)= (tau*dd2*cos(twoPi*(kappax*(x)+kappay*(y)-w*(tm))));
                              UMEZ(i1,i2,i3)= (0.);
                        }
                      }
                    }
      	}
            }

            else if( initialConditionOption==gaussianIntegralInitialCondition )
            {
      	printF("Setting initial condition to be Tom's Gaussian integral solution");
          	    
	// adjust array dimensions for local arrays
      	Index J1 = Range(max(I1.getBase(),uel.getBase(0)),min(I1.getBound(),uel.getBound(0)));
      	Index J2 = Range(max(I2.getBase(),uel.getBase(1)),min(I2.getBound(),uel.getBound(1)));
      	Index J3 = Range(max(I3.getBase(),uel.getBase(2)),min(I3.getBound(),uel.getBound(2)));

            if( initialConditionOption==gaussianIntegralInitialCondition )
            {
                double wt,wx,wy;
                const int nsources=1;
                double xs[nsources], ys[nsources], tau[nsources], var[nsources], amp[nsources];
                xs[0]=0.;
                ys[0]=1.e-8*1./3.;  // should not be on a grid point
                tau[0]=-.95;
                var[0]=30.;
                amp[0]=1.;
                double period= 1.;  // period in y
                double time=t;
                int i1,i2,i3;
                FOR_3D(i1,i2,i3,J1,J2,J3)
                {
                    double x=X(i1,i2,i3,0); 
                    double y=X(i1,i2,i3,1);
                    exmax(wt,wx,wy,nsources,xs[0],ys[0],tau[0],var[0],amp[0],period,x,y,time);
                        UEX(i1,i2,i3) = wy;
                        UEY(i1,i2,i3) =-wx;
                        UHZ(i1,i2,i3)= wt;
                }
            }

            if( initialConditionOption==gaussianIntegralInitialCondition )
            {
                double wt,wx,wy;
                const int nsources=1;
                double xs[nsources], ys[nsources], tau[nsources], var[nsources], amp[nsources];
                xs[0]=0.;
                ys[0]=1.e-8*1./3.;  // should not be on a grid point
                tau[0]=-.95;
                var[0]=30.;
                amp[0]=1.;
                double period= 1.;  // period in y
                double time=t-dt;
                int i1,i2,i3;
                FOR_3D(i1,i2,i3,J1,J2,J3)
                {
                    double x=X(i1,i2,i3,0); 
                    double y=X(i1,i2,i3,1);
                    exmax(wt,wx,wy,nsources,xs[0],ys[0],tau[0],var[0],amp[0],period,x,y,time);
                        UMEX(i1,i2,i3) = wy;
                        UMEY(i1,i2,i3) =-wx;
                        UMHZ(i1,i2,i3)= wt;
                }
            }
          	    
//             uh(Ih1,Ih2,Ih3,hz)=hzGaussianPulse(xhi);
//             ue(Ie1,Ie2,Ie3,ex)=exGaussianPulse(xei);
//             ue(Ie1,Ie2,Ie3,ey)=eyGaussianPulse(xei);

//             xhi+=cc*dt;
//             xei+=cc*dt;
//             umh(Ih1,Ih2,Ih3,hz)=hzGaussianPulse(xhi);
//             ume(Ie1,Ie2,Ie3,ex)=exGaussianPulse(xei);//u(I1,I2,I3,hz)*(-ky/(eps*cc));
//             ume(Ie1,Ie2,Ie3,ey)=eyGaussianPulse(xei);//u(I1,I2,I3,hz)*( kx/(eps*cc));

      	if( saveExtraForcingLevels )
      	{
	  // we need to save the "RHS" at some previous times.
        	  for( int m=0; m<numberOfFunctions; m++ )
        	  {
#ifdef USE_PPP
          	    realSerialArray fnLocal; getLocalArrayWithGhostBoundaries(FN(m),fnLocal);
          	    Overture::abort("finish me for parallel");
#else
          	    realSerialArray & fnLocal = FN(m);
#endif
          	    fnLocal(I1,I2,I3,hz)=0.; 
          	    fnLocal(I1,I2,I3,ex)=0.; 
          	    fnLocal(I1,I2,I3,ey)=0.; 
        	  }
      	}
            }

            else if( initialConditionOption==defaultInitialCondition )
            {
      	printF("Setting initial conditions to be zero. (default)\n");
          	    
	//            u(I1,I2,I3,C)=0.;
	//            um(I1,I2,I3,C)=0.;
      	uh = 0;
      	ue = 0;
      	umh = 0.;
      	ume = 0;
      	if( saveExtraForcingLevels )
      	{
        	  for( int m=0; m<numberOfFunctions; m++ )
        	  {
#ifdef USE_PPP
          	    realSerialArray fnLocal; getLocalArrayWithGhostBoundaries(FN(m),fnLocal);
          	    Overture::abort("finish me for parallel");
#else
          	    realSerialArray & fnLocal = FN(m);
#endif
          	    fnLocal(I1,I2,I3,C)=0.;
        	  }
        	  
      	}
      	if( forcingOption==planeWaveBoundaryForcing )
      	{
        	  printF("*** Set BC's for planeWaveBoundaryForcing on initial conditions...\n");
        	  realMappedGridFunction & fieldPrev    =mgp!=NULL ? fields[prev]    : cgfields[prev][grid];
        	  realMappedGridFunction & fieldCurrent =mgp!=NULL ? fields[current] : cgfields[current][grid];

        	  int option=0; // not used.
        	  assignBoundaryConditions( option, grid, t-dt, dt, fieldPrev, fieldPrev, prev );
        	  assignBoundaryConditions( option, grid, t   , dt, fieldCurrent, fieldCurrent, current );

      	}

            }
            else
            {
      	Overture::abort("Maxwell::unknown initialConditionOption option");
            }

        }
#undef FN	      
//kkc XXX look inside EXTRACT_GFP_END for the replacement
//kkc XXX what should replace this??      fieldCurrent.periodicUpdate(); 
//kkc XXX what should replace this??      fieldPrev.periodicUpdate();

    // reset the cpp macros for the E and H field gridfunctions
    // should the above periodic updates be done in this macro too?
        if( method==dsiMatVec  )
        {
            #ifdef USE_PPP
                Overture::abort("finish me for parallel");
            #else
      // XXX the following is broken for PARALLEL right now (need to use more macros...
            bool vCent = mg.isAllVertexCentered();
            int nDim = mg.numberOfDimensions();
            realMappedGridFunction &uep = (mgp==NULL ? getCGField(EField,current)[grid] : fields[current+numberOfTimeLevels]);
            realMappedGridFunction &uhp = (mgp==NULL ? getCGField(HField,current)[grid] : fields[current]);
            realMappedGridFunction &uepm = (mgp==NULL ? getCGField(EField,next)[grid] : fields[next+numberOfTimeLevels]);
            realMappedGridFunction &uhpm = (mgp==NULL ? getCGField(HField,next)[grid] : fields[next]);
            if ( mg.numberOfDimensions()==2 )
            {
                for ( int e=0; e<edgeAreaNormals.getLength(0); e++ )
                {
                    uep(e,0,0,0) = 0;
                    uepm(e,0,0,0) =  0;
                    for ( int a=0; a<mg.numberOfDimensions(); a++ )
                    {
              	uep(e,0,0,0) += edgeAreaNormals(e,0,0,a)*ue(e,0,0,a);
              	uepm(e,0,0,0) += edgeAreaNormals(e,0,0,a)*ume(e,0,0,a);
                    }
                }
                uhp = uh;
                uhpm = umh;
            }
            else
            {
        //      cout<<"geom sizes "<<cFArea.getLength(0)<<"  "<<cEArea.getLength(0)<<endl;
                for ( int f=0; f<faceAreaNormals.getLength(0); f++ )
                {
                    uhp(f,0,0,0) = 0;
                    uhpm(f,0,0,0) =  0;
                    for ( int a=0; a<mg.numberOfDimensions(); a++ )
                    {
              	uhp(f,0,0,0) += faceAreaNormals(f,0,0,a)*uh(f,0,0,a);
              	uhpm(f,0,0,0) += faceAreaNormals(f,0,0,a)*umh(f,0,0,a);
                    }
                }
                for ( int e=0; e<edgeAreaNormals.getLength(0); e++ )
                {
                    uep(e,0,0,0) = 0;
                    uepm(e,0,0,0) =  0;
                    for ( int a=0; a<mg.numberOfDimensions(); a++ )
                    {
              	uep(e,0,0,0) += edgeAreaNormals(e,0,0,a)*ue(e,0,0,a);
              	uepm(e,0,0,0) += edgeAreaNormals(e,0,0,a)*ume(e,0,0,a);
                    }
                }
            }
            #endif
        }
        if ( method==nfdtd )
        {
            (mgp==NULL ? getCGField(HField,current)[grid] : fields[current]).periodicUpdate();
            (mgp==NULL ? getCGField(HField,prev)[grid] : fields[prev]).periodicUpdate();
        }
        else
        {
            (mgp==NULL ? getCGField(HField,current)[grid] : fields[current]).periodicUpdate();
            (mgp==NULL ? getCGField(EField,current)[grid] : fields[current+2]).periodicUpdate();
        }
        #undef         UHX
        #undef         UHY
        #undef         UHZ
        #undef         UEX
        #undef         UEY
        #undef         UEZ
        #undef         UMHX
        #undef         UMHY
        #undef         UMHZ
        #undef         UMEX
        #undef         UMEY
        #undef         UMEZ
        #undef         UNHX
        #undef         UNHY
        #undef         UNHZ
        #undef         UNEX
        #undef         UNEY
        #undef         UNEZ
        #undef         XEP
        #undef         XHP
        #undef         X
        #undef         ERRHX
        #undef         ERRHY
        #undef         ERRHZ
        #undef         ERREX
        #undef         ERREY
        #undef         ERREZ
        #undef         MASK
        #endif 
        #undef EXTGFP_SENTINEL
        
    }
    

        
    if( debug & 4 ) 
    {	  
        for( int grid=0; grid<numberOfComponentGrids; grid++ )
        {
            realMappedGridFunction & fieldPrev    =mgp!=NULL ? fields[prev]    : cgfields[prev][grid];
            realMappedGridFunction & fieldCurrent =mgp!=NULL ? fields[current] : cgfields[current][grid];

            ::display(fieldPrev,sPrintF("fieldPrev after initial conditions, t=%e",t),debugFile,"%9.2e ");
            ::display(fieldCurrent,sPrintF("fieldCurrent after initial conditions, t=%e",t),debugFile,"%9.2e ");
        }  // end for grid
    } 



    if( projectInitialConditions )
    {
        project( numberOfStepsTaken-1, prev,    t-dt, dt );

        project( numberOfStepsTaken  , current, t   , dt );

        if( true )
        {
      // Apply the BC;s
            for( int grid=0; grid<cg.numberOfComponentGrids(); grid++ )
            {
      	realMappedGridFunction & fieldNext    =mgp!=NULL ? fields[next]    : cgfields[next][grid];
      	realMappedGridFunction & fieldCurrent =mgp!=NULL ? fields[current] : cgfields[current][grid];
      	realMappedGridFunction & fieldPrev    =mgp!=NULL ? fields[prev]    : cgfields[prev][grid];

      	int option=0;
        // what should we use as the "previous" solution in the next call ?
      	assignBoundaryConditions( option, grid, t-dt, dt, fieldPrev   , fieldCurrent,current ); // check this

      	assignBoundaryConditions( option, grid, t   , dt, fieldCurrent, fieldPrev   ,prev );
            }
        }
    }
    
    timing(timeForProject)=0.; // count project of IC's as part of the time for IC's
    timing(timeForInitialConditions)+=getCPU()-time0;

}


// =========================================================================================
//  Use this function to initialize a known solution -- currently used to compute
//  scattering past a cylinder or sphere or the Gaussian integral solution from Tom H.
// =========================================================================================
void Maxwell::
initializeKnownSolution()
{
    if( knownSolution!=NULL )
        return;

    assert( cgp!=NULL );
    CompositeGrid & cg = *cgp;

    if( knownSolution==NULL )
    {
    // We save the Re and Im parts of the known solution
    //      u(.,.,.,0..2) = (Ex,Ey,[Hz,ez]) : Re part
    //      u(.,.,.,3..5) = (Ex,Ey,[Hz,ez]) : Im part
        Range all;
        int numberOfComponents=6;
        knownSolution=new realCompositeGridFunction(cg,all,all,all,numberOfComponents);
    }

//    if( true )
//    {
//      *knownSolution=0.;
//      return;
//    }

    const real a=.5;  // radius of the cylinder or sphere
    real cr = 1.;  // c1/c2 (c2=inside)
    int computeIncident=0;  // set to 1 to compute incident wave too 
    real rpar[] = {twoPi*kx,a,cr}; //
    int option=0;  // 0=PEC cylinder, 1=di-electric
    int inOut=0;   // 0=exterior, 1=interior to the dielectric
    int ipar[] = {0,1,2,3,4,5,option,inOut,computeIncident}; //

    Index I1,I2,I3;
    for( int grid=0; grid<cg.numberOfComponentGrids(); grid++ )
    {

        MappedGrid & mg = cg[grid];
        mg.update(MappedGrid::THEcenter);
        
        getIndex(mg.dimension(),I1,I2,I3);
        
#ifdef USE_PPP
        const realArray & uga = (*knownSolution)[grid];
        realSerialArray ug; getLocalArrayWithGhostBoundaries(uga,ug);

        const realArray & xya = mg.center();
        realSerialArray xy;  getLocalArrayWithGhostBoundaries(xya,xy);

        const int includeGhost=1;
        bool ok = ParallelUtility::getLocalArrayBounds(uga,ug,I1,I2,I3,includeGhost); 
        if( !ok ) continue;

#else
        const realSerialArray & ug = (*knownSolution)[grid];
        const realSerialArray & xy = mg.center();
#endif

//     if( initialConditionOption==planeWaveScatteredFieldInitialCondition ||
// 	initialConditionOption==planeMaterialInterfaceInitialCondition ||
//          initialConditionOption==zeroInitialCondition )
        if( knownSolutionOption==scatteringFromADiskKnownSolution ||
      	knownSolutionOption==scatteringFromADielectricDiskKnownSolution ||
      	knownSolutionOption==scatteringFromASphereKnownSolution ||
      	knownSolutionOption==scatteringFromADielectricSphereKnownSolution )
        {
            if( gridHasMaterialInterfaces )
            {
      	assert( (cg.numberOfDimensions()==2 && cg.numberOfComponentGrids()==4 ) ||
                                (cg.numberOfDimensions()==3 && cg.numberOfComponentGrids()==6 ) );
      	option=1;
      	ipar[6]=option;
	// rpar[2] = sqrt(epsGrid(2)/epsGrid(0)); // c1/c2 (c2=inside)
	// assume grids 0 and 1 are outside and grids 2,3 are inside the cylinder
      	if( cg.numberOfDimensions()==2 )
      	{
            	  rpar[1] =.4;  // radius for dielectric cyl or sphere 
        	  cr = cGrid(0)/cGrid(2); // c1/c2 (c2=inside)
        	  rpar[2] = cr;
        	  if( cg.numberOfDomains()>1 )
                        ipar[7]= cg.domainNumber(grid);    // new way 
        	  else
              	    ipar[7]= grid<=1 ? 0 : 1;       // assume 2 grids on the outside (fix me!)
      	}
                else
      	{
        	  rpar[1] =1.;  // radius for dielectric cyl or sphere 
        	  cr = cGrid(0)/cGrid(3); // c1/c2 (c2=inside)
        	  rpar[2] = cr;
          // ipar[7]= grid<=2 ? 0 : 1;       // assume 3 grids on the outside (fix me!)
                    ipar[7]= cg.domainNumber(grid);    // new way domain=0 : outside, 1=inside 
                    ipar[8]=1;  // compute incident field
      	}
            }

            if( cg.numberOfDimensions()==2 )
            {
        // --- evaluate scattering by a cylinder ---

      	printF(" Call scatCyl for grid=%i, option=%i cr=%7.3f...\n",grid,option,cr);
      	scatCyl(mg.numberOfDimensions(), 
            		I1.getBase(),I1.getBound(),I2.getBase(),I2.getBound(),I3.getBase(),I3.getBound(),
            		ug.getBase(0),ug.getBound(0),
            		ug.getBase(1),ug.getBound(1),
            		ug.getBase(2),ug.getBound(2),
            		ug.getBase(3),ug.getBound(3),
            		*(xy.getDataPointer()),*(ug.getDataPointer()),ipar[0],rpar[0] );
            }
            else
            {
        // --- evaluate scattering by a sphere ---
      	printF(" Call scatSphere for grid=%i...\n",grid);
      	scatSphere(mg.numberOfDimensions(), 
               		   I1.getBase(),I1.getBound(),I2.getBase(),I2.getBound(),I3.getBase(),I3.getBound(),
               		   ug.getBase(0),ug.getBound(0),
               		   ug.getBase(1),ug.getBound(1),
               		   ug.getBase(2),ug.getBound(2),
               		   ug.getBase(3),ug.getBound(3),
               		   *(xy.getDataPointer()),*(ug.getDataPointer()),ipar[0],rpar[0] );
            }


      // Add on the incident field if we are computing the total field
      //   -- only add on incident field for the outer domain in multi-domain problems ---
            if( initialConditionOption==planeWaveInitialCondition   &&
                    (cg.numberOfDomains()==1 || cg.domainNumber(grid)==0 ) )
            {
                printF(" ** Add on incident field grid=%i...\n",grid);
                const real t=0.;
      	const real cc= c*sqrt( kx*kx+ky*ky );
      	if( mg.numberOfDimensions()==2 )
      	{
        	  const realSerialArray & x = xy(I1,I2,I3,0);
        	  const realSerialArray & y = xy(I1,I2,I3,1);


          // Ex.t=(Hz).y =>  -i*k*Ex = (Hz).y -> Ex = i (Hz).y/k  -> Re(Ex) = -Im(Hz.y)/k  Im(Ex) = Re(Hz.y)
          // k*Ey =-i*(Hz).x

          // the following is only valid for material interfaces I think 
        	  assert( gridHasMaterialInterfaces );

                    realSerialArray cosa,sina;
        	  cosa=cos(twoPi*(kx*(x)+ky*(y)-cc*(t)));
        	  sina=sin(twoPi*(kx*(x)+ky*(y)-cc*(t)));
        	  
        	  ug(I1,I2,I3,hz  )+= cosa;
        	  ug(I1,I2,I3,hz+3)+= sina;

        	  ug(I1,I2,I3,ex  )+= -cosa*(ky/cc); 
        	  ug(I1,I2,I3,ex+3)+= -sina*(ky/cc);

        	  ug(I1,I2,I3,ey  )+= cosa*(kx/cc); 
        	  ug(I1,I2,I3,ey+3)+= sina*(kx/cc);

      	}
      	else
      	{
          // *** fix me for material interfaces ***
        	  assert( !gridHasMaterialInterfaces );
        	  
        	  const realSerialArray & x = xy(I1,I2,I3,0);
        	  const realSerialArray & y = xy(I1,I2,I3,1);
        	  const realSerialArray & z = xy(I1,I2,I3,2);

        	  if( solveForElectricField )
        	  {
          	    ug(I1,I2,I3,ex)+=exTrue3d(x,y,z,t);
          	    ug(I1,I2,I3,ey)+=eyTrue3d(x,y,z,t);
          	    ug(I1,I2,I3,ez)+=ezTrue3d(x,y,z,t);
        	  }

      	}
            }

        }
        else
        {
            printF("initializeKnownSolution:ERROR: unexpected initialConditionOption=%i\n",
           	     initialConditionOption);
            Overture::abort("initializeKnownSolution:ERROR");
        }



    }  // end for grid
    

}


