! This file automatically generated from advSmCons2dOrder2c.bf with bpp.
! ogf2d, ogf3d, ogDeriv2, etc. are foundin forcing.bC
      
      
!       ntd,nxd,nyd,nzd : number of derivatives to evaluate in t,x,y,z
      
       
      
      
      






c     
c     Advance the equations of solid mechanics
c       
      subroutine advSmCons2dOrder2c(nd,n1a,n1b,n2a,n2b,n3a,n3b,nd1a,
     & nd1b,
     & nd2a,nd2b,nd3a,nd3b,nd4a,nd4b,mask,rsxy,xy, um,u,un,f, bc, dis,
     &     varDis, ipar, rpar, ierr )
c======================================================================
c     Advance a time step for the equations of Solid Mechanics (linear elasticity for now)
c     
c     nd : number of space dimensions
c     
c     ipar(0)  = option : option=0 - Elasticity+Artificial diffusion
c     =1 - AD only
c     
c     dis(i1,i2,i3) : temp space to hold artificial dissipation
c     varDis(i1,i2,i3) : coefficient of the variable artificial dissipation
c======================================================================
      implicit none
      integer nd, n1a,n1b,n2a,n2b,n3a,n3b,nd1a,nd1b,nd2a,nd2b,nd3a,
     &     nd3b,nd4a,nd4b
      real um(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
      real u(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
      real un(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
      real f(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
      real dis(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
      real varDis(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,0:nd-1,0:nd-1)
      real xy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,0:nd-1)
      integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      integer bc(0:1,0:2),ierr
      integer ipar(0:*)
      real rpar(0:*)
c     ---- local variables -----
      integer c,i1,i2,i3,n,gridType,orderOfAccuracy,orderInTime
      integer addForcing,orderOfDissipation,option
      integer useWhereMask,useWhereMaskSave,grid,
     &     useVariableDissipation,timeSteppingMethod
      integer useConservative,combineDissipationWithAdvance
      integer uc,vc,wc
      real dt,dx(0:3),adc,dr(0:3),c1,c2,kx,ky,kz,t
      real qx,qy,qz,rx,ry,rz,sx,sy,sz
      real lam2mu,lam,mu,uxy0,uy0,vxy0,vy0,epep
      integer ipp,ip,im,jp,jm,i
      real Dup, Dum, Dvp, Dvm, Ep, Em ,dcons,dc,Jac,u1,u2
      real rh1(nd1a:nd1b,nd2a:nd2b)
      real rh2(nd1a:nd1b,nd2a:nd2b)
      real dri(0:3)
      real dtsq,errmaxu,errtmpu,exsolu,errmaxv,errtmpv,exsolv
      real du,fd22d,fd42d,adcdt,energy,weight,etmp
      integer dirichlet,stressFree,debug
      parameter( dirichlet=1,stressFree=2 )

      qx(i1,i2)=rsxy(i1,i2,nd3a,0,0)
      qy(i1,i2)=rsxy(i1,i2,nd3a,0,1)
      rx(i1,i2)=rsxy(i1,i2,nd3a,1,0)
      ry(i1,i2)=rsxy(i1,i2,nd3a,1,1)
      Jac(i1,i2)=1.d0/(qx(i1,i2)*ry(i1,i2)-rx(i1,i2)*qy(i1,i2))
      lam(i1,i2)=(c1-c2)
      mu(i1,i2)=c2
      lam2mu(i1,i2)=(lam(i1,i2)+2.0*mu(i1,12))
      u1(i1,i2)=u(i1,i2,0,uc)   !!???
      u2(i1,i2)=u(i1,i2,0,vc)   !!???
c ******* artificial dissipation ******
      du(i1,i2,i3,c)=u(i1,i2,i3,c)-um(i1,i2,i3,c)
c      (2nd difference)
      fd22d(i1,i2,i3,c)=(( du(i1-1,i2,i3,c)+du(i1+1,i2,i3,c)+du(i1,i2-
     & 1,i3,c)+du(i1,i2+1,i3,c) )-4.*du(i1,i2,i3,c))
c     -(fourth difference)
      fd42d(i1,i2,i3,c)=(-( du(i1-2,i2,i3,c)+du(i1+2,i2,i3,c)+du(i1,i2-
     & 2,i3,c)+du(i1,i2+2,i3,c) )+4.*( du(i1-1,i2,i3,c)+du(i1+1,i2,i3,
     & c)+du(i1,i2-1,i3,c)+du(i1,i2+1,i3,c) )-12.*du(i1,i2,i3,c) )
      
      dt    =rpar(0)
      dx(0) =rpar(1)
      dx(1) =rpar(2)
      dx(2) =rpar(3)
      adc   =rpar(4)  ! coefficient of artificial dissipation
      dr(0) =rpar(5)
      dr(1) =rpar(6)
      dr(2) =rpar(7)
      c1    =rpar(8)
      c2    =rpar(9)
      kx    =rpar(10)
      ky    =rpar(11)
      kz    =rpar(12)
      epep  =rpar(13)
      t     =rpar(14)

      option             =ipar(0)
      gridType           =ipar(1)
      orderOfAccuracy    =ipar(2)
      orderInTime        =ipar(3)
      addForcing         =ipar(4)
      orderOfDissipation =ipar(5)
      uc                 =ipar(6)
      vc                 =ipar(7)
      wc                 =ipar(8)
      useWhereMask       =ipar(9)
      timeSteppingMethod =ipar(10)
      useVariableDissipation=ipar(11)
      useConservative    =ipar(12)
      combineDissipationWithAdvance = ipar(13)
      debug              =ipar(14)
      dtsq=dt*dt
      do i=0,2 
         dri(i)=1.0d0/dr(i)
      enddo
      
!        write(*,'(" advSmCons2dOrder2c t=",e10.2)') t

      if(debug.gt.2) then
         errmaxu=0.0
         errmaxv=0.0
      endif
!       initialize to zero
      do i2=n2a,n2b
      do i1=n1a,n1b
      rh1(i1,i2)=0.d0
      rh2(i1,i2)=0.d0
      end do
      end do
!       do the cross terms everywhere and overwrite if necessary
      dc=0.25d0*dri(0)*dri(1)
      do i2=n2a,n2b
      do i1=n1a,n1b
      rh1(i1,i2)=0.d0
      rh2(i1,i2)=0.d0
      ip=i1+1
      im=i1-1
      jp=i2+1
      jm=i2-1
      !       (2 mu+lam) uxx 
      Ep=Jac(ip,i2)*qx(ip,i2)*qx(ip,i2)*lam2mu(ip,i2)+Jac(i1,i2)*qx(i1,
     & i2)*qx(i1,i2)*lam2mu(i1,i2)
      Em=Jac(im,i2)*qx(im,i2)*qx(im,i2)*lam2mu(im,i2)+Jac(i1,i2)*qx(i1,
     & i2)*qx(i1,i2)*lam2mu(i1,i2)
      rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(i1,i2))-
     & Em*(u1(i1,i2)-u1(im,i2)))
      Ep=Jac(ip,i2)*qx(ip,i2)*rx(ip,i2)*lam2mu(ip,i2)
      Em=Jac(im,i2)*qx(im,i2)*rx(im,i2)*lam2mu(im,i2)
      rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(im,jp)-
     & u1(im,jm)))
      Ep=Jac(i1,jp)*rx(i1,jp)*qx(i1,jp)*lam2mu(i1,jp)
      Em=Jac(i1,jm)*rx(i1,jm)*qx(i1,jm)*lam2mu(i1,jm)
      rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(ip,jm)-
     & u1(im,jm)))
      Ep=Jac(i1,jp)*rx(i1,jp)*rx(i1,jp)*lam2mu(i1,jp)+Jac(i1,i2)*rx(i1,
     & i2)*rx(i1,i2)*lam2mu(i1,i2)
      Em=Jac(i1,jm)*rx(i1,jm)*rx(i1,jm)*lam2mu(i1,jm)+Jac(i1,i2)*rx(i1,
     & i2)*rx(i1,i2)*lam2mu(i1,i2)
      rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(i1,i2))-
     & Em*(u1(i1,i2)-u1(i1,jm)))
      ! mu uyy 
      Ep=Jac(ip,i2)*qy(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qy(i1,i2)*
     & qy(i1,i2)*mu(i1,i2)
      Em=Jac(im,i2)*qy(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qy(i1,i2)*
     & qy(i1,i2)*mu(i1,i2)
      rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(i1,i2))-
     & Em*(u1(i1,i2)-u1(im,i2)))
      Ep=Jac(ip,i2)*qy(ip,i2)*ry(ip,i2)*mu(ip,i2)
      Em=Jac(im,i2)*qy(im,i2)*ry(im,i2)*mu(im,i2)
      rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(im,jp)-
     & u1(im,jm)))
      Ep=Jac(i1,jp)*ry(i1,jp)*qy(i1,jp)*mu(i1,jp)
      Em=Jac(i1,jm)*ry(i1,jm)*qy(i1,jm)*mu(i1,jm)
      rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(ip,jm)-
     & u1(im,jm)))
      Ep=Jac(i1,jp)*ry(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*ry(i1,i2)*
     & ry(i1,i2)*mu(i1,i2)
      Em=Jac(i1,jm)*ry(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*ry(i1,i2)*
     & ry(i1,i2)*mu(i1,i2)
      rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(i1,i2))-
     & Em*(u1(i1,i2)-u1(i1,jm)))
      ! d_x lam v_y
      Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*lam(ip,i2)+Jac(i1,i2)*qx(i1,i2)
     & *qy(i1,i2)*lam(i1,i2)
      Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*lam(im,i2)+Jac(i1,i2)*qx(i1,i2)
     & *qy(i1,i2)*lam(i1,i2)
      rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(i1,i2))-
     & Em*(u2(i1,i2)-u2(im,i2)))
      Ep=Jac(ip,i2)*qx(ip,i2)*ry(ip,i2)*lam(ip,i2)
      Em=Jac(im,i2)*qx(im,i2)*ry(im,i2)*lam(im,i2)
      rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(im,jp)-
     & u2(im,jm)))
      Ep=Jac(i1,jp)*rx(i1,jp)*qy(i1,jp)*lam(i1,jp)
      Em=Jac(i1,jm)*rx(i1,jm)*qy(i1,jm)*lam(i1,jm)
      rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(ip,jm)-
     & u2(im,jm)))
      Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*lam(i1,jp)+Jac(i1,i2)*rx(i1,i2)
     & *ry(i1,i2)*lam(i1,i2)
      Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*lam(i1,jm)+Jac(i1,i2)*rx(i1,i2)
     & *ry(i1,i2)*lam(i1,i2)
      rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(i1,i2))-
     & Em*(u2(i1,i2)-u2(i1,jm)))
      ! d_y mu v_x
      Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(i1,i2)*
     & qy(i1,i2)*mu(i1,i2)
      Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(i1,i2)*
     & qy(i1,i2)*mu(i1,i2)
      rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(i1,i2))-
     & Em*(u2(i1,i2)-u2(im,i2)))
      Ep=Jac(ip,i2)*qy(ip,i2)*rx(ip,i2)*mu(ip,i2)
      Em=Jac(im,i2)*qy(im,i2)*rx(im,i2)*mu(im,i2)
      rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(im,jp)-
     & u2(im,jm)))
      Ep=Jac(i1,jp)*ry(i1,jp)*qx(i1,jp)*mu(i1,jp)
      Em=Jac(i1,jm)*ry(i1,jm)*qx(i1,jm)*mu(i1,jm)
      rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(ip,jm)-
     & u2(im,jm)))
      Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(i1,i2)*
     & ry(i1,i2)*mu(i1,i2)
      Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(i1,i2)*
     & ry(i1,i2)*mu(i1,i2)
      rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(i1,i2))-
     & Em*(u2(i1,i2)-u2(i1,jm)))
      ! mu vxx 	
      Ep=Jac(ip,i2)*qx(ip,i2)*qx(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(i1,i2)*
     & qx(i1,i2)*mu(i1,i2)
      Em=Jac(im,i2)*qx(im,i2)*qx(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(i1,i2)*
     & qx(i1,i2)*mu(i1,i2)
      rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(i1,i2))-
     & Em*(u2(i1,i2)-u2(im,i2)))
      Ep=Jac(ip,i2)*qx(ip,i2)*rx(ip,i2)*mu(ip,i2)
      Em=Jac(im,i2)*qx(im,i2)*rx(im,i2)*mu(im,i2)
      rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(im,jp)-
     & u2(im,jm)))
      Ep=Jac(i1,jp)*rx(i1,jp)*qx(i1,jp)*mu(i1,jp)
      Em=Jac(i1,jm)*rx(i1,jm)*qx(i1,jm)*mu(i1,jm)
      rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(ip,jm)-
     & u2(im,jm)))
      Ep=Jac(i1,jp)*rx(i1,jp)*rx(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(i1,i2)*
     & rx(i1,i2)*mu(i1,i2)
      Em=Jac(i1,jm)*rx(i1,jm)*rx(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(i1,i2)*
     & rx(i1,i2)*mu(i1,i2)
      rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(i1,i2))-
     & Em*(u2(i1,i2)-u2(i1,jm)))
      ! (2 mu + lam) vyy 
      Ep=Jac(ip,i2)*qy(ip,i2)*qy(ip,i2)*lam2mu(ip,i2)+Jac(i1,i2)*qy(i1,
     & i2)*qy(i1,i2)*lam2mu(i1,i2)
      Em=Jac(im,i2)*qy(im,i2)*qy(im,i2)*lam2mu(im,i2)+Jac(i1,i2)*qy(i1,
     & i2)*qy(i1,i2)*lam2mu(i1,i2)
      rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(i1,i2))-
     & Em*(u2(i1,i2)-u2(im,i2)))
      Ep=Jac(ip,i2)*qy(ip,i2)*ry(ip,i2)*lam2mu(ip,i2)
      Em=Jac(im,i2)*qy(im,i2)*ry(im,i2)*lam2mu(im,i2)
      rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(im,jp)-
     & u2(im,jm)))
      Ep=Jac(i1,jp)*ry(i1,jp)*qy(i1,jp)*lam2mu(i1,jp)
      Em=Jac(i1,jm)*ry(i1,jm)*qy(i1,jm)*lam2mu(i1,jm)
      rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(ip,jm)-
     & u2(im,jm)))
      Ep=Jac(i1,jp)*ry(i1,jp)*ry(i1,jp)*lam2mu(i1,jp)+Jac(i1,i2)*ry(i1,
     & i2)*ry(i1,i2)*lam2mu(i1,i2)
      Em=Jac(i1,jm)*ry(i1,jm)*ry(i1,jm)*lam2mu(i1,jm)+Jac(i1,i2)*ry(i1,
     & i2)*ry(i1,i2)*lam2mu(i1,i2)
      rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(i1,i2))-
     & Em*(u2(i1,i2)-u2(i1,jm)))
      ! d_x my u_y
      Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(i1,i2)*
     & qy(i1,i2)*mu(i1,i2)
      Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(i1,i2)*
     & qy(i1,i2)*mu(i1,i2)
      rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(i1,i2))-
     & Em*(u1(i1,i2)-u1(im,i2)))
      Ep=Jac(ip,i2)*qy(ip,i2)*rx(ip,i2)*mu(ip,i2)
      Em=Jac(im,i2)*qy(im,i2)*rx(im,i2)*mu(im,i2)
      rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(im,jp)-
     & u1(im,jm)))
      Ep=Jac(i1,jp)*ry(i1,jp)*qx(i1,jp)*mu(i1,jp)
      Em=Jac(i1,jm)*ry(i1,jm)*qx(i1,jm)*mu(i1,jm)
      rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(ip,jm)-
     & u1(im,jm)))
      Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(i1,i2)*
     & ry(i1,i2)*mu(i1,i2)
      Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(i1,i2)*
     & ry(i1,i2)*mu(i1,i2)
      rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(i1,i2))-
     & Em*(u1(i1,i2)-u1(i1,jm)))
      ! d_y lam u_y
      Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*lam(ip,i2)+Jac(i1,i2)*qx(i1,i2)
     & *qy(i1,i2)*lam(i1,i2)
      Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*lam(im,i2)+Jac(i1,i2)*qx(i1,i2)
     & *qy(i1,i2)*lam(i1,i2)
      rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(i1,i2))-
     & Em*(u1(i1,i2)-u1(im,i2)))
      Ep=Jac(ip,i2)*qx(ip,i2)*ry(ip,i2)*lam(ip,i2)
      Em=Jac(im,i2)*qx(im,i2)*ry(im,i2)*lam(im,i2)
      rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(im,jp)-
     & u1(im,jm)))
      Ep=Jac(i1,jp)*rx(i1,jp)*qy(i1,jp)*lam(i1,jp)
      Em=Jac(i1,jm)*rx(i1,jm)*qy(i1,jm)*lam(i1,jm)
      rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(ip,jm)-
     & u1(im,jm)))
      Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*lam(i1,jp)+Jac(i1,i2)*rx(i1,i2)
     & *ry(i1,i2)*lam(i1,i2)
      Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*lam(i1,jm)+Jac(i1,i2)*rx(i1,i2)
     & *ry(i1,i2)*lam(i1,i2)
      rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(i1,i2))-
     & Em*(u1(i1,i2)-u1(i1,jm)))
      end do
      end do
      
!       We correct the sides
      dc=0.5d0*dri(0)*dri(1)
      if( bc(0,0).eq.stressFree)then
         do i2=n2a,n2b
            do i1=n1a,n1a
        rh1(i1,i2)=0.d0
        rh2(i1,i2)=0.d0
             ip=i1+1
             im=i1-1
             jp=i2+1
             jm=i2-1
             !       (2 mu+lam) uxx 
             Ep=Jac(ip,i2)*qx(ip,i2)*qx(ip,i2)*lam2mu(ip,i2)+Jac(i1,i2)
     & *qx(i1,i2)*qx(i1,i2)*lam2mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qx(im,i2)*lam2mu(im,i2)+Jac(i1,i2)
     & *qx(i1,i2)*qx(i1,i2)*lam2mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*rx(i1,jp)*lam2mu(i1,jp)+Jac(i1,i2)
     & *rx(i1,i2)*rx(i1,i2)*lam2mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*rx(i1,jm)*lam2mu(i1,jm)+Jac(i1,i2)
     & *rx(i1,i2)*rx(i1,i2)*lam2mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! mu uyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qy(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qy(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qy(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*ry(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*ry(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*ry(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*ry(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! d_x lam v_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*lam(ip,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*lam(im,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*lam(i1,jp)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*lam(i1,jm)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! d_y mu v_x
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! mu vxx 	
             Ep=Jac(ip,i2)*qx(ip,i2)*qx(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qx(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qx(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qx(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*rx(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*rx(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*rx(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*rx(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! (2 mu + lam) vyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*qy(ip,i2)*lam2mu(ip,i2)+Jac(i1,i2)
     & *qy(i1,i2)*qy(i1,i2)*lam2mu(i1,i2)
             Em=Jac(im,i2)*qy(im,i2)*qy(im,i2)*lam2mu(im,i2)+Jac(i1,i2)
     & *qy(i1,i2)*qy(i1,i2)*lam2mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*ry(i1,jp)*ry(i1,jp)*lam2mu(i1,jp)+Jac(i1,i2)
     & *ry(i1,i2)*ry(i1,i2)*lam2mu(i1,i2)
             Em=Jac(i1,jm)*ry(i1,jm)*ry(i1,jm)*lam2mu(i1,jm)+Jac(i1,i2)
     & *ry(i1,i2)*ry(i1,i2)*lam2mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! d_x my u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! d_y lam u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*lam(ip,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*lam(im,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*lam(i1,jp)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*lam(i1,jm)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
        ip=i1+1
        im=i1 
        jp=i2+1 
        jm=i2-1
             !       (2 mu+lam) uxx 
             Ep=Jac(ip,i2)*qx(ip,i2)*rx(ip,i2)*lam2mu(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*rx(im,i2)*lam2mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qx(i1,jp)*lam2mu(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qx(i1,jm)*lam2mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! mu uyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*ry(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*ry(im,i2)*mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qy(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qy(i1,jm)*mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! d_x lam v_y
             Ep=Jac(ip,i2)*qx(ip,i2)*ry(ip,i2)*lam(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*ry(im,i2)*lam(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qy(i1,jp)*lam(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qy(i1,jm)*lam(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! d_y mu v_x
             Ep=Jac(ip,i2)*qy(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*rx(im,i2)*mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! mu vxx 	
             Ep=Jac(ip,i2)*qx(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*rx(im,i2)*mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! (2 mu + lam) vyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*ry(ip,i2)*lam2mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*ry(im,i2)*lam2mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qy(i1,jp)*lam2mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qy(i1,jm)*lam2mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! d_x my u_y
             Ep=Jac(ip,i2)*qy(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*rx(im,i2)*mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! d_y lam u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*ry(ip,i2)*lam(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*ry(im,i2)*lam(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qy(i1,jp)*lam(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qy(i1,jm)*lam(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
            enddo
         enddo
      endif
      if( bc(1,0).eq.stressFree)then
         do i2=n2a,n2b
            do i1=n1b,n1b
        rh1(i1,i2)=0.d0
        rh2(i1,i2)=0.d0
             ip=i1+1
             im=i1-1
             jp=i2+1
             jm=i2-1
             !       (2 mu+lam) uxx 
             Ep=Jac(ip,i2)*qx(ip,i2)*qx(ip,i2)*lam2mu(ip,i2)+Jac(i1,i2)
     & *qx(i1,i2)*qx(i1,i2)*lam2mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qx(im,i2)*lam2mu(im,i2)+Jac(i1,i2)
     & *qx(i1,i2)*qx(i1,i2)*lam2mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*rx(i1,jp)*lam2mu(i1,jp)+Jac(i1,i2)
     & *rx(i1,i2)*rx(i1,i2)*lam2mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*rx(i1,jm)*lam2mu(i1,jm)+Jac(i1,i2)
     & *rx(i1,i2)*rx(i1,i2)*lam2mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! mu uyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qy(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qy(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qy(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*ry(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*ry(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*ry(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*ry(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! d_x lam v_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*lam(ip,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*lam(im,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*lam(i1,jp)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*lam(i1,jm)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! d_y mu v_x
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! mu vxx 	
             Ep=Jac(ip,i2)*qx(ip,i2)*qx(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qx(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qx(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qx(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*rx(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*rx(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*rx(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*rx(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! (2 mu + lam) vyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*qy(ip,i2)*lam2mu(ip,i2)+Jac(i1,i2)
     & *qy(i1,i2)*qy(i1,i2)*lam2mu(i1,i2)
             Em=Jac(im,i2)*qy(im,i2)*qy(im,i2)*lam2mu(im,i2)+Jac(i1,i2)
     & *qy(i1,i2)*qy(i1,i2)*lam2mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*ry(i1,jp)*ry(i1,jp)*lam2mu(i1,jp)+Jac(i1,i2)
     & *ry(i1,i2)*ry(i1,i2)*lam2mu(i1,i2)
             Em=Jac(i1,jm)*ry(i1,jm)*ry(i1,jm)*lam2mu(i1,jm)+Jac(i1,i2)
     & *ry(i1,i2)*ry(i1,i2)*lam2mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! d_x my u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! d_y lam u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*lam(ip,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*lam(im,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*lam(i1,jp)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*lam(i1,jm)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
        ip=i1
        im=i1-1
        jp=i2+1 
        jm=i2-1
             !       (2 mu+lam) uxx 
             Ep=Jac(ip,i2)*qx(ip,i2)*rx(ip,i2)*lam2mu(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*rx(im,i2)*lam2mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qx(i1,jp)*lam2mu(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qx(i1,jm)*lam2mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! mu uyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*ry(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*ry(im,i2)*mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qy(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qy(i1,jm)*mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! d_x lam v_y
             Ep=Jac(ip,i2)*qx(ip,i2)*ry(ip,i2)*lam(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*ry(im,i2)*lam(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qy(i1,jp)*lam(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qy(i1,jm)*lam(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! d_y mu v_x
             Ep=Jac(ip,i2)*qy(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*rx(im,i2)*mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! mu vxx 	
             Ep=Jac(ip,i2)*qx(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*rx(im,i2)*mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! (2 mu + lam) vyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*ry(ip,i2)*lam2mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*ry(im,i2)*lam2mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qy(i1,jp)*lam2mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qy(i1,jm)*lam2mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! d_x my u_y
             Ep=Jac(ip,i2)*qy(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*rx(im,i2)*mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! d_y lam u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*ry(ip,i2)*lam(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*ry(im,i2)*lam(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qy(i1,jp)*lam(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qy(i1,jm)*lam(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
            enddo
         enddo
      endif
      if( bc(0,1).eq.stressFree)then
         do i2=n2a,n2a
            do i1=n1a,n1b
        rh1(i1,i2)=0.d0
        rh2(i1,i2)=0.d0
             ip=i1+1
             im=i1-1
             jp=i2+1
             jm=i2-1
             !       (2 mu+lam) uxx 
             Ep=Jac(ip,i2)*qx(ip,i2)*qx(ip,i2)*lam2mu(ip,i2)+Jac(i1,i2)
     & *qx(i1,i2)*qx(i1,i2)*lam2mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qx(im,i2)*lam2mu(im,i2)+Jac(i1,i2)
     & *qx(i1,i2)*qx(i1,i2)*lam2mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*rx(i1,jp)*lam2mu(i1,jp)+Jac(i1,i2)
     & *rx(i1,i2)*rx(i1,i2)*lam2mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*rx(i1,jm)*lam2mu(i1,jm)+Jac(i1,i2)
     & *rx(i1,i2)*rx(i1,i2)*lam2mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! mu uyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qy(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qy(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qy(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*ry(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*ry(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*ry(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*ry(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! d_x lam v_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*lam(ip,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*lam(im,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*lam(i1,jp)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*lam(i1,jm)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! d_y mu v_x
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! mu vxx 	
             Ep=Jac(ip,i2)*qx(ip,i2)*qx(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qx(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qx(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qx(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*rx(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*rx(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*rx(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*rx(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! (2 mu + lam) vyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*qy(ip,i2)*lam2mu(ip,i2)+Jac(i1,i2)
     & *qy(i1,i2)*qy(i1,i2)*lam2mu(i1,i2)
             Em=Jac(im,i2)*qy(im,i2)*qy(im,i2)*lam2mu(im,i2)+Jac(i1,i2)
     & *qy(i1,i2)*qy(i1,i2)*lam2mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*ry(i1,jp)*ry(i1,jp)*lam2mu(i1,jp)+Jac(i1,i2)
     & *ry(i1,i2)*ry(i1,i2)*lam2mu(i1,i2)
             Em=Jac(i1,jm)*ry(i1,jm)*ry(i1,jm)*lam2mu(i1,jm)+Jac(i1,i2)
     & *ry(i1,i2)*ry(i1,i2)*lam2mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! d_x my u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! d_y lam u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*lam(ip,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*lam(im,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*lam(i1,jp)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*lam(i1,jm)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
        ip=i1+1
        im=i1-1 
        jp=i2+1
        jm=i2 
             !       (2 mu+lam) uxx 
             Ep=Jac(ip,i2)*qx(ip,i2)*rx(ip,i2)*lam2mu(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*rx(im,i2)*lam2mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qx(i1,jp)*lam2mu(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qx(i1,jm)*lam2mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! mu uyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*ry(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*ry(im,i2)*mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qy(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qy(i1,jm)*mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! d_x lam v_y
             Ep=Jac(ip,i2)*qx(ip,i2)*ry(ip,i2)*lam(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*ry(im,i2)*lam(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qy(i1,jp)*lam(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qy(i1,jm)*lam(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! d_y mu v_x
             Ep=Jac(ip,i2)*qy(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*rx(im,i2)*mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! mu vxx 	
             Ep=Jac(ip,i2)*qx(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*rx(im,i2)*mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! (2 mu + lam) vyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*ry(ip,i2)*lam2mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*ry(im,i2)*lam2mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qy(i1,jp)*lam2mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qy(i1,jm)*lam2mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! d_x my u_y
             Ep=Jac(ip,i2)*qy(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*rx(im,i2)*mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! d_y lam u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*ry(ip,i2)*lam(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*ry(im,i2)*lam(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qy(i1,jp)*lam(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qy(i1,jm)*lam(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
            enddo
         enddo
      endif
      if( bc(1,1).eq.stressFree)then
         do i2=n2b,n2b
            do i1=n1a,n1b
        rh1(i1,i2)=0.d0
        rh2(i1,i2)=0.d0
             ip=i1+1
             im=i1-1
             jp=i2+1
             jm=i2-1
             !       (2 mu+lam) uxx 
             Ep=Jac(ip,i2)*qx(ip,i2)*qx(ip,i2)*lam2mu(ip,i2)+Jac(i1,i2)
     & *qx(i1,i2)*qx(i1,i2)*lam2mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qx(im,i2)*lam2mu(im,i2)+Jac(i1,i2)
     & *qx(i1,i2)*qx(i1,i2)*lam2mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*rx(i1,jp)*lam2mu(i1,jp)+Jac(i1,i2)
     & *rx(i1,i2)*rx(i1,i2)*lam2mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*rx(i1,jm)*lam2mu(i1,jm)+Jac(i1,i2)
     & *rx(i1,i2)*rx(i1,i2)*lam2mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! mu uyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qy(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qy(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qy(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*ry(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*ry(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*ry(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*ry(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! d_x lam v_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*lam(ip,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*lam(im,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*lam(i1,jp)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*lam(i1,jm)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! d_y mu v_x
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! mu vxx 	
             Ep=Jac(ip,i2)*qx(ip,i2)*qx(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qx(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qx(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qx(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*rx(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*rx(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*rx(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*rx(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! (2 mu + lam) vyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*qy(ip,i2)*lam2mu(ip,i2)+Jac(i1,i2)
     & *qy(i1,i2)*qy(i1,i2)*lam2mu(i1,i2)
             Em=Jac(im,i2)*qy(im,i2)*qy(im,i2)*lam2mu(im,i2)+Jac(i1,i2)
     & *qy(i1,i2)*qy(i1,i2)*lam2mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*ry(i1,jp)*ry(i1,jp)*lam2mu(i1,jp)+Jac(i1,i2)
     & *ry(i1,i2)*ry(i1,i2)*lam2mu(i1,i2)
             Em=Jac(i1,jm)*ry(i1,jm)*ry(i1,jm)*lam2mu(i1,jm)+Jac(i1,i2)
     & *ry(i1,i2)*ry(i1,i2)*lam2mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! d_x my u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! d_y lam u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*lam(ip,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*lam(im,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*lam(i1,jp)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*lam(i1,jm)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
        ip=i1+1
        im=i1-1
        jp=i2
        jm=i2-1
             !       (2 mu+lam) uxx 
             Ep=Jac(ip,i2)*qx(ip,i2)*rx(ip,i2)*lam2mu(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*rx(im,i2)*lam2mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qx(i1,jp)*lam2mu(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qx(i1,jm)*lam2mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! mu uyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*ry(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*ry(im,i2)*mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qy(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qy(i1,jm)*mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! d_x lam v_y
             Ep=Jac(ip,i2)*qx(ip,i2)*ry(ip,i2)*lam(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*ry(im,i2)*lam(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qy(i1,jp)*lam(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qy(i1,jm)*lam(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! d_y mu v_x
             Ep=Jac(ip,i2)*qy(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*rx(im,i2)*mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! mu vxx 	
             Ep=Jac(ip,i2)*qx(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*rx(im,i2)*mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! (2 mu + lam) vyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*ry(ip,i2)*lam2mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*ry(im,i2)*lam2mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qy(i1,jp)*lam2mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qy(i1,jm)*lam2mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! d_x my u_y
             Ep=Jac(ip,i2)*qy(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*rx(im,i2)*mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! d_y lam u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*ry(ip,i2)*lam(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*ry(im,i2)*lam(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qy(i1,jp)*lam(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qy(i1,jm)*lam(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
            enddo
         enddo
      endif
				!// Finally we correct the corners
      dc=dri(0)*dri(1)
      if((bc(0,0).eq.stressFree).and.(bc(0,1).eq.stressFree))then
         do i2=n2a,n2a
            do i1=n1a,n1a
        rh1(i1,i2)=0.d0
        rh2(i1,i2)=0.d0
             ip=i1+1
             im=i1-1
             jp=i2+1
             jm=i2-1
             !       (2 mu+lam) uxx 
             Ep=Jac(ip,i2)*qx(ip,i2)*qx(ip,i2)*lam2mu(ip,i2)+Jac(i1,i2)
     & *qx(i1,i2)*qx(i1,i2)*lam2mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qx(im,i2)*lam2mu(im,i2)+Jac(i1,i2)
     & *qx(i1,i2)*qx(i1,i2)*lam2mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*rx(i1,jp)*lam2mu(i1,jp)+Jac(i1,i2)
     & *rx(i1,i2)*rx(i1,i2)*lam2mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*rx(i1,jm)*lam2mu(i1,jm)+Jac(i1,i2)
     & *rx(i1,i2)*rx(i1,i2)*lam2mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! mu uyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qy(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qy(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qy(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*ry(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*ry(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*ry(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*ry(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! d_x lam v_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*lam(ip,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*lam(im,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*lam(i1,jp)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*lam(i1,jm)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! d_y mu v_x
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! mu vxx 	
             Ep=Jac(ip,i2)*qx(ip,i2)*qx(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qx(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qx(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qx(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*rx(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*rx(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*rx(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*rx(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! (2 mu + lam) vyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*qy(ip,i2)*lam2mu(ip,i2)+Jac(i1,i2)
     & *qy(i1,i2)*qy(i1,i2)*lam2mu(i1,i2)
             Em=Jac(im,i2)*qy(im,i2)*qy(im,i2)*lam2mu(im,i2)+Jac(i1,i2)
     & *qy(i1,i2)*qy(i1,i2)*lam2mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*ry(i1,jp)*ry(i1,jp)*lam2mu(i1,jp)+Jac(i1,i2)
     & *ry(i1,i2)*ry(i1,i2)*lam2mu(i1,i2)
             Em=Jac(i1,jm)*ry(i1,jm)*ry(i1,jm)*lam2mu(i1,jm)+Jac(i1,i2)
     & *ry(i1,i2)*ry(i1,i2)*lam2mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! d_x my u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! d_y lam u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*lam(ip,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*lam(im,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*lam(i1,jp)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*lam(i1,jm)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
        ip=i1+1 
        im=i1
        jp=i2+1
        jm=i2
             !       (2 mu+lam) uxx 
             Ep=Jac(ip,i2)*qx(ip,i2)*rx(ip,i2)*lam2mu(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*rx(im,i2)*lam2mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qx(i1,jp)*lam2mu(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qx(i1,jm)*lam2mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! mu uyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*ry(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*ry(im,i2)*mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qy(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qy(i1,jm)*mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! d_x lam v_y
             Ep=Jac(ip,i2)*qx(ip,i2)*ry(ip,i2)*lam(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*ry(im,i2)*lam(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qy(i1,jp)*lam(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qy(i1,jm)*lam(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! d_y mu v_x
             Ep=Jac(ip,i2)*qy(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*rx(im,i2)*mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! mu vxx 	
             Ep=Jac(ip,i2)*qx(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*rx(im,i2)*mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! (2 mu + lam) vyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*ry(ip,i2)*lam2mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*ry(im,i2)*lam2mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qy(i1,jp)*lam2mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qy(i1,jm)*lam2mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! d_x my u_y
             Ep=Jac(ip,i2)*qy(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*rx(im,i2)*mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! d_y lam u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*ry(ip,i2)*lam(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*ry(im,i2)*lam(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qy(i1,jp)*lam(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qy(i1,jm)*lam(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
            enddo
         enddo
      endif
      if((bc(0,0).eq.stressFree).and.(bc(1,1).eq.stressFree))then
         do i2=n2b,n2b
            do i1=n1a,n1a
        rh1(i1,i2)=0.d0
        rh2(i1,i2)=0.d0
             ip=i1+1
             im=i1-1
             jp=i2+1
             jm=i2-1
             !       (2 mu+lam) uxx 
             Ep=Jac(ip,i2)*qx(ip,i2)*qx(ip,i2)*lam2mu(ip,i2)+Jac(i1,i2)
     & *qx(i1,i2)*qx(i1,i2)*lam2mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qx(im,i2)*lam2mu(im,i2)+Jac(i1,i2)
     & *qx(i1,i2)*qx(i1,i2)*lam2mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*rx(i1,jp)*lam2mu(i1,jp)+Jac(i1,i2)
     & *rx(i1,i2)*rx(i1,i2)*lam2mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*rx(i1,jm)*lam2mu(i1,jm)+Jac(i1,i2)
     & *rx(i1,i2)*rx(i1,i2)*lam2mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! mu uyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qy(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qy(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qy(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*ry(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*ry(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*ry(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*ry(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! d_x lam v_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*lam(ip,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*lam(im,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*lam(i1,jp)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*lam(i1,jm)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! d_y mu v_x
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! mu vxx 	
             Ep=Jac(ip,i2)*qx(ip,i2)*qx(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qx(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qx(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qx(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*rx(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*rx(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*rx(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*rx(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! (2 mu + lam) vyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*qy(ip,i2)*lam2mu(ip,i2)+Jac(i1,i2)
     & *qy(i1,i2)*qy(i1,i2)*lam2mu(i1,i2)
             Em=Jac(im,i2)*qy(im,i2)*qy(im,i2)*lam2mu(im,i2)+Jac(i1,i2)
     & *qy(i1,i2)*qy(i1,i2)*lam2mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*ry(i1,jp)*ry(i1,jp)*lam2mu(i1,jp)+Jac(i1,i2)
     & *ry(i1,i2)*ry(i1,i2)*lam2mu(i1,i2)
             Em=Jac(i1,jm)*ry(i1,jm)*ry(i1,jm)*lam2mu(i1,jm)+Jac(i1,i2)
     & *ry(i1,i2)*ry(i1,i2)*lam2mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! d_x my u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! d_y lam u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*lam(ip,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*lam(im,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*lam(i1,jp)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*lam(i1,jm)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
        ip=i1+1
        im=i1
        jp=i2
        jm=i2-1
             !       (2 mu+lam) uxx 
             Ep=Jac(ip,i2)*qx(ip,i2)*rx(ip,i2)*lam2mu(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*rx(im,i2)*lam2mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qx(i1,jp)*lam2mu(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qx(i1,jm)*lam2mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! mu uyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*ry(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*ry(im,i2)*mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qy(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qy(i1,jm)*mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! d_x lam v_y
             Ep=Jac(ip,i2)*qx(ip,i2)*ry(ip,i2)*lam(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*ry(im,i2)*lam(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qy(i1,jp)*lam(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qy(i1,jm)*lam(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! d_y mu v_x
             Ep=Jac(ip,i2)*qy(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*rx(im,i2)*mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! mu vxx 	
             Ep=Jac(ip,i2)*qx(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*rx(im,i2)*mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! (2 mu + lam) vyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*ry(ip,i2)*lam2mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*ry(im,i2)*lam2mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qy(i1,jp)*lam2mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qy(i1,jm)*lam2mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! d_x my u_y
             Ep=Jac(ip,i2)*qy(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*rx(im,i2)*mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! d_y lam u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*ry(ip,i2)*lam(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*ry(im,i2)*lam(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qy(i1,jp)*lam(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qy(i1,jm)*lam(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
            enddo
         enddo
      endif
      if((bc(1,0).eq.stressFree).and.(bc(0,1).eq.stressFree))then
         do i2=n2a,n2a
            do i1=n1b,n1b
        rh1(i1,i2)=0.d0
        rh2(i1,i2)=0.d0
             ip=i1+1
             im=i1-1
             jp=i2+1
             jm=i2-1
             !       (2 mu+lam) uxx 
             Ep=Jac(ip,i2)*qx(ip,i2)*qx(ip,i2)*lam2mu(ip,i2)+Jac(i1,i2)
     & *qx(i1,i2)*qx(i1,i2)*lam2mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qx(im,i2)*lam2mu(im,i2)+Jac(i1,i2)
     & *qx(i1,i2)*qx(i1,i2)*lam2mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*rx(i1,jp)*lam2mu(i1,jp)+Jac(i1,i2)
     & *rx(i1,i2)*rx(i1,i2)*lam2mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*rx(i1,jm)*lam2mu(i1,jm)+Jac(i1,i2)
     & *rx(i1,i2)*rx(i1,i2)*lam2mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! mu uyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qy(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qy(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qy(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*ry(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*ry(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*ry(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*ry(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! d_x lam v_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*lam(ip,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*lam(im,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*lam(i1,jp)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*lam(i1,jm)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! d_y mu v_x
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! mu vxx 	
             Ep=Jac(ip,i2)*qx(ip,i2)*qx(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qx(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qx(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qx(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*rx(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*rx(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*rx(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*rx(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! (2 mu + lam) vyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*qy(ip,i2)*lam2mu(ip,i2)+Jac(i1,i2)
     & *qy(i1,i2)*qy(i1,i2)*lam2mu(i1,i2)
             Em=Jac(im,i2)*qy(im,i2)*qy(im,i2)*lam2mu(im,i2)+Jac(i1,i2)
     & *qy(i1,i2)*qy(i1,i2)*lam2mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*ry(i1,jp)*ry(i1,jp)*lam2mu(i1,jp)+Jac(i1,i2)
     & *ry(i1,i2)*ry(i1,i2)*lam2mu(i1,i2)
             Em=Jac(i1,jm)*ry(i1,jm)*ry(i1,jm)*lam2mu(i1,jm)+Jac(i1,i2)
     & *ry(i1,i2)*ry(i1,i2)*lam2mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! d_x my u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! d_y lam u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*lam(ip,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*lam(im,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*lam(i1,jp)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*lam(i1,jm)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
        ip=i1
        im=i1-1
        jp=i2+1
        jm=i2
             !       (2 mu+lam) uxx 
             Ep=Jac(ip,i2)*qx(ip,i2)*rx(ip,i2)*lam2mu(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*rx(im,i2)*lam2mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qx(i1,jp)*lam2mu(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qx(i1,jm)*lam2mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! mu uyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*ry(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*ry(im,i2)*mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qy(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qy(i1,jm)*mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! d_x lam v_y
             Ep=Jac(ip,i2)*qx(ip,i2)*ry(ip,i2)*lam(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*ry(im,i2)*lam(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qy(i1,jp)*lam(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qy(i1,jm)*lam(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! d_y mu v_x
             Ep=Jac(ip,i2)*qy(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*rx(im,i2)*mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! mu vxx 	
             Ep=Jac(ip,i2)*qx(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*rx(im,i2)*mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! (2 mu + lam) vyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*ry(ip,i2)*lam2mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*ry(im,i2)*lam2mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qy(i1,jp)*lam2mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qy(i1,jm)*lam2mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! d_x my u_y
             Ep=Jac(ip,i2)*qy(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*rx(im,i2)*mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! d_y lam u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*ry(ip,i2)*lam(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*ry(im,i2)*lam(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qy(i1,jp)*lam(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qy(i1,jm)*lam(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
            enddo
         enddo
      endif
      if((bc(1,1).eq.stressFree).and.(bc(1,0).eq.stressFree))then
         do i2=n2b,n2b
            do i1=n1b,n1b
        rh1(i1,i2)=0.d0
        rh2(i1,i2)=0.d0
             ip=i1+1
             im=i1-1
             jp=i2+1
             jm=i2-1
             !       (2 mu+lam) uxx 
             Ep=Jac(ip,i2)*qx(ip,i2)*qx(ip,i2)*lam2mu(ip,i2)+Jac(i1,i2)
     & *qx(i1,i2)*qx(i1,i2)*lam2mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qx(im,i2)*lam2mu(im,i2)+Jac(i1,i2)
     & *qx(i1,i2)*qx(i1,i2)*lam2mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*rx(i1,jp)*lam2mu(i1,jp)+Jac(i1,i2)
     & *rx(i1,i2)*rx(i1,i2)*lam2mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*rx(i1,jm)*lam2mu(i1,jm)+Jac(i1,i2)
     & *rx(i1,i2)*rx(i1,i2)*lam2mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! mu uyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qy(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qy(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qy(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*ry(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*ry(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*ry(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*ry(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! d_x lam v_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*lam(ip,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*lam(im,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*lam(i1,jp)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*lam(i1,jm)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! d_y mu v_x
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh1(i1,i2)=rh1(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! mu vxx 	
             Ep=Jac(ip,i2)*qx(ip,i2)*qx(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qx(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qx(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qx(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*rx(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*rx(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*rx(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*rx(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! (2 mu + lam) vyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*qy(ip,i2)*lam2mu(ip,i2)+Jac(i1,i2)
     & *qy(i1,i2)*qy(i1,i2)*lam2mu(i1,i2)
             Em=Jac(im,i2)*qy(im,i2)*qy(im,i2)*lam2mu(im,i2)+Jac(i1,i2)
     & *qy(i1,i2)*qy(i1,i2)*lam2mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u2(ip,i2)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(im,i2)))
             Ep=Jac(i1,jp)*ry(i1,jp)*ry(i1,jp)*lam2mu(i1,jp)+Jac(i1,i2)
     & *ry(i1,i2)*ry(i1,i2)*lam2mu(i1,i2)
             Em=Jac(i1,jm)*ry(i1,jm)*ry(i1,jm)*lam2mu(i1,jm)+Jac(i1,i2)
     & *ry(i1,i2)*ry(i1,i2)*lam2mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u2(i1,jp)-u2(
     & i1,i2))-Em*(u2(i1,i2)-u2(i1,jm)))
             ! d_x my u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*mu(ip,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*mu(im,i2)+Jac(i1,i2)*qx(
     & i1,i2)*qy(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*mu(i1,jp)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*mu(i1,jm)+Jac(i1,i2)*rx(
     & i1,i2)*ry(i1,i2)*mu(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
             ! d_y lam u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*qy(ip,i2)*lam(ip,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             Em=Jac(im,i2)*qx(im,i2)*qy(im,i2)*lam(im,i2)+Jac(i1,i2)*
     & qx(i1,i2)*qy(i1,i2)*lam(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(0)**2*(Ep*(u1(ip,i2)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(im,i2)))
             Ep=Jac(i1,jp)*rx(i1,jp)*ry(i1,jp)*lam(i1,jp)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             Em=Jac(i1,jm)*rx(i1,jm)*ry(i1,jm)*lam(i1,jm)+Jac(i1,i2)*
     & rx(i1,i2)*ry(i1,i2)*lam(i1,i2)
             rh2(i1,i2)=rh2(i1,i2)+0.5d0*dri(1)**2*(Ep*(u1(i1,jp)-u1(
     & i1,i2))-Em*(u1(i1,i2)-u1(i1,jm)))
        ip=i1
        im=i1-1
        jp=i2
        jm=i2-1
             !       (2 mu+lam) uxx 
             Ep=Jac(ip,i2)*qx(ip,i2)*rx(ip,i2)*lam2mu(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*rx(im,i2)*lam2mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qx(i1,jp)*lam2mu(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qx(i1,jm)*lam2mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! mu uyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*ry(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*ry(im,i2)*mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qy(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qy(i1,jm)*mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! d_x lam v_y
             Ep=Jac(ip,i2)*qx(ip,i2)*ry(ip,i2)*lam(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*ry(im,i2)*lam(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qy(i1,jp)*lam(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qy(i1,jm)*lam(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! d_y mu v_x
             Ep=Jac(ip,i2)*qy(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*rx(im,i2)*mu(im,i2)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh1(i1,i2)=rh1(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! mu vxx 	
             Ep=Jac(ip,i2)*qx(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*rx(im,i2)*mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! (2 mu + lam) vyy 
             Ep=Jac(ip,i2)*qy(ip,i2)*ry(ip,i2)*lam2mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*ry(im,i2)*lam2mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(ip,jm))-Em*(u2(
     & im,jp)-u2(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qy(i1,jp)*lam2mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qy(i1,jm)*lam2mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u2(ip,jp)-u2(im,jp))-Em*(u2(
     & ip,jm)-u2(im,jm)))
             ! d_x my u_y
             Ep=Jac(ip,i2)*qy(ip,i2)*rx(ip,i2)*mu(ip,i2)
             Em=Jac(im,i2)*qy(im,i2)*rx(im,i2)*mu(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*ry(i1,jp)*qx(i1,jp)*mu(i1,jp)
             Em=Jac(i1,jm)*ry(i1,jm)*qx(i1,jm)*mu(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
             ! d_y lam u_y
             Ep=Jac(ip,i2)*qx(ip,i2)*ry(ip,i2)*lam(ip,i2)
             Em=Jac(im,i2)*qx(im,i2)*ry(im,i2)*lam(im,i2)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(ip,jm))-Em*(u1(
     & im,jp)-u1(im,jm)))
             Ep=Jac(i1,jp)*rx(i1,jp)*qy(i1,jp)*lam(i1,jp)
             Em=Jac(i1,jm)*rx(i1,jm)*qy(i1,jm)*lam(i1,jm)
             rh2(i1,i2)=rh2(i1,i2)+dc*(Ep*(u1(ip,jp)-u1(im,jp))-Em*(u1(
     & ip,jm)-u1(im,jm)))
            enddo
         enddo
      endif

c     Divide by Jacobian      
      do i2=n2a,n2b
      do i1=n1a,n1b
      rh1(i1,i2)=rh1(i1,i2)/Jac(i1,i2)
      rh2(i1,i2)=rh2(i1,i2)/Jac(i1,i2)
      end do
      end do
c     Assign next to next time level            
      do i2=n2a,n2b
      do i1=n1a,n1b
      un(i1,i2,nd3a,uc)=2.0d0*u(i1,i2,nd3a,uc)-um(i1,i2,nd3a,uc)+dtsq*
     & rh1(i1,i2)
      un(i1,i2,nd3a,vc)=2.0d0*u(i1,i2,nd3a,vc)-um(i1,i2,nd3a,vc)+dtsq*
     & rh2(i1,i2)
      end do
      end do
c     Add on forcing
      if(addForcing.ne.0) then
      do i2=n2a,n2b
      do i1=n1a,n1b
      un(i1,i2,nd3a,uc)=un(i1,i2,nd3a,uc)+dtsq*f(i1,i2,nd3a,uc)
      un(i1,i2,nd3a,vc)=un(i1,i2,nd3a,vc)+dtsq*f(i1,i2,nd3a,vc)
      end do
      end do
      end if
      if( (orderOfDissipation.eq.4 ).and.(adc.gt.0))then
      adcdt=adc*dt
      do i2=n2a,n2b
      do i1=n1a,n1b
      un(i1,i2,nd3a,uc)=un(i1,i2,nd3a,uc)+adcdt*fd42d(i1,i2,nd3a,uc)
      end do
      end do
      end if
      if( (orderOfDissipation.eq.2 ).and.(adc.gt.0))then
      adcdt=adc*dt
      do i2=n2a,n2b
      do i1=n1a,n1b
      un(i1,i2,nd3a,uc)=un(i1,i2,nd3a,uc)+adcdt*fd22d(i1,i2,nd3a,uc)
      end do
      end do
      end if

      if(debug.eq.3) then 
      energy=0.d0
      ! DEAA ENERGY
      do i2=n2a,n2b
      do i1=n1a,n1b
            weight=1.d0
      if ((i1.eq.n1a).and.((bc(0,0).eq.stressFree))) weight=weight*
     & 0.5d0
      if ((i1.eq.n1b).and.((bc(0,1).eq.stressFree))) weight=weight*
     & 0.5d0
      if ((i2.eq.n2a).and.((bc(1,0).eq.stressFree))) weight=weight*
     & 0.5d0
      if ((i2.eq.n2b).and.((bc(1,1).eq.stressFree))) weight=weight*
     & 0.5d0
      energy=energy-weight*un(i1,i2,nd3a,uc)*rh1(i1,i2)*Jac(i1,i2)
      energy=energy-weight*un(i1,i2,nd3a,vc)*rh2(i1,i2)*Jac(i1,i2)
	!       we use f to store u_t
        rh1(i1,i2)=(un(i1,i2,nd3a,uc)-u(i1,i2,nd3a,uc))/dt
        rh2(i1,i2)=(un(i1,i2,nd3a,vc)-u(i1,i2,nd3a,vc))/dt
      energy=energy+weight*rh1(i1,i2)*rh1(i1,i2)*Jac(i1,i2)
      energy=energy+weight*rh2(i1,i2)*rh2(i1,i2)*Jac(i1,i2)
      end do
      end do
      write(*,*) "Discrete energy  ",energy
      end if
      end

