! ogf2d, ogf3d, ogDeriv2, etc. are foundin forcing.bC
#beginMacro OGF2D(i1,i2,i3,t,u0,v0)
call ogf2d(ep,xy(i1,i2,i3,0),xy(i1,i2,i3,1),t,u0,v0)
#endMacro
	
#beginMacro OGF3D(i1,i2,i3,t,u0,v0,w0)
call ogf3d(ep,xy(i1,i2,i3,0),xy(i1,i2,i3,1),xy(i1,i2,i3,2),t,u0,v0,w0)
#endMacro
	
!       ntd,nxd,nyd,nzd : number of derivatives to evaluate in t,x,y,z
#beginMacro OGDERIV2D(ntd,nxd,nyd,nzd,i1,i2,i3,t,ux,vx)
call ogDeriv2(epep, ntd,nxd,nyd,nzd, xy(i1,i2,i3,0),xy(i1,i2,i3,1),0.,t, uc,ux, vc,vx)
#endMacro
	
#beginMacro OGDERIV3D(ntd,nxd,nyd,nzd,i1,i2,i3,t,ux,vx,wx)
call ogDeriv3(epep, ntd,nxd,nyd,nzd, xy(i1,i2,i3,0),xy(i1,i2,i3,1),xy(i1,i2,i3,2),t, uc,ux, vc,vx, wc,wx)
#endMacro
		
#beginMacro DxDy(i,j,im,jm,ip,jp,dc,w,c1,rh)
rh(i,j)=rh(i,j)+dc*(c1(ip,j)*(w(ip,jp)-w(ip,jm))-c1(im,j)*(w(im,jp)-w(im,jm)))
#endMacro
	
#beginMacro DyDx(i,j,im,jm,ip,jp,dc,w,c1,rh)
rh(i,j)=rh(i,j)+dc*(c1(i,jp)*(w(ip,jp)-w(im,jp))-c1(i,jm)*(w(ip,jm)-w(im,jm)))
#endMacro
	
#beginMacro Dxx(i,j,w,c1,rh)
Ep=c1(ip,j)+c1(i,j) 
Em=c1(im,j)+c1(i,j)  
rh(i,j)=rh(i,j)+0.5d0*dxi(0)**2*(Ep*(w(ip,j)-w(i,j))-Em*(w(i,j)-w(im,j)))
#endMacro
	
#beginMacro Dyy(i,j,w,c1,rh)
Ep=c1(i,jp)+c1(i,j)
Em=c1(i,jm)+c1(i,j)
rh(i,j)=rh(i,j)+0.5d0*dxi(1)**2*(Ep*(w(i,jp)-w(i,j))-Em*(w(i,j)-w(i,jm)))
#endMacro
#beginMacro ComputeRhside()
ip=i1+1
im=i1-1
jp=i2+1
jm=i2-1
!       (2 mu+lam) uxx 
Dxx(i1,i2,u1,lam2mu,rh1)
! mu uyy 
Dyy(i1,i2,u1,mu,rh1)
! d_x lam v_y
DxDy(i1,i2,im,jm,ip,jp,dc,u2,lam,rh1)
! d_y mu v_x
DyDx(i1,i2,im,jm,ip,jp,dc,u2,mu,rh1)
! mu vxx 	
Dxx(i1,i2,u2,mu,rh2)
! (2 mu + lam) vyy 
Dyy(i1,i2,u2,lam2mu,rh2)
! d_x my u_y
DxDy(i1,i2,im,jm,ip,jp,dc,u1,mu,rh2)
! d_y lam u_y
DyDx(i1,i2,im,jm,ip,jp,dc,u1,lam,rh2)
#endMacro

#beginMacro ComputeRhsideCross()
! d_x lam v_y
DxDy(i1,i2,im,jm,ip,jp,dc,u2,lam,rh1)
! d_y mu v_x
DyDx(i1,i2,im,jm,ip,jp,dc,u2,mu,rh1)
! d_x my u_y
DxDy(i1,i2,im,jm,ip,jp,dc,u1,mu,rh2)
! d_y lam u_y
DyDx(i1,i2,im,jm,ip,jp,dc,u1,lam,rh2)
#endMacro

#beginMacro ComputeRhsideNonCross()
ip=i1+1
im=i1-1
jp=i2+1
jm=i2-1
!       (2 mu+lam) uxx 
Dxx(i1,i2,u1,lam2mu,rh1)
! mu uyy 
Dyy(i1,i2,u1,mu,rh1)
! mu vxx 	
Dxx(i1,i2,u2,mu,rh2)
! (2 mu + lam) vyy 
Dyy(i1,i2,u2,lam2mu,rh2)
#endMacro


#beginMacro beginLoops()
do i2=n2a,n2b
do i1=n1a,n1b
#endMacro

#beginMacro endLoops()
end do
end do
#endMacro

c     
c     Advance the equations of solid mechanics
c       
	subroutine advSmCons2dOrder2r(nd,n1a,n1b,n2a,n2b,n3a,n3b,nd1a,nd1b,
     &     nd2a,nd2b,nd3a,nd3b,nd4a,nd4b,mask,rsxy,xy, um,u,un,f, bc, dis, 
     &     varDis, ipar, rpar, ierr )
c======================================================================
c     Advance a time step for the equations of Solid Mechanics (linear elasticity for now)
c     
c     nd : number of space dimensions
c     
c     ipar(0)  = option : option=0 - Elasticity+Artificial diffusion
c     =1 - AD only
c     
c     dis(i1,i2,i3) : temp space to hold artificial dissipation
c     varDis(i1,i2,i3) : coefficient of the variable artificial dissipation
c======================================================================
	implicit none
	integer nd, n1a,n1b,n2a,n2b,n3a,n3b,nd1a,nd1b,nd2a,nd2b,nd3a,
     &     nd3b,nd4a,nd4b
	real um(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
	real u(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
	real un(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
      real f(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
      real dis(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,nd4a:nd4b)
      real varDis(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,0:nd-1,0:nd-1)
      real xy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,0:nd-1)
      integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b)
      integer bc(0:1,0:2),ierr
      integer ipar(0:*)
      real rpar(0:*)
c     ---- local variables -----
      integer c,i1,i2,i3,n,gridType,orderOfAccuracy,orderInTime
      integer addForcing,orderOfDissipation,option
      integer useWhereMask,useWhereMaskSave,grid,
     &     useVariableDissipation,timeSteppingMethod
      integer useConservative,combineDissipationWithAdvance
      integer uc,vc,wc
      real dt,dx(0:3),adc,dr(0:3),c1,c2,kx,ky,kz,t
      real qx,qy,qz,rx,ry,rz,sx,sy,sz
      real lam2mu,lam,mu,uxy0,uy0,vxy0,vy0,epep
      integer ipp,ip,im,jp,jm,i	
      real Dup, Dum, Dvp, Dvm, Ep, Em ,dcons,dc,Jac,u1,u2
      real rh1(nd1a:nd1b,nd2a:nd2b)
      real rh2(nd1a:nd1b,nd2a:nd2b)
      real dxi(0:2)
      real dtsq,errmaxu,errtmpu,exsolu,errmaxv,errtmpv,exsolv
      real du,fd22d,fd42d,adcdt,energy,weight
      integer dirichlet,stressFree,debug
      parameter( dirichlet=1,stressFree=2 )
      
      lam(i1,i2)=(c1-c2)
      mu(i1,i2)=c2
      lam2mu(i1,i2)=(lam(i1,i2)+2.0*mu(i1,12))
      u1(i1,i2)=u(i1,i2,0,uc)   !!???
      u2(i1,i2)=u(i1,i2,0,vc)   !!??? 
c ******* artificial dissipation ******
      du(i1,i2,i3,c)=u(i1,i2,i3,c)-um(i1,i2,i3,c)
c      (2nd difference)
      fd22d(i1,i2,i3,c)=(( du(i1-1,i2,i3,c)+du(i1+1,i2,i3,c)+du(i1,i2-1,i3,c)+du(i1,i2+1,i3,c) )-4.*du(i1,i2,i3,c))
c     -(fourth difference)
      fd42d(i1,i2,i3,c)=(-( du(i1-2,i2,i3,c)+du(i1+2,i2,i3,c)+du(i1,i2-2,i3,c)+du(i1,i2+2,i3,c) )+4.*( du(i1-1,i2,i3,c)+du(i1+1,i2,i3,c)+du(i1,i2-1,i3,c)+du(i1,i2+1,i3,c) )-12.*du(i1,i2,i3,c) )
	
	dt    =rpar(0)
	dx(0) =rpar(1)
	dx(1) =rpar(2)
	dx(2) =rpar(3)
	adc   =rpar(4)		! coefficient of artificial dissipation
	dr(0) =rpar(5)
	dr(1) =rpar(6)
	dr(2) =rpar(7)
	c1    =rpar(8)
	c2    =rpar(9) 
	kx    =rpar(10) 
	ky    =rpar(11) 
	kz    =rpar(12) 
	epep  =rpar(13)
	t     =rpar(14)

	option             =ipar(0)
	gridType           =ipar(1)
	orderOfAccuracy    =ipar(2)
	orderInTime        =ipar(3)
	addForcing         =ipar(4)
	orderOfDissipation =ipar(5)
	uc                 =ipar(6)
	vc                 =ipar(7)
	wc                 =ipar(8)
	useWhereMask       =ipar(9)
	timeSteppingMethod =ipar(10)
	useVariableDissipation=ipar(11)
	useConservative    =ipar(12)   
	combineDissipationWithAdvance = ipar(13)
	debug              =ipar(14)
	dtsq=dt*dt
	do i=0,2	
	   dxi(i)=1.0d0/dx(i)
	enddo
	
!       write(*,'(" advSmCons2dOrder2r t=",e10.2)') t

!       initialize to zero
	beginLoops() 
	rh1(i1,i2)=0.d0
	rh2(i1,i2)=0.d0      
	endLoops()
!       do the cross terms everywhere and overwrite if necessary
	dc=0.25d0*dxi(0)*dxi(1)
	beginLoops() 
	rh1(i1,i2)=0.d0
	rh2(i1,i2)=0.d0      
	ComputeRhside()
	endLoops()
	
!       We correct the sides
	dc=0.5d0*dxi(0)*dxi(1)
	if( bc(0,0).eq.stressFree)then
	   do i2=n2a,n2b
	      do i1=n1a,n1a
		 rh1(i1,i2)=0.d0
		 rh2(i1,i2)=0.d0      
		 ComputeRhsideNonCross()
		 ip=i1+1
		 im=i1	
		 jp=i2+1	
		 jm=i2-1
		 ComputeRhsideCross()
	      enddo
	   enddo
	endif
	if( bc(1,0).eq.stressFree)then
	   do i2=n2a,n2b
	      do i1=n1b,n1b
		 rh1(i1,i2)=0.d0
		 rh2(i1,i2)=0.d0      
		 ComputeRhsideNonCross()
		 ip=i1
		 im=i1-1
		 jp=i2+1	
		 jm=i2-1
		 ComputeRhsideCross()
	      enddo
	   enddo
	endif
	if( bc(0,1).eq.stressFree)then
	   do i2=n2a,n2a
	      do i1=n1a,n1b
		 rh1(i1,i2)=0.d0
		 rh2(i1,i2)=0.d0      
		 ComputeRhsideNonCross()
		 ip=i1+1
		 im=i1-1	
		 jp=i2+1
		 jm=i2	
		 ComputeRhsideCross()
	      enddo
	   enddo
	endif
	if( bc(1,1).eq.stressFree)then
	   do i2=n2b,n2b
	      do i1=n1a,n1b
		 rh1(i1,i2)=0.d0
		 rh2(i1,i2)=0.d0      
		 ComputeRhsideNonCross()
		 ip=i1+1
		 im=i1-1
		 jp=i2
		 jm=i2-1
		 ComputeRhsideCross()
	      enddo
	   enddo
	endif
				!// Finally we correct the corners
	dc=dxi(0)*dxi(1)
	if((bc(0,0).eq.stressFree).and.(bc(0,1).eq.stressFree))then
	   do i2=n2a,n2a
	      do i1=n1a,n1a
		 rh1(i1,i2)=0.d0
		 rh2(i1,i2)=0.d0      
		 ComputeRhsideNonCross()
		 ip=i1+1	
		 im=i1
		 jp=i2+1
		 jm=i2
		 ComputeRhsideCross()
	      enddo
	   enddo
	endif 
	if((bc(0,0).eq.stressFree).and.(bc(1,1).eq.stressFree))then
	   do i2=n2b,n2b
	      do i1=n1a,n1a
		 rh1(i1,i2)=0.d0
		 rh2(i1,i2)=0.d0      
		 ComputeRhsideNonCross()
		 ip=i1+1
		 im=i1
		 jp=i2
		 jm=i2-1
		 ComputeRhsideCross()
	      enddo
	   enddo
	endif 
	if((bc(1,0).eq.stressFree).and.(bc(0,1).eq.stressFree))then
	   do i2=n2a,n2a
	      do i1=n1b,n1b
		 rh1(i1,i2)=0.d0
		 rh2(i1,i2)=0.d0      
		 ComputeRhsideNonCross()
		 ip=i1
		 im=i1-1
		 jp=i2+1
		 jm=i2
		 ComputeRhsideCross()
	      enddo
	   enddo
	endif 
	if((bc(1,1).eq.stressFree).and.(bc(1,0).eq.stressFree))then
	   do i2=n2b,n2b
	      do i1=n1b,n1b
		 rh1(i1,i2)=0.d0
		 rh2(i1,i2)=0.d0      
		 ComputeRhsideNonCross()
		 ip=i1
		 im=i1-1
		 jp=i2
		 jm=i2-1
		 ComputeRhsideCross()
	      enddo
	   enddo
	endif

c     Assign next to next time level            
      beginLoops() 
      un(i1,i2,nd3a,uc)=2.0d0*u(i1,i2,nd3a,uc)-um(i1,i2,nd3a,uc)+dtsq*rh1(i1,i2)
      un(i1,i2,nd3a,vc)=2.0d0*u(i1,i2,nd3a,vc)-um(i1,i2,nd3a,vc)+dtsq*rh2(i1,i2)
      endLoops()
c     Add on forcing
      if(addForcing.ne.0) then
	 beginLoops() 
	 un(i1,i2,nd3a,uc)=un(i1,i2,nd3a,uc)+dtsq*f(i1,i2,nd3a,uc)
	 un(i1,i2,nd3a,vc)=un(i1,i2,nd3a,vc)+dtsq*f(i1,i2,nd3a,vc)
	 endLoops()       
      end if

      if( (orderOfDissipation.eq.4 ).and.(adc.gt.0))then
      adcdt=adc*dt
      beginLoops() 
      un(i1,i2,nd3a,uc)=un(i1,i2,nd3a,uc)+adcdt*fd42d(i1,i2,nd3a,uc)
      un(i1,i2,nd3a,vc)=un(i1,i2,nd3a,vc)+adcdt*fd42d(i1,i2,nd3a,vc),\
      endLoops()       
      end if
      if( (orderOfDissipation.eq.2 ).and.(adc.gt.0))then
      adcdt=adc*dt
      beginLoops() 
      un(i1,i2,nd3a,uc)=un(i1,i2,nd3a,uc)+adcdt*fd22d(i1,i2,nd3a,uc)
      un(i1,i2,nd3a,vc)=un(i1,i2,nd3a,vc)+adcdt*fd22d(i1,i2,nd3a,vc),\
      endLoops()       
      end if

      if(debug.eq.3) then	
      energy=0.d0
      ! DEAA ENERGY
      beginLoops() 
      	weight=1.d0
	if ((i1.eq.n1a).and.((bc(0,0).eq.stressFree))) weight=weight*0.5d0
	if ((i1.eq.n1b).and.((bc(0,1).eq.stressFree))) weight=weight*0.5d0
	if ((i2.eq.n2a).and.((bc(1,0).eq.stressFree))) weight=weight*0.5d0
	if ((i2.eq.n2b).and.((bc(1,1).eq.stressFree))) weight=weight*0.5d0
	energy=energy-weight*un(i1,i2,nd3a,uc)*rh1(i1,i2)
	energy=energy-weight*un(i1,i2,nd3a,vc)*rh2(i1,i2)
	!       we use rh to store u_t
        rh1(i1,i2)=(un(i1,i2,nd3a,uc)-u(i1,i2,nd3a,uc))/dt
        rh2(i1,i2)=(un(i1,i2,nd3a,vc)-u(i1,i2,nd3a,vc))/dt
	energy=energy+weight*rh1(i1,i2)*rh1(i1,i2)
	energy=energy+weight*rh2(i1,i2)*rh2(i1,i2)
      endLoops() 
      write(*,*) "Discrete energy ",energy
      end if     
      ! *wdh end subroutine 
      end 

