// This file automatically generated from assignBoundaryConditionsFOS.bC with bpp.
#include "Cgsm.h"
#include "SmParameters.h"
#include "CompositeGridOperators.h"
#include "display.h"
#include "UnstructuredMapping.h"
#include "OGPolyFunction.h"
#include "OGTrigFunction.h"
#include "OGPulseFunction.h"
#include "RadiationBoundaryCondition.h"
#include "ParallelUtility.h"


#define bcOptSmFOS EXTERN_C_NAME(bcoptsmfos)

extern "C"
{
    void bcOptSmFOS(const int&nd,
             	       const int&nd1a,const int&nd1b,const int&nd2a,const int&nd2b,const int&nd3a,const int&nd3b,
             	       const int& gridIndexRange,real& u, const int&mask,const real&rsxy, const real&xy, const real&det,
             	       const int&boundaryCondition, const int&addBoundaryForcing, const int& interfaceType, const int&dim,
                              const real & bcf00, const real & bcf10, 
                              const real & bcf01, const real & bcf11, 
                              const real & bcf02, const real & bcf12, 
                              const real & bcf0, const int64_t & bcfOffset,
                              const int&ipar, const real&rpar, const DataBase *pdb, const int&ierr );
}

#define FOR_3D(i1,i2,i3,I1,I2,I3) int I1Base =I1.getBase(),   I2Base =I2.getBase(),  I3Base =I3.getBase();  int I1Bound=I1.getBound(),  I2Bound=I2.getBound(), I3Bound=I3.getBound(); for(i3=I3Base; i3<=I3Bound; i3++) for(i2=I2Base; i2<=I2Bound; i2++) for(i1=I1Base; i1<=I1Bound; i1++)

#define FOR_3(i1,i2,i3,I1,I2,I3) I1Base =I1.getBase(),   I2Base =I2.getBase(),  I3Base =I3.getBase();  I1Bound=I1.getBound(),  I2Bound=I2.getBound(), I3Bound=I3.getBound(); for(i3=I3Base; i3<=I3Bound; i3++) for(i2=I2Base; i2<=I2Bound; i2++) for(i1=I1Base; i1<=I1Bound; i1++)


//   (Ex).t = (1/eps)*[  (Hz).y ]
//   (Ey).t = (1/eps)*[ -(Hz).x ]
//   (Hz).t = (1/mu) *[ (Ex).y - (Ey).x ]

#define exTrue(x,y,t) sin(twoPi*(kx*(x)+ky*(y)-cc*(t)))*(-ky/(eps*cc))
#define eyTrue(x,y,t) sin(twoPi*(kx*(x)+ky*(y)-cc*(t)))*( kx/(eps*cc))
#define hzTrue(x,y,t) sin(twoPi*(kx*(x)+ky*(y)-cc*(t)))

#define exLaplacianTrue(x,y,t) sin(twoPi*(kx*(x)+ky*(y)-cc*(t)))*(+ky*(twoPi*twoPi*(kx*kx+ky*ky))/(eps*cc))
#define eyLaplacianTrue(x,y,t) sin(twoPi*(kx*(x)+ky*(y)-cc*(t)))*(-kx*(twoPi*twoPi*(kx*kx+ky*ky))/(eps*cc))
#define hzLaplacianTrue(x,y,t) sin(twoPi*(kx*(x)+ky*(y)-cc*(t)))*( -(twoPi*twoPi*(kx*kx+ky*ky) ) )

// define eyTrue(x,y,t) exp( -beta*SQR((x-x0)-c*(t)) )

// Here is a plane wave with the shape of a Gaussian
// xi = kx*(x)+ky*(y)-cc*(t)
// cc=  c*sqrt( kx*kx+ky*ky );
#define hzGaussianPulse(xi)  exp(-betaGaussianPlaneWave*((xi)*(xi)))
#define exGaussianPulse(xi)  hzGaussianPulse(xi)*(-ky/(eps*cc))
#define eyGaussianPulse(xi)  hzGaussianPulse(xi)*( kx/(eps*cc))

#define hzLaplacianGaussianPulse(xi)  ((4.*betaGaussianPlaneWave*betaGaussianPlaneWave*(kx*kx+ky*ky))*xi*xi-(2.*betaGaussianPlaneWave*(kx*kx+ky*ky)))*exp(-betaGaussianPlaneWave*((xi)*(xi)))
#define exLaplacianGaussianPulse(xi)  hzLaplacianGaussianPulse(xi,t)*(-ky/(eps*cc))
#define eyLaplacianGaussianPulse(xi)  hzLaplacianGaussianPulse(xi,t)*( kx/(eps*cc))

// 3D
// E:
//   u.tt = (1/eps)*[ ((1/mu)*u.x).x + ((1/mu)*u.y).y + ((1/mu)*u.z).z ]
//   div(u)=0
// H
//   v.tt = (1/mu)*[ ((1/eps)*v.x).x + ((1/eps)*v.y).y + ((1/eps)*v.z).z ]
// Define macros for forcing functions


//
//   (Ex).t = (1/eps)*[ (Hz).y - (Hy).z ]
//   (Ey).t = (1/eps)*[ (Hx).z - (Hz).x ]
//   (Ez).t = (1/eps)*[ (Hy).x - (Hx).y ]
//   (Hx).t = (1/mu) *[ (Ey).z - (Ez).y ]
//   (Hy).t = (1/mu) *[ (Ez).x - (Ex).z ]
//   (Hz).t = (1/mu) *[ (Ex).y - (Ey).x ]

// ****************** finish this -> should `rotate' the 2d solution ****************

#define exTrue3d(x,y,z,t) sin(twoPi*(kx*(x)+ky*(y)+kz*(z)-cc*(t)))*(-ky/(eps*cc))
#define eyTrue3d(x,y,z,t) sin(twoPi*(kx*(x)+ky*(y)+kz*(z)-cc*(t)))*( kx/(eps*cc))
#define ezTrue3d(x,y,z,t) 0

#define hxTrue3d(x,y,z,t) 0
#define hyTrue3d(x,y,z,t) 0
#define hzTrue3d(x,y,z,t) sin(twoPi*(kx*(x)+ky*(y)+kz*(z)-cc*(t)))

#define exLaplacianTrue3d(x,y,z,t) sin(twoPi*(kx*(x)+ky*(y)-cc*(t)))*(+ky*(twoPi*twoPi*(kx*kx+ky*ky))/(eps*cc))
#define eyLaplacianTrue3d(x,y,z,t) sin(twoPi*(kx*(x)+ky*(y)-cc*(t)))*(-kx*(twoPi*twoPi*(kx*kx+ky*ky))/(eps*cc))
#define ezLaplacianTrue3d(x,y,z,t) 0

#define hxLaplacianTrue3d(x,y,z,t) 0
#define hyLaplacianTrue3d(x,y,z,t) 0
#define hzLaplacianTrue3d(x,y,z,t) sin(twoPi*(kx*(x)+ky*(y)-cc*(t)))*( -(twoPi*twoPi*(kx*kx+ky*ky) ) )


// ------------ macros for the plane material interface -------------------------


// OPTION: initialCondition, error, boundaryCondition

//==================================================================================================
// Evaluate Tom Hagstom's exact solution defined as an integral of Guassian sources
// 
// OPTION: OPTION=solution or OPTION=error OPTION=bounary to compute the solution or the error or
//     the boundary condition
//
//==================================================================================================
// ===================================================================================
//   This macro extracts the boundary data arrays
// ===================================================================================


// ************* WE SHOULD SHARE THE NEXT MACRO WITH BCOPSM *****************

// =============================================================
// Macro to apply optimized versions of BC's
// =============================================================


// =========================================================================================================
/// \brief Apply boundary conditions for the First-Order-System.
///
///  \param option: 
///
// Note: uOld = u[current]
///
// =========================================================================================================
void Cgsm::
assignBoundaryConditionsFOS( int option, int grid, real t, real dt, realMappedGridFunction & u, 
                       			     realMappedGridFunction & uOld, int current )
{

    SmParameters::PDEVariation & pdeVariation = parameters.dbase.get<SmParameters::PDEVariation>("pdeVariation");
    if( pdeVariation==SmParameters::hemp )
    {
    // for now we do not apply BC's for hemp 
        return;
    }
    

    FILE *& debugFile  =parameters.dbase.get<FILE* >("debugFile");
    FILE *& logFile    =parameters.dbase.get<FILE* >("logFile");
    FILE *& pDebugFile =parameters.dbase.get<FILE* >("pDebugFile");

    const int prev = (current-1+numberOfTimeLevels) % numberOfTimeLevels;
    const int next = (current+1) % numberOfTimeLevels;

    SmParameters::PDEModel & pdeModel = parameters.dbase.get<SmParameters::PDEModel>("pdeModel");

    const int & numberOfComponents = parameters.dbase.get<int >("numberOfComponents");
    const int & uc =  parameters.dbase.get<int >("uc");
    const int & vc =  parameters.dbase.get<int >("vc");
    const int & wc =  parameters.dbase.get<int >("wc");
    const int & rc =  parameters.dbase.get<int >("rc");
    const int & tc =  parameters.dbase.get<int >("tc");

    const int & v1c =  parameters.dbase.get<int >("v1c");

    const int & orderOfAccuracyInSpace = parameters.dbase.get<int>("orderOfAccuracy");
    const int & orderOfAccuracyInTime  = parameters.dbase.get<int>("orderOfTimeAccuracy");

    real & rho=parameters.dbase.get<real>("rho");
    real & mu = parameters.dbase.get<real>("mu");
    real & lambda = parameters.dbase.get<real>("lambda");
    RealArray & muGrid = parameters.dbase.get<RealArray>("muGrid");
    RealArray & lambdaGrid = parameters.dbase.get<RealArray>("lambdaGrid");
  // bool & gridHasMaterialInterfaces = parameters.dbase.get<bool>("gridHasMaterialInterfaces");
    int & debug = parameters.dbase.get<int >("debug");

    lambda = lambdaGrid(grid);
    mu = muGrid(grid);
    c1=(mu+lambda)/rho, c2= mu/rho;

  //   const real cc= c*sqrt( kx*kx+ky*ky );

    MappedGrid & mg = *u.getMappedGrid();
    MappedGridOperators & mgop = (*cgop)[grid];
    
    const int numberOfDimensions = mg.numberOfDimensions();
    
  // The RHS for BC's are saved in these next two objects:
    const RealArray & bcData = parameters.dbase.get<RealArray>("bcData");
    BoundaryData::BoundaryDataArray & pBoundaryData = parameters.getBoundaryData(grid);

  // The interfaceType(side,axis,grid) defines which faces are interfaces.
    const IntegerArray & interfaceType = parameters.dbase.get<IntegerArray >("interfaceType");

    Range all;
    BoundaryConditionParameters bcParams;            
    BoundaryConditionParameters extrapParams;

    Range C=numberOfComponents;

    Range U=Range(uc,uc+numberOfDimensions-1);   // displacements
    Range V=Range(v1c,v1c+numberOfDimensions-1);  // velocities

    bool assignDisplacementBC=false;
    bool assignTractionBC=false;
    bool assignSlipWall=false;
    for( int axis=0; axis<mg.numberOfDimensions(); axis++ )
    {
        for( int side=0; side<=1; side++ )
        {
            int bc=mg.boundaryCondition(side,axis);
            switch (bc)
            {
            case 0 : break;
            case -1: break;
            case SmParameters::displacementBC:  assignDisplacementBC=true; break;
            case SmParameters::tractionBC:  assignTractionBC=true; break;
            case SmParameters::slipWall:  assignSlipWall=true; break;
            default: 
                printf("assignBCFOS: unknown boundary condition =%i on grid %i, side=%i, axis=%i\n",bc,grid,side,axis);
                Overture::abort("error");
            break;
            }
        }
    }

  //if( false )
  // assign exact solution at boundaries for 3D code ... FIX ME ...
    if( numberOfDimensions == 3 )
    {
        if( forcingOption==twilightZoneForcing )
        {
      // Temporary: assign exact values on boundaries for TZ
            printF(" assignBoundaryConditionsFOS: set exact BC's ...\n");
        
      // assign the boundary and 2 ghost with the exact solution
            int numGhost=2;
            for( int g=0; g<=numGhost; g++ )
            {
      	extrapParams.lineToAssign=g;
      	u.applyBoundaryCondition(C,BCTypes::dirichlet,BCTypes::allBoundaries,0.,t,extrapParams);
            }
            extrapParams.lineToAssign=1;
        }
        else
        {

      // -- both the displacement and velocities are given on a displacementBC
            u.applyBoundaryCondition(U,BCTypes::dirichlet,SmParameters::displacementBC,bcData,pBoundaryData,t,
                         			       Overture::defaultBoundaryConditionParameters(),grid);

            u.applyBoundaryCondition(V,BCTypes::dirichlet,SmParameters::displacementBC,bcData,pBoundaryData,t,
                         			       Overture::defaultBoundaryConditionParameters(),grid);

            u.applyBoundaryCondition(C,BCTypes::extrapolate,SmParameters::displacementBC,0.,t);
         	   
                      
            u.applyBoundaryCondition(C,BCTypes::evenSymmetry,SmParameters::symmetry,0.,t);
        
        }
    
        if( parameters.dbase.get<int >("extrapolateInterpolationNeighbours") )
        {
      // extrapolate the 2nd ghost line and interpolation neighbours for higher-order dissipation
      // -- is this the right place to do this ? 
            extrapParams.ghostLineToAssign=2;
            extrapParams.orderOfExtrapolation=orderOfAccuracyInSpace+1;
            u.applyBoundaryCondition(C,BCTypes::extrapolate,BCTypes::allBoundaries,0.,t,extrapParams);

      // printF(" extrapolateInterpolationNeighbours at t=%g\n",t);
            u.applyBoundaryCondition(C,BCTypes::extrapolateInterpolationNeighbours,BCTypes::allBoundaries,0.,t);
        }

        u.finishBoundaryConditions();
    }
    

  // **** now call the optimized BC routine so Don can make changes to the above boundary conditions


    const real dtb2=dt*.5;

    const realArray & x = mg.center();

    const bool isRectangular = mg.isRectangular();

  // const bool isRectangular=false; // ********** do this for now for Don ***************

    real dx[3]={0.,0.,0.}; //

    if( isRectangular )
    {
        mg.getDeltaX(dx);
    }
    if( !isRectangular )
    {
        mg.update( MappedGrid::THEinverseVertexDerivative | 
             	       MappedGrid::THEinverseCenterDerivative | MappedGrid::THEcenterJacobian );	
    }

    #ifdef USE_PPP
      realSerialArray uLocal; getLocalArrayWithGhostBoundaries(u,uLocal);
    #else
      const realSerialArray & uLocal = u;
    #endif
    
      const IntegerArray & bcg = mg.boundaryCondition();
      IntegerArray gid, dim, bc;
      getLocalBoundsAndBoundaryConditions( u, gid, dim, bc );


      Index Iv[3], &I1=Iv[0], &I2=Iv[1], &I3=Iv[2];
      Index Igv[3], &Ig1=Igv[0], &Ig2=Igv[1], &Ig3=Igv[2];

      bool useOpt=true; 
      int side,axis;


      u.periodicUpdate();

   // *wdh* 041127 -- apply opt BC's after above dirichlet BC's ----
      if( numberOfDimensions != 3 )
      {
          getIndex(mg.gridIndexRange(),I1,I2,I3);
          int includeGhost=1;
          bool ok = ParallelUtility::getLocalArrayBounds(u,uLocal,I1,I2,I3,includeGhost);
          if( ok && useOpt )
          {
       // use optimised boundary conditions
              int ipar[30];
              real rpar[20];
              int gridType = isRectangular ? 0 : 1;
              int orderOfExtrapolation=orderOfAccuracyInSpace+1;  // not used
              int useForcing = forcingOption==twilightZoneForcing;
              int useWhereMask=false;
              realArray f;  // not currently used
              ipar[0]=numberOfDimensions;
              ipar[1] = grid;
              ipar[2] = uc;
              ipar[3] = vc;
              ipar[4] = wc;
              ipar[5] = gridType;
              ipar[6] = orderOfAccuracyInSpace;
              ipar[7] = orderOfExtrapolation;
              ipar[8] = forcingOption; // (int)addForcing;
              ipar[9] = useWhereMask;
              ipar[10]= debug; 
              rpar[ 0]=dx[0];
              rpar[ 1]=dx[1];
              rpar[ 2]=dx[2];
              rpar[ 3]=mg.gridSpacing(0);
              rpar[ 4]=mg.gridSpacing(1);
              rpar[ 5]=mg.gridSpacing(2);
              rpar[ 6]=t;
              OGFunction *& tz = parameters.dbase.get<OGFunction* >("exactSolution");
              rpar[ 7]=(real &)tz;  // twilight zone pointer, ep
              rpar[ 8]=dt;
              rpar[ 9]=mu;
              rpar[10]=lambda;
              rpar[11]=c1;
              rpar[12]=c2;
       // fprintf(pDebugFile,"**** pu= %i, %i...\n",&u,pu);
              const bool centerNeeded=useForcing || (forcingOption==planeWaveBoundaryForcing); // **************** fix this 
          #ifdef USE_PPP 
              realSerialArray uu;    getLocalArrayWithGhostBoundaries(u,uu);
              realSerialArray uuOld; getLocalArrayWithGhostBoundaries(uOld,uuOld);
              intSerialArray  mask;  getLocalArrayWithGhostBoundaries(mg.mask(),mask);
              realSerialArray rx;    if( !isRectangular ) getLocalArrayWithGhostBoundaries(mg.inverseVertexDerivative(),rx);
              realSerialArray xy;    if( centerNeeded ) getLocalArrayWithGhostBoundaries(mg.center(),xy);
              realSerialArray jacLocal; if( !isRectangular ) getLocalArrayWithGhostBoundaries(mg.centerJacobian(),jacLocal);
              realSerialArray ff;    getLocalArrayWithGhostBoundaries(f,ff); 
              if( debug & 1 )
              {
                  fprintf(pDebugFile,"\n **** grid=%i p=%i assignBC: gid=[%i,%i][%i,%i][%i,%i] bc=[%i,%i][%i,%i][%i,%i]"
                    	    " bcg=[%i,%i][%i,%i][%i,%i]******\n\n",grid,Communication_Manager::My_Process_Number,
                    	    gid(0,0),gid(1,0),gid(0,1),gid(1,1),gid(0,2),gid(1,2),
                    	    bc(0,0),bc(1,0),bc(0,1),bc(1,1),bc(0,2),bc(1,2),
                    	    bcg(0,0),bcg(1,0),bcg(0,1),bcg(1,1),bcg(0,2),bcg(1,2));
                  fprintf(pDebugFile,"\n **** uu=[%i,%i] xy=[%i,%i] rsxy=[%i,%i]\n",
                    	    uu.getBase(0),uu.getBound(0),xy.getBase(0),xy.getBound(0),rx.getBase(0),rx.getBound(0));
              }
          #else
              const realSerialArray & uu    = u;
              const realSerialArray & uuOld = uOld;
              const realSerialArray & ff    = f;
              const intSerialArray  & mask  = mg.mask();
              const realSerialArray & rx = !isRectangular? mg.inverseVertexDerivative() : uu;
              const realSerialArray & xy = centerNeeded ? mg.center() : uu;
              const realSerialArray & jacLocal=mg.centerJacobian();
              const IntegerArray & gid = mg.gridIndexRange();
              const IntegerArray & dim = mg.dimension();
              const IntegerArray & bc = mg.boundaryCondition();
              if( debug & 1 )
              {
                  const IntegerArray & bcg = mg.boundaryCondition();
                  fprintf(pDebugFile,"\n **** grid=%i p=%i assignBC: gid=[%i,%i][%i,%i][%i,%i] bc=[%i,%i][%i,%i][%i,%i]"
                    	    " bcg=[%i,%i][%i,%i][%i,%i]******\n\n",grid,Communication_Manager::My_Process_Number,
                    	    gid(0,0),gid(1,0),gid(0,1),gid(1,1),gid(0,2),gid(1,2),
                    	    bc(0,0),bc(1,0),bc(0,1),bc(1,1),bc(0,2),bc(1,2),
                    	    bcg(0,0),bcg(1,0),bcg(0,1),bcg(1,1),bcg(0,2),bcg(1,2));
              }
          #endif
              real *uptr   = uu.getDataPointer();
              real *fptr   = ff.getDataPointer();
              int *maskptr = mask.getDataPointer();
              real *rxptr  = rx.getDataPointer();
              real *xyptr  = centerNeeded ? xy.getDataPointer() : uptr;
              assert( xyptr!=NULL );
              real *jacptr = !isRectangular ? jacLocal.getDataPointer() : uptr;
       // Do this for now -- assumes all sides are PML
              bool usePML = (bc(0,0)==SmParameters::abcPML || bc(1,0)==SmParameters::abcPML ||
                       		 bc(0,1)==SmParameters::abcPML || bc(1,1)==SmParameters::abcPML ||
                       		 bc(0,2)==SmParameters::abcPML || bc(1,2)==SmParameters::abcPML);
       // *** need to fix gridIndex Range and bc ***********************
              if( debug & 4 )
              {
                  ::display(uu,sPrintF("uu before bcOptSolidMechanics, t=%e",t),pDebugFile,"%8.1e ");
              }
              if( !isRectangular && debug & 4  ) ::display(rx,sPrintF("rx before bcOptSolidMechanics, t=%e",t),debugFile,"%9.2e ");
       // The next macro is in boundaryMacros.h
                  int pdbc[2*3*2*3];
                  #define dbc(s,a,side,axis) (pdbc[(s)+2*((a)+3*((side)+2*(axis)))])
                  int pAddBoundaryForcing[6];
                  #define addBoundaryForcing(side,axis) (pAddBoundaryForcing[(side)+2*(axis)])
                  real *pbcf[2][3];
         // long int pbcfOffset[6];
         // We need an 8 byte integer so we can pass to fortran: int64_t is in stdint.h 
                  int64_t pbcfOffset[6];
                  #define bcfOffset(side,axis) pbcfOffset[(side)+2*(axis)]
                  for( int axis=0; axis<=2; axis++ )
                  {
                      for( int side=0; side<=1; side++ )
                      {
             // *** for now make sure the boundary data array is allocated on all sides
                          if( pBoundaryData[side][axis]==NULL && mg.boundaryCondition(side,axis)>0 )
                          {
                    	parameters.getBoundaryData(side,axis,grid,mg);
                              RealArray & bd = *pBoundaryData[side][axis];
                              bd=0.;
                          }
                          if( pBoundaryData[side][axis]!=NULL )
                          {
                    	if( debug & 8 )
                      	  printP("+++ Cgsm: add boundary forcing to (side,axis,grid)=(%i,%i,%i) useConservative=%i\n",side,axis,grid,
                           		 (int)useConservative);
                              addBoundaryForcing(side,axis)=true;
                              RealArray & bd = *pBoundaryData[side][axis];
                              pbcf[side][axis] = bd.getDataPointer();
       	// if( debug & 8 )
               //  ::display(bd," ++++ Cgsm: Here is bd ++++","%4.2f ");
                    	for( int a=0; a<=2; a++ )
                    	{
                      	  dbc(0,a,side,axis)=bd.getBase(a);
                      	  dbc(1,a,side,axis)=bd.getBound(a);
                    	}
                          }
                          else
                          {
                              addBoundaryForcing(side,axis)=false;
                    	pbcf[side][axis] = fptr;  // should not be used in this case 
                    	for( int a=0; a<=2; a++ )
                    	{
                      	  dbc(0,a,side,axis)=0;
                      	  dbc(1,a,side,axis)=0;
                    	}
                          }
             // for now we save the offset in a 4 byte int (double check that this is ok)
                          int64_t offset = pbcf[side][axis]- pbcf[0][0];
       //       if( offset > INT_MAX )
       //       {
       // 	printF("ERROR: offset=%li INT_MAX=%li \n",offset,(long int)INT_MAX);
       //       }
       //       assert( offset < INT_MAX );
                          bcfOffset(side,axis) = offset;
             // bcfOffset(side,axis) = pbcf[side][axis]- pbcf[0][0];
             // cout << " **** bcfOffset= " << bcfOffset(side,axis) << endl;
                      }
                  }
              int ierr=0;
              const int bc0=-1;  // do all boundaries.
              if( !usePML ) // *** fix this ***
              {
                  DataBase *pdb = &parameters.dbase;
                  bcOptSmFOS( numberOfDimensions, 
                       		 uu.getBase(0),uu.getBound(0),
                       		 uu.getBase(1),uu.getBound(1),
                       		 uu.getBase(2),uu.getBound(2),
                       		 gid(0,0), *uptr, *maskptr, *rxptr, *xyptr, *jacptr, *bc.getDataPointer(),
                       		 *pAddBoundaryForcing,*interfaceType.getDataPointer(),*pdbc, 
                       		 *pbcf[0][0],*pbcf[1][0], *pbcf[0][1],*pbcf[1][1], *pbcf[0][2],*pbcf[1][2],
                       		 *pbcf[0][0],pbcfOffset[0],
                       		 ipar[0], rpar[0], pdb, ierr );
              }
              if( debug & 4  ) ::display(uu,sPrintF("uu after bcOptSolidMechanics, t=%e",t),pDebugFile,"%8.1e ");
              real *uOldptr = uuOld.getDataPointer();
          } // end use opt
      }


    if( parameters.dbase.get<int >("extrapolateInterpolationNeighbours") )
    {
    // extrapolate the 2nd ghost line and interpolation neighbours for higher-order dissipation
    // -- is this the right place to do this ? 
        extrapParams.ghostLineToAssign=2;
        extrapParams.orderOfExtrapolation=orderOfAccuracyInSpace+1;

    // extrapParams.orderOfExtrapolation=orderOfAccuracyInSpace;  // *wdh* ***********081111

        u.applyBoundaryCondition(C,BCTypes::extrapolate,BCTypes::allBoundaries,0.,t,extrapParams);

    // printF(" extrapolateInterpolationNeighbours at t=%g\n",t);
        u.applyBoundaryCondition(C,BCTypes::extrapolateInterpolationNeighbours,BCTypes::allBoundaries,0.,t);
    }

    u.periodicUpdate();

  // u.finishBoundaryConditions();
}

